## hersheydata.py
##
## This file prepared in 2011 by Windell H. Oskay, www.evilmadscientist.com
##
##
## Contents adapted from emergent.unpythonic.net/software/hershey
##  by way of http://www.thingiverse.com/thing:6168 
##
##The Hershey Fonts are a set of vector fonts with a liberal license. 
##
##USE RESTRICTION:
##	This distribution of the Hershey Fonts may be used by anyone for
##	any purpose, commercial or otherwise, providing that:
##		1. The following acknowledgements must be distributed with
##			the font data:
##			- The Hershey Fonts were originally created by Dr.
##				A. V. Hershey while working at the U. S.
##				National Bureau of Standards.
##			- The format of the Font data in this distribution
##				was originally created by
##					James Hurt
##					Cognition, Inc.
##					900 Technology Park Drive
##					Billerica, MA 01821
##					(mit-eddie!ci-dandelion!hurt)
##		2. The font data in this distribution may be converted into
##			any other format *EXCEPT* the format distributed by
##			the U.S. NTIS (which organization holds the rights
##			to the distribution and use of the font data in that
##			particular format). Not that anybody would really
##			*want* to use their format... each point is described
##			in eight bytes as "xxx yyy:", where xxx and yyy are
##			the coordinate values as ASCII numbers.


astrology = ["-8 8","-12 12 M -8 -10 L -4 -8 L -2 -6 L -1 -3 L -1 0 L -2 3 L -4 5 L -8 7 M -8 -10 L -5 -9 L -3 -8 L -1 -6 L 0 -3 M 0 0 L -1 3 L -3 5 L -5 6 L -8 7 M 8 -10 L 5 -9 L 3 -8 L 1 -6 L 0 -3 M 0 0 L 1 3 L 3 5 L 5 6 L 8 7 M 8 -10 L 4 -8 L 2 -6 L 1 -3 L 1 0 L 2 3 L 4 5 L 8 7 M -9 -2 L 9 -2 M -9 -1 L 9 -1","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-13 14 M -1 -12 L -4 -11 L -7 -9 L -9 -6 L -10 -3 L -10 0 L -9 3 L -7 6 L -4 8 L -1 9 L 2 9 L 5 8 L 8 6 L 10 3 L 11 0 L 11 -3 L 10 -6 L 8 -9 L 5 -11 L 2 -12 L -1 -12 M 0 -3 L -1 -2 L -1 -1 L 0 0 L 1 0 L 2 -1 L 2 -2 L 1 -3 L 0 -3 M 0 -2 L 0 -1 L 1 -1 L 1 -2 L 0 -2","-8 9 M -2 -12 L -4 -11 L -3 -9 L -1 -8 M -2 -12 L -3 -11 L -3 -9 M 3 -12 L 5 -11 L 4 -9 L 2 -8 M 3 -12 L 4 -11 L 4 -9 M -1 -8 L -3 -7 L -4 -6 L -5 -4 L -5 -1 L -4 1 L -3 2 L -1 3 L 2 3 L 4 2 L 5 1 L 6 -1 L 6 -4 L 5 -6 L 4 -7 L 2 -8 L -1 -8 M 0 3 L 0 9 M 1 3 L 1 9 M -4 6 L 5 6","-9 10 M 0 -12 L -3 -11 L -5 -9 L -6 -6 L -6 -5 L -5 -2 L -3 0 L 0 1 L 1 1 L 4 0 L 6 -2 L 7 -5 L 7 -6 L 6 -9 L 4 -11 L 1 -12 L 0 -12 M 0 1 L 0 9 M 1 1 L 1 9 M -4 5 L 5 5","-14 14 M -2 -12 L -5 -11 L -8 -9 L -10 -6 L -11 -3 L -11 1 L -10 4 L -8 7 L -5 9 L -2 10 L 2 10 L 5 9 L 8 7 L 10 4 L 11 1 L 11 -3 L 10 -6 L 8 -9 L 5 -11 L 2 -12 L -2 -12 M 0 -12 L 0 10 M -11 -1 L 11 -1","-11 14 M -2 -5 L -5 -4 L -7 -2 L -8 1 L -8 2 L -7 5 L -5 7 L -2 8 L -1 8 L 2 7 L 4 5 L 5 2 L 5 1 L 4 -2 L 2 -4 L -1 -5 L -2 -5 M 11 -11 L 5 -11 L 9 -10 L 3 -4 M 11 -11 L 11 -5 L 10 -9 L 4 -3 M 10 -10 L 4 -4","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16 M 2 -14 L 0 -10 L -1 -7 L -2 -2 L -2 2 L -1 7 L 0 10 L 2 14","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 M -2 -14 L 0 -10 L 1 -7 L 2 -2 L 2 2 L 1 7 L 0 10 L -2 14","-12 10 M -9 -9 L -8 -11 L -6 -12 L -3 -12 L -1 -11 L 0 -9 L 0 -6 L -1 -3 L -2 -1 L -4 1 L -7 3 M -3 -12 L -2 -11 L -1 -9 L -1 -5 L -2 -2 L -4 1 M 4 -12 L 2 9 M 5 -12 L 1 9 M -7 3 L 7 3","-9 10 M -5 -12 L -5 3 M -4 -12 L -5 -1 M -5 -1 L -4 -3 L -3 -4 L -1 -5 L 2 -5 L 5 -4 L 6 -2 L 6 0 L 5 2 L 3 4 M 2 -5 L 4 -4 L 5 -2 L 5 0 L 2 6 L 2 8 L 3 9 L 5 9 L 7 7 M -7 -12 L -4 -12","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-9 10 M 0 -4 L -3 -3 L -5 -1 L -6 2 L -6 3 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 M 0 -10 L -4 -8 L 0 -12 L 0 -4 M 1 -10 L 5 -8 L 1 -12 L 1 -4 M 0 1 L -1 2 L -1 3 L 0 4 L 1 4 L 2 3 L 2 2 L 1 1 L 0 1 M 0 2 L 0 3 L 1 3 L 1 2 L 0 2","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 12 M -1 -10 L 0 -12 L 0 9 M 2 -10 L 1 -12 L 1 9 M -8 -10 L -7 -12 L -7 -5 L -6 -2 L -4 0 L -1 1 L 0 1 M -5 -10 L -6 -12 L -6 -4 L -5 -1 M 9 -10 L 8 -12 L 8 -5 L 7 -2 L 5 0 L 2 1 L 1 1 M 6 -10 L 7 -12 L 7 -4 L 6 -1 M -4 5 L 5 5","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 M -1 -10 L -3 -8 L -4 -6 L -5 -3 L -6 1 L -6 5 L -5 7 M 2 7 L 4 5 L 5 3 L 6 0 L 7 -4 L 7 -8 L 6 -10 M 2 -12 L 0 -11 L -2 -8 L -3 -6 L -4 -3 L -5 1 L -5 6 L -4 8 L -3 9 M -1 9 L 1 8 L 3 5 L 4 3 L 5 0 L 6 -4 L 6 -9 L 5 -11 L 4 -12","-10 11 M 2 -8 L -3 9 L -1 9 M 5 -12 L 3 -8 L -2 9 M 5 -12 L -1 9 M 5 -12 L 2 -9 L -1 -7 L -3 -6 M 2 -8 L 0 -7 L -3 -6","-10 11 M -3 -7 L -3 -8 L -2 -8 L -2 -6 L -4 -6 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 5 -3 L -5 3 L -7 5 L -9 9 M 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 L 1 -1 M 4 -12 L 5 -11 L 6 -9 L 6 -7 L 5 -5 L 3 -3 L -5 3 M -8 7 L -7 6 L -5 6 L 0 7 L 5 7 L 6 6 M -5 6 L 0 8 L 5 8 M -5 6 L 0 9 L 3 9 L 5 8 L 6 6 L 6 5","-10 11 M -3 -7 L -3 -8 L -2 -8 L -2 -6 L -4 -6 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 L 1 -2 M 6 -11 L 7 -9 L 7 -7 L 6 -5 L 5 -4 M 4 -12 L 5 -11 L 6 -9 L 6 -7 L 5 -5 L 3 -3 L 1 -2 M -1 -2 L 1 -2 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 3 8 L 0 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 3 L -6 3 L -6 5 L -7 5 L -7 4 M 4 0 L 5 2 L 5 5 L 4 7 M 1 -2 L 3 -1 L 4 1 L 4 5 L 3 7 L 2 8 L 0 9","-10 11 M 5 -8 L 0 9 L 2 9 M 8 -12 L 6 -8 L 1 9 M 8 -12 L 2 9 M 8 -12 L -8 3 L 8 3","-10 11 M -1 -12 L -6 -2 M -1 -12 L 9 -12 M -1 -11 L 7 -11 M -2 -10 L 3 -10 L 7 -11 L 9 -12 M -6 -2 L -5 -3 L -2 -4 L 1 -4 L 4 -3 L 5 -2 L 6 0 L 6 3 L 5 6 L 3 8 L -1 9 L -4 9 L -6 8 L -7 7 L -8 5 L -8 3 L -6 3 L -6 5 L -7 5 L -7 4 M 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 M 1 -4 L 3 -3 L 4 -1 L 4 3 L 3 6 L 1 8 L -1 9","-10 11 M 7 -8 L 7 -9 L 6 -9 L 6 -7 L 8 -7 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 1 L 5 -1 L 4 -2 L 2 -3 L -1 -3 L -3 -2 L -4 -1 L -5 1 M -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 5 L -5 7 M 4 6 L 5 4 L 5 1 L 4 -1 M 2 -12 L 0 -11 L -2 -8 L -3 -6 L -4 -3 L -5 1 L -5 6 L -4 8 L -3 9 M 0 9 L 2 8 L 3 7 L 4 4 L 4 0 L 3 -2 L 2 -3","-10 11 M -4 -12 L -6 -6 M 9 -12 L 8 -9 L 6 -6 L 2 -1 L 0 2 L -1 5 L -2 9 M 0 1 L -2 5 L -3 9 M 6 -6 L 0 0 L -2 3 L -3 5 L -4 9 L -2 9 M -5 -9 L -2 -12 L 0 -12 L 5 -9 M -3 -11 L 0 -11 L 5 -9 M -5 -9 L -3 -10 L 0 -10 L 5 -9 L 7 -9 L 8 -10 L 9 -12","-10 11 M 1 -12 L -2 -11 L -3 -10 L -4 -8 L -4 -5 L -3 -3 L -1 -2 L 2 -2 L 5 -3 L 7 -4 L 8 -6 L 8 -9 L 7 -11 L 5 -12 L 1 -12 M 3 -12 L -2 -11 M -2 -10 L -3 -8 L -3 -4 L -2 -3 M -3 -3 L 0 -2 M 1 -2 L 5 -3 M 6 -4 L 7 -6 L 7 -9 L 6 -11 M 7 -11 L 3 -12 M 1 -12 L -1 -10 L -2 -8 L -2 -4 L -1 -2 M 2 -2 L 4 -3 L 5 -4 L 6 -6 L 6 -10 L 5 -12 M -1 -2 L -5 -1 L -7 1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 4 8 L 5 7 L 6 5 L 6 2 L 5 0 L 4 -1 L 2 -2 M 0 -2 L -5 -1 M -4 -1 L -6 1 L -7 3 L -7 6 L -6 8 M -7 8 L -2 9 L 4 8 M 4 7 L 5 5 L 5 2 L 4 0 M 4 -1 L 1 -2 M -1 -2 L -3 -1 L -5 1 L -6 3 L -6 6 L -5 8 L -4 9 M 0 9 L 2 8 L 3 7 L 4 5 L 4 1 L 3 -1 L 2 -2","-10 11 M 6 -4 L 5 -2 L 4 -1 L 2 0 L -1 0 L -3 -1 L -4 -2 L -5 -4 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 4 -12 L 6 -11 L 7 -10 L 8 -7 L 8 -4 L 7 0 L 6 3 L 4 6 L 2 8 L -1 9 L -4 9 L -6 8 L -7 6 L -7 4 L -5 4 L -5 6 L -6 6 L -6 5 M -3 -2 L -4 -4 L -4 -7 L -3 -9 M 6 -10 L 7 -8 L 7 -4 L 6 0 L 5 3 L 3 6 M -1 0 L -2 -1 L -3 -3 L -3 -7 L -2 -10 L -1 -11 L 1 -12 M 4 -12 L 5 -11 L 6 -9 L 6 -4 L 5 0 L 4 3 L 3 5 L 1 8 L -1 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 3 -1 L -5 -1 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 3 -1 M -9 9 L 7 9 L 7 4 L 6 9","-10 9 M 7 -11 L 3 -11 L -1 -10 L -4 -8 L -6 -5 L -7 -2 L -7 1 L -6 4 L -4 7 L -1 9 L 3 10 L 7 10 M 7 -11 L 4 -10 L 1 -8 L -1 -5 L -2 -2 L -2 1 L -1 4 L 1 7 L 4 9 L 7 10","-12 13 M -3 -1 L -5 -1 L -7 0 L -8 1 L -9 3 L -9 5 L -8 7 L -7 8 L -5 9 L -3 9 L -1 8 L 0 7 L 1 5 L 1 3 L 0 1 L -1 0 L -3 -1 M 1 -10 L -2 -1 M 8 -8 L 0 0 M 10 -1 L 1 2","-10 10 M -3 -7 L 3 7 M 3 -7 L -3 7 M -7 -3 L 7 3 M 7 -3 L -7 3","-12 12 M -4 4 L -6 3 L -7 3 L -9 4 L -10 6 L -10 7 L -9 9 L -7 10 L -6 10 L -4 9 L -3 7 L -3 6 L -4 4 L -7 0 L -8 -3 L -8 -5 L -7 -8 L -5 -10 L -2 -11 L 2 -11 L 5 -10 L 7 -8 L 8 -5 L 8 -3 L 7 0 L 4 4 L 3 6 L 3 7 L 4 9 L 6 10 L 7 10 L 9 9 L 10 7 L 10 6 L 9 4 L 7 3 L 6 3 L 4 4 M -8 -5 L -7 -7 L -5 -9 L -2 -10 L 2 -10 L 5 -9 L 7 -7 L 8 -5","-12 12 M -4 -5 L -6 -4 L -7 -4 L -9 -5 L -10 -7 L -10 -8 L -9 -10 L -7 -11 L -6 -11 L -4 -10 L -3 -8 L -3 -7 L -4 -5 L -7 -1 L -8 2 L -8 4 L -7 7 L -5 9 L -2 10 L 2 10 L 5 9 L 7 7 L 8 4 L 8 2 L 7 -1 L 4 -5 L 3 -7 L 3 -8 L 4 -10 L 6 -11 L 7 -11 L 9 -10 L 10 -8 L 10 -7 L 9 -5 L 7 -4 L 6 -4 L 4 -5 M -8 4 L -7 6 L -5 8 L -2 9 L 2 9 L 5 8 L 7 6 L 8 4","-12 13 M -8 -5 L -9 -6 L -9 -8 L -8 -10 L -6 -11 L -4 -11 L -2 -10 L -1 -9 L 0 -7 L 1 -2 M -9 -8 L -7 -10 L -5 -10 L -3 -9 L -2 -8 L -1 -6 L 0 -2 L 0 9 M 9 -5 L 10 -6 L 10 -8 L 9 -10 L 7 -11 L 5 -11 L 3 -10 L 2 -9 L 1 -7 L 0 -2 M 10 -8 L 8 -10 L 6 -10 L 4 -9 L 3 -8 L 2 -6 L 1 -2 L 1 9","-10 10 M 0 -12 L -7 8 M -1 -9 L 5 9 M 0 -9 L 6 9 M 0 -12 L 7 9 M -5 3 L 4 3 M -9 9 L -3 9 M 2 9 L 9 9 M -7 8 L -8 9 M -7 8 L -5 9 M 5 8 L 3 9 M 5 7 L 4 9 M 6 7 L 8 9","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 M 6 -10 L 7 -8 L 7 -6 L 6 -4 M 3 -12 L 5 -11 L 6 -9 L 6 -5 L 5 -3 L 3 -2 M -4 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -9 9 M 6 0 L 7 2 L 7 5 L 6 7 M 3 -2 L 5 -1 L 6 1 L 6 6 L 5 8 L 3 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 10 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 2 9 L 4 8 L 6 6 L 7 4 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8 L 1 9 L -9 9 M 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 M 1 -12 L 3 -11 L 5 -8 L 6 -4 L 6 1 L 5 5 L 3 8 L 1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 10 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 7 -12 L 7 -6 M -4 -2 L 2 -2 M 2 -6 L 2 2 M -9 9 L 7 9 L 7 3 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M 2 -12 L 7 -11 M 4 -12 L 7 -10 M 5 -12 L 7 -9 M 6 -12 L 7 -6 M 2 -6 L 1 -2 L 2 2 M 2 -4 L 0 -2 L 2 0 M 2 -3 L -2 -2 L 2 -1 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9 M 2 9 L 7 8 M 4 9 L 7 7 M 5 9 L 7 6 M 6 9 L 7 3","-11 9 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 7 -12 L 7 -6 M -4 -2 L 2 -2 M 2 -6 L 2 2 M -9 9 L -1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M 2 -12 L 7 -11 M 4 -12 L 7 -10 M 5 -12 L 7 -9 M 6 -12 L 7 -6 M 2 -6 L 1 -2 L 2 2 M 2 -4 L 0 -2 L 2 0 M 2 -3 L -2 -2 L 2 -1 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 12 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 2 9 L 4 8 L 6 8 L 7 9 L 7 1 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9 M 6 2 L 6 7 M 5 1 L 5 7 L 4 8 M 2 1 L 10 1 M 3 1 L 5 2 M 4 1 L 5 3 M 8 1 L 7 3 M 9 1 L 7 2","-12 12 M -7 -12 L -7 9 M -6 -11 L -6 8 M -5 -12 L -5 9 M 5 -12 L 5 9 M 6 -11 L 6 8 M 7 -12 L 7 9 M -10 -12 L -2 -12 M 2 -12 L 10 -12 M -5 -2 L 5 -2 M -10 9 L -2 9 M 2 9 L 10 9 M -9 -12 L -7 -11 M -8 -12 L -7 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 3 -12 L 5 -11 M 4 -12 L 5 -10 M 8 -12 L 7 -10 M 9 -12 L 7 -11 M -7 8 L -9 9 M -7 7 L -8 9 M -5 7 L -4 9 M -5 8 L -3 9 M 5 8 L 3 9 M 5 7 L 4 9 M 7 7 L 8 9 M 7 8 L 9 9","-6 6 M -1 -12 L -1 9 M 0 -11 L 0 8 M 1 -12 L 1 9 M -4 -12 L 4 -12 M -4 9 L 4 9 M -3 -12 L -1 -11 M -2 -12 L -1 -10 M 2 -12 L 1 -10 M 3 -12 L 1 -11 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-8 8 M 1 -12 L 1 5 L 0 8 L -1 9 M 2 -11 L 2 5 L 1 8 M 3 -12 L 3 5 L 2 8 L -1 9 L -3 9 L -5 8 L -6 6 L -6 4 L -5 3 L -4 3 L -3 4 L -3 5 L -4 6 L -5 6 M -5 4 L -5 5 L -4 5 L -4 4 L -5 4 M -2 -12 L 6 -12 M -1 -12 L 1 -11 M 0 -12 L 1 -10 M 4 -12 L 3 -10 M 5 -12 L 3 -11","-12 10 M -7 -12 L -7 9 M -6 -11 L -6 8 M -5 -12 L -5 9 M 6 -11 L -5 0 M -2 -2 L 5 9 M -1 -2 L 6 9 M -1 -4 L 7 9 M -10 -12 L -2 -12 M 3 -12 L 9 -12 M -10 9 L -2 9 M 2 9 L 9 9 M -9 -12 L -7 -11 M -8 -12 L -7 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 5 -12 L 6 -11 M 8 -12 L 6 -11 M -7 8 L -9 9 M -7 7 L -8 9 M -5 7 L -4 9 M -5 8 L -3 9 M 5 7 L 3 9 M 5 7 L 8 9","-9 9 M -4 -12 L -4 9 M -3 -11 L -3 8 M -2 -12 L -2 9 M -7 -12 L 1 -12 M -7 9 L 8 9 L 8 3 M -6 -12 L -4 -11 M -5 -12 L -4 -10 M -1 -12 L -2 -10 M 0 -12 L -2 -11 M -4 8 L -6 9 M -4 7 L -5 9 M -2 7 L -1 9 M -2 8 L 0 9 M 3 9 L 8 8 M 5 9 L 8 7 M 6 9 L 8 6 M 7 9 L 8 3","-13 13 M -8 -12 L -8 8 M -8 -12 L -1 9 M -7 -12 L -1 6 M -6 -12 L 0 6 M 6 -12 L -1 9 M 6 -12 L 6 9 M 7 -11 L 7 8 M 8 -12 L 8 9 M -11 -12 L -6 -12 M 6 -12 L 11 -12 M -11 9 L -5 9 M 3 9 L 11 9 M -10 -12 L -8 -11 M 9 -12 L 8 -10 M 10 -12 L 8 -11 M -8 8 L -10 9 M -8 8 L -6 9 M 6 8 L 4 9 M 6 7 L 5 9 M 8 7 L 9 9 M 8 8 L 10 9","-12 12 M -7 -12 L -7 8 M -7 -12 L 7 9 M -6 -12 L 6 6 M -5 -12 L 7 6 M 7 -11 L 7 9 M -10 -12 L -5 -12 M 4 -12 L 10 -12 M -10 9 L -4 9 M -9 -12 L -7 -11 M 5 -12 L 7 -11 M 9 -12 L 7 -11 M -7 8 L -9 9 M -7 8 L -5 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M 5 6 L 6 4 L 7 1 L 7 -4 L 6 -7 L 5 -9 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9 M 1 9 L 3 8 L 5 5 L 6 1 L 6 -4 L 5 -8 L 3 -11 L 1 -12","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 3 -1 L -4 -1 M 6 -10 L 7 -8 L 7 -5 L 6 -3 M 3 -12 L 5 -11 L 6 -9 L 6 -4 L 5 -2 L 3 -1 M -9 9 L -1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M 5 6 L 6 4 L 7 1 L 7 -4 L 6 -7 L 5 -9 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9 M 1 9 L 3 8 L 5 5 L 6 1 L 6 -4 L 5 -8 L 3 -11 L 1 -12 M -4 6 L -3 4 L -1 3 L 0 3 L 2 4 L 3 6 L 4 12 L 5 14 L 7 14 L 8 12 L 8 10 M 4 10 L 5 12 L 6 13 L 7 13 M 3 6 L 5 11 L 6 12 L 7 12 L 8 11","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 L -4 -2 M 6 -10 L 7 -8 L 7 -6 L 6 -4 M 3 -12 L 5 -11 L 6 -9 L 6 -5 L 5 -3 L 3 -2 M 0 -2 L 2 -1 L 3 1 L 5 7 L 6 9 L 8 9 L 9 7 L 9 5 M 5 5 L 6 7 L 7 8 L 8 8 M 2 -1 L 3 0 L 6 6 L 7 7 L 8 7 L 9 6 M -9 9 L -1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-10 10 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 1 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -6 L -6 -4 L -3 -2 L 3 0 L 5 1 L 6 3 L 6 6 L 5 8 M -6 -6 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 2 M -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 3 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -1 9 L -4 8 L -6 6 L -7 3 L -7 9 L -6 6","-10 10 M -8 -12 L -8 -6 M -1 -12 L -1 9 M 0 -11 L 0 8 M 1 -12 L 1 9 M 8 -12 L 8 -6 M -8 -12 L 8 -12 M -4 9 L 4 9 M -7 -12 L -8 -6 M -6 -12 L -8 -9 M -5 -12 L -8 -10 M -3 -12 L -8 -11 M 3 -12 L 8 -11 M 5 -12 L 8 -10 M 6 -12 L 8 -9 M 7 -12 L 8 -6 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-12 12 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -11 M -6 -11 L -6 4 L -5 6 M -5 -12 L -5 4 L -4 7 L -3 8 L -1 9 M -10 -12 L -2 -12 M 4 -12 L 10 -12 M -9 -12 L -7 -11 M -8 -12 L -7 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 5 -12 L 7 -11 M 9 -12 L 7 -11","-10 10 M -7 -12 L 0 9 M -6 -12 L 0 6 L 0 9 M -5 -12 L 1 6 M 7 -11 L 0 9 M -9 -12 L -2 -12 M 3 -12 L 9 -12 M -8 -12 L -6 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 5 -12 L 7 -11 M 8 -12 L 7 -11","-12 12 M -8 -12 L -4 9 M -7 -12 L -4 4 L -4 9 M -6 -12 L -3 4 M 0 -12 L -3 4 L -4 9 M 0 -12 L 4 9 M 1 -12 L 4 4 L 4 9 M 2 -12 L 5 4 M 8 -11 L 5 4 L 4 9 M -11 -12 L -3 -12 M 0 -12 L 2 -12 M 5 -12 L 11 -12 M -10 -12 L -7 -11 M -9 -12 L -7 -10 M -5 -12 L -6 -10 M -4 -12 L -6 -11 M 6 -12 L 8 -11 M 10 -12 L 8 -11","-10 10 M -7 -12 L 5 9 M -6 -12 L 6 9 M -5 -12 L 7 9 M 6 -11 L -6 8 M -9 -12 L -2 -12 M 3 -12 L 9 -12 M -9 9 L -3 9 M 2 9 L 9 9 M -8 -12 L -5 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 4 -12 L 6 -11 M 8 -12 L 6 -11 M -6 8 L -8 9 M -6 8 L -4 9 M 5 8 L 3 9 M 5 7 L 4 9 M 5 7 L 8 9","-11 11 M -8 -12 L -1 -1 L -1 9 M -7 -12 L 0 -1 L 0 8 M -6 -12 L 1 -1 L 1 9 M 7 -11 L 1 -1 M -10 -12 L -3 -12 M 4 -12 L 10 -12 M -4 9 L 4 9 M -9 -12 L -7 -11 M -4 -12 L -6 -11 M 5 -12 L 7 -11 M 9 -12 L 7 -11 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-10 10 M 7 -12 L -7 -12 L -7 -6 M 5 -12 L -7 9 M 6 -12 L -6 9 M 7 -12 L -5 9 M -7 9 L 7 9 L 7 3 M -6 -12 L -7 -6 M -5 -12 L -7 -9 M -4 -12 L -7 -10 M -2 -12 L -7 -11 M 2 9 L 7 8 M 4 9 L 7 7 M 5 9 L 7 6 M 6 9 L 7 3","-12 12 M -9 -11 L -8 -7 L -7 -5 L -5 -3 L -2 -2 L 2 -2 L 5 -3 L 7 -5 L 8 -7 L 9 -11 M -9 -11 L -8 -8 L -7 -6 L -5 -4 L -2 -3 L 2 -3 L 5 -4 L 7 -6 L 8 -8 L 9 -11 M -2 -3 L -4 -2 L -5 -1 L -6 1 L -6 4 L -5 6 L -3 8 L -1 9 L 1 9 L 3 8 L 5 6 L 6 4 L 6 1 L 5 -1 L 4 -2 L 2 -3 M -2 -2 L -4 -1 L -5 1 L -5 4 L -4 7 M 4 7 L 5 4 L 5 1 L 4 -1 L 2 -2","-7 7 M -7 -12 L 7 12","-12 12 M -5 -8 L -5 4 M -4 -7 L -4 3 M 4 -7 L 4 3 M 5 -8 L 5 4 M -9 -11 L -7 -9 L -5 -8 L -2 -7 L 2 -7 L 5 -8 L 7 -9 L 9 -11 M -9 7 L -7 5 L -5 4 L -2 3 L 2 3 L 5 4 L 7 5 L 9 7","-12 12 M 9 -9 L -6 -9 L -8 -8 L -9 -6 L -9 -4 L -8 -2 L -6 -1 L -4 -1 L -2 -2 L -1 -4 L -1 -6 L -2 -8 L 9 -8 M -9 -5 L -8 -3 L -7 -2 L -5 -1 M -1 -5 L -2 -7 L -3 -8 L -5 -9 M -9 6 L 6 6 L 8 5 L 9 3 L 9 1 L 8 -1 L 6 -2 L 4 -2 L 2 -1 L 1 1 L 1 3 L 2 5 L -9 5 M 9 2 L 8 0 L 7 -1 L 5 -2 M 1 2 L 2 4 L 3 5 L 5 6","-12 11 M -3 3 L -5 2 L -6 2 L -8 3 L -9 5 L -9 6 L -8 8 L -6 9 L -5 9 L -3 8 L -2 6 L -2 5 L -3 3 L -8 -2 L -9 -4 L -9 -7 L -8 -9 L -6 -10 L -3 -11 L 1 -11 L 5 -10 L 7 -8 L 8 -6 L 8 -3 L 7 0 L 4 3 L 3 5 L 3 7 L 4 9 L 6 9 L 7 8 L 8 6 M -5 1 L -7 -2 L -8 -4 L -8 -7 L -7 -9 L -6 -10 M 1 -11 L 4 -10 L 6 -8 L 7 -6 L 7 -3 L 6 0 L 4 3","-11 13 M -10 -7 L -7 -10 L -5 -7 L -5 4 M -8 -9 L -6 -6 L -6 4 M -5 -7 L -2 -10 L 0 -7 L 0 3 M -3 -9 L -1 -6 L -1 3 M 0 -7 L 3 -10 L 5 -7 L 5 9 M 2 -9 L 4 -6 L 4 9 M 5 -7 L 8 -10 L 9 -8 L 10 -5 L 10 -2 L 9 1 L 8 3 L 6 5 L 3 7 L -2 9 M 7 -9 L 8 -8 L 9 -5 L 9 -2 L 8 1 L 7 3 L 5 5 L 2 7 L -2 9","-11 11 M 5 -5 L 3 2 L 3 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5 M 6 -5 L 4 2 L 4 8 M 5 -5 L 7 -5 L 5 2 L 4 6 M 3 2 L 3 -1 L 2 -4 L 0 -5 L -2 -5 L -5 -4 L -7 -1 L -8 2 L -8 4 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 2 5 L 3 2 M -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 M -2 -5 L -4 -3 L -5 -1 L -6 2 L -6 5 L -5 8 L -4 9","-9 10 M -2 -12 L -4 -5 L -5 1 L -5 5 L -4 7 L -3 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 2 L 7 0 L 6 -3 L 5 -4 L 3 -5 L 1 -5 L -1 -4 L -2 -3 L -3 -1 L -4 2 M -1 -12 L -3 -5 L -4 -1 L -4 5 L -3 8 M 4 7 L 5 5 L 6 2 L 6 -1 L 5 -3 M -5 -12 L 0 -12 L -2 -5 L -4 2 M 1 9 L 3 7 L 4 5 L 5 2 L 5 -1 L 4 -4 L 3 -5 M -4 -12 L -1 -11 M -3 -12 L -2 -10","-9 9 M 5 -1 L 5 -2 L 4 -2 L 4 0 L 6 0 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 M -3 -3 L -4 -1 L -5 2 L -5 5 L -4 7 M 0 -5 L -2 -3 L -3 -1 L -4 2 L -4 5 L -3 8 L -2 9","-11 11 M 7 -12 L 4 -1 L 3 3 L 3 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5 M 8 -12 L 5 -1 L 4 3 L 4 8 M 4 -12 L 9 -12 L 5 2 L 4 6 M 3 2 L 3 -1 L 2 -4 L 0 -5 L -2 -5 L -5 -4 L -7 -1 L -8 2 L -8 4 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 2 5 L 3 2 M -5 -3 L -6 -1 L -7 2 L -7 5 L -6 7 M -2 -5 L -4 -3 L -5 -1 L -6 2 L -6 5 L -5 8 L -4 9 M 5 -12 L 8 -11 M 6 -12 L 7 -10","-9 9 M -5 4 L -1 3 L 2 2 L 5 0 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 6 M -3 -3 L -4 -1 L -5 2 L -5 5 L -4 7 M 0 -5 L -2 -3 L -3 -1 L -4 2 L -4 5 L -3 8 L -2 9","-8 8 M 8 -10 L 8 -11 L 7 -11 L 7 -9 L 9 -9 L 9 -11 L 8 -12 L 6 -12 L 4 -11 L 2 -9 L 1 -7 L 0 -4 L -1 0 L -3 9 L -4 12 L -5 14 L -7 16 M 2 -8 L 1 -5 L 0 0 L -2 9 L -3 12 M 6 -12 L 4 -10 L 3 -8 L 2 -5 L 1 0 L -1 8 L -2 11 L -3 13 L -5 15 L -7 16 L -9 16 L -10 15 L -10 13 L -8 13 L -8 15 L -9 15 L -9 14 M -4 -5 L 7 -5","-10 11 M 6 -5 L 2 9 L 1 12 L -1 15 L -3 16 M 7 -5 L 3 9 L 1 13 M 6 -5 L 8 -5 L 4 9 L 2 13 L 0 15 L -3 16 L -6 16 L -8 15 L -9 14 L -9 12 L -7 12 L -7 14 L -8 14 L -8 13 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 L 3 5 L 4 2 M -4 -3 L -5 -1 L -6 2 L -6 5 L -5 7 M -1 -5 L -3 -3 L -4 -1 L -5 2 L -5 5 L -4 8 L -3 9","-11 11 M -3 -12 L -9 9 L -7 9 M -2 -12 L -8 9 M -6 -12 L -1 -12 L -7 9 M -5 2 L -3 -2 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -2 L 6 1 L 4 6 M 5 -4 L 5 0 L 4 4 L 4 8 M 5 -2 L 3 3 L 3 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5 M -5 -12 L -2 -11 M -4 -12 L -3 -10","-7 6 M 1 -12 L 1 -10 L 3 -10 L 3 -12 L 1 -12 M 2 -12 L 2 -10 M 1 -11 L 3 -11 M -6 -1 L -5 -3 L -3 -5 L -1 -5 L 0 -4 L 1 -2 L 1 1 L -1 6 M 0 -4 L 0 0 L -1 4 L -1 8 M 0 -2 L -2 3 L -2 6 L -1 8 L 0 9 L 2 9 L 4 7 L 5 5","-7 6 M 3 -12 L 3 -10 L 5 -10 L 5 -12 L 3 -12 M 4 -12 L 4 -10 M 3 -11 L 5 -11 M -5 -1 L -4 -3 L -2 -5 L 0 -5 L 1 -4 L 2 -2 L 2 1 L 0 8 L -1 11 L -2 13 L -4 15 L -6 16 L -8 16 L -9 15 L -9 13 L -7 13 L -7 15 L -8 15 L -8 14 M 1 -4 L 1 1 L -1 8 L -2 11 L -3 13 M 1 -2 L 0 2 L -2 9 L -3 12 L -4 14 L -6 16","-11 11 M -3 -12 L -9 9 L -7 9 M -2 -12 L -8 9 M -6 -12 L -1 -12 L -7 9 M 7 -3 L 7 -4 L 6 -4 L 6 -2 L 8 -2 L 8 -4 L 7 -5 L 5 -5 L 3 -4 L -1 0 L -3 1 M -5 1 L -3 1 L -1 2 L 0 3 L 2 7 L 3 8 L 5 8 M -1 3 L 1 7 L 2 8 M -3 1 L -2 2 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5 M -5 -12 L -2 -11 M -4 -12 L -3 -10","-6 6 M 2 -12 L -1 -1 L -2 3 L -2 6 L -1 8 L 0 9 L 2 9 L 4 7 L 5 5 M 3 -12 L 0 -1 L -1 3 L -1 8 M -1 -12 L 4 -12 L 0 2 L -1 6 M 0 -12 L 3 -11 M 1 -12 L 2 -10","-18 17 M -17 -1 L -16 -3 L -14 -5 L -12 -5 L -11 -4 L -10 -2 L -10 1 L -12 9 M -11 -4 L -11 1 L -13 9 M -11 -2 L -12 2 L -14 9 L -12 9 M -10 1 L -8 -2 L -6 -4 L -4 -5 L -2 -5 L 0 -4 L 1 -2 L 1 1 L -1 9 M 0 -4 L 0 1 L -2 9 M 0 -2 L -1 2 L -3 9 L -1 9 M 1 1 L 3 -2 L 5 -4 L 7 -5 L 9 -5 L 11 -4 L 12 -2 L 12 1 L 10 6 M 11 -4 L 11 0 L 10 4 L 10 8 M 11 -2 L 9 3 L 9 6 L 10 8 L 11 9 L 13 9 L 15 7 L 16 5","-12 12 M -11 -1 L -10 -3 L -8 -5 L -6 -5 L -5 -4 L -4 -2 L -4 1 L -6 9 M -5 -4 L -5 1 L -7 9 M -5 -2 L -6 2 L -8 9 L -6 9 M -4 1 L -2 -2 L 0 -4 L 2 -5 L 4 -5 L 6 -4 L 7 -2 L 7 1 L 5 6 M 6 -4 L 6 0 L 5 4 L 5 8 M 6 -2 L 4 3 L 4 6 L 5 8 L 6 9 L 8 9 L 10 7 L 11 5","-10 10 M -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 4 L -6 7 L -5 8 L -2 9 L 1 9 L 4 8 L 6 5 L 7 2 L 7 0 L 6 -3 L 5 -4 L 2 -5 L -1 -5 M -4 -3 L -5 -1 L -6 2 L -6 5 L -5 7 M 4 7 L 5 5 L 6 2 L 6 -1 L 5 -3 M -1 -5 L -3 -3 L -4 -1 L -5 2 L -5 5 L -4 8 L -2 9 M 1 9 L 3 7 L 4 5 L 5 2 L 5 -1 L 4 -4 L 2 -5","-11 11 M -10 -1 L -9 -3 L -7 -5 L -5 -5 L -4 -4 L -3 -2 L -3 1 L -4 5 L -7 16 M -4 -4 L -4 1 L -5 5 L -8 16 M -4 -2 L -5 2 L -9 16 M -3 2 L -2 -1 L -1 -3 L 0 -4 L 2 -5 L 4 -5 L 6 -4 L 7 -3 L 8 0 L 8 2 L 7 5 L 5 8 L 2 9 L 0 9 L -2 8 L -3 5 L -3 2 M 6 -3 L 7 -1 L 7 2 L 6 5 L 5 7 M 4 -5 L 5 -4 L 6 -1 L 6 2 L 5 5 L 4 7 L 2 9 M -12 16 L -4 16 M -8 15 L -11 16 M -8 14 L -10 16 M -7 14 L -6 16 M -8 15 L -5 16","-11 10 M 5 -5 L -1 16 M 6 -5 L 0 16 M 5 -5 L 7 -5 L 1 16 M 3 2 L 3 -1 L 2 -4 L 0 -5 L -2 -5 L -5 -4 L -7 -1 L -8 2 L -8 4 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 2 5 L 3 2 M -5 -3 L -6 -1 L -7 2 L -7 5 L -6 7 M -2 -5 L -4 -3 L -5 -1 L -6 2 L -6 5 L -5 8 L -4 9 M -4 16 L 4 16 M 0 15 L -3 16 M 0 14 L -2 16 M 1 14 L 2 16 M 0 15 L 3 16","-9 9 M -8 -1 L -7 -3 L -5 -5 L -3 -5 L -2 -4 L -1 -2 L -1 2 L -3 9 M -2 -4 L -2 2 L -4 9 M -2 -2 L -3 2 L -5 9 L -3 9 M 7 -3 L 7 -4 L 6 -4 L 6 -2 L 8 -2 L 8 -4 L 7 -5 L 5 -5 L 3 -4 L 1 -2 L -1 2","-8 9 M 6 -2 L 6 -3 L 5 -3 L 5 -1 L 7 -1 L 7 -3 L 6 -4 L 3 -5 L 0 -5 L -3 -4 L -4 -3 L -4 -1 L -3 1 L -1 2 L 2 3 L 4 4 L 5 6 M -3 -4 L -4 -1 M -3 0 L -1 1 L 2 2 L 4 3 M 5 4 L 4 8 M -4 -3 L -3 -1 L -1 0 L 2 1 L 4 2 L 5 4 L 5 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -6 5 L -4 5 L -4 7 L -5 7 L -5 6","-7 7 M 2 -12 L -1 -1 L -2 3 L -2 6 L -1 8 L 0 9 L 2 9 L 4 7 L 5 5 M 3 -12 L 0 -1 L -1 3 L -1 8 M 2 -12 L 4 -12 L 0 2 L -1 6 M -4 -5 L 6 -5","-12 12 M -11 -1 L -10 -3 L -8 -5 L -6 -5 L -5 -4 L -4 -2 L -4 1 L -6 6 M -5 -4 L -5 0 L -6 4 L -6 8 M -5 -2 L -7 3 L -7 6 L -6 8 L -4 9 L -2 9 L 0 8 L 2 6 L 4 3 M 6 -5 L 4 3 L 4 6 L 5 8 L 6 9 L 8 9 L 10 7 L 11 5 M 7 -5 L 5 3 L 5 8 M 6 -5 L 8 -5 L 6 2 L 5 6","-10 10 M -9 -1 L -8 -3 L -6 -5 L -4 -5 L -3 -4 L -2 -2 L -2 1 L -4 6 M -3 -4 L -3 0 L -4 4 L -4 8 M -3 -2 L -5 3 L -5 6 L -4 8 L -2 9 L 0 9 L 2 8 L 4 6 L 6 3 L 7 -1 L 7 -5 L 6 -5 L 6 -4 L 7 -2","-15 15 M -14 -1 L -13 -3 L -11 -5 L -9 -5 L -8 -4 L -7 -2 L -7 1 L -9 6 M -8 -4 L -8 0 L -9 4 L -9 8 M -8 -2 L -10 3 L -10 6 L -9 8 L -7 9 L -5 9 L -3 8 L -1 6 L 0 3 M 2 -5 L 0 3 L 0 6 L 1 8 L 3 9 L 5 9 L 7 8 L 9 6 L 11 3 L 12 -1 L 12 -5 L 11 -5 L 11 -4 L 12 -2 M 3 -5 L 1 3 L 1 8 M 2 -5 L 4 -5 L 2 2 L 1 6","-11 11 M -8 -1 L -6 -4 L -4 -5 L -2 -5 L 0 -4 L 1 -2 L 1 0 M -2 -5 L -1 -4 L -1 0 L -2 4 L -3 6 L -5 8 L -7 9 L -9 9 L -10 8 L -10 6 L -8 6 L -8 8 L -9 8 L -9 7 M 0 -3 L 0 0 L -1 4 L -1 7 M 8 -3 L 8 -4 L 7 -4 L 7 -2 L 9 -2 L 9 -4 L 8 -5 L 6 -5 L 4 -4 L 2 -2 L 1 0 L 0 4 L 0 8 L 1 9 M -2 4 L -2 6 L -1 8 L 1 9 L 3 9 L 5 8 L 7 5","-11 11 M -10 -1 L -9 -3 L -7 -5 L -5 -5 L -4 -4 L -3 -2 L -3 1 L -5 6 M -4 -4 L -4 0 L -5 4 L -5 8 M -4 -2 L -6 3 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 3 6 L 5 2 M 7 -5 L 3 9 L 2 12 L 0 15 L -2 16 M 8 -5 L 4 9 L 2 13 M 7 -5 L 9 -5 L 5 9 L 3 13 L 1 15 L -2 16 L -5 16 L -7 15 L -8 14 L -8 12 L -6 12 L -6 14 L -7 14 L -7 13","-10 10 M 7 -5 L 6 -3 L 4 -1 L -4 5 L -6 7 L -7 9 M 6 -3 L -3 -3 L -5 -2 L -6 0 M 4 -3 L 0 -4 L -3 -4 L -4 -3 M 4 -3 L 0 -5 L -3 -5 L -5 -3 L -6 0 M -6 7 L 3 7 L 5 6 L 6 4 M -4 7 L 0 8 L 3 8 L 4 7 M -4 7 L 0 9 L 3 9 L 5 7 L 6 4","-12 13 M -11 -6 L -8 -9 L -5 -6 L -5 6 M -9 -8 L -6 -5 L -6 6 M -5 -6 L -2 -9 L 1 -6 L 1 6 M -3 -8 L 0 -5 L 0 6 M 1 -6 L 4 -9 L 7 -6 L 7 5 L 9 7 M 3 -8 L 6 -5 L 6 6 L 8 8 L 11 5","-11 11 M 8 -9 L -8 7 M 8 -9 L 5 -8 L -1 -8 M 6 -7 L 3 -7 L -1 -8 M 8 -9 L 7 -6 L 7 0 M 6 -7 L 6 -4 L 7 0 M -1 0 L -8 0 M -2 1 L -5 1 L -8 0 M -1 0 L -1 7 M -2 1 L -2 4 L -1 7","-12 12 M -10 -3 L -8 -7 L -3 3 M -8 -5 L -3 5 L 0 -2 L 5 -2 L 8 -3 L 9 -5 L 9 -7 L 8 -9 L 6 -10 L 5 -10 L 3 -9 L 2 -7 L 2 -5 L 3 -2 L 4 0 L 5 3 L 5 6 L 3 8 M 5 -10 L 4 -9 L 3 -7 L 3 -5 L 5 -1 L 6 2 L 6 5 L 5 7 L 3 8","-12 12 M -9 -3 L -6 -6 L -2 -4 M -7 -5 L -3 -3 L 0 -6 L 3 -4 M -1 -5 L 2 -3 L 5 -6 L 7 -4 M 4 -5 L 6 -3 L 9 -6 M -9 3 L -6 0 L -2 2 M -7 1 L -3 3 L 0 0 L 3 2 M -1 1 L 2 3 L 5 0 L 7 2 M 4 1 L 6 3 L 9 0","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3"]
cursive = ["-8 8","-5 5 M 0 -12 L 0 2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-8 8 M -4 -12 L -4 -5 M 4 -12 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -6 9 L -8 8 L -9 7 L -10 5 L -10 3 L -9 1 L -8 0 L -1 -4 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 7 9 L 9 9 L 10 8 L 10 7","-2 2 M 0 -5 L 0 -1","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L 0 -4 L 3 -4 L 5 -3 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 3 -12 L -7 2 L 8 2 M 3 -12 L 3 9","-10 10 M 5 -12 L -5 -12 L -6 -3 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2","-10 10 M 7 -12 L -3 9 M -7 -12 L 7 -12","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 1 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -1 -3 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-11 9 M -11 9 L -9 8 L -6 5 L -3 1 L 1 -6 L 4 -12 L 4 9 L 3 6 L 1 3 L -1 1 L -4 -1 L -6 -1 L -7 0 L -7 2 L -6 4 L -4 6 L -1 8 L 2 9 L 7 9","-12 11 M 1 -10 L 2 -9 L 2 -6 L 1 -2 L 0 1 L -1 3 L -3 6 L -5 8 L -7 9 L -8 9 L -9 8 L -9 5 L -8 0 L -7 -3 L -6 -5 L -4 -8 L -2 -10 L 0 -11 L 3 -12 L 6 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 5 -3 L 2 -2 M 1 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9 L 0 9 L -2 8 L -3 6","-10 10 M 2 -6 L 2 -5 L 3 -4 L 5 -4 L 7 -5 L 8 -7 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -4 L -7 0 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 5 4","-11 12 M 2 -12 L 0 -11 L -1 -9 L -2 -5 L -3 1 L -4 4 L -5 6 L -7 8 L -9 9 L -11 9 L -12 8 L -12 6 L -11 5 L -9 5 L -7 6 L -5 8 L -2 9 L 1 9 L 4 8 L 6 6 L 8 2 L 9 -3 L 9 -7 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L 0 -10 L 0 -8 L 1 -5 L 3 -2 L 5 0 L 8 2 L 10 3","-10 10 M 4 -8 L 4 -7 L 5 -6 L 7 -6 L 8 -7 L 8 -9 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -4 -9 L -4 -6 L -3 -4 L -2 -3 L 1 -2 L -2 -2 L -5 -1 L -6 0 L -7 2 L -7 5 L -6 7 L -5 8 L -2 9 L 1 9 L 4 8 L 6 6 L 7 4","-10 10 M 0 -6 L -2 -6 L -4 -7 L -5 -9 L -4 -11 L -1 -12 L 2 -12 L 6 -11 L 9 -11 L 11 -12 M 6 -11 L 4 -4 L 2 2 L 0 6 L -2 8 L -4 9 L -6 9 L -8 8 L -9 6 L -9 4 L -8 3 L -6 3 L -4 4 M -1 -2 L 8 -2","-11 12 M -11 9 L -9 8 L -5 4 L -2 -1 L -1 -4 L 0 -8 L 0 -11 L -1 -12 L -2 -12 L -3 -11 L -4 -9 L -4 -6 L -3 -4 L -1 -3 L 3 -3 L 6 -4 L 7 -5 L 8 -7 L 8 -1 L 7 4 L 6 6 L 4 8 L 1 9 L -3 9 L -6 8 L -8 6 L -9 4 L -9 2","-12 12 M -5 -5 L -7 -6 L -8 -8 L -8 -9 L -7 -11 L -5 -12 L -4 -12 L -2 -11 L -1 -9 L -1 -7 L -2 -3 L -4 3 L -6 7 L -8 9 L -10 9 L -11 8 L -11 6 M -5 0 L 4 -3 L 6 -4 L 9 -6 L 11 -8 L 12 -10 L 12 -11 L 11 -12 L 10 -12 L 8 -10 L 6 -6 L 4 0 L 3 5 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-9 8 M 5 4 L 3 2 L 1 -1 L 0 -3 L -1 -6 L -1 -9 L 0 -11 L 1 -12 L 3 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -1 L 2 4 L 1 6 L -1 8 L -3 9 L -5 9 L -7 8 L -8 6 L -8 4 L -7 3 L -5 3 L -3 4","-8 7 M 2 12 L 0 9 L -2 4 L -3 -2 L -3 -8 L -2 -11 L 0 -12 L 2 -12 L 3 -11 L 4 -8 L 4 -5 L 3 0 L 0 9 L -2 15 L -3 18 L -4 20 L -6 21 L -7 20 L -7 18 L -6 15 L -4 12 L -2 10 L 1 8 L 5 6","-12 12 M -5 -5 L -7 -6 L -8 -8 L -8 -9 L -7 -11 L -5 -12 L -4 -12 L -2 -11 L -1 -9 L -1 -7 L -2 -3 L -4 3 L -6 7 L -8 9 L -10 9 L -11 8 L -11 6 M 12 -9 L 12 -11 L 11 -12 L 10 -12 L 8 -11 L 6 -9 L 4 -6 L 2 -4 L 0 -3 L -2 -3 M 0 -3 L 1 -1 L 1 6 L 2 8 L 3 9 L 4 9 L 6 8 L 7 7 L 9 4","-9 10 M -5 0 L -3 0 L 1 -1 L 4 -3 L 6 -5 L 7 -7 L 7 -10 L 6 -12 L 4 -12 L 3 -11 L 2 -9 L 1 -4 L 0 1 L -1 4 L -2 6 L -4 8 L -6 9 L -8 9 L -9 8 L -9 6 L -8 5 L -6 5 L -4 6 L -1 8 L 2 9 L 4 9 L 7 8 L 9 6","-18 15 M -13 -5 L -15 -6 L -16 -8 L -16 -9 L -15 -11 L -13 -12 L -12 -12 L -10 -11 L -9 -9 L -9 -7 L -10 -2 L -11 2 L -13 9 M -11 2 L -8 -6 L -6 -10 L -5 -11 L -3 -12 L -2 -12 L 0 -11 L 1 -9 L 1 -7 L 0 -2 L -1 2 L -3 9 M -1 2 L 2 -6 L 4 -10 L 5 -11 L 7 -12 L 8 -12 L 10 -11 L 11 -9 L 11 -7 L 10 -2 L 8 5 L 8 8 L 9 9 L 10 9 L 12 8 L 13 7 L 15 4","-13 11 M -8 -5 L -10 -6 L -11 -8 L -11 -9 L -10 -11 L -8 -12 L -7 -12 L -5 -11 L -4 -9 L -4 -7 L -5 -2 L -6 2 L -8 9 M -6 2 L -3 -6 L -1 -10 L 0 -11 L 2 -12 L 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -2 L 4 5 L 4 8 L 5 9 L 6 9 L 8 8 L 9 7 L 11 4","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -4 L -7 0 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 1 L 8 -3 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 L 0 -10 L 0 -7 L 1 -4 L 3 -1 L 5 1 L 8 3 L 10 4","-12 13 M 1 -10 L 2 -9 L 2 -6 L 1 -2 L 0 1 L -1 3 L -3 6 L -5 8 L -7 9 L -8 9 L -9 8 L -9 5 L -8 0 L -7 -3 L -6 -5 L -4 -8 L -2 -10 L 0 -11 L 3 -12 L 8 -12 L 10 -11 L 11 -10 L 12 -8 L 12 -5 L 11 -3 L 10 -2 L 8 -1 L 5 -1 L 3 -2 L 2 -3","-10 12 M 3 -6 L 2 -4 L 1 -3 L -1 -2 L -3 -2 L -4 -4 L -4 -6 L -3 -9 L -1 -11 L 2 -12 L 5 -12 L 7 -11 L 8 -9 L 8 -5 L 7 -2 L 5 1 L 1 5 L -2 7 L -4 8 L -7 9 L -9 9 L -10 8 L -10 6 L -9 5 L -7 5 L -5 6 L -2 8 L 1 9 L 4 9 L 7 8 L 9 6","-12 13 M 1 -10 L 2 -9 L 2 -6 L 1 -2 L 0 1 L -1 3 L -3 6 L -5 8 L -7 9 L -8 9 L -9 8 L -9 5 L -8 0 L -7 -3 L -6 -5 L -4 -8 L -2 -10 L 0 -11 L 3 -12 L 7 -12 L 9 -11 L 10 -10 L 11 -8 L 11 -5 L 10 -3 L 9 -2 L 7 -1 L 4 -1 L 1 -2 L 2 -1 L 3 1 L 3 6 L 4 8 L 6 9 L 8 8 L 9 7 L 11 4","-10 10 M -10 9 L -8 8 L -6 6 L -3 2 L -1 -1 L 1 -5 L 2 -8 L 2 -11 L 1 -12 L 0 -12 L -1 -11 L -2 -9 L -2 -7 L -1 -5 L 1 -3 L 4 -1 L 6 1 L 7 3 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6 L -8 4 L -8 2","-10 9 M 0 -6 L -2 -6 L -4 -7 L -5 -9 L -4 -11 L -1 -12 L 2 -12 L 6 -11 L 9 -11 L 11 -12 M 6 -11 L 4 -4 L 2 2 L 0 6 L -2 8 L -4 9 L -6 9 L -8 8 L -9 6 L -9 4 L -8 3 L -6 3 L -4 4","-13 11 M -8 -5 L -10 -6 L -11 -8 L -11 -9 L -10 -11 L -8 -12 L -7 -12 L -5 -11 L -4 -9 L -4 -7 L -5 -3 L -6 0 L -7 4 L -7 6 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 3 3 L 6 -5 L 8 -12 M 6 -5 L 5 -1 L 4 5 L 4 8 L 5 9 L 6 9 L 8 8 L 9 7 L 11 4","-12 11 M -7 -5 L -9 -6 L -10 -8 L -10 -9 L -9 -11 L -7 -12 L -6 -12 L -4 -11 L -3 -9 L -3 -7 L -4 -3 L -5 0 L -6 4 L -6 7 L -5 9 L -3 9 L -1 8 L 2 5 L 4 2 L 6 -2 L 7 -5 L 8 -9 L 8 -11 L 7 -12 L 6 -12 L 5 -11 L 4 -9 L 4 -7 L 5 -4 L 7 -2 L 9 -1","-15 13 M -10 -5 L -12 -6 L -13 -8 L -13 -9 L -12 -11 L -10 -12 L -9 -12 L -7 -11 L -6 -9 L -6 -6 L -7 9 M 3 -12 L -7 9 M 3 -12 L 1 9 M 15 -12 L 13 -11 L 10 -8 L 7 -4 L 4 2 L 1 9","-12 12 M -4 -6 L -6 -6 L -7 -7 L -7 -9 L -6 -11 L -4 -12 L -2 -12 L 0 -11 L 1 -9 L 1 -6 L -1 3 L -1 6 L 0 8 L 2 9 L 4 9 L 6 8 L 7 6 L 7 4 L 6 3 L 4 3 M 11 -9 L 11 -11 L 10 -12 L 8 -12 L 6 -11 L 4 -9 L 2 -6 L -2 3 L -4 6 L -6 8 L -8 9 L -10 9 L -11 8 L -11 6","-12 11 M -7 -5 L -9 -6 L -10 -8 L -10 -9 L -9 -11 L -7 -12 L -6 -12 L -4 -11 L -3 -9 L -3 -7 L -4 -3 L -5 0 L -6 4 L -6 6 L -5 8 L -4 9 L -2 9 L 0 8 L 2 6 L 4 3 L 5 1 L 7 -5 M 9 -12 L 7 -5 L 4 5 L 2 11 L 0 16 L -2 20 L -4 21 L -5 20 L -5 18 L -4 15 L -2 12 L 1 9 L 4 7 L 9 4","-10 11 M 3 -6 L 2 -4 L 1 -3 L -1 -2 L -3 -2 L -4 -4 L -4 -6 L -3 -9 L -1 -11 L 2 -12 L 5 -12 L 7 -11 L 8 -9 L 8 -5 L 7 -2 L 5 2 L 2 5 L -2 8 L -4 9 L -7 9 L -8 8 L -8 6 L -7 5 L -4 5 L -2 6 L -1 7 L 0 9 L 0 12 L -1 15 L -2 17 L -4 20 L -6 21 L -7 20 L -7 18 L -6 15 L -4 12 L -1 9 L 2 7 L 8 4","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-8 8 M 0 -14 L -8 0 M 0 -14 L 8 0","-11 9 M -11 16 L 9 16","-4 4 M 1 -7 L -1 -5 L -1 -3 L 0 -2 L 1 -3 L 0 -4 L -1 -3","-6 10 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 L 4 0 L 3 5 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-5 9 M -5 4 L -3 1 L 0 -4 L 1 -6 L 2 -9 L 2 -11 L 1 -12 L -1 -11 L -2 -9 L -3 -5 L -4 2 L -4 8 L -3 9 L -2 9 L 0 8 L 2 6 L 3 3 L 3 0 L 4 4 L 5 5 L 7 5 L 9 4","-5 6 M 2 2 L 2 1 L 1 0 L -1 0 L -3 1 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9 L 1 9 L 4 7 L 6 4","-6 10 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 L 8 -12 M 4 0 L 3 5 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-4 6 M -3 7 L -1 6 L 0 5 L 1 3 L 1 1 L 0 0 L -1 0 L -3 1 L -4 3 L -4 6 L -3 8 L -1 9 L 1 9 L 3 8 L 4 7 L 6 4","-3 5 M -3 4 L 1 -1 L 3 -4 L 4 -6 L 5 -9 L 5 -11 L 4 -12 L 2 -11 L 1 -9 L -1 -1 L -4 8 L -7 15 L -8 18 L -8 20 L -7 21 L -5 20 L -4 17 L -3 8 L -2 9 L 0 9 L 2 8 L 3 7 L 5 4","-6 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 M 4 0 L 2 7 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -2 12 L 1 10 L 3 9 L 6 7 L 9 4","-5 10 M -5 4 L -3 1 L 0 -4 L 1 -6 L 2 -9 L 2 -11 L 1 -12 L -1 -11 L -2 -9 L -3 -5 L -4 1 L -5 9 M -5 9 L -4 6 L -3 4 L -1 1 L 1 0 L 3 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-2 5 M 1 -5 L 1 -4 L 2 -4 L 2 -5 L 1 -5 M -2 4 L 0 0 L -2 6 L -2 8 L -1 9 L 0 9 L 2 8 L 3 7 L 5 4","-2 5 M 1 -5 L 1 -4 L 2 -4 L 2 -5 L 1 -5 M -2 4 L 0 0 L -6 18 L -7 20 L -9 21 L -10 20 L -10 18 L -9 15 L -6 12 L -3 10 L -1 9 L 2 7 L 5 4","-5 9 M -5 4 L -3 1 L 0 -4 L 1 -6 L 2 -9 L 2 -11 L 1 -12 L -1 -11 L -2 -9 L -3 -5 L -4 1 L -5 9 M -5 9 L -4 6 L -3 4 L -1 1 L 1 0 L 3 0 L 4 1 L 4 3 L 2 4 L -1 4 M -1 4 L 1 5 L 2 8 L 3 9 L 4 9 L 6 8 L 7 7 L 9 4","-3 5 M -3 4 L -1 1 L 2 -4 L 3 -6 L 4 -9 L 4 -11 L 3 -12 L 1 -11 L 0 -9 L -1 -5 L -2 2 L -2 8 L -1 9 L 0 9 L 2 8 L 3 7 L 5 4","-13 12 M -13 4 L -11 1 L -9 0 L -8 1 L -8 2 L -9 6 L -10 9 M -9 6 L -8 4 L -6 1 L -4 0 L -2 0 L -1 1 L -1 2 L -2 6 L -3 9 M -2 6 L -1 4 L 1 1 L 3 0 L 5 0 L 6 1 L 6 3 L 5 6 L 5 8 L 6 9 L 7 9 L 9 8 L 10 7 L 12 4","-8 10 M -8 4 L -6 1 L -4 0 L -3 1 L -3 2 L -4 6 L -5 9 M -4 6 L -3 4 L -1 1 L 1 0 L 3 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-6 8 M 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 L 3 5 L 3 3 L 2 1 L 0 0 L -1 1 L -1 3 L 0 5 L 2 6 L 5 6 L 7 5 L 8 4","-7 8 M -7 4 L -5 1 L -4 -1 L -5 3 L -11 21 M -5 3 L -4 1 L -2 0 L 0 0 L 2 1 L 3 3 L 3 5 L 2 7 L 1 8 L -1 9 M -5 8 L -3 9 L 0 9 L 3 8 L 5 7 L 8 4","-6 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 M 4 0 L 3 3 L 1 8 L -2 15 L -3 18 L -3 20 L -2 21 L 0 20 L 1 17 L 1 10 L 3 9 L 6 7 L 9 4","-5 8 M -5 4 L -3 1 L -2 -1 L -2 1 L 1 1 L 2 2 L 2 4 L 1 7 L 1 8 L 2 9 L 3 9 L 5 8 L 6 7 L 8 4","-4 7 M -4 4 L -2 1 L -1 -1 L -1 1 L 1 4 L 2 6 L 2 8 L 0 9 M -4 8 L -2 9 L 2 9 L 4 8 L 5 7 L 7 4","-3 6 M -3 4 L -1 1 L 1 -3 M 4 -12 L -2 6 L -2 8 L -1 9 L 1 9 L 3 8 L 4 7 L 6 4 M -2 -4 L 5 -4","-6 9 M -6 4 L -4 0 L -6 6 L -6 8 L -5 9 L -3 9 L -1 8 L 1 6 L 3 3 M 4 0 L 2 6 L 2 8 L 3 9 L 4 9 L 6 8 L 7 7 L 9 4","-6 9 M -6 4 L -4 0 L -5 5 L -5 8 L -4 9 L -3 9 L 0 8 L 2 6 L 3 3 L 3 0 M 3 0 L 4 4 L 5 5 L 7 5 L 9 4","-9 12 M -6 0 L -8 2 L -9 5 L -9 7 L -8 9 L -6 9 L -4 8 L -2 6 M 0 0 L -2 6 L -2 8 L -1 9 L 1 9 L 3 8 L 5 6 L 6 3 L 6 0 M 6 0 L 7 4 L 8 5 L 10 5 L 12 4","-8 8 M -8 4 L -6 1 L -4 0 L -2 0 L -1 1 L -1 8 L 0 9 L 3 9 L 6 7 L 8 4 M 5 1 L 4 0 L 2 0 L 1 1 L -3 8 L -4 9 L -6 9 L -7 8","-6 9 M -6 4 L -4 0 L -6 6 L -6 8 L -5 9 L -3 9 L -1 8 L 1 6 L 3 3 M 4 0 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -2 12 L 1 10 L 3 9 L 6 7 L 9 4","-6 8 M -6 4 L -4 1 L -2 0 L 0 0 L 2 2 L 2 4 L 1 6 L -1 8 L -4 9 L -2 10 L -1 12 L -1 15 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -2 12 L 1 10 L 5 7 L 8 4","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
cyrillic = ["-8 8","-5 5 M 0 -12 L -1 -10 L 0 2 L 1 -10 L 0 -12 M 0 -10 L 0 -4 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-8 8 M -4 -12 L -5 -5 M -3 -12 L -5 -5 M 4 -12 L 3 -5 M 5 -12 L 3 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-15 15 M -10 -12 L -10 9 M -9 -12 L -9 9 M -13 -12 L -6 -12 M -9 -2 L -2 -2 L 1 -1 L 2 0 L 3 2 L 3 5 L 2 7 L 1 8 L -2 9 L -13 9 M -2 -2 L 0 -1 L 1 0 L 2 2 L 2 5 L 1 7 L 0 8 L -2 9 M 9 -12 L 9 9 M 10 -12 L 10 9 M 6 -12 L 13 -12 M 6 9 L 13 9","-11 11 M -6 -5 L -6 9 M -5 -5 L -5 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L -2 -5 M 2 -5 L 9 -5 M -9 9 L 9 9 L 9 14 L 8 9","-13 13 M -8 -5 L -8 9 M -7 -5 L -7 9 M -11 -5 L -4 -5 M -7 2 L -3 2 L 0 3 L 1 5 L 1 6 L 0 8 L -3 9 L -11 9 M -3 2 L -1 3 L 0 5 L 0 6 L -1 8 L -3 9 M 7 -5 L 7 9 M 8 -5 L 8 9 M 4 -5 L 11 -5 M 4 9 L 11 9","-4 4 M 0 -12 L -1 -5 M 1 -12 L -1 -5","-7 7 M 3 -16 L 1 -14 L -1 -11 L -3 -7 L -4 -2 L -4 2 L -3 7 L -1 11 L 1 14 L 3 16 L 4 16 M 3 -16 L 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 L -3 16 M -4 -16 L -3 -16 L -1 -14 L 1 -11 L 3 -7 L 4 -2 L 4 2 L 3 7 L 1 11 L -1 14 L -3 16","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -4 -10 L -5 -8 L -6 -3 L -6 0 L -5 5 L -4 7 L -3 8 L -1 9 M 1 9 L 3 8 L 4 7 L 5 5 L 6 0 L 6 -3 L 5 -8 L 4 -10 L 3 -11 L 1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9 M 0 -11 L 0 9 M -4 9 L 5 9","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 3 -2 L -2 0 L -4 1 L -6 3 L -7 6 L -7 9 M 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 2 -2 L -2 0 M -7 7 L -6 6 L -4 6 L 1 8 L 4 8 L 6 7 L 7 6 M -4 6 L 1 9 L 5 9 L 6 8 L 7 6 L 7 4","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -9 L 6 -6 L 5 -4 L 2 -3 L -1 -3 M 2 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -4 L 2 -3 M 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 5 -1 L 6 2 L 6 5 L 5 7 L 4 8 L 2 9","-10 10 M 2 -10 L 2 9 M 3 -12 L 3 9 M 3 -12 L -8 3 L 8 3 M -1 9 L 6 9","-10 10 M -5 -12 L -7 -2 M -7 -2 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -5 -12 L 5 -12 M -5 -11 L 0 -11 L 5 -12","-10 10 M 5 -9 L 4 -8 L 5 -7 L 6 -8 L 6 -9 L 5 -11 L 3 -12 L 0 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2 M 0 -12 L -2 -11 L -4 -9 L -5 -7 L -6 -3 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 2 L 5 -1 L 3 -3 L 1 -4","-10 10 M -7 -12 L -7 -6 M -7 -8 L -6 -10 L -4 -12 L -2 -12 L 3 -9 L 5 -9 L 6 -10 L 7 -12 M -6 -10 L -4 -11 L -2 -11 L 3 -9 M 7 -12 L 7 -9 L 6 -6 L 2 -1 L 1 1 L 0 4 L 0 9 M 6 -6 L 1 -1 L 0 1 L -1 4 L -1 9","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -6 L -5 -4 L -2 -3 L 2 -3 L 5 -4 L 6 -6 L 6 -9 L 5 -11 L 2 -12 L -2 -12 M -2 -12 L -4 -11 L -5 -9 L -5 -6 L -4 -4 L -2 -3 M 2 -3 L 4 -4 L 5 -6 L 5 -9 L 4 -11 L 2 -12 M -2 -3 L -5 -2 L -6 -1 L -7 1 L -7 5 L -6 7 L -5 8 L -2 9 L 2 9 L 5 8 L 6 7 L 7 5 L 7 1 L 6 -1 L 5 -2 L 2 -3 M -2 -3 L -4 -2 L -5 -1 L -6 1 L -6 5 L -5 7 L -4 8 L -2 9 M 2 9 L 4 8 L 5 7 L 6 5 L 6 1 L 5 -1 L 4 -2 L 2 -3","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -6 L 7 0 L 6 4 L 5 6 L 3 8 L 0 9 L -3 9 L -5 8 L -6 6 L -6 5 L -5 4 L -4 5 L -5 6 M -1 1 L -3 0 L -5 -2 L -6 -5 L -6 -6 L -5 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 5 -9 L 6 -6 L 6 0 L 5 4 L 4 6 L 2 8 L 0 9","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -5 -8 L -4 -7 L -5 -6 L -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 1 -12 L 3 -11 L 4 -10 L 5 -8 L 5 -6 L 4 -4 L 2 -2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 0 -12 L -7 9 M 0 -12 L 7 9 M 0 -9 L 6 9 M -5 3 L 4 3 M -9 9 L -3 9 M 3 9 L 9 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 7 -12 L 7 -6 L 6 -12 M -5 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -9 9 M 3 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9","-10 11 M -6 -9 L -7 -12 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 1 -12 L 3 -11 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 3 8 L 1 9 M -2 -2 L 7 -2","-12 12 M -4 -12 L -4 -6 L -5 2 L -6 6 L -7 8 L -8 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -7 -12 L 10 -12 M -11 9 L 10 9 M -11 9 L -11 16 M -10 9 L -11 16 M 9 9 L 10 16 M 10 9 L 10 16","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L -3 -12 M 3 -12 L 10 -12 M 6 -10 L -6 7 M -10 9 L -3 9 M 3 9 L 10 9","-12 13 M 0 -12 L 0 9 M 1 -12 L 1 9 M -3 -12 L 4 -12 M -2 -9 L -6 -8 L -8 -6 L -9 -3 L -9 0 L -8 3 L -6 5 L -2 6 L 3 6 L 7 5 L 9 3 L 10 0 L 10 -3 L 9 -6 L 7 -8 L 3 -9 L -2 -9 M -2 -9 L -5 -8 L -7 -6 L -8 -3 L -8 0 L -7 3 L -5 5 L -2 6 M 3 6 L 6 5 L 8 3 L 9 0 L 9 -3 L 8 -6 L 6 -8 L 3 -9 M -3 9 L 4 9","-9 9 M -4 -12 L -4 9 M -3 -12 L -3 9 M -7 -12 L 8 -12 L 8 -6 L 7 -12 M -7 9 L 0 9","-15 16 M 0 -12 L 0 9 M 1 -12 L 1 9 M -3 -12 L 4 -12 M -11 -11 L -10 -10 L -11 -9 L -12 -10 L -12 -11 L -11 -12 L -10 -12 L -9 -11 L -8 -9 L -7 -5 L -6 -3 L -4 -2 L 5 -2 L 7 -3 L 8 -5 L 9 -9 L 10 -11 L 11 -12 L 12 -12 L 13 -11 L 13 -10 L 12 -9 L 11 -10 L 12 -11 M -4 -2 L -6 -1 L -7 1 L -8 6 L -9 8 L -10 9 M -4 -2 L -5 -1 L -6 1 L -7 6 L -8 8 L -9 9 L -11 9 L -12 8 L -13 6 M 5 -2 L 7 -1 L 8 1 L 9 6 L 10 8 L 11 9 M 5 -2 L 6 -1 L 7 1 L 8 6 L 9 8 L 10 9 L 12 9 L 13 8 L 14 6 M -3 9 L 4 9","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L -3 -12 M 3 -12 L 10 -12 M 6 -10 L -6 7 M -10 9 L -3 9 M 3 9 L 10 9","-12 11 M -7 -12 L -7 -1 L -6 1 L -3 2 L 0 2 L 3 1 L 5 -1 M -6 -12 L -6 -1 L -5 1 L -3 2 M 5 -12 L 5 9 M 6 -12 L 6 9 M -10 -12 L -3 -12 M 2 -12 L 9 -12 M 2 9 L 9 9","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M -10 -12 L -3 -12 M -6 -2 L 1 -2 L 3 -3 L 4 -5 L 5 -9 L 6 -11 L 7 -12 L 8 -12 L 9 -11 L 9 -10 L 8 -9 L 7 -10 L 8 -11 M 1 -2 L 3 -1 L 4 1 L 5 6 L 6 8 L 7 9 M 1 -2 L 2 -1 L 3 1 L 4 6 L 5 8 L 6 9 L 8 9 L 9 8 L 10 6 M -10 9 L -3 9","-13 12 M -5 -12 L -5 -6 L -6 2 L -7 6 L -8 8 L -9 9 L -10 9 L -11 8 L -11 7 L -10 6 L -9 7 L -10 8 M 6 -12 L 6 9 M 7 -12 L 7 9 M -8 -12 L 10 -12 M 3 9 L 10 9","-12 13 M -7 -12 L -7 9 M -6 -12 L 0 6 M -7 -12 L 0 9 M 7 -12 L 0 9 M 7 -12 L 7 9 M 8 -12 L 8 9 M -10 -12 L -6 -12 M 7 -12 L 11 -12 M -10 9 L -4 9 M 4 9 L 11 9","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L -3 -12 M 3 -12 L 10 -12 M -6 -2 L 6 -2 M -10 9 L -3 9 M 3 9 L 10 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 0 L -6 4 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 4 L 7 0 L 7 -3 L 6 -7 L 5 -9 L 3 -11 L 1 -12","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L 10 -12 M -10 9 L -3 9 M 3 9 L 10 9","-16 17 M -11 -12 L -11 9 M -10 -12 L -10 9 M 0 -12 L 0 9 M 1 -12 L 1 9 M 11 -12 L 11 9 M 12 -12 L 12 9 M -14 -12 L -7 -12 M -3 -12 L 4 -12 M 8 -12 L 15 -12 M -14 9 L 15 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 3 -1 L -5 -1 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 3 -1 M -9 9 L -2 9","-11 10 M 6 -9 L 7 -6 L 7 -12 L 6 -9 L 4 -11 L 1 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9","-9 10 M 0 -12 L 0 9 M 1 -12 L 1 9 M -6 -12 L -7 -6 L -7 -12 L 8 -12 L 8 -6 L 7 -12 M -3 9 L 4 9","-15 16 M -10 -12 L -10 9 M -9 -12 L -9 9 M -13 -12 L -6 -12 M -13 9 L -6 9 M 4 -12 L 1 -11 L -1 -9 L -2 -7 L -3 -3 L -3 0 L -2 4 L -1 6 L 1 8 L 4 9 L 6 9 L 9 8 L 11 6 L 12 4 L 13 0 L 13 -3 L 12 -7 L 11 -9 L 9 -11 L 6 -12 L 4 -12 M 4 -12 L 2 -11 L 0 -9 L -1 -7 L -2 -3 L -2 0 L -1 4 L 0 6 L 2 8 L 4 9 M 6 9 L 8 8 L 10 6 L 11 4 L 12 0 L 12 -3 L 11 -7 L 10 -9 L 8 -11 L 6 -12 M -9 -2 L -3 -2","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 3 -2 M -5 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -9 9 M 3 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9","-16 17 M -11 -12 L -11 9 M -10 -12 L -10 9 M 0 -12 L 0 9 M 1 -12 L 1 9 M 11 -12 L 11 9 M 12 -12 L 12 9 M -14 -12 L -7 -12 M -3 -12 L 4 -12 M 8 -12 L 15 -12 M -14 9 L 15 9 M 14 9 L 15 16 M 15 9 L 15 16","-10 10 M -7 -12 L 6 9 M -6 -12 L 7 9 M 7 -12 L -7 9 M -9 -12 L -3 -12 M 3 -12 L 9 -12 M -9 9 L -3 9 M 3 9 L 9 9","-10 11 M -7 -12 L 0 4 M -6 -12 L 1 4 M 8 -12 L 1 4 L -1 7 L -2 8 L -4 9 L -5 9 L -6 8 L -6 7 L -5 6 L -4 7 L -5 8 M -9 -12 L -3 -12 M 4 -12 L 10 -12","-10 10 M -6 -9 L -7 -12 L -7 -6 L -6 -9 L -4 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -9 L 6 -6 L 5 -4 L 2 -3 L -1 -3 M 2 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -4 L 2 -3 M 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -3 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 5 -1 L 6 2 L 6 5 L 5 7 L 4 8 L 2 9","-11 10 M -6 -12 L -6 9 M -5 -12 L -5 9 M 1 -6 L 1 2 M -9 -12 L 7 -12 L 7 -6 L 6 -12 M -5 -2 L 1 -2 M -9 9 L 7 9 L 7 3 L 6 9","-7 7 M -7 -12 L 7 12","-12 14 M -2 -12 L -2 9 M -1 -12 L -1 9 M -9 -12 L -10 -6 L -10 -12 L 2 -12 M -1 -2 L 6 -2 L 9 -1 L 10 0 L 11 2 L 11 5 L 10 7 L 9 8 L 6 9 L -5 9 M 6 -2 L 8 -1 L 9 0 L 10 2 L 10 5 L 9 7 L 8 8 L 6 9","-11 11 M 5 -12 L 5 9 M 6 -12 L 6 9 M 9 -12 L -3 -12 L -6 -11 L -7 -10 L -8 -8 L -8 -6 L -7 -4 L -6 -3 L -3 -2 L 5 -2 M -3 -12 L -5 -11 L -6 -10 L -7 -8 L -7 -6 L -6 -4 L -5 -3 L -3 -2 M 0 -2 L -2 -1 L -3 0 L -6 7 L -7 8 L -8 8 L -9 7 M -2 -1 L -3 1 L -5 8 L -6 9 L -8 9 L -9 7 L -9 6 M 2 9 L 9 9","-10 11 M -5 -12 L -5 9 M -4 -12 L -4 9 M -8 -12 L -1 -12 M -4 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -8 9 M 3 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L -3 -12 M 3 -12 L 10 -12 M -10 9 L 10 9 M 9 9 L 10 16 M 10 9 L 10 16","-9 11 M -4 -3 L -4 -2 L -5 -2 L -5 -3 L -4 -4 L -2 -5 L 2 -5 L 4 -4 L 5 -3 L 6 -1 L 6 6 L 7 8 L 8 9 M 5 -3 L 5 6 L 6 8 L 8 9 L 9 9 M 5 -1 L 4 0 L -2 1 L -5 2 L -6 4 L -6 6 L -5 8 L -2 9 L 1 9 L 3 8 L 5 6 M -2 1 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9","-10 10 M 6 -12 L 5 -11 L -1 -9 L -4 -7 L -6 -4 L -7 -1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 M 6 -12 L 5 -10 L 3 -9 L -1 -8 L -4 -6 L -6 -4 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 1 L 5 -2 L 3 -4 L 1 -5","-10 11 M -6 -9 L -7 -12 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 1 -12 L 3 -11 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 3 8 L 1 9 M -2 -2 L 7 -2","-12 11 M -4 -5 L -4 -1 L -5 5 L -6 8 L -7 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -7 -5 L 9 -5 M -9 9 L -10 14 L -10 9 L 9 9 L 9 14 L 8 9","-11 11 M -6 -5 L -6 9 M -5 -5 L -5 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L -2 -5 M 2 -5 L 9 -5 M -9 9 L -2 9 M 2 9 L 9 9 M 5 -4 L -5 8 M -3 -11 L -3 -12 L -4 -12 L -4 -11 L -3 -9 L -1 -8 L 1 -8 L 3 -9 L 4 -11","-10 11 M 0 -12 L 0 16 M 1 -12 L 1 16 M -3 -12 L 1 -12 M 0 -2 L -1 -4 L -2 -5 L -4 -5 L -6 -4 L -7 -1 L -7 5 L -6 8 L -4 9 L -2 9 L -1 8 L 0 6 M -4 -5 L -5 -4 L -6 -1 L -6 5 L -5 8 L -4 9 M 5 -5 L 6 -4 L 7 -1 L 7 5 L 6 8 L 5 9 M 1 -2 L 2 -4 L 3 -5 L 5 -5 L 7 -4 L 8 -1 L 8 5 L 7 8 L 5 9 L 3 9 L 2 8 L 1 6 M -3 16 L 4 16","-10 8 M -5 -5 L -5 9 M -4 -5 L -4 9 M -8 -5 L 6 -5 L 6 0 L 5 -5 M -8 9 L -1 9","-13 14 M 0 -5 L 0 9 M 1 -5 L 1 9 M -3 -5 L 4 -5 M -8 -4 L -9 -3 L -10 -4 L -9 -5 L -8 -5 L -7 -4 L -5 0 L -4 1 L -2 2 L 3 2 L 5 1 L 6 0 L 8 -4 L 9 -5 L 10 -5 L 11 -4 L 10 -3 L 9 -4 M -2 2 L -4 3 L -5 4 L -7 8 L -8 9 M -2 2 L -4 4 L -6 8 L -7 9 L -9 9 L -10 8 L -11 6 M 3 2 L 5 3 L 6 4 L 8 8 L 9 9 M 3 2 L 5 4 L 7 8 L 8 9 L 10 9 L 11 8 L 12 6 M -3 9 L 4 9","-11 11 M -6 -5 L -6 9 M -5 -5 L -5 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L -2 -5 M 2 -5 L 9 -5 M -9 9 L -2 9 M 2 9 L 9 9 M 5 -4 L -5 8","-11 11 M -6 -5 L -6 2 L -5 4 L -2 5 L 0 5 L 3 4 L 5 2 M -5 -5 L -5 2 L -4 4 L -2 5 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L -2 -5 M 2 -5 L 9 -5 M 2 9 L 9 9","-10 10 M -5 -5 L -5 9 M -4 -5 L -4 9 M -8 -5 L -1 -5 M -4 2 L -2 2 L 1 1 L 2 0 L 4 -4 L 5 -5 L 6 -5 L 7 -4 L 6 -3 L 5 -4 M -2 2 L 1 3 L 2 4 L 4 8 L 5 9 M -2 2 L 0 3 L 1 4 L 3 8 L 4 9 L 6 9 L 7 8 L 8 6 M -8 9 L -1 9","-11 11 M -4 -5 L -4 -1 L -5 5 L -6 8 L -7 9 L -8 9 L -9 8 L -8 7 L -7 8 M 5 -5 L 5 9 M 6 -5 L 6 9 M -7 -5 L 9 -5 M 2 9 L 9 9","-11 12 M -6 -5 L -6 9 M -6 -5 L 0 9 M -5 -5 L 0 7 M 6 -5 L 0 9 M 6 -5 L 6 9 M 7 -5 L 7 9 M -9 -5 L -5 -5 M 6 -5 L 10 -5 M -9 9 L -3 9 M 3 9 L 10 9","-11 11 M -6 -5 L -6 9 M -5 -5 L -5 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L -2 -5 M 2 -5 L 9 -5 M -5 2 L 5 2 M -9 9 L -2 9 M 2 9 L 9 9","-10 10 M -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 1 -5 L -1 -5 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 1 L 5 -2 L 3 -4 L 1 -5","-11 11 M -6 -5 L -6 9 M -5 -5 L -5 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L 9 -5 M -9 9 L -2 9 M 2 9 L 9 9","-15 16 M -10 -5 L -10 9 M -9 -5 L -9 9 M 0 -5 L 0 9 M 1 -5 L 1 9 M 10 -5 L 10 9 M 11 -5 L 11 9 M -13 -5 L -6 -5 M -3 -5 L 4 -5 M 7 -5 L 14 -5 M -13 9 L 14 9","-11 10 M -6 -5 L -6 16 M -5 -5 L -5 16 M -5 -2 L -3 -4 L -1 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -1 9 L -3 8 L -5 6 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -9 -5 L -5 -5 M -9 16 L -2 16","-10 9 M 5 -2 L 4 -1 L 5 0 L 6 -1 L 6 -2 L 4 -4 L 2 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9","-9 10 M 0 -5 L 0 9 M 1 -5 L 1 9 M -5 -5 L -6 0 L -6 -5 L 7 -5 L 7 0 L 6 -5 M -3 9 L 4 9","-14 15 M -9 -5 L -9 9 M -8 -5 L -8 9 M -12 -5 L -5 -5 M -12 9 L -5 9 M 4 -5 L 1 -4 L -1 -2 L -2 1 L -2 3 L -1 6 L 1 8 L 4 9 L 6 9 L 9 8 L 11 6 L 12 3 L 12 1 L 11 -2 L 9 -4 L 6 -5 L 4 -5 M 4 -5 L 2 -4 L 0 -2 L -1 1 L -1 3 L 0 6 L 2 8 L 4 9 M 6 9 L 8 8 L 10 6 L 11 3 L 11 1 L 10 -2 L 8 -4 L 6 -5 M -8 2 L -2 2","-10 10 M -5 -5 L -5 9 M -4 -5 L -4 9 M -8 -5 L 3 -5 L 6 -4 L 7 -2 L 7 -1 L 6 1 L 3 2 M 3 -5 L 5 -4 L 6 -2 L 6 -1 L 5 1 L 3 2 M -4 2 L 3 2 L 6 3 L 7 5 L 7 6 L 6 8 L 3 9 L -8 9 M 3 2 L 5 3 L 6 5 L 6 6 L 5 8 L 3 9","-15 16 M -10 -5 L -10 9 M -9 -5 L -9 9 M 0 -5 L 0 9 M 1 -5 L 1 9 M 10 -5 L 10 9 M 11 -5 L 11 9 M -13 -5 L -6 -5 M -3 -5 L 4 -5 M 7 -5 L 14 -5 M -13 9 L 14 9 L 14 14 L 13 9","-10 10 M -6 -5 L 5 9 M -5 -5 L 6 9 M 6 -5 L -6 9 M -8 -5 L -2 -5 M 2 -5 L 8 -5 M -8 9 L -2 9 M 2 9 L 8 9","-9 9 M -6 -5 L 0 9 M -5 -5 L 0 7 M 6 -5 L 0 9 L -2 13 L -4 15 L -6 16 L -7 16 L -8 15 L -7 14 L -6 15 M -8 -5 L -2 -5 M 2 -5 L 8 -5","-9 9 M -5 -3 L -6 -5 L -6 -1 L -5 -3 L -4 -4 L -2 -5 L 2 -5 L 5 -4 L 6 -2 L 6 -1 L 5 1 L 2 2 M 2 -5 L 4 -4 L 5 -2 L 5 -1 L 4 1 L 2 2 M -1 2 L 2 2 L 5 3 L 6 5 L 6 6 L 5 8 L 2 9 L -2 9 L -5 8 L -6 6 L -6 5 L -5 4 L -4 5 L -5 6 M 2 2 L 4 3 L 5 5 L 5 6 L 4 8 L 2 9","-10 9 M -6 1 L 6 1 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M 5 1 L 5 -2 L 4 -4 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9","-10 11 M -1 -5 L -1 9 M 0 -5 L 0 9 M -6 -5 L -7 0 L -7 -5 L 3 -5 M 0 2 L 4 2 L 7 3 L 8 5 L 8 6 L 7 8 L 4 9 L -4 9 M 4 2 L 6 3 L 7 5 L 7 6 L 6 8 L 4 9","-11 10 M 4 -5 L 4 9 M 5 -5 L 5 9 M 8 -5 L -3 -5 L -6 -4 L -7 -2 L -7 -1 L -6 1 L -3 2 L 4 2 M -3 -5 L -5 -4 L -6 -2 L -6 -1 L -5 1 L -3 2 M 2 2 L -1 3 L -2 4 L -4 8 L -5 9 M 2 2 L 0 3 L -1 4 L -3 8 L -4 9 L -6 9 L -7 8 L -8 6 M 1 9 L 8 9","-8 9 M -3 -5 L -3 9 M -2 -5 L -2 9 M -6 -5 L 1 -5 M -2 2 L 2 2 L 5 3 L 6 5 L 6 6 L 5 8 L 2 9 L -6 9 M 2 2 L 4 3 L 5 5 L 5 6 L 4 8 L 2 9","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3"]
futural = ["-8 8","-5 5 M 0 -12 L 0 2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-8 8 M -4 -12 L -4 -5 M 4 -12 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -6 9 L -8 8 L -9 7 L -10 5 L -10 3 L -9 1 L -8 0 L -1 -4 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 7 9 L 9 9 L 10 8 L 10 7","-5 5 M 0 -10 L -1 -11 L 0 -12 L 1 -11 L 1 -9 L 0 -7 L -1 -6","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L 0 -4 L 3 -4 L 5 -3 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 3 -12 L -7 2 L 8 2 M 3 -12 L 3 9","-10 10 M 5 -12 L -5 -12 L -6 -3 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2","-10 10 M 7 -12 L -3 9 M -7 -12 L 7 -12","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 1 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -1 -3 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-9 9 M 0 -12 L -8 9 M 0 -12 L 8 9 M -5 2 L 5 2","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 M -7 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -7 9","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4","-11 10 M -7 -12 L -7 9 M -7 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 3 8 L 0 9 L -7 9","-10 9 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2 M -6 9 L 7 9","-10 8 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4 L 8 1 M 3 1 L 8 1","-11 11 M -7 -12 L -7 9 M 7 -12 L 7 9 M -7 -2 L 7 -2","-4 4 M 0 -12 L 0 9","-8 8 M 4 -12 L 4 4 L 3 7 L 2 8 L 0 9 L -2 9 L -4 8 L -5 7 L -6 4 L -6 2","-11 10 M -7 -12 L -7 9 M 7 -12 L -7 2 M -2 -3 L 7 9","-10 7 M -6 -12 L -6 9 M -6 9 L 6 9","-12 12 M -8 -12 L -8 9 M -8 -12 L 0 9 M 8 -12 L 0 9 M 8 -12 L 8 9","-11 11 M -7 -12 L -7 9 M -7 -12 L 7 9 M 7 -12 L 7 9","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 2 -1 L -7 -1","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12 M 1 5 L 7 11","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 L -7 -2 M 0 -2 L 7 9","-10 10 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-8 8 M 0 -12 L 0 9 M -7 -12 L 7 -12","-11 11 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -12","-9 9 M -8 -12 L 0 9 M 8 -12 L 0 9","-12 12 M -10 -12 L -5 9 M 0 -12 L -5 9 M 0 -12 L 5 9 M 10 -12 L 5 9","-10 10 M -7 -12 L 7 9 M 7 -12 L -7 9","-9 9 M -8 -12 L 0 -2 L 0 9 M 8 -12 L 0 -2","-10 10 M 7 -12 L -7 9 M -7 -12 L 7 -12 M -7 9 L 7 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-8 8 M 0 -14 L -8 0 M 0 -14 L 8 0","-9 9 M -9 16 L 9 16","-4 4 M 1 -7 L -1 -5 L -1 -3 L 0 -2 L 1 -3 L 0 -4 L -1 -3","-9 10 M 6 -5 L 6 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-10 9 M -6 -12 L -6 9 M -6 -2 L -4 -4 L -2 -5 L 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -6 6","-9 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 10 M 6 -12 L 6 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 9 M -6 1 L 6 1 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-5 7 M 5 -12 L 3 -12 L 1 -11 L 0 -8 L 0 9 M -3 -5 L 4 -5","-9 10 M 6 -5 L 6 11 L 5 14 L 4 15 L 2 16 L -1 16 L -3 15 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 10 M -5 -12 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9","-4 4 M -1 -12 L 0 -11 L 1 -12 L 0 -13 L -1 -12 M 0 -5 L 0 9","-5 5 M 0 -12 L 1 -11 L 2 -12 L 1 -13 L 0 -12 M 1 -5 L 1 12 L 0 15 L -2 16 L -4 16","-9 8 M -5 -12 L -5 9 M 5 -5 L -5 5 M -1 1 L 6 9","-4 4 M 0 -12 L 0 9","-15 15 M -11 -5 L -11 9 M -11 -1 L -8 -4 L -6 -5 L -3 -5 L -1 -4 L 0 -1 L 0 9 M 0 -1 L 3 -4 L 5 -5 L 8 -5 L 10 -4 L 11 -1 L 11 9","-9 10 M -5 -5 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9","-9 10 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 2 -5 L -1 -5","-10 9 M -6 -5 L -6 16 M -6 -2 L -4 -4 L -2 -5 L 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -6 6","-9 10 M 6 -5 L 6 16 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-7 6 M -3 -5 L -3 9 M -3 1 L -2 -2 L 0 -4 L 2 -5 L 5 -5","-8 9 M 6 -2 L 5 -4 L 2 -5 L -1 -5 L -4 -4 L -5 -2 L -4 0 L -2 1 L 3 2 L 5 3 L 6 5 L 6 6 L 5 8 L 2 9 L -1 9 L -4 8 L -5 6","-5 7 M 0 -12 L 0 5 L 1 8 L 3 9 L 5 9 M -3 -5 L 4 -5","-9 10 M -5 -5 L -5 5 L -4 8 L -2 9 L 1 9 L 3 8 L 6 5 M 6 -5 L 6 9","-8 8 M -6 -5 L 0 9 M 6 -5 L 0 9","-11 11 M -8 -5 L -4 9 M 0 -5 L -4 9 M 0 -5 L 4 9 M 8 -5 L 4 9","-8 9 M -5 -5 L 6 9 M 6 -5 L -5 9","-8 8 M -6 -5 L 0 9 M 6 -5 L 0 9 L -2 13 L -4 15 L -6 16 L -7 16","-8 9 M 6 -5 L -5 9 M -5 -5 L 6 -5 M -5 9 L 6 9","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
futuram = ["-8 8","-5 6 M 0 -12 L 0 2 L 1 2 M 0 -12 L 1 -12 L 1 2 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-9 10 M 0 -16 L 0 13 L 1 13 M 0 -16 L 1 -16 L 1 13 M 5 -9 L 7 -9 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -9 L -6 -7 L -5 -5 L -4 -4 L 4 0 L 5 1 L 6 3 L 6 5 L 5 7 L 2 8 L -1 8 L -3 7 L -4 6 M 5 -9 L 4 -10 L 2 -11 L -1 -11 L -4 -10 L -5 -9 L -5 -7 L -4 -5 L 4 -1 L 6 1 L 7 3 L 7 5 L 6 7 L 5 8 L 2 9 L -1 9 L -4 8 L -6 6 L -4 6 M 6 6 L 3 8","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-12 13 M 9 -4 L 8 -3 L 9 -2 L 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -5 9 L -8 8 L -9 6 L -9 3 L -8 1 L -2 -3 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 8 9 L 9 9 L 10 8 L 10 7 M -5 9 L -7 8 L -8 6 L -8 3 L -7 1 L -5 -1 M -5 -7 L -4 -5 L 4 6 L 6 8 L 8 9","-4 5 M 1 -12 L 0 -11 L 0 -5 M 1 -11 L 0 -5 M 1 -12 L 2 -11 L 0 -5","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16 M 2 -14 L 0 -10 L -1 -7 L -2 -2 L -2 2 L -1 7 L 0 10 L 2 14","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 M -2 -14 L 0 -10 L 1 -7 L 2 -2 L 2 2 L 1 7 L 0 10 L -2 14","-8 8 M 0 -12 L -1 -11 L 1 -1 L 0 0 M 0 -12 L 0 0 M 0 -12 L 1 -11 L -1 -1 L 0 0 M -5 -9 L -4 -9 L 4 -3 L 5 -3 M -5 -9 L 5 -3 M -5 -9 L -5 -8 L 5 -4 L 5 -3 M 5 -9 L 4 -9 L -4 -3 L -5 -3 M 5 -9 L -5 -3 M 5 -9 L 5 -8 L -5 -4 L -5 -3","-12 13 M 0 -9 L 0 8 L 1 8 M 0 -9 L 1 -9 L 1 8 M -8 -1 L 9 -1 L 9 0 M -8 -1 L -8 0 L 9 0","-5 6 M 2 8 L 1 9 L 0 9 L -1 8 L -1 7 L 0 6 L 1 6 L 2 7 L 2 10 L 1 12 L -1 13 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7 M 1 9 L 2 10 M 2 8 L 1 12","-13 13 M -9 0 L 9 0","-5 6 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-11 12 M 9 -16 L -9 16 L -8 16 M 9 -16 L 10 -16 L -8 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12 M -3 -11 L -5 -8 L -6 -3 L -6 0 L -5 5 L -3 8 M -4 7 L -1 8 L 1 8 L 4 7 M 3 8 L 5 5 L 6 0 L 6 -3 L 5 -8 L 3 -11 M 4 -10 L 1 -11 L -1 -11 L -4 -10","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9 M -4 -8 L -4 -7 L -2 -8 L 0 -10 L 0 9 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -6 9 M -6 -7 L -5 -7 L -5 -8 L -4 -10 L -2 -11 L 2 -11 L 4 -10 L 5 -8 L 5 -6 L 4 -4 L 2 -1 L -7 9 M -6 8 L 7 8 L 7 9 M -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L -1 -3 M -5 -12 L -5 -11 L 5 -11 M 5 -12 L -2 -3 M -1 -4 L 1 -4 L 4 -3 L 6 -1 L 7 2 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -6 5 M -2 -3 L 1 -3 L 4 -2 L 6 1 M 2 -3 L 5 -1 L 6 2 L 6 3 L 5 6 L 2 8 M 6 4 L 4 7 L 1 8 L -2 8 L -5 7 L -6 5 M -3 8 L -6 6","-10 10 M 3 -9 L 3 9 L 4 9 M 4 -12 L 4 9 M 4 -12 L -7 4 L 8 4 M 3 -9 L -6 4 M -6 3 L 8 3 L 8 4","-10 10 M -5 -12 L -6 -3 M -4 -11 L -5 -4 M -5 -12 L 5 -12 L 5 -11 M -4 -11 L 5 -11 M -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -6 5 M -6 -3 L -5 -3 L -3 -4 L 1 -4 L 4 -3 L 6 0 M 2 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 2 8 M 6 4 L 4 7 L 1 8 L -2 8 L -5 7 L -6 5 M -3 8 L -6 6","-10 10 M 4 -11 L 5 -9 L 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 M 5 -10 L 2 -11 L 0 -11 L -3 -10 M -2 -11 L -4 -8 L -5 -3 L -5 2 L -4 6 L -1 8 M -5 4 L -3 7 L 0 8 L 1 8 L 4 7 L 6 4 M 2 8 L 5 6 L 6 3 L 6 2 L 5 -1 L 2 -3 M 6 1 L 4 -2 L 1 -3 L 0 -3 L -3 -2 L -5 1 M -1 -3 L -4 -1 L -5 2","-10 10 M -7 -12 L 7 -12 L -3 9 M -7 -12 L -7 -11 L 6 -11 M 6 -12 L -4 9 L -3 9","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -4 -4 L -2 -3 L 2 -2 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 2 8 L -2 8 L -5 7 L -6 5 L -6 2 L -5 0 L -4 -1 L -2 -2 L 2 -3 L 4 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12 M -4 -11 L -5 -9 L -5 -7 L -4 -5 L -2 -4 L 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -2 -3 L 2 -4 L 4 -5 L 5 -7 L 5 -9 L 4 -11 M 5 -10 L 2 -11 L -2 -11 L -5 -10 M -6 6 L -3 8 M 3 8 L 6 6","-10 10 M 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6 L -5 6 L -4 8 M 5 -5 L 4 -2 L 1 0 M 5 -4 L 3 -1 L 0 0 L -1 0 L -4 -1 L -6 -4 M -2 0 L -5 -2 L -6 -5 L -6 -6 L -5 -9 L -2 -11 M -6 -7 L -4 -10 L -1 -11 L 0 -11 L 3 -10 L 5 -7 M 1 -11 L 4 -9 L 5 -5 L 5 0 L 4 5 L 2 8 M 3 7 L 0 8 L -2 8 L -5 7","-5 6 M 0 -5 L -1 -4 L -1 -3 L 0 -2 L 1 -2 L 2 -3 L 2 -4 L 1 -5 L 0 -5 M 0 -4 L 0 -3 L 1 -3 L 1 -4 L 0 -4 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-5 6 M 0 -5 L -1 -4 L -1 -3 L 0 -2 L 1 -2 L 2 -3 L 2 -4 L 1 -5 L 0 -5 M 0 -4 L 0 -3 L 1 -3 L 1 -4 L 0 -4 M 2 8 L 1 9 L 0 9 L -1 8 L -1 7 L 0 6 L 1 6 L 2 7 L 2 10 L 1 12 L -1 13 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7 M 1 9 L 2 10 M 2 8 L 1 12","-12 12 M 8 -9 L -8 0 L 8 9","-12 13 M -8 -5 L 9 -5 L 9 -4 M -8 -5 L -8 -4 L 9 -4 M -8 3 L 9 3 L 9 4 M -8 3 L -8 4 L 9 4","-12 12 M -8 -9 L 8 0 L -8 9","-9 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -1 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 3 -2 L 0 -1 M -6 -7 L -5 -7 L -5 -8 L -4 -10 L -1 -11 L 2 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -3 L 0 -2 M -5 -9 L -2 -11 M 3 -11 L 6 -9 M 6 -5 L 2 -2 M 0 -2 L 0 2 L 1 2 L 1 -2 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 0 -12 L -8 9 M 0 -9 L -7 9 L -8 9 M 0 -9 L 7 9 L 8 9 M 0 -12 L 8 9 M -5 3 L 5 3 M -6 4 L 6 4","-10 10 M -6 -12 L -6 9 M -5 -11 L -5 8 M -6 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 2 -1 M -5 -11 L 2 -11 L 5 -10 L 6 -8 L 6 -5 L 5 -3 L 2 -2 M -5 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -6 9 M -5 -1 L 2 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 2 8 L -5 8","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4 M 8 -7 L 7 -7 L 6 -9 L 5 -10 L 3 -11 L -1 -11 L -3 -10 L -5 -7 L -6 -4 L -6 1 L -5 4 L -3 7 L -1 8 L 3 8 L 5 7 L 6 6 L 7 4 L 8 4","-10 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -6 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8 L 1 9 L -6 9 M -5 -11 L 1 -11 L 4 -10 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 4 7 L 1 8 L -5 8","-9 10 M -5 -12 L -5 9 M -4 -11 L -4 8 M -5 -12 L 7 -12 M -4 -11 L 7 -11 L 7 -12 M -4 -2 L 2 -2 L 2 -1 M -4 -1 L 2 -1 M -4 8 L 7 8 L 7 9 M -5 9 L 7 9","-9 9 M -5 -12 L -5 9 M -4 -11 L -4 9 L -5 9 M -5 -12 L 7 -12 M -4 -11 L 7 -11 L 7 -12 M -4 -2 L 2 -2 L 2 -1 M -4 -1 L 2 -1","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4 L 8 0 L 3 0 M 8 -7 L 7 -7 L 6 -9 L 5 -10 L 3 -11 L -1 -11 L -3 -10 L -4 -9 L -5 -7 L -6 -4 L -6 1 L -5 4 L -4 6 L -3 7 L -1 8 L 3 8 L 5 7 L 6 6 L 7 4 L 7 1 L 3 1 L 3 0","-11 11 M -7 -12 L -7 9 M -7 -12 L -6 -12 L -6 9 L -7 9 M 7 -12 L 6 -12 L 6 9 L 7 9 M 7 -12 L 7 9 M -6 -2 L 6 -2 M -6 -1 L 6 -1","-4 5 M 0 -12 L 0 9 L 1 9 M 0 -12 L 1 -12 L 1 9","-8 9 M 4 -12 L 4 4 L 3 7 L 1 8 L -1 8 L -3 7 L -4 4 L -5 4 M 4 -12 L 5 -12 L 5 4 L 4 7 L 3 8 L 1 9 L -1 9 L -3 8 L -4 7 L -5 4","-10 11 M -6 -12 L -6 9 L -5 9 M -6 -12 L -5 -12 L -5 9 M 8 -12 L 7 -12 L -5 0 M 8 -12 L -5 1 M -2 -3 L 7 9 L 8 9 M -1 -3 L 8 9","-9 8 M -5 -12 L -5 9 M -5 -12 L -4 -12 L -4 8 M -4 8 L 7 8 L 7 9 M -5 9 L 7 9","-12 12 M -8 -12 L -8 9 M -7 -7 L -7 9 L -8 9 M -7 -7 L 0 9 M -8 -12 L 0 6 M 8 -12 L 0 6 M 7 -7 L 0 9 M 7 -7 L 7 9 L 8 9 M 8 -12 L 8 9","-11 11 M -7 -12 L -7 9 M -6 -9 L -6 9 L -7 9 M -6 -9 L 7 9 M -7 -12 L 6 6 M 6 -12 L 6 6 M 6 -12 L 7 -12 L 7 9","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12 M -1 -11 L -4 -10 L -6 -7 L -7 -4 L -7 1 L -6 4 L -4 7 L -1 8 L 1 8 L 4 7 L 6 4 L 7 1 L 7 -4 L 6 -7 L 4 -10 L 1 -11 L -1 -11","-10 10 M -6 -12 L -6 9 M -5 -11 L -5 9 L -6 9 M -6 -12 L 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 3 -1 L -5 -1 M -5 -11 L 3 -11 L 5 -10 L 6 -8 L 6 -5 L 5 -3 L 3 -2 L -5 -2","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12 M -1 -11 L -4 -10 L -6 -7 L -7 -4 L -7 1 L -6 4 L -4 7 L -1 8 L 1 8 L 4 7 L 6 4 L 7 1 L 7 -4 L 6 -7 L 4 -10 L 1 -11 L -1 -11 M 1 6 L 6 11 L 7 11 M 1 6 L 2 6 L 7 11","-10 10 M -6 -12 L -6 9 M -5 -11 L -5 9 L -6 9 M -6 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 2 -1 L -5 -1 M -5 -11 L 2 -11 L 5 -10 L 6 -8 L 6 -5 L 5 -3 L 2 -2 L -5 -2 M 0 -1 L 6 9 L 7 9 M 1 -1 L 7 9","-10 10 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 2 -1 L 4 0 L 5 1 L 6 3 L 6 6 L 5 7 L 2 8 L -2 8 L -4 7 L -5 6 L -7 6 M 7 -9 L 5 -9 L 4 -10 L 2 -11 L -2 -11 L -5 -10 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 2 -2 L 4 -1 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-8 9 M 0 -11 L 0 9 M 1 -11 L 1 9 L 0 9 M -6 -12 L 7 -12 L 7 -11 M -6 -12 L -6 -11 L 7 -11","-11 11 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -12 M -7 -12 L -6 -12 L -6 3 L -5 6 L -4 7 L -1 8 L 1 8 L 4 7 L 5 6 L 6 3 L 6 -12 L 7 -12","-10 10 M -8 -12 L 0 9 M -8 -12 L -7 -12 L 0 6 M 8 -12 L 7 -12 L 0 6 M 8 -12 L 0 9","-13 13 M -11 -12 L -5 9 M -11 -12 L -10 -12 L -5 6 M 0 -12 L -5 6 M 0 -9 L -5 9 M 0 -9 L 5 9 M 0 -12 L 5 6 M 11 -12 L 10 -12 L 5 6 M 11 -12 L 5 9","-10 10 M -7 -12 L 6 9 L 7 9 M -7 -12 L -6 -12 L 7 9 M 7 -12 L 6 -12 L -7 9 M 7 -12 L -6 9 L -7 9","-9 10 M -7 -12 L 0 -2 L 0 9 L 1 9 M -7 -12 L -6 -12 L 1 -2 M 8 -12 L 7 -12 L 0 -2 M 8 -12 L 1 -2 L 1 9","-10 10 M 6 -12 L -7 9 M 7 -12 L -6 9 M -7 -12 L 7 -12 M -7 -12 L -7 -11 L 6 -11 M -6 8 L 7 8 L 7 9 M -7 9 L 7 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-10 10 M -10 16 L 10 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-10 10 M 5 -5 L 5 9 L 6 9 M 5 -5 L 6 -5 L 6 9 M 5 -2 L 3 -4 L 1 -5 L -2 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -2 9 L 1 9 L 3 8 L 5 6 M 5 -2 L 1 -4 L -2 -4 L -4 -3 L -5 -2 L -6 1 L -6 3 L -5 6 L -4 7 L -2 8 L 1 8 L 5 6","-10 10 M -6 -12 L -6 9 L -5 9 M -6 -12 L -5 -12 L -5 9 M -5 -2 L -3 -4 L -1 -5 L 2 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 2 9 L -1 9 L -3 8 L -5 6 M -5 -2 L -1 -4 L 2 -4 L 4 -3 L 5 -2 L 6 1 L 6 3 L 5 6 L 4 7 L 2 8 L -1 8 L -5 6","-9 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6 M 6 -2 L 5 -1 L 4 -3 L 2 -4 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 3 L -4 6 L -3 7 L -1 8 L 2 8 L 4 7 L 5 5 L 6 6","-10 10 M 5 -12 L 5 9 L 6 9 M 5 -12 L 6 -12 L 6 9 M 5 -2 L 3 -4 L 1 -5 L -2 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -2 9 L 1 9 L 3 8 L 5 6 M 5 -2 L 1 -4 L -2 -4 L -4 -3 L -5 -2 L -6 1 L -6 3 L -5 6 L -4 7 L -2 8 L 1 8 L 5 6","-9 9 M -5 2 L 6 2 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6 M -5 1 L 5 1 L 5 -1 L 4 -3 L 2 -4 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 3 L -4 6 L -3 7 L -1 8 L 2 8 L 4 7 L 5 5 L 6 6","-6 8 M 5 -12 L 3 -12 L 1 -11 L 0 -8 L 0 9 L 1 9 M 5 -12 L 5 -11 L 3 -11 L 1 -10 M 2 -11 L 1 -8 L 1 9 M -3 -5 L 4 -5 L 4 -4 M -3 -5 L -3 -4 L 4 -4","-10 10 M 6 -5 L 5 -5 L 5 10 L 4 13 L 3 14 L 1 15 L -1 15 L -3 14 L -4 13 L -6 13 M 6 -5 L 6 10 L 5 13 L 3 15 L 1 16 L -2 16 L -4 15 L -6 13 M 5 -2 L 3 -4 L 1 -5 L -2 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -2 9 L 1 9 L 3 8 L 5 6 M 5 -2 L 1 -4 L -2 -4 L -4 -3 L -5 -2 L -6 1 L -6 3 L -5 6 L -4 7 L -2 8 L 1 8 L 5 6","-10 10 M -6 -12 L -6 9 L -5 9 M -6 -12 L -5 -12 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9 M -5 -1 L -2 -3 L 0 -4 L 2 -4 L 4 -3 L 5 -1 L 5 9 L 6 9","-4 5 M 0 -12 L -1 -11 L -1 -10 L 0 -9 L 1 -9 L 2 -10 L 2 -11 L 1 -12 L 0 -12 M 0 -11 L 0 -10 L 1 -10 L 1 -11 L 0 -11 M 0 -5 L 0 9 L 1 9 M 0 -5 L 1 -5 L 1 9","-4 5 M 0 -12 L -1 -11 L -1 -10 L 0 -9 L 1 -9 L 2 -10 L 2 -11 L 1 -12 L 0 -12 M 0 -11 L 0 -10 L 1 -10 L 1 -11 L 0 -11 M 0 -5 L 0 16 L 1 16 M 0 -5 L 1 -5 L 1 16","-10 9 M -6 -12 L -6 9 L -5 9 M -6 -12 L -5 -12 L -5 9 M 6 -5 L 5 -5 L -5 5 M 6 -5 L -5 6 M -2 2 L 4 9 L 6 9 M -1 1 L 6 9","-4 5 M 0 -12 L 0 9 L 1 9 M 0 -12 L 1 -12 L 1 9","-15 16 M -11 -5 L -11 9 L -10 9 M -11 -5 L -10 -5 L -10 9 M -10 -1 L -7 -4 L -5 -5 L -2 -5 L 0 -4 L 1 -1 L 1 9 M -10 -1 L -7 -3 L -5 -4 L -3 -4 L -1 -3 L 0 -1 L 0 9 L 1 9 M 1 -1 L 4 -4 L 6 -5 L 9 -5 L 11 -4 L 12 -1 L 12 9 M 1 -1 L 4 -3 L 6 -4 L 8 -4 L 10 -3 L 11 -1 L 11 9 L 12 9","-10 10 M -6 -5 L -6 9 L -5 9 M -6 -5 L -5 -5 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9 M -5 -1 L -2 -3 L 0 -4 L 2 -4 L 4 -3 L 5 -1 L 5 9 L 6 9","-9 10 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 2 -5 L -1 -5 M -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 3 L -4 6 L -3 7 L -1 8 L 2 8 L 4 7 L 5 6 L 6 3 L 6 1 L 5 -2 L 4 -3 L 2 -4 L -1 -4","-10 10 M -6 -5 L -6 16 L -5 16 M -6 -5 L -5 -5 L -5 16 M -5 -2 L -3 -4 L -1 -5 L 2 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 2 9 L -1 9 L -3 8 L -5 6 M -5 -2 L -1 -4 L 2 -4 L 4 -3 L 5 -2 L 6 1 L 6 3 L 5 6 L 4 7 L 2 8 L -1 8 L -5 6","-10 10 M 5 -5 L 5 16 L 6 16 M 5 -5 L 6 -5 L 6 16 M 5 -2 L 3 -4 L 1 -5 L -2 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -2 9 L 1 9 L 3 8 L 5 6 M 5 -2 L 1 -4 L -2 -4 L -4 -3 L -5 -2 L -6 1 L -6 3 L -5 6 L -4 7 L -2 8 L 1 8 L 5 6","-7 7 M -3 -5 L -3 9 L -2 9 M -3 -5 L -2 -5 L -2 9 M -2 1 L -1 -2 L 1 -4 L 3 -5 L 6 -5 M -2 1 L -1 -1 L 1 -3 L 3 -4 L 6 -4 L 6 -5","-8 9 M 6 -2 L 5 -4 L 2 -5 L -1 -5 L -4 -4 L -5 -2 L -4 0 L -2 1 L 3 3 L 5 4 M 4 3 L 5 5 L 5 6 L 4 8 M 5 7 L 2 8 L -1 8 L -4 7 M -3 8 L -4 6 L -5 6 M 6 -2 L 5 -2 L 4 -4 M 5 -3 L 2 -4 L -1 -4 L -4 -3 M -3 -4 L -4 -2 L -3 0 M -4 -1 L -2 0 L 3 2 L 5 3 L 6 5 L 6 6 L 5 8 L 2 9 L -1 9 L -4 8 L -5 6","-5 6 M 0 -12 L 0 9 L 1 9 M 0 -12 L 1 -12 L 1 9 M -3 -5 L 4 -5 L 4 -4 M -3 -5 L -3 -4 L 4 -4","-10 10 M -6 -5 L -6 5 L -5 8 L -3 9 L 0 9 L 2 8 L 5 5 M -6 -5 L -5 -5 L -5 5 L -4 7 L -2 8 L 0 8 L 2 7 L 5 5 M 5 -5 L 5 9 L 6 9 M 5 -5 L 6 -5 L 6 9","-8 8 M -6 -5 L 0 9 M -6 -5 L -5 -5 L 0 7 M 6 -5 L 5 -5 L 0 7 M 6 -5 L 0 9","-12 12 M -9 -5 L -4 9 M -9 -5 L -8 -5 L -4 6 M 0 -5 L -4 6 M 0 -2 L -4 9 M 0 -2 L 4 9 M 0 -5 L 4 6 M 9 -5 L 8 -5 L 4 6 M 9 -5 L 4 9","-9 9 M -6 -5 L 5 9 L 6 9 M -6 -5 L -5 -5 L 6 9 M 6 -5 L 5 -5 L -6 9 M 6 -5 L -5 9 L -6 9","-8 8 M -6 -5 L 0 9 M -6 -5 L -5 -5 L 0 7 M 6 -5 L 5 -5 L 0 7 L -4 16 M 6 -5 L 0 9 L -3 16 L -4 16","-9 9 M 4 -4 L -6 9 M 6 -5 L -4 8 M -6 -5 L 6 -5 M -6 -5 L -6 -4 L 4 -4 M -4 8 L 6 8 L 6 9 M -6 9 L 6 9","-7 7 M 3 -16 L -4 0 L 3 16","-4 4 M 0 -16 L 0 16","-7 7 M -3 -16 L 4 0 L -3 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
gothiceng = ["-8 8","-6 6 M 0 -12 L -1 -11 L -3 -10 L -1 -9 L 0 2 M 0 -9 L 1 -10 L 0 -11 L -1 -10 L 0 -9 L 0 2 M 0 -12 L 1 -11 L 3 -10 L 1 -9 L 0 2 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 2 -12 L 4 -11 L 5 -9 L 5 -7 L 7 -8 L 6 -10 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -6 L -6 -4 L -3 -2 L 3 0 L 5 1 L 6 3 L 6 6 L 5 8 M 6 -8 L 5 -10 M -6 -6 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 2 M -5 7 L -6 5 M -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 3 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -5 4 L -5 6 L -4 8 L -2 9","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 7 -4 L 8 -3 L 9 -3 L 10 -4 M 6 -3 L 7 -2 L 9 -2 M 6 -2 L 7 -1 L 8 -1 L 9 -2 L 10 -4 M 7 -4 L 1 2 M 0 3 L -6 9 L -10 4 L -4 -2 M -3 -3 L 1 -7 L -3 -12 L -8 -6 L -2 0 L 2 6 L 4 8 L 6 9 L 8 9 L 9 8 L 10 6 M -6 8 L -9 4 M 0 -7 L -3 -11 M -7 -6 L -2 -1 L 2 5 L 4 7 L 6 8 L 9 8 M -5 8 L -9 3 M 0 -6 L -4 -11 M -7 -7 L -1 -1 L 3 5 L 4 6 L 6 7 L 9 7 L 10 6","-4 5 M 1 -12 L 0 -11 L 0 -5 M 1 -11 L 0 -5 M 1 -12 L 2 -11 L 0 -5","-7 7 M 3 -16 L 1 -14 L -1 -11 L -3 -7 L -4 -2 L -4 2 L -3 7 L -1 11 L 1 14 L 3 16 M -1 -10 L -2 -7 L -3 -3 L -3 3 L -2 7 L -1 10 M 1 -14 L 0 -12 L -1 -9 L -2 -3 L -2 3 L -1 9 L 0 12 L 1 14","-7 7 M -3 -16 L -1 -14 L 1 -11 L 3 -7 L 4 -2 L 4 2 L 3 7 L 1 11 L -1 14 L -3 16 M 1 -10 L 2 -7 L 3 -3 L 3 3 L 2 7 L 1 10 M -1 -14 L 0 -12 L 1 -9 L 2 -3 L 2 3 L 1 9 L 0 12 L -1 14","-8 8 M 0 -12 L -1 -11 L 1 -1 L 0 0 M 0 -12 L 0 0 M 0 -12 L 1 -11 L -1 -1 L 0 0 M -5 -9 L -4 -9 L 4 -3 L 5 -3 M -5 -9 L 5 -3 M -5 -9 L -5 -8 L 5 -4 L 5 -3 M 5 -9 L 4 -9 L -4 -3 L -5 -3 M 5 -9 L -5 -3 M 5 -9 L 5 -8 L -5 -4 L -5 -3","-12 13 M 0 -9 L 0 8 L 1 8 M 0 -9 L 1 -9 L 1 8 M -8 -1 L 9 -1 L 9 0 M -8 -1 L -8 0 L 9 0","-6 6 M 0 12 L 0 10 L -2 8 L 0 6 L 1 8 L 1 10 L 0 12 L -2 13 M 0 7 L -1 8 L 0 9 L 0 7","-13 13 M -9 0 L 9 0","-6 6 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-11 12 M 9 -16 L -9 16 L -8 16 M 9 -16 L 10 -16 L -8 16","-10 10 M -6 -10 L -6 6 L -8 7 M -5 -9 L -5 6 L -2 8 M -4 -10 L -4 6 L -2 7 L -1 8 M -6 -10 L -4 -10 L 1 -11 L 3 -12 M 1 -11 L 2 -10 L 4 -9 L 4 7 M 2 -11 L 5 -9 L 5 6 M 3 -12 L 4 -11 L 6 -10 L 8 -10 L 6 -9 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -3 -10 L -2 -9 L -1 -7 L -1 6 L -3 7 M -1 -9 L -2 -10 L -1 -11 L 0 -9 L 0 7 L 2 8 M -3 -10 L 0 -12 L 1 -10 L 1 6 L 3 7 L 4 7 M -3 7 L -2 7 L 0 8 L 1 9 L 2 8 L 4 7","-10 10 M -6 -10 L -4 -10 L -2 -11 L -1 -12 L 1 -11 L 4 -10 L 6 -10 M -2 -10 L 0 -11 M -6 -10 L -4 -9 L -2 -9 L 0 -10 L 1 -11 M 4 -10 L 4 -2 M 5 -9 L 5 -3 M 6 -10 L 6 -2 L -1 -2 L -4 -1 L -6 1 L -7 4 L -7 9 M -7 9 L -3 7 L 1 6 L 4 6 L 8 7 M -4 8 L -1 7 L 4 7 L 7 8 M -7 9 L -2 8 L 3 8 L 6 9 L 8 7","-10 10 M -6 -10 L -5 -10 L -3 -11 L -2 -12 L 0 -11 L 4 -10 L 6 -10 M -3 -10 L -1 -11 M -6 -10 L -4 -9 L -2 -9 L 0 -11 M 4 -10 L 4 -3 M 5 -9 L 5 -4 M 6 -10 L 6 -3 L 4 -3 L 1 -2 L -1 -1 M -1 -2 L 1 -1 L 4 0 L 6 0 L 6 7 M 5 1 L 5 6 M 4 0 L 4 7 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-10 10 M 3 -12 L -7 -2 L -7 3 L 2 3 M 4 3 L 8 3 L 9 4 L 9 2 L 8 3 M -6 -2 L -6 2 M -5 -4 L -5 3 M 2 -11 L 2 6 L 0 7 M 3 -8 L 4 -10 L 3 -11 L 3 7 L 5 8 M 3 -12 L 5 -10 L 4 -8 L 4 6 L 6 7 L 7 7 M 0 7 L 1 7 L 3 8 L 4 9 L 5 8 L 7 7","-10 10 M -6 -12 L -6 -3 M -6 -12 L 6 -12 M -5 -11 L 4 -11 M -6 -10 L 3 -10 L 5 -11 L 6 -12 M 4 -6 L 3 -5 L 1 -4 L -3 -3 L -6 -3 M 1 -4 L 2 -4 L 4 -3 L 4 7 M 3 -5 L 5 -4 L 5 6 M 4 -6 L 5 -5 L 7 -4 L 8 -4 L 6 -3 L 6 7 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-10 10 M -6 -10 L -6 6 L -8 7 M -5 -9 L -5 6 L -2 8 M -4 -10 L -4 6 L -2 7 L -1 8 M -6 -10 L -4 -10 L 0 -11 L 2 -12 L 3 -11 L 5 -10 L 6 -10 M 1 -11 L 3 -10 M 0 -11 L 2 -9 L 4 -9 L 6 -10 M -4 -2 L -3 -2 L 1 -3 L 3 -4 L 4 -5 M 1 -3 L 2 -3 L 4 -2 L 4 7 M 3 -4 L 5 -2 L 5 6 M 4 -5 L 5 -4 L 7 -3 L 8 -3 L 6 -2 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -7 -10 L -5 -12 L -2 -11 L 3 -11 L 8 -12 M -6 -11 L -3 -10 L 2 -10 L 5 -11 M -7 -10 L -3 -9 L 0 -9 L 4 -10 L 8 -12 M 8 -12 L 7 -10 L 5 -7 L 1 -3 L -1 0 L -2 3 L -2 6 L -1 9 M 0 -1 L -1 2 L -1 5 L 0 8 M 3 -5 L 1 -2 L 0 1 L 0 4 L 1 7 L -1 9","-10 10 M -6 -9 L -6 -3 M -5 -8 L -5 -4 M -4 -9 L -4 -3 M -6 -9 L -4 -9 L 1 -10 L 3 -11 L 4 -12 M 1 -10 L 2 -10 L 4 -9 L 4 -3 M 3 -11 L 5 -10 L 5 -4 M 4 -12 L 5 -11 L 7 -10 L 8 -10 L 6 -9 L 6 -3 M -6 -3 L -4 -3 L 4 0 L 6 0 M 6 -3 L 4 -3 L -4 0 L -6 0 M -6 0 L -6 6 L -8 7 M -5 1 L -5 6 L -2 8 M -4 0 L -4 6 L -2 7 L -1 8 M 4 0 L 4 7 M 5 1 L 5 6 M 6 0 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -6 -10 L -6 -1 L -8 0 M -5 -9 L -5 0 L -3 1 M -4 -10 L -4 -1 L -2 0 L -1 0 M -6 -10 L -4 -10 L 1 -11 L 3 -12 M 1 -11 L 2 -10 L 4 -9 L 4 7 M 2 -11 L 5 -9 L 5 6 M 3 -12 L 4 -11 L 6 -10 L 8 -10 L 6 -9 L 6 7 M -8 0 L -7 0 L -5 1 L -4 2 L -3 1 L -1 0 L 3 -1 L 4 -1 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-6 6 M 0 -5 L -2 -3 L 0 -2 L 2 -3 L 0 -5 M 0 -4 L -1 -3 L 1 -3 L 0 -4 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-6 6 M 0 -5 L -2 -3 L 0 -2 L 2 -3 L 0 -5 M 0 -4 L -1 -3 L 1 -3 L 0 -4 M 0 12 L 0 10 L -2 8 L 0 6 L 1 8 L 1 10 L 0 12 L -2 13 M 0 7 L -1 8 L 0 9 L 0 7","-12 12 M 8 -9 L -8 0 L 8 9","-12 13 M -8 -5 L 9 -5 L 9 -4 M -8 -5 L -8 -4 L 9 -4 M -8 3 L 9 3 L 9 4 M -8 3 L -8 4 L 9 4","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -6 -8 L -5 -10 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -2 L 1 -1 M -5 -8 L -4 -10 M 4 -10 L 5 -9 L 5 -5 L 4 -4 M -6 -8 L -4 -7 L -4 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 4 -9 L 4 -5 L 3 -3 L 1 -1 M 0 -1 L 0 2 L 1 -1 L -1 -1 L 0 2 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-11 11 M -6 -9 L -4 -11 L -2 -12 L 0 -12 L 1 -11 L 8 5 L 9 6 L 11 6 M -1 -11 L 0 -10 L 7 6 L 8 8 L 9 7 L 7 6 M -4 -11 L -2 -11 L -1 -10 L 6 6 L 7 8 L 8 9 L 9 9 L 11 6 M -6 -5 L -5 -6 L -3 -7 L -2 -7 L -1 -6 M -2 -6 L -2 -5 M -5 -6 L -3 -6 L -2 -4 M -11 9 L -9 7 L -7 6 L -4 6 L -2 7 M -8 7 L -4 7 L -3 8 M -11 9 L -8 8 L -5 8 L -4 9 L -2 7 M 0 -8 L -6 6 M -4 1 L 4 1","-12 12 M -10 -10 L -8 -12 L -5 -12 L -3 -11 L -1 -12 M -7 -11 L -4 -11 M -10 -10 L -8 -11 L -6 -10 L -3 -10 L -1 -12 M -5 -7 L -6 -6 L -7 -4 L -7 -3 L -9 -3 L -10 -2 L -10 0 L -9 -1 L -7 -1 L -7 5 M -6 -5 L -6 3 M -9 -2 L -6 -2 M -5 -7 L -5 2 L -6 4 L -7 5 M 0 -9 L -1 -8 L -2 -6 L -2 3 M -1 -7 L -1 1 M 0 -9 L 0 0 L -1 2 L -2 3 M 0 -9 L 6 -12 L 8 -11 L 9 -9 L 9 -7 L 7 -5 L 3 -3 M 6 -11 L 8 -9 L 8 -7 M 4 -11 L 6 -10 L 7 -9 L 7 -6 L 5 -4 M 5 -4 L 8 -2 L 9 0 L 9 6 M 7 -2 L 8 0 L 8 5 M 5 -4 L 6 -3 L 7 -1 L 7 6 M -8 9 L -5 7 L -2 6 L 2 6 L 5 7 M -6 8 L -3 7 L 2 7 L 4 8 M -8 9 L -4 8 L 1 8 L 3 9 L 5 7 L 7 6 L 9 6 M 3 -3 L 3 6 M 3 0 L 7 0 M 3 3 L 7 3","-13 11 M -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 1 L -9 4 L -8 6 L -5 8 L -2 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 M -8 -7 L -9 -4 L -9 1 L -7 5 L -4 7 L -1 8 L 2 8 L 5 7 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 0 L -7 3 L -4 6 L -1 7 L 2 7 L 5 6 L 7 5 L 9 3 M -2 -8 L -2 4 M -1 -8 L -1 2 M 0 -9 L 0 1 L -1 3 L -2 4 M -2 -8 L 0 -9 L 3 -12 L 5 -11 L 7 -11 L 8 -12 M 2 -11 L 4 -10 L 6 -10 M 1 -10 L 3 -9 L 5 -9 L 7 -10 L 8 -12 M 5 -9 L 5 6","-11 12 M -9 -12 L 5 -12 L 7 -11 L 8 -9 L 8 6 M -7 -11 L 5 -11 L 7 -9 L 7 5 M -9 -12 L -8 -11 L -6 -10 L 5 -10 L 6 -9 L 6 6 M -3 -7 L -4 -6 L -5 -4 L -5 -3 L -7 -3 L -8 -2 L -8 0 L -7 -1 L -5 -1 L -5 4 M -4 -5 L -4 2 M -7 -2 L -4 -2 M -3 -7 L -3 1 L -4 3 L -5 4 M -9 9 L -6 7 L -3 6 L 1 6 L 4 7 M -7 8 L -4 7 L 1 7 L 3 8 M -9 9 L -5 8 L 0 8 L 2 9 L 4 7 L 6 6 L 8 6 M 0 -10 L 0 6 M 0 -5 L 2 -4 L 4 -4 L 6 -5 M 0 1 L 2 0 L 4 0 L 6 1","-11 11 M -9 -10 L -7 -12 L -5 -12 L -3 -11 L -1 -12 M -6 -11 L -4 -11 M -9 -10 L -7 -11 L -5 -10 L -3 -10 L -1 -12 M -4 -7 L -5 -6 L -6 -4 L -6 -3 L -8 -3 L -9 -2 L -9 0 L -8 -1 L -6 -1 L -6 5 M -5 -5 L -5 3 M -8 -2 L -5 -2 M -4 -7 L -4 2 L -5 4 L -6 5 M -1 -5 L 0 -8 L 1 -10 L 2 -11 L 4 -12 L 6 -12 L 9 -11 M 2 -10 L 4 -11 L 6 -11 L 8 -10 M 0 -8 L 1 -9 L 3 -10 L 5 -10 L 7 -9 L 9 -11 M -1 3 L 0 0 L 1 -2 L 2 -3 L 4 -3 L 6 -2 M 2 -2 L 4 -2 L 5 -1 M 0 0 L 1 -1 L 3 -1 L 4 0 L 6 -2 M -7 9 L -4 7 L 0 6 L 5 6 L 9 7 M -5 8 L -2 7 L 5 7 L 8 8 M -7 9 L -3 8 L 4 8 L 7 9 L 9 7 M -1 -5 L -1 6","-12 11 M -8 -10 L -6 -12 L -3 -12 L -1 -11 L 1 -12 M -5 -11 L -2 -11 M -8 -10 L -6 -11 L -4 -10 L -1 -10 L 1 -12 M -2 -7 L -3 -6 L -4 -4 L -4 -3 L -6 -3 L -7 -2 L -7 0 L -6 -1 L -4 -1 L -4 4 M -3 -5 L -3 2 M -6 -2 L -3 -2 M -2 -7 L -2 1 L -3 3 L -4 4 M 1 -8 L 1 7 L 0 8 L -1 8 L -5 6 L -7 6 L -9 7 L -11 9 M 2 -8 L 2 6 M 2 -2 L 6 -2 M -2 8 L -3 8 L -5 7 L -8 7 M 3 -9 L 3 -3 L 6 -3 M 6 -1 L 3 -1 L 3 5 L 2 7 L -2 9 L -4 9 L -6 8 L -8 8 L -11 9 M 1 -8 L 3 -9 L 6 -12 L 8 -11 L 10 -11 L 11 -12 M 5 -11 L 7 -10 L 9 -10 M 4 -10 L 6 -9 L 8 -9 L 10 -10 L 11 -12 M 6 -9 L 6 5","-13 12 M -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 3 9 L 6 8 L 8 6 L 9 4 L 9 1 L 8 -1 L 7 -2 L 5 -3 L 3 -3 M -8 -7 L -9 -4 L -9 1 L -8 4 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 M 7 6 L 8 5 L 8 1 L 7 -1 M 3 9 L 5 8 L 6 7 L 7 5 L 7 1 L 6 -1 L 5 -2 L 3 -3 M -2 -8 L -2 5 M -1 -8 L -1 3 M 0 -9 L 0 2 L -1 4 L -2 5 M -2 -8 L 0 -9 L 3 -12 L 5 -11 L 7 -11 L 8 -12 M 2 -11 L 4 -10 L 6 -10 M 1 -10 L 3 -9 L 5 -9 L 7 -10 L 8 -12 M 7 -10 L 3 -3 L 3 9 M 3 1 L 7 1 M 3 4 L 7 4","-12 12 M -10 -10 L -8 -12 L -5 -12 L -3 -11 L -1 -12 M -7 -11 L -4 -11 M -10 -10 L -8 -11 L -6 -10 L -3 -10 L -1 -12 M -5 -7 L -6 -6 L -7 -4 L -7 -3 L -9 -3 L -10 -2 L -10 0 L -9 -1 L -7 -1 L -7 5 M -6 -5 L -6 3 M -9 -2 L -6 -2 M -5 -7 L -5 2 L -6 4 L -7 5 M -8 9 L -5 7 L -2 6 L 1 6 L 3 7 M -6 8 L -3 7 L 0 7 L 2 8 M -8 9 L -4 8 L -1 8 L 1 9 L 3 7 M 0 -9 L -1 -8 L -2 -6 L -2 3 M -1 -7 L -1 1 M 0 -9 L 0 0 L -1 2 L -2 3 M 0 -9 L 2 -11 L 4 -12 L 6 -12 L 8 -11 M 5 -11 L 6 -11 L 7 -10 M 2 -11 L 4 -11 L 6 -9 L 8 -11 M 3 -3 L 5 -4 L 7 -6 L 8 -5 L 9 -2 L 9 2 L 8 6 L 6 9 M 6 -5 L 7 -4 L 8 -2 L 8 3 L 7 6 M 5 -4 L 6 -4 L 7 -2 L 7 3 L 6 9 M 3 -3 L 3 7 M 3 0 L 7 0 M 3 3 L 7 3","-9 10 M -6 -10 L -4 -12 L -1 -12 L 2 -11 L 4 -12 M -3 -11 L 1 -11 M -6 -10 L -4 -11 L -1 -10 L 2 -10 L 4 -12 M 1 -7 L 0 -6 L -1 -4 L -1 -3 L -3 -3 L -4 -2 L -4 0 L -3 -1 L -1 -1 L -1 4 M 0 -5 L 0 2 M -3 -2 L 0 -2 M 1 -7 L 1 1 L 0 3 L -1 4 M 7 -10 L 5 -8 L 4 -5 L 4 6 L 3 8 L 1 8 L -3 6 L -5 6 L -7 7 L -9 9 M 5 -7 L 5 5 M 0 8 L -1 8 L -3 7 L -6 7 M 7 -10 L 6 -8 L 6 4 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -7 8 L -9 9","-10 10 M -6 -10 L -4 -12 L -1 -12 L 2 -11 L 4 -12 M -3 -11 L 1 -11 M -6 -10 L -4 -11 L -1 -10 L 2 -10 L 4 -12 M 1 -7 L 0 -6 L -1 -4 L -1 -3 L -3 -3 L -4 -2 L -4 0 L -3 -1 L -1 -1 L -1 4 M 0 -5 L 0 2 M -3 -2 L 0 -2 M 1 -7 L 1 1 L 0 3 L -1 4 M 7 -10 L 5 -8 L 4 -5 L 4 6 L 3 8 M 5 -7 L 5 5 M 7 -10 L 6 -8 L 6 4 L 5 6 L 3 8 L 0 9 L -3 9 L -6 8 L -8 6 L -8 4 L -7 3 L -6 3 L -5 4 L -6 5 L -7 5 M -8 4 L -5 4","-12 12 M -10 -10 L -8 -12 L -5 -12 L -3 -11 L -1 -12 M -7 -11 L -4 -11 M -10 -10 L -8 -11 L -6 -10 L -3 -10 L -1 -12 M -5 -7 L -6 -6 L -7 -4 L -7 -3 L -9 -3 L -10 -2 L -10 0 L -9 -1 L -7 -1 L -7 5 M -6 -5 L -6 3 M -9 -2 L -6 -2 M -5 -7 L -5 2 L -6 4 L -7 5 M -8 9 L -5 7 L -2 6 L 1 6 L 3 7 M -6 8 L -4 7 L 0 7 L 2 8 M -8 9 L -4 8 L -1 8 L 1 9 L 3 7 M 0 -9 L -1 -8 L -2 -6 L -2 3 M -1 -7 L -1 1 M 0 -9 L 0 0 L -1 2 L -2 3 M 0 -9 L 2 -11 L 4 -12 L 6 -12 L 8 -11 M 5 -11 L 6 -11 L 7 -10 M 2 -11 L 4 -11 L 6 -9 L 8 -11 M 3 -3 L 6 -6 L 7 -5 L 9 -4 M 5 -5 L 7 -4 L 9 -4 M 9 -4 L 7 -1 L 5 1 L 3 3 M 5 1 L 7 2 L 8 6 L 9 8 L 10 8 M 7 4 L 8 8 M 5 1 L 6 2 L 7 8 L 8 9 L 9 9 L 10 8 M 3 -3 L 3 7","-11 11 M -9 -10 L -7 -12 L -4 -12 L -2 -11 L 0 -12 M -6 -11 L -3 -11 M -9 -10 L -7 -11 L -5 -10 L -2 -10 L 0 -12 M -4 -7 L -5 -6 L -6 -4 L -6 -3 L -8 -3 L -9 -2 L -9 0 L -8 -1 L -6 -1 L -6 5 M -5 -5 L -5 3 M -8 -2 L -5 -2 M -4 -7 L -4 2 L -5 4 L -6 5 M -7 9 L -4 7 L 0 6 L 5 6 L 9 7 M -5 8 L -2 7 L 5 7 L 8 8 M -7 9 L -3 8 L 4 8 L 7 9 L 9 7 M 1 -9 L 0 -8 L -1 -6 L -1 3 M 0 -7 L 0 1 M 1 -9 L 1 0 L 0 2 L -1 3 M 1 -9 L 3 -11 L 5 -12 L 7 -12 L 9 -11 M 6 -11 L 7 -11 L 8 -10 M 3 -11 L 5 -11 L 7 -9 L 9 -11 M 5 -11 L 5 6","-14 14 M -6 -8 L -7 -7 L -8 -5 L -8 -3 L -10 -3 L -11 -2 L -11 0 L -10 -1 L -8 -1 L -8 3 M -7 -6 L -7 1 M -10 -2 L -7 -2 M -6 -8 L -6 0 L -7 2 L -8 3 M -13 9 L -11 7 L -9 6 L -7 6 L -5 7 L -4 7 L -3 6 M -10 7 L -7 7 L -5 8 M -13 9 L -11 8 L -8 8 L -6 9 L -5 9 L -4 8 L -3 6 M -6 -8 L -2 -12 L 2 -8 L 2 5 L 3 7 L 4 7 M -2 -11 L 1 -8 L 1 6 L 0 7 L 1 8 L 2 7 L 1 6 M -2 -2 L 1 -2 M -4 -10 L -3 -10 L 0 -7 L 0 -3 L -3 -3 M -3 -1 L 0 -1 L 0 6 L -1 7 L 1 9 L 4 7 L 5 6 M 2 -8 L 6 -12 L 10 -8 L 10 5 L 11 7 L 12 7 M 6 -11 L 9 -8 L 9 6 L 11 8 M 6 -2 L 9 -2 M 4 -10 L 5 -10 L 8 -7 L 8 -3 L 5 -3 M 5 -1 L 8 -1 L 8 7 L 10 9 L 12 7 M -3 -10 L -3 6 M 5 -10 L 5 6","-13 12 M -11 -9 L -9 -11 L -7 -12 L -5 -12 L -3 -11 L -1 -8 L 4 3 L 6 6 L 7 7 M -5 -11 L -3 -9 L -2 -7 L 4 5 L 7 8 M -9 -11 L -7 -11 L -5 -10 L -3 -7 L 2 4 L 4 7 L 5 8 L 7 9 M 4 -10 L 6 -9 L 8 -9 L 10 -10 L 11 -12 M 5 -11 L 7 -10 L 9 -10 M 4 -10 L 6 -12 L 8 -11 L 10 -11 L 11 -12 M -7 -3 L -9 -3 L -10 -2 L -10 0 L -9 -1 L -7 -1 M -9 -2 L -7 -2 M -11 9 L -9 7 L -7 6 L -4 6 L -2 7 M -8 7 L -5 7 L -3 8 M -11 9 L -8 8 L -5 8 L -4 9 L -2 7 M -7 -11 L -7 6 M 7 -9 L 7 9 M 0 -6 L 1 -5 L 3 -4 L 5 -4 L 7 -5 M -7 2 L -5 1 L -1 1 L 1 2","-13 13 M -4 -12 L -6 -11 L -8 -9 L -9 -7 L -10 -4 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 L 10 0 L 10 -4 L 9 -7 L 8 -9 L 6 -11 L 4 -12 L 3 -11 L 0 -9 L -3 -8 M -8 -8 L -9 -5 L -9 1 L -8 4 M -4 -12 L -6 -10 L -7 -8 L -8 -5 L -8 1 L -7 4 L -6 6 L -4 8 M 8 4 L 9 1 L 9 -5 L 7 -9 L 6 -10 M 4 8 L 6 6 L 7 4 L 8 1 L 8 -5 L 7 -7 L 5 -10 L 3 -11 M -3 -8 L -3 5 M -2 -8 L -2 3 M -1 -8 L -1 2 L -2 4 L -3 5 M 3 -11 L 3 8 M 3 -5 L 5 -4 L 6 -4 L 8 -5 M 3 1 L 5 0 L 6 0 L 8 1","-10 12 M -7 -12 L -6 -11 L -5 -9 L -5 -3 L -7 -3 L -8 -2 L -8 0 L -7 -1 L -5 -1 L -5 7 L -8 9 L -5 8 L -5 16 L -3 14 M -5 -10 L -4 -8 L -4 14 M -7 -2 L -4 -2 M -7 -12 L -5 -11 L -4 -10 L -3 -8 L -3 14 M -3 -7 L 0 -9 L 4 -12 L 8 -8 L 8 6 M 4 -11 L 7 -8 L 7 6 M 2 -10 L 3 -10 L 6 -7 L 6 7 M 0 6 L 3 6 L 6 7 M 1 7 L 3 7 L 5 8 M 0 8 L 2 8 L 4 9 L 6 7 L 8 6 M 0 -9 L 0 13 M 0 -5 L 2 -4 L 4 -4 L 6 -5 M 0 1 L 2 0 L 4 0 L 6 1","-13 13 M -4 -12 L -6 -11 L -8 -9 L -9 -7 L -10 -4 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -2 9 L 2 9 L 4 8 L 6 7 L 8 5 L 9 3 L 10 0 L 10 -4 L 9 -7 L 8 -9 L 6 -11 L 4 -12 L 3 -11 L 0 -9 L -3 -8 M -8 -8 L -9 -5 L -9 1 L -8 4 M -4 -12 L -6 -10 L -7 -8 L -8 -5 L -8 1 L -7 4 L -6 6 L -4 8 M 8 4 L 9 1 L 9 -5 L 7 -9 L 6 -10 M 4 8 L 6 6 L 7 4 L 8 1 L 8 -5 L 7 -7 L 5 -10 L 3 -11 M -3 -8 L -3 5 M -2 -8 L -2 3 M -1 -8 L -1 2 L -2 4 L -3 5 M 3 -11 L 3 8 M 3 -5 L 5 -4 L 6 -4 L 8 -5 M 3 1 L 5 0 L 6 0 L 8 1 M -2 9 L -1 8 L 0 8 L 2 9 L 6 14 L 8 15 L 9 15 M 2 10 L 4 13 L 6 15 L 7 15 M 0 8 L 1 9 L 4 15 L 6 16 L 8 16 L 9 15","-12 12 M -10 -10 L -8 -12 L -5 -12 L -3 -11 L -1 -12 M -7 -11 L -4 -11 M -10 -10 L -8 -11 L -6 -10 L -3 -10 L -1 -12 M -5 -7 L -6 -6 L -7 -4 L -7 -3 L -9 -3 L -10 -2 L -10 0 L -9 -1 L -7 -1 L -7 5 M -6 -5 L -6 3 M -9 -2 L -6 -2 M -5 -7 L -5 2 L -6 4 L -7 5 M -8 9 L -5 7 L -2 6 L 0 6 L 3 7 M -6 8 L -4 7 L 0 7 L 2 8 M -8 9 L -4 8 L -1 8 L 1 9 L 3 7 M 0 -9 L -1 -8 L -2 -6 L -2 3 M -1 -7 L -1 1 M 0 -9 L 0 0 L -1 2 L -2 3 M 0 -9 L 3 -11 L 5 -12 L 7 -11 L 8 -9 L 8 -6 L 7 -4 L 6 -3 L 2 -1 L 0 0 M 5 -11 L 6 -11 L 7 -9 L 7 -5 L 6 -4 M 3 -11 L 5 -10 L 6 -8 L 6 -5 L 5 -3 L 2 -1 M 2 -1 L 4 0 L 5 1 L 8 6 L 9 7 L 10 7 M 5 2 L 7 6 L 9 8 M 2 -1 L 4 1 L 6 7 L 8 9 L 10 7","-11 12 M 3 -9 L 2 -10 L 0 -11 L -3 -12 M 4 -10 L 2 -11 M 5 -11 L 1 -12 L -3 -12 L -6 -11 L -7 -10 L -8 -8 L -7 -6 L -6 -5 L -3 -4 L 5 -4 L 7 -3 L 8 -2 L 8 0 L 7 3 M -7 -7 L -6 -6 L -3 -5 L 6 -5 L 8 -4 L 9 -3 L 9 -1 L 8 1 M -7 -10 L -7 -8 L -6 -7 L -3 -6 L 7 -6 L 9 -5 L 10 -3 L 10 -1 L 7 3 L 3 9 M -9 -3 L -8 -2 L -6 -1 L 3 -1 L 4 0 L 4 1 L 3 3 M -8 -1 L -6 0 L 2 0 L 3 1 M -9 -3 L -9 -2 L -8 0 L -6 1 L 1 1 L 3 2 L 3 3 M -9 9 L -6 7 L -2 6 L 1 6 L 4 7 M -7 8 L -4 7 L 0 7 L 3 8 M -9 9 L -5 8 L 0 8 L 3 9 M 5 -11 L 3 -9 L 1 -6 M 0 -4 L -2 -1 M -3 1 L -5 3 L -7 4 L -8 4 L -8 3 L -7 4","-13 11 M -8 -8 L -9 -6 L -10 -3 L -10 1 L -9 4 L -7 7 L -5 8 L -2 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 M -9 1 L -8 4 L -6 6 L -4 7 L -1 8 L 2 8 L 5 7 M -8 -8 L -9 -5 L -9 -1 L -8 2 L -6 5 L -4 6 L -1 7 L 2 7 L 5 6 L 7 5 L 9 3 M -10 -9 L -9 -11 L -7 -12 L -3 -12 L 3 -11 L 7 -11 L 9 -12 M -2 -11 L 2 -10 L 6 -10 M -10 -9 L -9 -10 L -7 -11 L -4 -11 L 2 -9 L 5 -9 L 7 -10 L 9 -12 M 1 -9 L 0 -8 L -2 -7 L -2 4 M -1 -7 L -1 2 M 0 -8 L 0 1 L -1 3 L -2 4 M 5 -9 L 5 6","-12 12 M -10 -10 L -8 -12 L -6 -12 L -3 -11 L -1 -12 M -7 -11 L -4 -11 M -10 -10 L -8 -11 L -5 -10 L -3 -10 L -1 -12 M -7 -8 L -8 -6 L -9 -3 L -9 1 L -8 4 L -7 6 L -5 8 L -2 9 L 1 9 L 4 8 L 6 7 L 8 9 L 10 7 M -8 1 L -7 4 L -4 7 L -1 8 L 2 8 M -7 -8 L -8 -4 L -8 -1 L -7 2 L -6 4 L -4 6 L -1 7 L 3 7 L 6 6 M 3 -9 L -1 -8 L -2 -6 L -2 4 M -1 -7 L -1 2 M 0 -8 L 0 1 L -1 3 L -2 4 M 3 -9 L 5 -10 L 7 -12 L 8 -11 L 10 -10 L 8 -9 L 8 5 L 9 7 L 10 7 M 7 -9 L 8 -10 L 7 -11 L 6 -10 L 7 -9 L 7 6 L 9 8 M 5 -10 L 6 -9 L 6 6 M 3 -9 L 3 7 M 3 -4 L 6 -4 M 3 0 L 6 0","-11 12 M -8 -12 L -7 -11 L -6 -9 L -6 -3 L -8 -3 L -9 -2 L -9 0 L -8 -1 L -6 -1 L -6 6 L -8 7 M -6 -10 L -5 -8 L -5 6 M -8 -2 L -5 -2 M -4 7 L -1 7 L 1 8 M -8 -12 L -6 -11 L -5 -10 L -4 -8 L -4 6 L 0 6 L 3 7 M -8 7 L -5 7 L -2 8 L 0 9 L 3 7 L 6 6 L 8 6 M 0 -8 L 3 -9 L 5 -10 L 7 -12 L 8 -11 L 10 -10 L 8 -9 L 8 6 M 7 -9 L 8 -10 L 7 -11 L 6 -10 L 7 -9 L 7 5 M 5 -10 L 6 -9 L 6 6 M 0 -8 L 0 6 M 0 -5 L 2 -4 L 4 -4 L 6 -5 M 0 1 L 2 0 L 4 0 L 6 1","-13 14 M -10 -12 L -9 -11 L -8 -9 L -8 -3 L -10 -3 L -11 -2 L -11 0 L -10 -1 L -8 -1 L -8 6 L -10 7 M -8 -10 L -7 -8 L -7 6 M -10 -2 L -7 -2 M -6 7 L -4 7 L -2 8 M -10 -12 L -8 -11 L -7 -10 L -6 -8 L -6 6 L -3 6 L -1 7 M -10 7 L -7 7 L -4 8 L -3 9 L -1 7 L 2 6 L 4 7 L 5 9 L 7 7 L 10 6 M -3 -10 L 0 -12 L 2 -10 L 2 6 L 5 6 L 7 7 M 0 -11 L 1 -10 L 1 6 M -3 -10 L -1 -10 L 0 -9 L 0 6 L -1 7 M 5 7 L 6 8 M 5 -10 L 8 -12 L 10 -10 L 10 6 M 8 -11 L 9 -10 L 9 6 M 5 -10 L 7 -10 L 8 -9 L 8 6 L 7 7 M -3 -10 L -3 6 M 5 -10 L 5 6 M -3 -4 L 0 -4 M -3 0 L 0 0 M 5 -4 L 8 -4 M 5 0 L 8 0","-11 11 M -10 -9 L -8 -11 L -6 -12 L -4 -12 L -3 -11 L 5 7 L 6 8 L 8 8 M -5 -11 L -4 -10 L 4 7 L 5 8 M -8 -11 L -6 -11 L -5 -10 L 3 8 L 4 9 L 6 9 L 8 8 L 10 6 M 5 -12 L 7 -11 L 9 -11 L 10 -12 M 5 -11 L 6 -10 L 8 -10 M 4 -10 L 5 -9 L 7 -9 L 9 -10 L 10 -12 M -10 9 L -9 7 L -7 6 L -5 6 L -4 7 M -8 7 L -6 7 L -5 8 M -10 9 L -9 8 L -7 8 L -5 9 M 5 -12 L 1 -3 M -1 0 L -5 9 M -6 -2 L -2 -2 M 1 -2 L 6 -2","-11 12 M -8 -12 L -7 -11 L -6 -9 L -6 -3 L -8 -3 L -9 -2 L -9 0 L -8 -1 L -6 -1 L -6 6 L -8 7 M -6 -10 L -5 -8 L -5 6 M -8 -2 L -5 -2 M -4 7 L -1 7 L 1 8 M -8 -12 L -6 -11 L -5 -10 L -4 -8 L -4 6 L 0 6 L 3 7 M -8 7 L -5 7 L -2 8 L 0 9 L 3 7 L 6 6 M 0 -8 L 3 -9 L 5 -10 L 7 -12 L 8 -11 L 10 -10 L 8 -9 L 8 12 L 7 14 L 5 16 L 3 15 L -1 14 L -6 14 M 7 -9 L 8 -10 L 7 -11 L 6 -10 L 7 -9 L 7 7 M 5 -10 L 6 -9 L 6 6 L 8 9 M 6 15 L 4 14 L 1 14 M 7 14 L 4 13 L -2 13 L -6 14 M 0 -8 L 0 6 M 0 -5 L 2 -4 L 4 -4 L 6 -5 M 0 1 L 2 0 L 4 0 L 6 1","-10 10 M 6 -11 L 5 -9 L 0 -3 L -3 1 L -5 5 L -8 9 M 4 -7 L -4 4 M 8 -12 L 5 -8 L 3 -4 L 0 0 L -5 6 L -6 8 M -8 -10 L -6 -12 L -3 -11 L 3 -11 L 8 -12 M -7 -11 L -3 -10 L 1 -10 L 5 -11 M -8 -10 L -4 -9 L 0 -9 L 4 -10 L 6 -11 M -6 8 L -4 7 L 0 6 L 4 6 L 8 7 M -5 8 L -1 7 L 3 7 L 7 8 M -8 9 L -3 8 L 3 8 L 6 9 L 8 7 M -5 -2 L -1 -2 M 2 -2 L 6 -2","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-11 11 M -11 16 L 11 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-8 9 M -2 0 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9 L 0 7 L 3 6 M -5 4 L -4 6 L -3 7 L -1 8 M -4 2 L -4 4 L -3 6 L -1 7 L 0 7 M -4 -2 L -2 -2 L 1 -3 L 3 -4 L 4 -5 L 6 -3 L 5 -2 L 5 6 L 6 7 L 7 7 M -3 -4 L -4 -3 L -1 -3 M 2 -3 L 5 -3 L 4 -4 L 4 7 L 5 8 M -5 -3 L -3 -5 L -2 -4 L 0 -3 L 3 -2 L 3 7 L 5 9 L 7 7 M -5 -3 L 0 2","-9 9 M -6 -10 L -5 -8 L -5 6 L -7 7 M -4 -8 L -5 -10 L -4 -11 L -4 6 L -1 8 M -6 -10 L -3 -12 L -3 6 L -1 7 L 0 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 3 7 L 5 7 M -3 -2 L 0 -3 L 2 -4 L 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 7 M 2 -4 L 4 -3 L 4 6 M 0 -3 L 1 -3 L 3 -2 L 3 7","-8 6 M -4 -3 L -4 6 L -6 7 L -5 7 L -3 8 L -2 9 M -3 -3 L -3 7 L -1 8 M -2 -3 L -2 6 L 0 7 L 1 7 L -1 8 L -2 9 M -4 -3 L 0 -4 L 2 -5 L 3 -4 L 5 -3 L 6 -3 M 1 -4 L 2 -3 L 4 -3 M -2 -3 L 0 -4 L 2 -2 L 4 -2 L 6 -3","-9 8 M 0 -5 L -2 -4 L -5 -3 L -5 6 L -7 7 M -4 -3 L -4 6 L -1 8 M 0 -5 L -3 -3 L -3 6 L -1 7 L 0 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 3 7 L 5 7 M -5 -10 L -2 -12 L -1 -9 L 5 -3 L 5 7 M -2 -9 L -4 -10 L -3 -11 L -2 -9 L 4 -3 L 4 6 M -5 -10 L 3 -2 L 3 7","-8 6 M -4 -3 L -4 6 L -6 7 L -5 7 L -3 8 L -2 9 M -3 -3 L -3 7 L -1 8 M -2 -3 L -2 6 L 0 7 L 1 7 L -1 8 L -2 9 M -4 -3 L 0 -4 L 2 -5 L 5 -1 L 3 0 L -2 3 M 1 -4 L 4 -1 M -2 -3 L 0 -4 L 3 0","-8 5 M -4 -10 L -4 6 L -6 7 L -5 7 L -3 8 L -2 9 M -3 -10 L -3 7 L -1 8 M -2 -10 L -2 6 L 0 7 L 1 7 L -1 8 L -2 9 M -4 -10 L -1 -11 L 1 -12 L 2 -11 L 4 -10 L 5 -10 M 0 -11 L 1 -10 L 3 -10 M -2 -10 L -1 -11 L 1 -9 L 3 -9 L 5 -10 M -7 -5 L -4 -5 M -2 -5 L 2 -5","-9 9 M -5 -3 L -5 6 L -7 7 L -6 7 L -4 8 L -3 9 L -2 8 L 0 7 L 3 6 M -4 -2 L -4 7 L -2 8 M -3 -3 L -3 6 L -1 7 L 0 7 M -5 -3 L -3 -3 L 0 -4 L 2 -5 L 3 -4 L 5 -3 L 7 -3 L 5 -2 L 5 10 L 4 13 L 2 15 L 0 16 L -1 15 L -3 14 L -5 14 M 1 -4 L 4 -2 L 4 10 M 1 15 L -1 14 L -2 14 M 0 -4 L 1 -3 L 3 -2 L 3 8 L 4 11 L 4 13 M 2 15 L 1 14 L -1 13 L -3 13 L -5 14","-9 9 M -6 -10 L -5 -8 L -5 6 L -7 7 L -6 7 L -4 8 L -3 9 M -4 -8 L -5 -10 L -4 -11 L -4 7 L -2 8 M -6 -10 L -3 -12 L -3 6 L -1 7 L -3 9 M -3 -2 L 0 -3 L 2 -4 L 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 7 L 3 9 L 2 11 M 2 -4 L 4 -3 L 4 7 L 3 9 M 0 -3 L 1 -3 L 3 -2 L 3 7 L 2 11 L 2 14 L 3 16 L 4 16 L 2 14","-5 5 M 0 -12 L -2 -10 L 0 -9 L 2 -10 L 0 -12 M 0 -11 L -1 -10 L 1 -10 L 0 -11 M 0 -5 L -1 -4 L -3 -3 L -1 -2 L -1 7 L 1 9 L 3 7 M 0 -2 L 1 -3 L 0 -4 L -1 -3 L 0 -2 L 0 7 L 1 8 M 0 -5 L 1 -4 L 3 -3 L 1 -2 L 1 6 L 2 7 L 3 7","-5 5 M 0 -12 L -2 -10 L 0 -9 L 2 -10 L 0 -12 M 0 -11 L -1 -10 L 1 -10 L 0 -11 M 0 -5 L -1 -4 L -3 -3 L -1 -2 L -1 7 L 1 9 L 2 11 M 0 -2 L 1 -3 L 0 -4 L -1 -3 L 0 -2 L 0 7 L 1 9 M 0 -5 L 1 -4 L 3 -3 L 1 -2 L 1 7 L 2 11 L 2 14 L 0 16 L -2 16 L -2 15 L 0 16","-9 8 M -6 -10 L -5 -8 L -5 6 L -7 7 L -6 7 L -4 8 L -3 9 M -4 -8 L -5 -10 L -4 -11 L -4 7 L -2 8 M -6 -10 L -3 -12 L -3 6 L -1 7 L -3 9 M -3 -2 L 0 -4 L 2 -5 L 4 -2 L 1 0 L -3 3 M 1 -4 L 3 -2 M 0 -4 L 2 -1 M 1 0 L 2 1 L 4 6 L 5 7 L 6 7 M 1 1 L 2 2 L 3 7 L 4 8 M 0 1 L 1 2 L 2 7 L 4 9 L 6 7","-5 5 M -2 -10 L -1 -8 L -1 6 L -3 7 L -2 7 L 0 8 L 1 9 M 0 -8 L -1 -10 L 0 -11 L 0 7 L 2 8 M -2 -10 L 1 -12 L 1 6 L 3 7 L 4 7 L 2 8 L 1 9","-13 13 M -11 -3 L -10 -3 L -9 -2 L -9 6 L -11 7 L -10 7 L -8 8 L -7 9 M -9 -4 L -8 -3 L -8 7 L -6 8 M -11 -3 L -9 -5 L -7 -3 L -7 6 L -5 7 L -7 9 M -7 -2 L -4 -3 L -2 -4 L -1 -5 L 1 -3 L 1 6 L 3 7 L 1 9 M -2 -4 L 0 -3 L 0 7 L 2 8 M -4 -3 L -3 -3 L -1 -2 L -1 6 L -2 7 L 0 8 L 1 9 M 1 -2 L 4 -3 L 6 -4 L 7 -5 L 8 -4 L 10 -3 L 11 -3 L 9 -2 L 9 6 L 10 7 L 11 7 M 6 -4 L 8 -3 L 8 7 L 9 8 M 4 -3 L 5 -3 L 7 -2 L 7 7 L 9 9 L 11 7","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 6 L -7 7 L -6 7 L -4 8 L -3 9 M -5 -4 L -4 -3 L -4 7 L -2 8 M -7 -3 L -5 -5 L -3 -3 L -3 6 L -1 7 L -3 9 M -3 -2 L 0 -3 L 2 -4 L 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 6 L 6 7 L 7 7 M 2 -4 L 4 -3 L 4 7 L 5 8 M 0 -3 L 1 -3 L 3 -2 L 3 7 L 5 9 L 7 7","-9 9 M -5 -3 L -5 6 L -7 7 M -4 -2 L -4 6 L -1 8 M -3 -3 L -3 6 L -1 7 L 0 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 3 7 L 5 7 M -5 -3 L -3 -3 L 0 -4 L 2 -5 L 3 -4 L 5 -3 L 7 -3 L 5 -2 L 5 7 M 1 -4 L 4 -2 L 4 6 M 0 -4 L 1 -3 L 3 -2 L 3 7","-9 9 M -6 -5 L -5 -3 L -5 6 L -7 7 L -5 7 L -5 16 M -5 -4 L -4 -3 L -4 15 L -3 14 L -4 12 M -4 7 L -3 7 L -1 8 M -6 -5 L -4 -4 L -3 -3 L -3 6 L -1 7 L 0 8 M -3 8 L -2 9 L 0 8 L 3 7 L 5 7 M -3 8 L -3 12 L -2 14 L -5 16 M -3 -2 L 0 -3 L 2 -4 L 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 7 M 2 -4 L 4 -3 L 4 6 M 0 -3 L 1 -3 L 3 -2 L 3 7","-9 9 M -5 -3 L -5 6 L -7 7 M -4 -2 L -4 7 L -2 8 M -3 -3 L -3 6 L -1 7 L 0 7 M -7 7 L -6 7 L -4 8 L -3 9 L -2 8 L 0 7 L 3 6 M -5 -3 L -3 -3 L 0 -4 L 2 -5 L 3 -4 L 5 -3 L 7 -3 L 5 -2 L 5 16 M 1 -4 L 4 -2 L 4 15 L 3 14 L 4 12 M 0 -4 L 1 -3 L 3 -2 L 3 12 L 2 14 L 5 16","-8 6 M -6 -3 L -5 -3 L -4 -2 L -4 6 L -6 7 L -5 7 L -3 8 L -2 9 M -5 -4 L -3 -3 L -3 7 L -1 8 M -6 -3 L -4 -5 L -2 -3 L -2 6 L 0 7 L 1 7 L -1 8 L -2 9 M -2 -3 L 2 -5 L 3 -4 L 5 -3 L 6 -3 M 1 -4 L 2 -3 L 4 -3 M 0 -4 L 2 -2 L 4 -2 L 6 -3","-8 8 M -5 -3 L -5 1 L -3 2 L 3 2 L 5 3 L 5 7 M -4 -3 L -4 1 M 4 3 L 4 7 M -2 -4 L -3 -3 L -3 1 L -1 2 M 1 2 L 3 3 L 3 7 L 2 8 M -5 -3 L -2 -4 L 0 -5 L 2 -4 L 4 -4 L 5 -5 M -1 -4 L 1 -4 M -2 -4 L 0 -3 L 2 -3 L 4 -4 M 5 7 L 2 8 L 0 9 L -2 8 L -4 8 L -6 9 M 1 8 L -1 8 M 2 8 L 0 7 L -3 7 L -6 9 M 5 -5 L 4 -3 L 2 0 L -3 5 L -6 9","-5 5 M -2 -10 L -1 -8 L -1 6 L -3 7 L -2 7 L 0 8 L 1 9 M 0 -8 L -1 -10 L 0 -11 L 0 7 L 2 8 M -2 -10 L 1 -12 L 1 6 L 3 7 L 4 7 L 2 8 L 1 9 M -4 -5 L -1 -5 M 1 -5 L 4 -5","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 6 L -7 7 M -6 -4 L -4 -3 L -4 7 L -2 8 M -7 -3 L -5 -5 L -3 -3 L -3 6 L -1 7 L 0 7 M -7 7 L -6 7 L -4 8 L -3 9 L -2 8 L 0 7 L 3 6 M 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 6 L 6 7 L 7 7 M 2 -4 L 4 -3 L 4 7 L 5 8 M 3 -5 L 1 -3 L 3 -2 L 3 7 L 5 9 L 7 7","-9 9 M -6 -5 L -5 -3 L -5 6 L -2 9 L 0 7 L 3 6 L 5 6 M -5 -4 L -4 -3 L -4 6 L -1 8 M -6 -5 L -4 -4 L -3 -3 L -3 5 L -2 6 L 0 7 M 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 6 M 2 -4 L 4 -3 L 4 5 M 3 -5 L 1 -3 L 3 -2 L 3 6","-13 13 M -10 -5 L -9 -3 L -9 6 L -6 9 L -4 7 L -1 6 M -9 -4 L -8 -3 L -8 6 L -5 8 M -10 -5 L -8 -4 L -7 -3 L -7 5 L -6 6 L -4 7 M -1 -5 L -3 -3 L -1 -2 L -1 6 L 2 9 L 4 7 L 7 6 L 9 6 M -2 -4 L 0 -3 L 0 6 L 3 8 M -1 -5 L 0 -4 L 2 -3 L 1 -2 L 1 5 L 2 6 L 4 7 M 7 -5 L 8 -4 L 10 -3 L 11 -3 L 9 -2 L 9 6 M 6 -4 L 8 -3 L 8 5 M 7 -5 L 5 -3 L 7 -2 L 7 6","-10 9 M -7 -3 L -6 -3 L -4 -2 L -3 -1 L 1 7 L 2 8 L 4 9 L 6 7 M -5 -4 L -3 -3 L 2 7 L 4 8 M -7 -3 L -5 -5 L -3 -4 L -2 -3 L 2 5 L 3 6 L 5 7 L 6 7 M 0 1 L 3 -5 L 4 -4 L 6 -4 L 7 -5 M 3 -4 L 4 -3 L 5 -3 M 2 -3 L 4 -2 L 6 -3 L 7 -5 M -1 3 L -4 9 L -5 8 L -7 8 L -8 9 M -4 8 L -5 7 L -6 7 M -3 7 L -5 6 L -7 7 L -8 9 M -5 2 L -2 2 M 1 2 L 4 2","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 6 L -7 7 M -6 -4 L -4 -3 L -4 7 L -2 8 M -7 -3 L -5 -5 L -3 -3 L -3 6 L -1 7 L 0 7 M -7 7 L -6 7 L -4 8 L -3 9 L -2 8 L 0 7 L 3 6 M 3 -5 L 4 -4 L 6 -3 L 7 -3 L 5 -2 L 5 10 L 4 13 L 2 15 L 0 16 L -1 15 L -3 14 L -5 14 M 2 -4 L 4 -3 L 4 10 M 1 15 L -1 14 L -2 14 M 3 -5 L 1 -3 L 3 -2 L 3 8 L 4 11 L 4 13 M 2 15 L 1 14 L -1 13 L -3 13 L -5 14","-9 9 M 6 -5 L -6 9 M -6 -3 L -4 -2 L -1 -2 L 2 -3 L 6 -5 M -5 -4 L -3 -3 L 1 -3 M -6 -3 L -4 -5 L -2 -4 L 2 -4 L 6 -5 M -6 9 L -2 7 L 1 6 L 4 6 L 6 7 M -1 7 L 3 7 L 5 8 M -6 9 L -2 8 L 2 8 L 4 9 L 6 7 M -4 2 L 4 2","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
gothicger = ["-8 8","-6 6 M 0 -12 L -1 -11 L -3 -10 L -1 -9 L 0 2 M 0 -9 L 1 -10 L 0 -11 L -1 -10 L 0 -9 L 0 2 M 0 -12 L 1 -11 L 3 -10 L 1 -9 L 0 2 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 2 -12 L 4 -11 L 5 -9 L 5 -7 L 7 -8 L 6 -10 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -6 L -6 -4 L -3 -2 L 3 0 L 5 1 L 6 3 L 6 6 L 5 8 M 6 -8 L 5 -10 M -6 -6 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 2 M -5 7 L -6 5 M -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 3 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -5 4 L -5 6 L -4 8 L -2 9","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 7 -4 L 8 -3 L 9 -3 L 10 -4 M 6 -3 L 7 -2 L 9 -2 M 6 -2 L 7 -1 L 8 -1 L 9 -2 L 10 -4 M 7 -4 L 1 2 M 0 3 L -6 9 L -10 4 L -4 -2 M -3 -3 L 1 -7 L -3 -12 L -8 -6 L -2 0 L 2 6 L 4 8 L 6 9 L 8 9 L 9 8 L 10 6 M -6 8 L -9 4 M 0 -7 L -3 -11 M -7 -6 L -2 -1 L 2 5 L 4 7 L 6 8 L 9 8 M -5 8 L -9 3 M 0 -6 L -4 -11 M -7 -7 L -1 -1 L 3 5 L 4 6 L 6 7 L 9 7 L 10 6","-4 5 M 1 -12 L 0 -11 L 0 -5 M 1 -11 L 0 -5 M 1 -12 L 2 -11 L 0 -5","-7 7 M 3 -16 L 1 -14 L -1 -11 L -3 -7 L -4 -2 L -4 2 L -3 7 L -1 11 L 1 14 L 3 16 M -1 -10 L -2 -7 L -3 -3 L -3 3 L -2 7 L -1 10 M 1 -14 L 0 -12 L -1 -9 L -2 -3 L -2 3 L -1 9 L 0 12 L 1 14","-7 7 M -3 -16 L -1 -14 L 1 -11 L 3 -7 L 4 -2 L 4 2 L 3 7 L 1 11 L -1 14 L -3 16 M 1 -10 L 2 -7 L 3 -3 L 3 3 L 2 7 L 1 10 M -1 -14 L 0 -12 L 1 -9 L 2 -3 L 2 3 L 1 9 L 0 12 L -1 14","-8 8 M 0 -12 L -1 -11 L 1 -1 L 0 0 M 0 -12 L 0 0 M 0 -12 L 1 -11 L -1 -1 L 0 0 M -5 -9 L -4 -9 L 4 -3 L 5 -3 M -5 -9 L 5 -3 M -5 -9 L -5 -8 L 5 -4 L 5 -3 M 5 -9 L 4 -9 L -4 -3 L -5 -3 M 5 -9 L -5 -3 M 5 -9 L 5 -8 L -5 -4 L -5 -3","-12 13 M 0 -9 L 0 8 L 1 8 M 0 -9 L 1 -9 L 1 8 M -8 -1 L 9 -1 L 9 0 M -8 -1 L -8 0 L 9 0","-6 6 M 0 12 L 0 10 L -2 8 L 0 6 L 1 8 L 1 10 L 0 12 L -2 13 M 0 7 L -1 8 L 0 9 L 0 7","-13 13 M -9 0 L 9 0","-6 6 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-11 12 M 9 -16 L -9 16 L -8 16 M 9 -16 L 10 -16 L -8 16","-10 10 M -6 -10 L -6 6 L -8 7 M -5 -9 L -5 6 L -2 8 M -4 -10 L -4 6 L -2 7 L -1 8 M -6 -10 L -4 -10 L 1 -11 L 3 -12 M 1 -11 L 2 -10 L 4 -9 L 4 7 M 2 -11 L 5 -9 L 5 6 M 3 -12 L 4 -11 L 6 -10 L 8 -10 L 6 -9 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -3 -10 L -2 -9 L -1 -7 L -1 6 L -3 7 M -1 -9 L -2 -10 L -1 -11 L 0 -9 L 0 7 L 2 8 M -3 -10 L 0 -12 L 1 -10 L 1 6 L 3 7 L 4 7 M -3 7 L -2 7 L 0 8 L 1 9 L 2 8 L 4 7","-10 10 M -6 -10 L -4 -10 L -2 -11 L -1 -12 L 1 -11 L 4 -10 L 6 -10 M -2 -10 L 0 -11 M -6 -10 L -4 -9 L -2 -9 L 0 -10 L 1 -11 M 4 -10 L 4 -2 M 5 -9 L 5 -3 M 6 -10 L 6 -2 L -1 -2 L -4 -1 L -6 1 L -7 4 L -7 9 M -7 9 L -3 7 L 1 6 L 4 6 L 8 7 M -4 8 L -1 7 L 4 7 L 7 8 M -7 9 L -2 8 L 3 8 L 6 9 L 8 7","-10 10 M -6 -10 L -5 -10 L -3 -11 L -2 -12 L 0 -11 L 4 -10 L 6 -10 M -3 -10 L -1 -11 M -6 -10 L -4 -9 L -2 -9 L 0 -11 M 4 -10 L 4 -3 M 5 -9 L 5 -4 M 6 -10 L 6 -3 L 4 -3 L 1 -2 L -1 -1 M -1 -2 L 1 -1 L 4 0 L 6 0 L 6 7 M 5 1 L 5 6 M 4 0 L 4 7 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-10 10 M 3 -12 L -7 -2 L -7 3 L 2 3 M 4 3 L 8 3 L 9 4 L 9 2 L 8 3 M -6 -2 L -6 2 M -5 -4 L -5 3 M 2 -11 L 2 6 L 0 7 M 3 -8 L 4 -10 L 3 -11 L 3 7 L 5 8 M 3 -12 L 5 -10 L 4 -8 L 4 6 L 6 7 L 7 7 M 0 7 L 1 7 L 3 8 L 4 9 L 5 8 L 7 7","-10 10 M -6 -12 L -6 -3 M -6 -12 L 6 -12 M -5 -11 L 4 -11 M -6 -10 L 3 -10 L 5 -11 L 6 -12 M 4 -6 L 3 -5 L 1 -4 L -3 -3 L -6 -3 M 1 -4 L 2 -4 L 4 -3 L 4 7 M 3 -5 L 5 -4 L 5 6 M 4 -6 L 5 -5 L 7 -4 L 8 -4 L 6 -3 L 6 7 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-10 10 M -6 -10 L -6 6 L -8 7 M -5 -9 L -5 6 L -2 8 M -4 -10 L -4 6 L -2 7 L -1 8 M -6 -10 L -4 -10 L 0 -11 L 2 -12 L 3 -11 L 5 -10 L 6 -10 M 1 -11 L 3 -10 M 0 -11 L 2 -9 L 4 -9 L 6 -10 M -4 -2 L -3 -2 L 1 -3 L 3 -4 L 4 -5 M 1 -3 L 2 -3 L 4 -2 L 4 7 M 3 -4 L 5 -2 L 5 6 M 4 -5 L 5 -4 L 7 -3 L 8 -3 L 6 -2 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -7 -10 L -5 -12 L -2 -11 L 3 -11 L 8 -12 M -6 -11 L -3 -10 L 2 -10 L 5 -11 M -7 -10 L -3 -9 L 0 -9 L 4 -10 L 8 -12 M 8 -12 L 7 -10 L 5 -7 L 1 -3 L -1 0 L -2 3 L -2 6 L -1 9 M 0 -1 L -1 2 L -1 5 L 0 8 M 3 -5 L 1 -2 L 0 1 L 0 4 L 1 7 L -1 9","-10 10 M -6 -9 L -6 -3 M -5 -8 L -5 -4 M -4 -9 L -4 -3 M -6 -9 L -4 -9 L 1 -10 L 3 -11 L 4 -12 M 1 -10 L 2 -10 L 4 -9 L 4 -3 M 3 -11 L 5 -10 L 5 -4 M 4 -12 L 5 -11 L 7 -10 L 8 -10 L 6 -9 L 6 -3 M -6 -3 L -4 -3 L 4 0 L 6 0 M 6 -3 L 4 -3 L -4 0 L -6 0 M -6 0 L -6 6 L -8 7 M -5 1 L -5 6 L -2 8 M -4 0 L -4 6 L -2 7 L -1 8 M 4 0 L 4 7 M 5 1 L 5 6 M 6 0 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -6 -10 L -6 -1 L -8 0 M -5 -9 L -5 0 L -3 1 M -4 -10 L -4 -1 L -2 0 L -1 0 M -6 -10 L -4 -10 L 1 -11 L 3 -12 M 1 -11 L 2 -10 L 4 -9 L 4 7 M 2 -11 L 5 -9 L 5 6 M 3 -12 L 4 -11 L 6 -10 L 8 -10 L 6 -9 L 6 7 M -8 0 L -7 0 L -5 1 L -4 2 L -3 1 L -1 0 L 3 -1 L 4 -1 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-6 6 M 0 -5 L -2 -3 L 0 -2 L 2 -3 L 0 -5 M 0 -4 L -1 -3 L 1 -3 L 0 -4 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-6 6 M 0 -5 L -2 -3 L 0 -2 L 2 -3 L 0 -5 M 0 -4 L -1 -3 L 1 -3 L 0 -4 M 0 12 L 0 10 L -2 8 L 0 6 L 1 8 L 1 10 L 0 12 L -2 13 M 0 7 L -1 8 L 0 9 L 0 7","-12 12 M 8 -9 L -8 0 L 8 9","-12 13 M -8 -5 L 9 -5 L 9 -4 M -8 -5 L -8 -4 L 9 -4 M -8 3 L 9 3 L 9 4 M -8 3 L -8 4 L 9 4","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -6 -8 L -5 -10 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -2 L 1 -1 M -5 -8 L -4 -10 M 4 -10 L 5 -9 L 5 -5 L 4 -4 M -6 -8 L -4 -7 L -4 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 4 -9 L 4 -5 L 3 -3 L 1 -1 M 0 -1 L 0 2 L 1 -1 L -1 -1 L 0 2 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-12 12 M -9 -10 L -8 -9 L -9 -8 L -10 -9 L -9 -11 L -7 -12 L -5 -12 L -3 -11 L -2 -10 L -1 -7 L -1 -3 L -2 0 L -4 2 L -6 3 L -9 4 M -3 -10 L -2 -7 L -2 -2 L -3 0 M -5 -12 L -4 -11 L -3 -8 L -3 -2 L -4 1 L -6 3 M -6 4 L -3 7 M -7 4 L -3 8 M -9 4 L -4 9 L 3 4 M 10 -11 L 9 -10 L 10 -10 L 10 -11 L 9 -12 L 7 -12 L 5 -11 L 4 -10 L 3 -8 L 3 7 L 5 9 L 9 5 M 5 -10 L 4 -8 L 4 6 L 6 8 M 7 -12 L 6 -11 L 5 -8 L 5 5 L 7 7","-13 13 M -11 -1 L -11 0 L -10 1 L -8 1 L -6 0 L -6 -3 L -7 -5 L -9 -8 L -9 -10 L -7 -12 M -7 -3 L -9 -7 M -8 1 L -7 0 L -7 -2 L -9 -5 L -10 -7 L -10 -9 L -9 -11 L -7 -12 L -4 -12 L -2 -11 L -1 -10 L 0 -8 L 0 0 L -1 3 L -3 5 M -2 -10 L -1 -8 L -1 2 M -4 -12 L -3 -11 L -2 -8 L -2 3 L -3 5 M 0 -9 L 1 -11 L 3 -12 L 5 -12 L 7 -11 L 8 -10 L 9 -8 L 10 -7 M 7 -10 L 8 -8 M 5 -12 L 6 -11 L 7 -8 L 8 -7 L 10 -7 M 10 -7 L 0 -2 M 7 -5 L 9 -3 L 10 0 L 10 3 L 9 6 L 7 8 L 4 9 L 1 9 L -2 8 L -8 5 L -9 5 L -10 6 M 6 -4 L 7 -4 L 9 -2 M 4 -4 L 7 -3 L 9 -1 L 10 1 M 2 8 L 0 8 L -6 5 L -7 5 M 8 7 L 6 8 L 3 8 L 0 7 L -4 5 L -7 4 L -9 4 L -10 6 L -10 8 L -9 9 L -8 8 L -9 7","-12 12 M 0 -10 L -2 -12 L -4 -12 L -6 -11 L -8 -8 L -9 -4 L -9 0 L -8 4 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 9 5 M -6 -10 L -7 -8 L -8 -5 L -8 0 L -7 4 L -5 7 L -2 8 M -4 -12 L -5 -11 L -6 -9 L -7 -5 L -7 -1 L -6 3 L -5 5 L -3 7 L 0 8 L 3 8 L 6 7 L 9 5 M 3 -12 L 0 -10 L -1 -9 L -2 -7 L -2 -6 L -1 -4 L 2 -2 L 3 0 L 3 2 M -1 -7 L -1 -6 L 3 -2 L 3 -1 M -1 -9 L -1 -8 L 0 -6 L 3 -4 L 4 -2 L 4 0 L 3 2 L 1 3 L 0 3 L -2 2 L -3 0 M 3 -12 L 4 -11 L 6 -10 L 8 -10 M 3 -11 L 4 -10 L 5 -10 M 2 -11 L 4 -9 L 6 -9 L 8 -10 L 9 -11","-13 13 M -10 -6 L -10 -7 L -9 -9 L -7 -11 L -4 -12 L 0 -12 L 3 -11 L 5 -10 L 7 -8 L 9 -5 L 10 -1 L 10 3 L 9 6 L 7 8 L 4 9 L 1 9 L -2 8 L -8 5 L -9 5 L -10 6 M -7 -10 L -5 -11 L 0 -11 L 3 -10 L 5 -9 L 7 -7 L 9 -4 M 2 8 L 0 8 L -6 5 L -7 5 M -10 -7 L -8 -9 L -5 -10 L 0 -10 L 3 -9 L 5 -8 L 7 -6 L 9 -3 L 10 0 M 8 7 L 6 8 L 3 8 L 0 7 L -4 5 L -7 4 L -9 4 L -10 6 L -10 8 L -9 9 L -8 8 L -9 7 M -2 -10 L -5 -7 L -6 -5 L -6 -3 L -4 1 L -4 3 M -5 -4 L -5 -3 L -4 -1 L -4 0 M -5 -7 L -5 -5 L -3 -1 L -3 1 L -4 3 L -5 4 L -7 4 L -8 3 L -8 2","-12 12 M 0 -10 L -2 -12 L -4 -12 L -6 -11 L -8 -8 L -9 -4 L -9 0 L -8 4 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 9 5 M -6 -10 L -7 -8 L -8 -5 L -8 0 L -7 4 L -5 7 L -2 8 M -4 -12 L -5 -11 L -6 -9 L -7 -5 L -7 -1 L -6 3 L -5 5 L -3 7 L 0 8 L 3 8 L 6 7 L 9 5 M 3 -12 L 0 -10 L -1 -9 L -2 -7 L -2 -6 L -1 -4 L 2 -2 L 3 0 L 3 2 M -1 -7 L -1 -6 L 3 -2 L 3 -1 M -1 -9 L -1 -8 L 0 -6 L 3 -4 L 4 -2 L 4 0 L 3 2 L 1 3 L 0 3 L -2 2 L -3 0 M 3 -12 L 4 -11 L 6 -10 L 8 -10 M 3 -11 L 4 -10 L 5 -10 M 2 -11 L 4 -9 L 6 -9 L 8 -10 L 9 -11 M 3 -4 L 7 -7 M 7 -7 L 8 -6 L 10 -6 M 6 -6 L 7 -5 L 8 -5 M 5 -5 L 6 -4 L 8 -4 L 10 -6","-12 12 M -5 -4 L -7 -5 L -8 -7 L -8 -9 L -7 -11 L -4 -12 L -1 -12 L 2 -11 L 6 -9 M -7 -10 L -5 -11 L 0 -11 L 3 -10 M -8 -7 L -7 -9 L -5 -10 L 0 -10 L 6 -9 L 8 -9 L 9 -10 L 9 -11 L 8 -12 L 7 -12 M 1 -10 L 0 -9 L -1 -7 L -1 -5 L 0 -3 L 4 1 L 5 4 L 5 7 L 4 10 L 3 11 L 1 12 M 2 -2 L 5 1 L 6 4 L 6 7 L 5 9 M -1 -5 L 1 -3 L 4 -1 L 6 1 L 7 4 L 7 7 L 6 9 L 4 11 L 1 12 L -3 12 L -6 11 L -7 10 L -8 8 L -8 5 L -6 2 L -6 0 L -7 -1 M -6 10 L -7 9 L -7 5 L -6 3 M -3 12 L -5 11 L -6 9 L -6 5 L -5 2 L -5 0 L -6 -1 L -8 -1 L -9 0 L -9 1 M 3 -2 L 7 -6 M 7 -6 L 8 -5 L 10 -5 M 6 -5 L 7 -4 L 8 -4 M 5 -4 L 6 -3 L 8 -3 L 10 -5","-13 13 M 3 -8 L 2 -10 L 1 -11 L -1 -12 L -4 -12 L -7 -11 L -9 -8 L -10 -4 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 9 5 L 10 2 L 10 -1 L 9 -4 L 7 -6 M -7 -10 L -8 -8 L -9 -5 L -9 0 L -8 3 L -7 5 M 8 5 L 9 3 L 9 -1 L 8 -4 L 7 -5 M -4 -12 L -6 -11 L -7 -9 L -8 -5 L -8 0 L -7 4 L -6 6 L -4 8 M 5 8 L 7 6 L 8 3 L 8 -1 L 7 -3 L 5 -5 M 3 -12 L 0 -10 L -2 -8 L -3 -6 L -3 -5 L -2 -3 L 1 -1 L 2 1 L 2 3 M -2 -6 L -2 -5 L 2 -1 L 2 0 M -2 -8 L -2 -7 L -1 -5 L 2 -3 L 3 -1 L 3 1 L 2 3 L 0 4 L -1 4 L -3 3 L -4 1 M 2 -3 L 7 -6 L 8 -8 M 10 -12 L 8 -8 M 7 -11 L 11 -9 M 10 -12 L 9 -11 L 7 -11 L 8 -10 L 8 -8 L 9 -9 L 11 -9 L 10 -10 L 10 -12","-12 13 M 0 -12 L -2 -11 L -4 -9 L -5 -7 L -5 -5 L -4 -3 L -2 -1 L -1 1 L -1 3 M -4 -6 L -4 -5 L -1 -1 L -1 0 M -4 -9 L -4 -7 L -3 -5 L -1 -3 L 0 -1 L 0 1 L -1 3 L -2 4 L -4 5 L -6 5 L -8 4 L -9 3 L -10 1 L -10 -1 L -9 -2 L -8 -1 L -9 0 M 0 -12 L 2 -10 L 4 -10 L 6 -11 M -1 -11 L 1 -10 M -2 -11 L -1 -10 L 1 -9 L 3 -9 L 6 -11 M 0 -2 L 7 -7 M 7 -7 L 9 -4 L 10 -1 L 10 2 L 9 5 L 7 7 L 4 8 L 0 9 M 6 -6 L 8 -4 L 9 -1 L 9 3 L 8 5 M 4 -5 L 5 -5 L 7 -3 L 8 0 L 8 4 L 7 6 L 6 7 L 4 8 M 4 8 L 2 8 L 0 7 L -2 7 L -4 8 L -5 10 L -4 12 L -2 13 L 0 13 L 2 12 M 1 8 L -1 8 M 0 9 L -2 8 L -4 8","-12 13 M -2 -2 L -4 -2 L -6 -3 L -7 -4 L -8 -6 L -8 -8 L -7 -10 L -6 -11 L -3 -12 L -1 -12 L 2 -11 L 5 -8 L 7 -7 M -6 -10 L -4 -11 L 0 -11 L 2 -10 L 3 -9 M -8 -8 L -7 -9 L -5 -10 L -1 -10 L 2 -9 L 4 -8 L 7 -7 L 9 -7 L 10 -8 L 10 -10 L 9 -11 L 7 -11 M -8 6 L -7 7 L -8 8 L -9 7 L -9 5 L -8 4 L -6 4 L -4 5 L -2 7 L 0 10 L 2 12 M -4 6 L -3 7 L -1 10 L 0 11 M -6 4 L -5 5 L -4 7 L -2 10 L -1 11 L 1 12 L 4 12 L 6 11 L 7 10 L 8 8 L 8 5 L 7 3 L 5 0 L 4 -2 L 4 -3 M 7 6 L 7 5 L 4 0 L 4 -1 M 6 11 L 7 9 L 7 7 L 6 5 L 4 2 L 3 0 L 3 -2 L 5 -4 L 7 -4 L 8 -3 L 8 -2","-12 13 M -2 -2 L -4 -2 L -6 -3 L -7 -4 L -8 -6 L -8 -8 L -7 -10 L -6 -11 L -3 -12 L -1 -12 L 2 -11 L 5 -8 L 7 -7 M -6 -10 L -4 -11 L 0 -11 L 2 -10 L 3 -9 M -8 -8 L -7 -9 L -5 -10 L -1 -10 L 2 -9 L 4 -8 L 7 -7 L 9 -7 L 10 -8 L 10 -10 L 9 -11 L 7 -11 M -8 6 L -7 7 L -8 8 L -9 7 L -9 5 L -8 4 L -6 4 L -4 5 L -2 7 L 0 10 L 2 12 M -4 6 L -3 7 L -1 10 L 0 11 M -6 4 L -5 5 L -4 7 L -2 10 L -1 11 L 1 12 L 4 12 L 6 11 L 7 10 L 8 8 L 8 5 L 7 3 L 5 0 L 4 -2 L 4 -3 M 7 6 L 7 5 L 4 0 L 4 -1 M 6 11 L 7 9 L 7 7 L 6 5 L 4 2 L 3 0 L 3 -2 L 5 -4 L 7 -4 L 8 -3 L 8 -2","-13 13 M 9 -7 L 8 -9 L 6 -11 L 3 -12 L 0 -12 L -3 -11 L -5 -9 L -6 -7 L -6 -4 L -5 -1 L -2 5 L -2 7 L -4 9 M -5 -4 L -5 -3 L -2 3 L -2 4 M -4 -10 L -5 -8 L -5 -5 L -4 -3 L -2 1 L -1 4 L -1 6 L -2 8 L -4 9 L -6 9 L -8 8 M -10 4 L -8 8 M -11 7 L -7 5 M -10 4 L -10 6 L -11 7 L -9 7 L -8 8 L -8 6 L -7 5 L -9 5 L -10 4 M -4 -3 L -4 -5 L -3 -7 L -1 -8 L 2 -8 L 4 -7 L 6 -5 L 7 -5 M 3 -7 L 5 -5 M 0 -8 L 2 -7 L 3 -6 L 4 -4 M 7 -5 L -2 -1 M 3 -3 L 7 6 L 8 7 L 9 7 M 2 -2 L 6 6 L 8 8 M 1 -2 L 5 7 L 7 9 L 10 6","-11 12 M 8 1 L 7 2 L 4 2 L 3 1 L 3 -1 L 4 -3 L 6 -6 L 7 -8 L 7 -10 M 4 -1 L 4 -2 L 7 -6 L 7 -7 M 5 2 L 4 1 L 4 0 L 5 -2 L 7 -4 L 8 -6 L 8 -8 L 7 -10 L 6 -11 L 3 -12 L -2 -12 L -5 -11 L -6 -10 L -7 -8 L -7 -6 L -6 -4 L -4 -1 L -3 1 L -3 2 L -4 4 M -6 -7 L -6 -6 L -3 -1 L -3 0 M -6 -10 L -6 -8 L -5 -6 L -3 -3 L -2 -1 L -2 1 L -3 3 L -5 5 L -8 7 M -5 5 L -3 5 L 0 7 L 3 8 L 6 8 L 8 7 M -4 6 L -3 6 L 1 8 L 2 8 M -8 7 L -6 6 L -5 6 L -1 8 L 2 9 L 4 9 L 7 8 L 8 7 L 9 5","-16 16 M -13 -1 L -13 0 L -12 1 L -10 1 L -8 0 L -8 -3 L -9 -5 L -11 -8 L -11 -10 L -9 -12 M -9 -3 L -11 -7 M -10 1 L -9 0 L -9 -2 L -11 -5 L -12 -7 L -12 -9 L -11 -11 L -9 -12 L -7 -12 L -5 -11 L -3 -9 L -2 -6 L -2 0 L -3 3 L -4 5 L -6 7 L -9 9 L -10 8 L -11 8 M -4 -9 L -3 -6 L -3 0 L -4 3 L -5 5 M -8 8 L -9 7 L -10 7 M -7 -12 L -5 -10 L -4 -7 L -4 0 L -5 4 L -6 6 L -7 7 L -8 6 L -9 6 L -12 9 M -4 -11 L -2 -12 L 0 -12 L 2 -11 L 4 -9 L 5 -6 L 5 0 L 4 3 L 3 5 L 1 7 L -1 9 L -2 8 L -3 8 M 3 -9 L 4 -6 L 4 0 L 3 4 M 0 8 L -1 7 L -2 7 M 0 -12 L 2 -10 L 3 -7 L 3 1 L 2 5 L 1 7 L 0 6 L -1 6 L -4 9 M 3 -10 L 4 -11 L 6 -12 L 8 -12 L 10 -11 L 11 -10 L 12 -8 L 13 -7 M 10 -10 L 11 -8 M 8 -12 L 9 -11 L 10 -8 L 11 -7 L 13 -7 M 13 -7 L 10 -5 L 9 -4 L 8 -1 L 8 2 L 9 6 L 11 9 L 14 6 M 10 -4 L 9 -2 L 9 2 L 10 5 L 12 8 M 13 -7 L 11 -5 L 10 -3 L 10 1 L 11 5 L 13 7","-14 14 M -11 -1 L -11 0 L -10 1 L -8 1 L -6 0 L -6 -3 L -7 -5 L -9 -8 L -9 -10 L -7 -12 M -7 -3 L -9 -7 M -8 1 L -7 0 L -7 -2 L -9 -5 L -10 -7 L -10 -9 L -9 -11 L -7 -12 L -4 -12 L -2 -11 L 0 -9 L 1 -6 L 1 0 L 0 3 L -1 5 L -3 7 L -6 9 L -7 8 L -9 8 L -11 9 M -1 -9 L 0 -7 L 0 0 L -1 3 L -2 5 L -3 6 M -5 8 L -7 7 L -9 7 M -4 -12 L -2 -10 L -1 -7 L -1 0 L -2 4 L -4 7 L -6 6 L -8 6 L -11 9 M 0 -10 L 1 -11 L 3 -12 L 5 -12 L 7 -11 L 8 -10 L 9 -8 L 10 -7 M 7 -10 L 8 -8 M 5 -12 L 6 -11 L 7 -8 L 8 -7 L 10 -7 M 10 -7 L 7 -5 L 6 -4 L 5 -1 L 5 2 L 6 6 L 8 9 L 11 6 M 7 -4 L 6 -2 L 6 2 L 7 5 L 9 8 M 10 -7 L 8 -5 L 7 -3 L 7 1 L 8 5 L 10 7","-14 14 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -7 -5 L -5 -1 L -5 1 M -6 -6 L -6 -5 L -5 -3 L -5 -2 M -6 -9 L -6 -7 L -4 -3 L -4 -1 L -5 1 L -6 2 L -8 2 L -9 1 L -9 0 M -2 -12 L -1 -11 L 5 -9 L 8 -7 L 9 -5 L 10 -2 L 10 1 L 9 4 L 8 6 L 6 8 L 3 9 L 0 9 L -3 8 L -9 5 L -10 5 L -11 6 M -2 -11 L -1 -10 L 5 -8 L 7 -7 L 8 -6 M -2 -12 L -2 -10 L -1 -9 L 5 -7 L 7 -6 L 9 -4 L 10 -2 M 1 8 L -1 8 L -7 5 L -8 5 M 7 7 L 5 8 L 2 8 L -1 7 L -5 5 L -8 4 L -10 4 L -11 6 L -11 8 L -10 9 L -9 8 L -10 7","-13 14 M -10 -1 L -10 0 L -9 1 L -7 1 L -5 0 L -5 -3 L -6 -5 L -8 -8 L -8 -10 L -6 -12 M -6 -3 L -8 -7 M -7 1 L -6 0 L -6 -2 L -8 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -3 -12 L -1 -11 L 0 -10 L 1 -8 L 1 3 M 1 5 L 1 10 L 0 12 L -2 13 L -5 13 L -6 12 L -6 10 L -5 9 L -4 10 L -5 11 M -1 -10 L 0 -8 L 0 10 L -1 12 M -3 -12 L -2 -11 L -1 -8 L -1 3 M -1 5 L -1 10 L -2 12 L -3 13 M 1 -8 L 6 -12 M 6 -12 L 8 -9 L 9 -7 L 10 -3 L 10 0 L 9 3 L 7 6 L 4 9 M 5 -11 L 8 -7 L 9 -4 L 9 -3 M 4 -10 L 6 -8 L 8 -5 L 9 -2 L 9 1 L 8 4 L 7 6 M 5 7 L 3 4 L 1 3 M -1 3 L -3 4 L -5 6 M 5 8 L 3 5 L 1 4 L -2 4 M 4 9 L 2 6 L 1 5 M -1 5 L -3 5 L -5 6","-14 14 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -7 -5 L -5 -1 L -5 1 M -6 -6 L -6 -5 L -5 -3 L -5 -2 M -6 -9 L -6 -7 L -4 -3 L -4 -1 L -5 1 L -6 2 L -8 2 L -9 1 L -9 0 M -2 -12 L -1 -11 L 5 -9 L 8 -7 L 9 -5 L 10 -2 L 10 1 L 9 4 L 8 6 M 6 8 L 3 9 L 0 9 L -3 8 L -9 5 L -10 5 L -11 6 M -2 -11 L -1 -10 L 5 -8 L 7 -7 L 8 -6 M -2 -12 L -2 -10 L -1 -9 L 5 -7 L 7 -6 L 9 -4 L 10 -2 M 1 8 L -1 8 L -7 5 L -8 5 M 6 8 L 2 8 L -1 7 L -5 5 L -8 4 L -10 4 L -11 6 L -11 8 L -10 9 L -9 8 L -10 7 M 2 6 L 4 4 L 6 4 L 10 8 L 11 8 M 5 5 L 6 5 L 9 8 M 3 5 L 4 5 L 8 9 L 10 9 L 12 7","-14 14 M -11 -1 L -11 0 L -10 1 L -8 1 L -6 0 L -6 -3 L -7 -5 L -9 -8 L -9 -10 L -7 -12 M -7 -3 L -9 -7 M -8 1 L -7 0 L -7 -2 L -9 -5 L -10 -7 L -10 -9 L -9 -11 L -7 -12 L -4 -12 L -2 -11 L -1 -10 L 0 -8 L 0 4 L -1 6 L -3 8 L -5 9 L -7 9 L -9 8 M -2 -10 L -1 -8 L -1 4 L -2 6 M -4 -12 L -3 -11 L -2 -8 L -2 4 L -3 7 L -5 9 M -11 4 L -9 8 M -12 7 L -8 5 M -11 4 L -11 6 L -12 7 L -10 7 L -9 8 L -9 6 L -8 5 L -10 5 L -11 4 M 0 -9 L 1 -11 L 3 -12 L 5 -12 L 7 -11 L 8 -10 L 9 -8 L 10 -7 M 7 -10 L 8 -8 M 5 -12 L 6 -11 L 7 -8 L 8 -7 L 10 -7 M 10 -7 L 0 -2 M 2 -3 L 6 7 L 8 9 L 11 6 M 3 -3 L 7 6 L 9 8 M 4 -4 L 8 6 L 9 7 L 10 7","-13 14 M 10 -10 L 9 -11 L 10 -12 L 11 -11 L 11 -9 L 10 -7 L 8 -7 L 4 -9 L 1 -10 L -3 -10 L -7 -9 L -9 -7 M 7 -8 L 4 -10 L 1 -11 L -3 -11 L -6 -10 M 11 -9 L 10 -8 L 8 -8 L 4 -11 L 1 -12 L -3 -12 L -6 -11 L -8 -9 L -9 -7 L -10 -4 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 3 9 L 6 8 L 8 7 L 10 5 L 11 2 L 11 -1 L 10 -3 L 8 -4 L 5 -4 L 3 -3 L 1 0 L -1 1 L -3 1 M -6 6 L -4 7 L -1 8 L 3 8 L 7 7 M -9 3 L -7 5 L -5 6 L -2 7 L 3 7 L 7 6 L 9 5 L 10 4 L 11 2 M 6 -3 L 5 -3 L 1 1 L 0 1 M 11 -1 L 9 -3 L 7 -3 L 5 -2 L 3 1 L 1 2 L -1 2 L -3 1 L -4 -1 L -4 -3 L -3 -5 L -1 -6","-12 13 M -6 -4 L -8 -5 L -9 -7 L -9 -9 L -8 -11 L -5 -12 L 0 -12 L 3 -11 L 7 -8 L 9 -8 L 10 -9 M -8 -10 L -6 -11 L 0 -11 L 3 -10 L 6 -8 M -9 -7 L -8 -9 L -6 -10 L 0 -10 L 3 -9 L 7 -7 L 9 -7 L 10 -9 L 10 -11 L 9 -12 L 8 -11 L 9 -10 M 3 -9 L 0 -6 L -1 -4 L -1 -2 L 1 2 L 1 4 M 0 -3 L 0 -2 L 1 0 L 1 1 M 0 -6 L 0 -4 L 2 0 L 2 2 L 1 4 L 0 5 L -2 5 L -3 4 L -3 2 M -8 7 L -7 8 L -8 9 L -9 8 L -9 6 L -8 4 L -6 4 L -3 5 L 1 7 L 4 8 L 7 8 L 9 7 M -6 5 L -5 5 L 1 8 L 3 8 M -9 6 L -8 5 L -7 5 L -5 6 L -1 8 L 2 9 L 5 9 L 8 8 L 10 6","-11 11 M -8 -10 L -7 -10 L -6 -9 L -6 5 L -8 6 M -7 -11 L -5 -10 L -5 6 L -2 8 M -9 -9 L -6 -12 L -4 -10 L -4 5 L -2 7 L 0 7 M -8 6 L -7 6 L -5 7 L -3 9 L 0 7 L 4 4 M 2 -10 L 3 -10 L 4 -9 L 4 7 L 6 9 L 9 6 M 3 -11 L 5 -10 L 5 7 L 7 8 M 1 -9 L 4 -12 L 7 -10 L 6 -9 L 6 6 L 7 7 L 8 7","-14 14 M -11 -1 L -11 0 L -10 1 L -8 1 L -6 0 L -6 -3 L -7 -5 L -9 -8 L -9 -10 L -7 -12 M -7 -3 L -9 -7 M -8 1 L -7 0 L -7 -2 L -9 -5 L -10 -7 L -10 -9 L -9 -11 L -7 -12 L -4 -12 L -2 -11 L -1 -10 L 0 -8 L 0 0 L -1 3 L -3 5 M -2 -10 L -1 -8 L -1 2 M -4 -12 L -3 -11 L -2 -8 L -2 3 L -3 5 M 0 -9 L 1 -11 L 3 -12 L 5 -12 L 7 -11 L 9 -8 L 10 -7 M 7 -10 L 8 -8 M 5 -12 L 6 -11 L 7 -8 L 8 -7 L 10 -7 M 8 -7 L 6 -7 L 5 -6 L 5 -4 L 6 -2 L 9 0 L 10 2 M 6 -3 L 9 -1 M 5 -5 L 6 -4 L 9 -2 L 10 0 L 10 4 L 9 6 L 7 8 L 5 9 L 1 9 L -2 8 L -8 5 L -9 5 L -10 6 M 2 8 L 0 8 L -6 5 L -7 5 M 8 7 L 6 8 L 3 8 L 0 7 L -4 5 L -7 4 L -9 4 L -10 6 L -10 8 L -9 9 L -8 8 L -9 7","-16 17 M -13 -1 L -13 0 L -12 1 L -10 1 L -8 0 L -8 -3 L -9 -5 L -11 -8 L -11 -10 L -9 -12 M -9 -3 L -11 -7 M -10 1 L -9 0 L -9 -2 L -11 -5 L -12 -7 L -12 -9 L -11 -11 L -9 -12 L -6 -12 L -4 -11 L -3 -10 L -2 -8 L -2 -4 L -3 -1 L -5 2 L -7 4 M -4 -10 L -3 -8 L -3 -3 L -4 0 M -6 -12 L -5 -11 L -4 -8 L -4 -3 L -5 1 L -7 4 M -4 -11 L -2 -12 L 1 -12 L 3 -11 M 5 -12 L 2 -11 L 1 -9 L 1 -5 L 2 -2 L 4 1 L 5 3 L 5 5 L 4 7 M 2 -5 L 2 -4 L 5 1 L 5 2 M 5 -12 L 3 -11 L 2 -9 L 2 -6 L 3 -4 L 5 -1 L 6 2 L 6 4 L 5 6 L 3 8 L 1 9 L -3 9 L -5 8 L -7 6 L -9 5 L -11 5 L -12 6 M -4 8 L -7 5 L -8 5 M -1 9 L -3 8 L -6 5 L -8 4 L -11 4 L -12 6 L -12 8 L -11 9 L -10 8 L -11 7 M 5 -12 L 8 -12 L 10 -11 L 12 -8 L 13 -7 M 10 -10 L 11 -8 M 8 -12 L 9 -11 L 10 -8 L 11 -7 L 13 -7 M 11 -7 L 9 -7 L 8 -6 L 8 -4 L 9 -2 L 12 0 L 13 2 M 9 -3 L 12 -1 M 8 -5 L 9 -4 L 12 -2 L 13 0 L 13 5 L 12 7 L 11 8 L 9 9 L 6 9 L 3 8 M 7 8 L 6 8 L 4 7 M 12 7 L 10 8 L 8 8 L 6 7 L 5 6","-12 12 M -7 -10 L -5 -10 L -3 -9 L -2 -8 L -1 -5 L -1 -3 M -1 -1 L -1 3 L -2 6 L -5 9 L -7 8 L -9 9 M -4 8 L -6 7 L -7 7 M -3 7 L -4 7 L -6 6 L -9 9 M -5 -11 L -2 -10 L -1 -9 L 0 -6 L 0 3 L 1 5 L 3 7 L 5 8 M -9 -9 L -4 -12 L -2 -11 L 0 -9 L 1 -6 L 1 -3 M 1 -1 L 1 2 L 2 5 L 3 6 L 5 7 L 7 7 M -1 3 L 0 6 L 2 8 L 4 9 L 9 6 M 1 -6 L 2 -9 L 5 -12 L 7 -11 L 9 -12 M 4 -11 L 6 -10 L 7 -10 M 3 -10 L 4 -10 L 6 -9 L 9 -12 M -7 1 L -5 -3 L -1 -3 M 1 -3 L 5 -3 L 7 -5 M -5 -2 L 5 -2 M -7 1 L -5 -1 L -1 -1 M 1 -1 L 5 -1 L 7 -5","-13 13 M -10 -1 L -10 0 L -9 1 L -7 1 L -5 0 L -5 -3 L -6 -5 L -8 -8 L -8 -10 L -6 -12 M -6 -3 L -8 -7 M -7 1 L -6 0 L -6 -2 L -8 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -3 -12 L -1 -11 L 0 -10 L 1 -8 L 1 -3 L 0 0 L -1 2 L -1 3 L 1 5 L 2 5 M -1 -10 L 0 -8 L 0 -2 L -1 1 L -2 3 L 1 6 M -3 -12 L -2 -11 L -1 -8 L -1 -2 L -2 2 L -3 4 L 0 7 L 3 4 M 1 -8 L 9 -12 M 7 -11 L 7 8 L 6 11 M 8 -11 L 8 6 L 7 9 M 9 -12 L 9 4 L 8 8 L 7 10 L 5 12 L 2 13 L -2 13 L -5 12 L -7 10 L -8 8 L -7 7 L -6 8 L -7 9","-12 12 M -4 -9 L -3 -11 L -1 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -5 L 5 -3 L 4 -2 L 2 -1 M -1 -1 L -3 -2 L -4 -4 M 4 -10 L 5 -9 L 5 -4 L 4 -3 M 2 -12 L 3 -11 L 4 -9 L 4 -4 L 3 -2 L 2 -1 M -5 3 L -4 1 L -3 0 L -1 -1 L 2 -1 L 5 0 L 7 2 L 8 4 L 8 8 L 7 10 L 5 12 L 2 13 L -2 13 L -4 12 L -7 8 L -8 7 M 6 2 L 7 4 L 7 8 L 6 10 M 2 -1 L 5 1 L 6 3 L 6 9 L 5 11 L 4 12 L 2 13 M -3 12 L -4 11 L -6 8 L -7 7 M 0 13 L -2 12 L -3 11 L -5 8 L -6 7 L -9 7 L -10 8 L -10 10 L -9 11 L -8 11","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-12 12 M -12 16 L 12 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-8 9 M 2 -5 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 4 L -4 7 L -3 9 L 3 6 M -4 4 L -3 7 L -2 8 M -1 -4 L -3 -2 L -4 1 L -4 3 L -3 6 L -1 8 M 0 -4 L 1 -3 L 3 -2 L 3 7 L 5 9 L 8 6 M 1 -4 L 4 -2 L 4 6 L 6 8 M 2 -5 L 3 -4 L 5 -3 L 6 -3 M 5 -2 L 6 -3 M 5 -2 L 5 6 L 6 7 L 7 7","-8 9 M -6 -10 L -5 -9 L -4 -7 M 2 -12 L -1 -11 L -3 -9 L -4 -7 L -4 6 L -5 7 M -2 -9 L -3 -7 L -3 6 L 0 8 M 2 -12 L 0 -11 L -1 -10 L -2 -7 L -2 6 L 0 7 L 1 8 M -5 7 L -4 7 L -2 8 L -1 9 L 2 8 M -2 -2 L 4 -5 L 5 -3 L 6 0 L 6 3 L 5 6 L 4 7 L 2 8 M 3 -4 L 4 -3 L 5 -1 M 2 -4 L 4 -2 L 5 1 L 5 3 L 4 6 L 2 8","-7 6 M 0 -4 L 2 -2 L 4 -3 L 2 -5 L 0 -4 L -3 -2 L -4 0 L -4 5 L -3 7 L -1 9 L 3 7 M 1 -4 L 3 -3 M -2 -2 L -3 0 L -3 5 L -2 7 L -1 8 M -1 -3 L -2 -1 L -2 4 L -1 6 L 1 8","-8 9 M -1 -12 L -4 -9 L -4 -7 L -3 -6 L 1 -4 L 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 M -3 -8 L -3 -7 L 1 -5 L 4 -3 L 5 -2 M -3 -10 L -3 -9 L -2 -8 L 3 -5 L 5 -3 L 6 0 L 6 3 L 5 6 L 2 8 L -1 9 M 0 -4 L -4 -2 L -4 6 L -5 7 M -3 -2 L -3 6 L 0 8 M -2 -3 L -2 6 L 0 7 L 1 8 M -5 7 L -4 7 L -2 8 L -1 9","-7 6 M -2 3 L 4 -1 L 1 -5 L -3 -2 L -4 0 L -4 5 L -3 7 L -1 9 L 3 7 M 3 -1 L 0 -4 M -2 -2 L -3 0 L -3 5 L -2 7 L -1 8 M 2 0 L 0 -3 L -1 -3 L -2 -1 L -2 4 L -1 6 L 1 8","-6 7 M 6 -12 L 5 -11 L 3 -11 L 1 -12 L -1 -12 L -2 -10 L -2 -5 L -3 -3 L -4 -2 M 4 -10 L 2 -10 L 0 -11 L -1 -11 M 6 -12 L 5 -10 L 4 -9 L 2 -9 L 0 -10 L -1 -10 L -2 -9 M -2 -7 L -1 -5 L 0 -4 L 2 -3 L 4 -3 L 4 -2 M -4 -2 L -2 -2 M 0 -2 L 4 -2 M -2 -2 L -2 2 L -1 14 M 1 -3 L -2 -3 L -1 -4 L -1 9 M 0 -2 L 0 2 L -1 14","-8 9 M 2 -5 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 4 L -4 7 L -3 9 L 3 6 M -4 5 L -3 7 L -2 8 M -1 -4 L -3 -2 L -4 1 L -4 3 L -3 6 L -1 8 M 0 -4 L 1 -3 L 3 -2 L 3 6 L 4 9 L 4 11 L 3 13 M 1 -4 L 4 -2 L 4 8 M 2 -5 L 3 -4 L 5 -3 L 6 -3 M 5 -2 L 6 -3 M 5 -2 L 5 10 L 4 12 L 3 13 L 1 14 L -2 14 L -4 13 L -5 12 L -5 11 L -4 11 L -4 12","-8 9 M -6 -10 L -5 -9 L -4 -7 M 2 -12 L -1 -11 L -3 -9 L -4 -7 L -4 6 L -5 7 M -2 -9 L -3 -7 L -3 7 L -2 8 M 2 -12 L 0 -11 L -1 -10 L -2 -7 L -2 6 L -1 7 L 0 7 M -5 7 L -3 8 L -2 9 L 1 6 M -2 -2 L 4 -5 L 5 -3 L 6 1 L 6 5 L 5 8 L 4 10 L 2 12 L -1 14 M 3 -4 L 4 -3 L 5 0 M 2 -4 L 4 -1 L 5 2 L 5 5 L 4 9 L 2 12","-5 5 M 0 -12 L -1 -11 L -1 -10 L 0 -9 L 1 -10 L 1 -11 L 0 -12 M -1 -11 L 1 -10 M -1 -10 L 1 -11 M -3 -3 L -2 -3 L -1 -2 L -1 7 L 1 9 L 4 6 M -2 -4 L 0 -3 L 0 6 L 2 8 M -4 -2 L -1 -5 L 0 -4 L 2 -3 M 1 -2 L 2 -3 M 1 -2 L 1 6 L 2 7 L 3 7","-5 5 M 0 -12 L -1 -11 L -1 -10 L 0 -9 L 1 -10 L 1 -11 L 0 -12 M -1 -11 L 1 -10 M -1 -10 L 1 -11 M -3 -3 L -2 -3 L -1 -2 L -1 9 L -2 12 L -3 13 L -5 14 M -2 -4 L 0 -3 L 0 9 L -1 11 M -4 -2 L -1 -5 L 0 -4 L 2 -3 M 1 -2 L 2 -3 M 1 -2 L 1 9 L 0 11 L -2 13 L -5 14 M 1 9 L 2 11 L 3 12","-7 7 M -4 -10 L -3 -9 L -2 -7 M 3 -12 L 1 -11 L -1 -9 L -2 -7 L -2 -5 L -3 -3 L -4 -2 M -2 -2 L -2 6 L -3 7 M 0 -9 L -1 -7 L -1 -5 M -1 -3 L -2 -3 L -1 -5 L -1 6 L 1 8 M 3 -12 L 1 -10 L 0 -7 L 0 -3 M 0 -2 L 0 6 L 1 7 L 2 7 M -3 7 L -1 8 L 0 9 L 3 6 M 0 -6 L 4 -9 L 5 -8 L 5 -6 L 3 -4 L 1 -3 M 3 -8 L 4 -7 L 4 -6 L 3 -4 M 0 -3 L 5 -3 L 5 -2 M -4 -2 L -2 -2 M 0 -2 L 5 -2","-5 5 M -3 -10 L -2 -9 L -1 -7 M 5 -12 L 2 -11 L 0 -9 L -1 -7 L -1 6 L -2 7 M 1 -9 L 0 -7 L 0 7 L 2 8 M 5 -12 L 3 -11 L 2 -10 L 1 -7 L 1 6 L 2 7 L 3 7 M -2 7 L 0 8 L 1 9 L 4 6","-13 13 M -11 -3 L -10 -3 L -9 -2 L -9 6 L -10 7 L -8 9 M -10 -4 L -8 -2 L -8 6 L -9 7 L -8 8 L -7 7 L -8 6 M -12 -2 L -9 -5 L -7 -3 L -7 6 L -6 7 L -8 9 M -4 -4 L -2 -3 L -1 -1 L -1 6 L -2 7 L 0 9 M -2 -4 L -1 -3 L 0 -1 L 0 6 L -1 7 L 0 8 L 1 7 L 0 6 M -7 -2 L -4 -4 L -2 -5 L 0 -4 L 1 -2 L 1 6 L 2 7 L 0 9 M 4 -4 L 5 -3 L 7 -2 L 7 7 L 9 9 L 12 6 M 5 -4 L 8 -2 L 8 6 L 10 8 M 1 -2 L 4 -4 L 6 -5 L 7 -4 L 9 -3 L 10 -3 M 9 -2 L 10 -3 M 9 -2 L 9 6 L 10 7 L 11 7","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 6 L -6 7 L -4 9 M -6 -4 L -4 -2 L -4 6 L -5 7 L -4 8 L -3 7 L -4 6 M -8 -2 L -5 -5 L -3 -3 L -3 6 L -2 7 L -4 9 M 0 -4 L 1 -3 L 3 -2 L 3 7 L 5 9 L 8 6 M 1 -4 L 4 -2 L 4 6 L 6 8 M -3 -2 L 0 -4 L 2 -5 L 3 -4 L 5 -3 L 6 -3 M 5 -2 L 6 -3 M 5 -2 L 5 6 L 6 7 L 7 7","-8 9 M -4 -2 L -4 6 L -5 7 M -3 -2 L -3 6 L 0 8 M -1 -3 L -2 -2 L -2 6 L 0 7 L 1 8 M -5 7 L -4 7 L -2 8 L -1 9 L 2 8 M -4 -2 L -1 -3 L 4 -5 L 5 -3 L 6 0 L 6 3 L 5 6 L 4 7 L 2 8 M 3 -4 L 4 -3 L 5 -1 M 2 -4 L 4 -2 L 5 1 L 5 3 L 4 6 L 2 8","-8 9 M -3 -8 L -5 -6 L -5 -4 L -4 -1 L -4 6 L -6 8 M -4 7 L -3 14 M -4 -5 L -4 -4 L -3 -1 L -3 9 M -4 -7 L -4 -6 L -3 -4 L -2 -1 L -2 6 L -1 6 L 1 7 L 2 8 M -2 7 L -3 14 M 1 8 L -1 7 M 2 8 L 0 9 L -2 7 M -4 7 L -6 8 M -2 -2 L 4 -5 L 5 -3 L 6 0 L 6 3 L 5 6 L 4 7 L 2 8 M 3 -4 L 4 -3 L 5 -1 M 2 -4 L 4 -2 L 5 1 L 5 3 L 4 6 L 2 8","-8 9 M 2 -5 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 4 L -4 7 L -3 9 L 3 6 M -4 5 L -3 7 L -2 8 M -1 -4 L -3 -2 L -4 1 L -4 3 L -3 6 L -1 8 M 0 -4 L 1 -3 L 3 -2 L 3 6 L 4 14 M 1 -4 L 4 -2 L 4 9 M 2 -5 L 3 -4 L 5 -3 L 6 -3 M 5 -2 L 6 -3 M 5 -2 L 5 6 L 4 14","-7 7 M -4 -3 L -3 -3 L -2 -2 L -2 6 L -3 7 M -3 -4 L -1 -2 L -1 7 L 1 8 M -5 -2 L -2 -5 L 0 -3 L 0 6 L 1 7 L 2 7 M -3 7 L -1 8 L 0 9 L 3 6 M 2 -4 L 3 -2 L 5 -3 L 4 -5 L 0 -3 M 3 -4 L 4 -3","-6 5 M 6 -12 L 5 -11 L 3 -11 L 1 -12 L -1 -12 L -2 -10 L -2 -5 L -3 -3 L -4 -2 M 4 -10 L 2 -10 L 0 -11 L -1 -11 M 6 -12 L 5 -10 L 4 -9 L 2 -9 L 0 -10 L -1 -10 L -2 -9 M -2 -7 L 0 -2 M -2 -2 L -2 2 L -1 14 M -1 -3 L -2 -3 L -1 -4 L -1 9 M 0 -2 L 0 2 L -1 14 M -4 -2 L -2 -2","-6 6 M 1 -9 L 0 -6 L -1 -4 L -2 -3 L -4 -2 M 1 -9 L 1 -3 L 4 -3 L 4 -2 M -4 -2 L -1 -2 M 1 -2 L 4 -2 M -1 -2 L -1 6 L -2 7 M 0 -3 L -1 -3 L 0 -5 L 0 6 L 2 8 M 1 -2 L 1 6 L 2 7 L 3 7 M -2 7 L 0 8 L 1 9 L 4 6","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 6 L -6 7 M -6 -4 L -4 -2 L -4 6 L -2 8 M -8 -2 L -5 -5 L -3 -3 L -3 6 L -1 7 L 0 8 M -6 7 L -5 7 L -3 8 L -2 9 L 0 8 L 3 6 M 4 -5 L 2 -3 L 3 -2 L 3 7 L 5 9 L 8 6 M 4 -2 L 5 -3 L 4 -4 L 3 -3 L 4 -2 L 4 6 L 6 8 M 4 -5 L 6 -3 L 5 -2 L 5 6 L 6 7 L 7 7","-8 9 M -3 -7 L -5 -5 L -5 -3 L -4 0 L -4 6 L -5 7 M -4 -4 L -4 -3 L -3 0 L -3 6 L 0 8 M -4 -6 L -4 -5 L -3 -3 L -2 0 L -2 6 L 0 7 L 1 8 M -5 7 L -4 7 L -2 8 L -1 9 L 2 8 M -2 -2 L 4 -5 L 5 -3 L 6 0 L 6 3 L 5 6 L 4 7 L 2 8 M 3 -4 L 4 -3 L 5 -1 M 2 -4 L 4 -2 L 5 1 L 5 3 L 4 6 L 2 8","-12 13 M -7 -7 L -9 -5 L -9 -3 L -8 0 L -8 6 L -9 7 L -7 9 M -8 -4 L -8 -3 L -7 0 L -7 6 L -8 7 L -7 8 L -6 7 L -7 6 M -8 -6 L -8 -5 L -7 -3 L -6 0 L -6 6 L -5 7 L -7 9 M -3 -4 L -1 -3 L 0 -1 L 0 6 L -1 7 M -1 -4 L 0 -3 L 1 -1 L 1 6 L 4 8 M -6 -2 L -3 -4 L -1 -5 L 1 -4 L 2 -2 L 2 6 L 4 7 L 5 8 M -1 7 L 0 7 L 2 8 L 3 9 L 6 8 M 2 -2 L 8 -5 L 9 -3 L 10 0 L 10 2 L 9 6 L 8 7 L 6 8 M 7 -4 L 8 -3 L 9 -1 M 6 -4 L 8 -2 L 9 1 L 9 3 L 8 6 L 6 8","-7 8 M -3 -3 L -2 -3 L -1 -2 L -1 6 L -2 6 L -4 7 L -5 9 L -5 11 L -4 13 L -2 14 L 1 14 L 4 13 L 4 12 L 3 12 L 3 13 M -2 -4 L 0 -2 L 0 6 L 3 8 M -4 -2 L -1 -5 L 1 -3 L 1 6 L 3 7 L 4 8 M 6 7 L 2 9 L 1 8 L -1 7 L -3 7 L -5 9 M 3 -4 L 4 -2 L 6 -3 L 5 -5 L 1 -3 M 4 -4 L 5 -3","-8 9 M -3 -7 L -5 -5 L -5 -3 L -4 0 L -4 6 L -5 7 M -4 -4 L -4 -3 L -3 0 L -3 7 L -1 8 M -4 -6 L -4 -5 L -3 -3 L -2 0 L -2 6 L -1 7 L 0 7 M -5 7 L -3 8 L -2 9 L 1 6 M -2 -2 L 4 -5 L 5 -3 L 6 1 L 6 5 L 5 8 L 4 10 L 2 12 L -1 14 M 3 -4 L 4 -3 L 5 0 M 2 -4 L 4 -1 L 5 2 L 5 5 L 4 9 L 2 12","-7 7 M -4 -2 L 1 -5 L 3 -4 L 4 -2 L 4 0 L 3 2 L -1 4 M 1 -4 L 3 -3 M 0 -4 L 2 -3 L 3 -1 L 3 0 L 2 2 L 1 3 M 1 3 L 3 5 L 4 7 L 4 11 L 3 13 L 1 14 L -1 14 L -3 13 L -4 11 L -4 9 L -3 7 L -1 6 L 5 4 M 0 4 L 2 5 L 3 7 M -1 4 L 2 6 L 3 8 L 3 11 L 2 13 L 1 14","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
gothicita = ["-8 8","-6 6 M 0 -12 L -1 -11 L -3 -10 L -1 -9 L 0 2 M 0 -9 L 1 -10 L 0 -11 L -1 -10 L 0 -9 L 0 2 M 0 -12 L 1 -11 L 3 -10 L 1 -9 L 0 2 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 2 -12 L 4 -11 L 5 -9 L 5 -7 L 7 -8 L 6 -10 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -6 L -6 -4 L -3 -2 L 3 0 L 5 1 L 6 3 L 6 6 L 5 8 M 6 -8 L 5 -10 M -6 -6 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 2 M -5 7 L -6 5 M -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 3 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -5 4 L -5 6 L -4 8 L -2 9","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 7 -4 L 8 -3 L 9 -3 L 10 -4 M 6 -3 L 7 -2 L 9 -2 M 6 -2 L 7 -1 L 8 -1 L 9 -2 L 10 -4 M 7 -4 L 1 2 M 0 3 L -6 9 L -10 4 L -4 -2 M -3 -3 L 1 -7 L -3 -12 L -8 -6 L -2 0 L 2 6 L 4 8 L 6 9 L 8 9 L 9 8 L 10 6 M -6 8 L -9 4 M 0 -7 L -3 -11 M -7 -6 L -2 -1 L 2 5 L 4 7 L 6 8 L 9 8 M -5 8 L -9 3 M 0 -6 L -4 -11 M -7 -7 L -1 -1 L 3 5 L 4 6 L 6 7 L 9 7 L 10 6","-4 5 M 1 -12 L 0 -11 L 0 -5 M 1 -11 L 0 -5 M 1 -12 L 2 -11 L 0 -5","-7 7 M 3 -16 L 1 -14 L -1 -11 L -3 -7 L -4 -2 L -4 2 L -3 7 L -1 11 L 1 14 L 3 16 M -1 -10 L -2 -7 L -3 -3 L -3 3 L -2 7 L -1 10 M 1 -14 L 0 -12 L -1 -9 L -2 -3 L -2 3 L -1 9 L 0 12 L 1 14","-7 7 M -3 -16 L -1 -14 L 1 -11 L 3 -7 L 4 -2 L 4 2 L 3 7 L 1 11 L -1 14 L -3 16 M 1 -10 L 2 -7 L 3 -3 L 3 3 L 2 7 L 1 10 M -1 -14 L 0 -12 L 1 -9 L 2 -3 L 2 3 L 1 9 L 0 12 L -1 14","-8 8 M 0 -12 L -1 -11 L 1 -1 L 0 0 M 0 -12 L 0 0 M 0 -12 L 1 -11 L -1 -1 L 0 0 M -5 -9 L -4 -9 L 4 -3 L 5 -3 M -5 -9 L 5 -3 M -5 -9 L -5 -8 L 5 -4 L 5 -3 M 5 -9 L 4 -9 L -4 -3 L -5 -3 M 5 -9 L -5 -3 M 5 -9 L 5 -8 L -5 -4 L -5 -3","-12 13 M 0 -9 L 0 8 L 1 8 M 0 -9 L 1 -9 L 1 8 M -8 -1 L 9 -1 L 9 0 M -8 -1 L -8 0 L 9 0","-6 6 M 0 12 L 0 10 L -2 8 L 0 6 L 1 8 L 1 10 L 0 12 L -2 13 M 0 7 L -1 8 L 0 9 L 0 7","-13 13 M -9 0 L 9 0","-6 6 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-11 12 M 9 -16 L -9 16 L -8 16 M 9 -16 L 10 -16 L -8 16","-10 10 M -6 -10 L -6 6 L -8 7 M -5 -9 L -5 6 L -2 8 M -4 -10 L -4 6 L -2 7 L -1 8 M -6 -10 L -4 -10 L 1 -11 L 3 -12 M 1 -11 L 2 -10 L 4 -9 L 4 7 M 2 -11 L 5 -9 L 5 6 M 3 -12 L 4 -11 L 6 -10 L 8 -10 L 6 -9 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -3 -10 L -2 -9 L -1 -7 L -1 6 L -3 7 M -1 -9 L -2 -10 L -1 -11 L 0 -9 L 0 7 L 2 8 M -3 -10 L 0 -12 L 1 -10 L 1 6 L 3 7 L 4 7 M -3 7 L -2 7 L 0 8 L 1 9 L 2 8 L 4 7","-10 10 M -6 -10 L -4 -10 L -2 -11 L -1 -12 L 1 -11 L 4 -10 L 6 -10 M -2 -10 L 0 -11 M -6 -10 L -4 -9 L -2 -9 L 0 -10 L 1 -11 M 4 -10 L 4 -2 M 5 -9 L 5 -3 M 6 -10 L 6 -2 L -1 -2 L -4 -1 L -6 1 L -7 4 L -7 9 M -7 9 L -3 7 L 1 6 L 4 6 L 8 7 M -4 8 L -1 7 L 4 7 L 7 8 M -7 9 L -2 8 L 3 8 L 6 9 L 8 7","-10 10 M -6 -10 L -5 -10 L -3 -11 L -2 -12 L 0 -11 L 4 -10 L 6 -10 M -3 -10 L -1 -11 M -6 -10 L -4 -9 L -2 -9 L 0 -11 M 4 -10 L 4 -3 M 5 -9 L 5 -4 M 6 -10 L 6 -3 L 4 -3 L 1 -2 L -1 -1 M -1 -2 L 1 -1 L 4 0 L 6 0 L 6 7 M 5 1 L 5 6 M 4 0 L 4 7 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-10 10 M 3 -12 L -7 -2 L -7 3 L 2 3 M 4 3 L 8 3 L 9 4 L 9 2 L 8 3 M -6 -2 L -6 2 M -5 -4 L -5 3 M 2 -11 L 2 6 L 0 7 M 3 -8 L 4 -10 L 3 -11 L 3 7 L 5 8 M 3 -12 L 5 -10 L 4 -8 L 4 6 L 6 7 L 7 7 M 0 7 L 1 7 L 3 8 L 4 9 L 5 8 L 7 7","-10 10 M -6 -12 L -6 -3 M -6 -12 L 6 -12 M -5 -11 L 4 -11 M -6 -10 L 3 -10 L 5 -11 L 6 -12 M 4 -6 L 3 -5 L 1 -4 L -3 -3 L -6 -3 M 1 -4 L 2 -4 L 4 -3 L 4 7 M 3 -5 L 5 -4 L 5 6 M 4 -6 L 5 -5 L 7 -4 L 8 -4 L 6 -3 L 6 7 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-10 10 M -6 -10 L -6 6 L -8 7 M -5 -9 L -5 6 L -2 8 M -4 -10 L -4 6 L -2 7 L -1 8 M -6 -10 L -4 -10 L 0 -11 L 2 -12 L 3 -11 L 5 -10 L 6 -10 M 1 -11 L 3 -10 M 0 -11 L 2 -9 L 4 -9 L 6 -10 M -4 -2 L -3 -2 L 1 -3 L 3 -4 L 4 -5 M 1 -3 L 2 -3 L 4 -2 L 4 7 M 3 -4 L 5 -2 L 5 6 M 4 -5 L 5 -4 L 7 -3 L 8 -3 L 6 -2 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -7 -10 L -5 -12 L -2 -11 L 3 -11 L 8 -12 M -6 -11 L -3 -10 L 2 -10 L 5 -11 M -7 -10 L -3 -9 L 0 -9 L 4 -10 L 8 -12 M 8 -12 L 7 -10 L 5 -7 L 1 -3 L -1 0 L -2 3 L -2 6 L -1 9 M 0 -1 L -1 2 L -1 5 L 0 8 M 3 -5 L 1 -2 L 0 1 L 0 4 L 1 7 L -1 9","-10 10 M -6 -9 L -6 -3 M -5 -8 L -5 -4 M -4 -9 L -4 -3 M -6 -9 L -4 -9 L 1 -10 L 3 -11 L 4 -12 M 1 -10 L 2 -10 L 4 -9 L 4 -3 M 3 -11 L 5 -10 L 5 -4 M 4 -12 L 5 -11 L 7 -10 L 8 -10 L 6 -9 L 6 -3 M -6 -3 L -4 -3 L 4 0 L 6 0 M 6 -3 L 4 -3 L -4 0 L -6 0 M -6 0 L -6 6 L -8 7 M -5 1 L -5 6 L -2 8 M -4 0 L -4 6 L -2 7 L -1 8 M 4 0 L 4 7 M 5 1 L 5 6 M 6 0 L 6 7 M -8 7 L -6 7 L -4 8 L -3 9 L -1 8 L 4 7 L 6 7","-10 10 M -6 -10 L -6 -1 L -8 0 M -5 -9 L -5 0 L -3 1 M -4 -10 L -4 -1 L -2 0 L -1 0 M -6 -10 L -4 -10 L 1 -11 L 3 -12 M 1 -11 L 2 -10 L 4 -9 L 4 7 M 2 -11 L 5 -9 L 5 6 M 3 -12 L 4 -11 L 6 -10 L 8 -10 L 6 -9 L 6 7 M -8 0 L -7 0 L -5 1 L -4 2 L -3 1 L -1 0 L 3 -1 L 4 -1 M -7 7 L -5 6 L -3 6 L -1 7 L 0 8 M -3 7 L -1 8 M -7 7 L -5 7 L -3 8 L -2 9 L 0 8 L 4 7 L 6 7","-6 6 M 0 -5 L -2 -3 L 0 -2 L 2 -3 L 0 -5 M 0 -4 L -1 -3 L 1 -3 L 0 -4 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-6 6 M 0 -5 L -2 -3 L 0 -2 L 2 -3 L 0 -5 M 0 -4 L -1 -3 L 1 -3 L 0 -4 M 0 12 L 0 10 L -2 8 L 0 6 L 1 8 L 1 10 L 0 12 L -2 13 M 0 7 L -1 8 L 0 9 L 0 7","-12 12 M 8 -9 L -8 0 L 8 9","-12 13 M -8 -5 L 9 -5 L 9 -4 M -8 -5 L -8 -4 L 9 -4 M -8 3 L 9 3 L 9 4 M -8 3 L -8 4 L 9 4","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -6 -8 L -5 -10 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -2 L 1 -1 M -5 -8 L -4 -10 M 4 -10 L 5 -9 L 5 -5 L 4 -4 M -6 -8 L -4 -7 L -4 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 4 -9 L 4 -5 L 3 -3 L 1 -1 M 0 -1 L 0 2 L 1 -1 L -1 -1 L 0 2 M 0 6 L -2 8 L 0 9 L 2 8 L 0 6 M 0 7 L -1 8 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-13 13 M -4 -10 L -6 -9 L -8 -7 L -9 -5 L -10 -2 L -10 1 L -9 3 L -7 4 M -8 -6 L -9 -3 L -9 1 L -8 3 M -4 -10 L -6 -8 L -7 -6 L -8 -3 L -8 0 L -7 4 L -7 6 L -8 8 L -10 9 M 4 -10 L 6 -10 L 6 7 L 4 7 M 7 -10 L 7 7 M 8 -11 L 8 8 M -10 -12 L -7 -11 L -1 -10 L 4 -10 L 8 -11 L 10 -12 M -8 -2 L 6 -2 M -10 9 L -7 8 L -1 7 L 4 7 L 8 8 L 10 9","-13 13 M -6 -11 L -6 8 M -5 -11 L -5 8 M -2 -12 L -4 -11 L -4 8 L -2 9 M -10 -8 L -8 -10 L -6 -11 L -2 -12 L 3 -12 L 6 -11 L 8 -9 L 8 -7 L 7 -5 M 6 -10 L 7 -9 L 7 -7 L 6 -5 M 3 -12 L 5 -11 L 6 -9 L 6 -7 L 5 -6 M -1 3 L -3 2 L -4 0 L -4 -2 L -3 -4 L -2 -5 L 1 -6 L 4 -6 L 7 -5 L 9 -3 L 10 -1 L 10 2 L 9 5 L 7 7 L 5 8 L 2 9 L -2 9 L -6 8 L -8 7 L -10 5 M 8 -3 L 9 -1 L 9 3 L 8 5 M 4 -6 L 7 -4 L 8 -1 L 8 3 L 7 6 L 5 8","-13 13 M 10 -12 L 9 -10 L 8 -8 L 6 -10 L 4 -11 L 1 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 7 L 10 9 M 9 -10 L 8 -5 L 8 2 L 9 7 M 8 -7 L 7 -8 M 8 -4 L 7 -7 L 6 -9 L 4 -11 M -8 -7 L -9 -4 L -9 1 L -8 4 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 M 7 5 L 8 4 M 4 8 L 6 6 L 7 4 L 8 1","-13 13 M -7 -11 L -7 8 M -6 -11 L -6 8 M -4 -12 L -5 -11 L -5 8 L -4 9 M -10 -7 L -9 -9 L -7 -11 L -4 -12 L 1 -12 L 4 -11 L 6 -10 L 8 -8 L 9 -6 L 10 -3 L 10 0 L 9 3 L 8 5 L 6 7 L 4 8 L 1 9 L -4 9 L -7 8 L -9 6 L -10 4 M 8 -7 L 9 -4 L 9 1 L 8 4 M 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8","-13 13 M 10 -12 L 9 -10 L 8 -8 L 6 -10 L 4 -11 L 1 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 7 L 10 9 M 9 -10 L 8 -5 L 8 2 L 9 7 M 8 -7 L 7 -8 M 8 -5 L 6 -9 L 4 -11 M -8 -7 L -9 -4 L -9 1 L -8 4 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 M 7 5 L 8 4 M 4 8 L 6 6 L 7 4 L 8 1 M -8 -2 L -7 -3 L -4 -3 L 3 -1 L 6 -1 L 8 -2 M -2 -2 L 0 -1 L 3 0 L 5 0 L 7 -1 M -5 -3 L 0 0 L 3 1 L 5 1 L 7 0 L 8 -2 M 8 -5 L 7 -6 L 6 -6 L 5 -5 L 6 -4 L 7 -5","-13 13 M -8 -10 L -8 8 M -5 -11 L -7 -10 L -7 7 M -3 -12 L -5 -11 L -6 -9 L -6 7 L -4 7 M -10 -8 L -8 -10 L -6 -11 L -3 -12 L 1 -12 L 4 -11 L 6 -10 L 7 -9 L 10 -12 M 10 -12 L 9 -10 L 8 -6 L 8 -3 L 9 1 L 10 3 M 8 -9 L 7 -7 M 4 -11 L 6 -9 L 7 -6 L 8 -3 M -6 -2 L -5 -3 L -3 -3 L 2 -2 L 5 -2 L 7 -3 M -1 -2 L 2 -1 L 4 -1 L 6 -2 M -4 -3 L 2 0 L 4 0 L 6 -1 L 7 -3 L 7 -6 L 6 -7 L 5 -7 L 4 -6 L 5 -5 L 6 -6 M -10 9 L -8 8 L -4 7 L 1 7 L 7 8 L 10 9","-13 13 M 10 -12 L 9 -10 L 8 -8 L 6 -10 L 4 -11 L 1 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 4 8 L 6 7 L 7 6 L 8 4 L 9 7 L 10 9 M 9 -10 L 8 -5 L 8 2 L 9 7 M 8 -7 L 7 -8 M 8 -4 L 7 -7 L 6 -9 L 4 -11 M -8 -7 L -9 -4 L -9 1 L -8 4 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 M 6 6 L 7 4 L 7 0 M 4 8 L 5 7 L 6 4 L 6 -1 M -7 1 L -6 0 L -5 1 L -6 2 L -7 2 L -8 1 M -8 -2 L -7 -4 L -5 -5 L -3 -5 L 0 -4 L 3 -2 L 5 -1 M -7 -3 L -5 -4 L -3 -4 L 0 -3 L 2 -2 M -8 -2 L -6 -3 L -3 -3 L 3 -1 L 7 -1 L 8 -2","-13 13 M -8 -11 L -8 8 L -10 9 M -7 -10 L -7 8 M -4 -10 L -6 -10 L -6 8 M -10 -12 L -8 -11 L -4 -10 L 1 -10 L 7 -11 L 10 -12 M -6 -2 L -5 -4 L -3 -6 L 0 -7 L 4 -7 L 7 -6 L 9 -4 L 10 -1 L 10 2 L 9 3 L 7 4 M 8 -4 L 9 -2 L 9 1 L 8 3 M 4 -7 L 6 -6 L 7 -5 L 8 -3 L 8 1 L 7 4 L 7 6 L 8 8 L 10 9 M -10 9 L -6 8 L -2 8 L 3 9","-13 13 M -1 -9 L -1 7 M 0 -8 L 0 6 M 1 -9 L 1 7 M -10 -12 L -6 -10 L -2 -9 L 2 -9 L 6 -10 L 10 -12 M -10 9 L -7 8 L -3 7 L 3 7 L 7 8 L 10 9","-13 13 M 2 -9 L 4 -9 L 4 6 L 3 8 L 1 9 M 5 -9 L 5 6 L 4 7 M 6 -10 L 6 7 M -10 -12 L -6 -10 L -2 -9 L 2 -9 L 6 -10 L 10 -12 M -9 -3 L -10 -1 L -10 3 L -9 6 L -7 8 L -4 9 L 1 9 L 4 8 L 6 7 L 8 5 L 10 2 M -9 3 L -8 6 L -7 7 M -10 1 L -8 3 L -7 6 L -6 8 L -4 9","-13 13 M -8 -11 L -8 8 L -10 9 M -7 -10 L -7 8 M -4 -10 L -6 -10 L -6 8 M -10 -12 L -8 -11 L -4 -10 L 1 -10 L 7 -11 L 10 -12 M -6 -2 L -5 -4 L -3 -6 L 0 -7 L 3 -7 L 6 -6 L 7 -5 L 7 -3 L 6 -2 L 1 0 L -1 1 L -2 2 L -2 3 L -1 4 L 0 3 L -1 2 M 5 -6 L 6 -5 L 6 -3 L 5 -2 M 3 -7 L 5 -5 L 5 -3 L 4 -2 L 1 0 M 1 0 L 4 0 L 7 1 L 8 3 L 8 5 L 7 6 M 5 1 L 7 3 L 7 5 M 1 0 L 4 1 L 6 3 L 7 6 L 8 8 L 9 9 L 10 9 M -10 9 L -6 8 L -2 8 L 3 9","-13 13 M -8 -11 L -8 8 M -7 -10 L -7 7 M -4 -10 L -6 -10 L -6 7 L -4 7 M 10 -7 L 8 -4 L 7 -2 L 6 1 L 6 3 L 7 5 L 9 6 M 8 -3 L 7 0 L 7 3 L 8 5 M 10 -7 L 9 -5 L 8 -1 L 8 2 L 9 6 L 10 9 M -10 -12 L -8 -11 L -4 -10 L 1 -10 L 7 -11 L 10 -12 M -10 9 L -8 8 L -4 7 L 1 7 L 7 8 L 10 9","-13 13 M -1 -9 L -1 7 M 0 -8 L 0 6 M 1 -9 L 1 7 M -4 7 L -6 5 L -8 4 L -9 3 L -10 0 L -10 -5 L -9 -8 L -7 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 7 -10 L 9 -8 L 10 -5 L 10 0 L 9 3 L 8 4 L 6 5 L 4 7 M -8 3 L -9 0 L -9 -5 L -8 -8 M -6 5 L -7 3 L -8 0 L -8 -6 L -7 -9 L -5 -11 M 8 -8 L 9 -5 L 9 0 L 8 3 M 5 -11 L 7 -9 L 8 -6 L 8 0 L 7 3 L 6 5 M -10 -12 L -6 -10 L -2 -9 L 2 -9 L 6 -10 L 10 -12 M -10 9 L -7 8 L -3 7 L 3 7 L 7 8 L 10 9","-13 13 M -8 -10 L -8 8 L -10 9 M -6 -10 L -7 -9 L -7 8 M -3 -12 L -5 -11 L -6 -9 L -6 8 M -10 -8 L -8 -10 L -6 -11 L -3 -12 L 1 -12 L 4 -11 L 6 -10 L 8 -8 L 9 -6 L 10 -3 L 10 1 L 9 3 L 7 4 M 8 -7 L 9 -4 L 9 0 L 8 3 M 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 0 L 7 4 L 7 6 L 8 8 L 9 9 L 10 9 M -10 9 L -6 8 L -2 8 L 3 9","-13 13 M -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 L 10 0 L 10 -3 L 9 -6 L 8 -8 L 6 -10 L 4 -11 L 1 -12 L -1 -12 M -8 -7 L -9 -4 L -9 1 L -8 4 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 M 8 4 L 9 1 L 9 -4 L 8 -7 M 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11","-13 13 M -8 -9 L -8 8 M -5 -10 L -7 -8 L -7 7 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -6 7 L -4 7 M -10 -7 L -8 -9 L -4 -11 L -1 -12 L 2 -12 L 5 -11 L 7 -10 L 9 -8 L 10 -5 L 10 -3 L 9 0 L 7 2 L 4 3 L 0 3 L -3 2 L -5 0 L -6 -3 M 8 -8 L 9 -6 L 9 -2 L 8 0 M 5 -11 L 7 -9 L 8 -6 L 8 -2 L 7 1 L 4 3 M -10 9 L -8 8 L -4 7 L 1 7 L 7 8 L 10 9","-13 13 M -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 L 10 0 L 10 -3 L 9 -6 L 8 -8 L 6 -10 L 4 -11 L 1 -12 L -1 -12 M -8 -7 L -9 -4 L -9 1 L -8 4 M -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 M 8 4 L 9 1 L 9 -4 L 8 -7 M 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 M -8 1 L -7 3 L -4 4 L 2 5 L 9 5 L 10 6 L 10 8 L 9 9 L 9 8 L 10 7 M -2 5 L 0 5 M -7 3 L -4 5 L -1 6 L 1 6 L 2 5","-13 13 M -8 -9 L -8 8 L -10 9 M -7 -9 L -7 8 M -6 -10 L -6 8 M -10 -7 L -8 -9 L -6 -10 L -4 -11 L -1 -12 L 3 -12 L 7 -11 L 9 -9 L 10 -7 L 10 -4 L 9 -2 L 8 -1 M 7 -10 L 8 -9 L 9 -7 L 9 -4 L 8 -2 M 3 -12 L 5 -11 L 7 -9 L 8 -7 L 8 -3 L 7 -1 M 6 0 L 3 1 L 0 1 L -2 0 L -2 -2 L 0 -3 L 3 -3 L 6 -2 L 8 0 L 10 3 L 10 5 L 9 6 L 8 6 M 6 -1 L 7 0 L 9 4 L 9 5 L 8 2 M 2 -3 L 4 -2 L 6 0 L 7 2 L 8 6 L 9 8 L 10 9 M -10 9 L -6 8 L -2 8 L 3 9","-13 13 M 2 -12 L 8 -11 L 10 -12 L 9 -10 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -8 -8 L -9 -5 L -9 -3 L -8 0 L -6 2 L -3 3 L 0 3 L 2 2 L 3 1 L 4 -1 L 4 -2 M 9 -11 L 8 -10 L 9 -8 M -8 -2 L -7 0 L -6 1 L -3 2 L 0 2 L 2 1 M -7 -9 L -8 -7 L -8 -4 L -7 -2 L -5 0 L -2 1 L 0 1 L 2 0 L 4 -2 L 5 -3 L 6 -3 M -6 -1 L -5 -1 L -4 -2 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 7 -2 L 8 0 L 8 3 L 7 6 L 5 8 M -2 -5 L 0 -6 L 3 -6 L 6 -5 L 8 -3 L 9 0 L 9 3 L 8 5 M -9 5 L -8 7 L -9 8 M -4 -2 L -4 -3 L -3 -5 L -2 -6 L 0 -7 L 3 -7 L 6 -6 L 9 -3 L 10 0 L 10 2 L 9 5 L 7 7 L 5 8 L 2 9 L -2 9 L -5 8 L -7 7 L -9 5 L -9 7 L -10 9 L -8 8 L -2 9","-13 13 M -1 -10 L -5 -10 L -7 -9 L -8 -8 L -9 -6 L -10 -3 L -10 1 L -9 4 L -8 6 L -7 7 L -5 8 L -2 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 L 10 0 L 10 -4 L 9 -7 L 7 -9 L 5 -10 M 3 -10 L 2 -9 L 2 -7 L 3 -6 L 4 -7 L 3 -8 M -9 1 L -8 4 L -6 6 L -4 7 L -1 8 L 2 8 L 5 7 M -8 -8 L -9 -4 L -9 -1 L -8 2 L -6 5 L -4 6 L -1 7 L 2 7 L 5 6 L 7 5 L 9 2 L 10 0 M -10 -12 L -7 -9 M -7 -10 L -6 -11 M -9 -11 L -8 -11 L -7 -12 L -5 -11 L -1 -10 L 5 -10 L 8 -11 L 10 -12","-13 13 M -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 3 9 L 6 8 L 8 7 M -7 -8 L -8 -6 L -9 -3 L -9 1 L -8 4 M -7 -9 L -6 -8 L -6 -7 L -7 -5 L -8 -2 L -8 1 L -7 4 L -6 6 L -4 8 M 4 -10 L 6 -10 L 6 6 L 5 8 L 3 9 M 7 -10 L 7 6 L 6 7 M 8 -11 L 8 7 L 10 9 M -10 -12 L -7 -11 L -1 -10 L 4 -10 L 8 -11 L 10 -12","-13 13 M -10 -12 L 0 9 M -9 -11 L -8 -10 L -1 5 L 0 7 M -8 -11 L -7 -10 L 0 5 L 1 6 M 10 -12 L 0 9 M 5 -4 L 3 1 M 7 -6 L 3 -1 L 2 2 L 2 4 M -10 -12 L -8 -11 L -3 -10 L 3 -10 L 8 -11 L 10 -12","-13 13 M -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 1 9 L 4 8 L 6 7 L 8 5 L 9 3 L 10 0 L 10 -3 L 9 -6 L 8 -8 L 6 -10 M -8 -6 L -9 -3 L -9 0 L -8 3 L -7 5 M -8 -8 L -7 -7 L -7 -6 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 M 7 5 L 8 3 L 9 0 L 9 -3 L 8 -6 M 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -6 L 7 -7 L 8 -8 M -1 -9 L -1 9 M 0 -8 L 0 8 M 1 -9 L 1 9 M -10 -12 L -6 -10 L -2 -9 L 2 -9 L 6 -10 L 10 -12","-13 13 M -10 -12 L 6 7 L 7 8 M -9 -11 L -7 -10 L 8 8 M -6 -10 L 10 9 M 10 -12 L 1 -2 M -1 0 L -8 8 M -2 1 L -5 3 L -6 5 M -1 0 L -5 2 L -6 3 L -7 5 L -7 7 M -10 -12 L -6 -10 L -2 -9 L 2 -9 L 6 -10 L 10 -12 M -10 9 L -8 8 L -4 7 L 1 7 L 7 8 L 10 9","-13 13 M 6 -10 L 6 8 M 7 -10 L 7 7 M 8 -11 L 8 7 M -7 -10 L -9 -8 L -10 -5 L -10 -2 L -9 1 L -7 3 L -5 4 L -2 5 L 1 5 L 4 4 L 6 3 M -6 3 L -3 4 L 3 4 M -10 -2 L -9 0 L -7 2 L -4 3 L 2 3 L 4 4 M -10 -12 L -6 -10 L -2 -9 L 2 -9 L 6 -10 L 10 -12 M -10 5 L -8 7 L -6 8 L -2 9 L 2 9 L 6 8 L 10 6","-13 13 M -10 -12 L -9 -11 L -7 -10 L -4 -10 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 M 6 -11 L 7 -9 L 7 -7 L 6 -5 M 4 -12 L 5 -11 L 6 -9 L 6 -6 M 6 -4 L 2 -3 L 0 -3 L -2 -4 L -2 -6 L 0 -7 L 2 -7 L 6 -6 M 2 -7 L 4 -6 L 5 -5 L 4 -4 L 2 -3 M 7 -5 L 9 -3 L 10 0 L 10 2 L 9 5 L 7 7 L 5 8 L 2 9 L -2 9 L -5 8 L -7 7 L -9 5 L -10 2 L -10 0 L -9 -3 L -8 -4 L -6 -5 L -4 -5 L -2 -4 L -2 -2 L -3 -1 L -4 -2 L -3 -3 M 6 -5 L 8 -3 L 9 -1 L 9 3 L 8 5 M 6 -4 L 7 -3 L 8 -1 L 8 3 L 7 6 L 5 8","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-13 13 M -13 16 L 13 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-8 9 M -2 -1 L -5 2 L -5 6 L -2 9 L 2 7 M -4 2 L -4 6 L -2 8 M -3 0 L -3 5 L 0 8 M 0 1 L -5 -4 L -4 -5 L -3 -4 L -4 -3 M -3 -4 L 1 -4 L 3 -5 L 5 -3 L 5 6 L 6 7 M 3 -4 L 4 -3 L 4 6 L 3 7 L 4 8 L 5 7 L 4 6 M 1 -4 L 3 -2 L 3 6 L 2 7 L 4 9 L 6 7","-9 8 M -4 -10 L -6 -12 L -5 -8 L -5 6 L -2 9 L 3 7 L 5 6 M -4 -10 L -4 6 L -2 8 M -4 -10 L -2 -12 L -3 -8 L -3 5 L 0 8 M -3 -3 L 2 -5 L 5 -2 L 5 6 M 2 -4 L 4 -2 L 4 6 M 0 -4 L 3 -1 L 3 7","-7 5 M -4 -2 L -4 7 L -2 9 L 0 7 M -3 -2 L -3 7 L -2 8 M -2 -3 L -2 6 L -1 7 L 0 7 M -4 -2 L 2 -5 L 4 -3 L 2 -2 L 0 -4 M 1 -4 L 3 -3","-8 8 M 0 -5 L -5 -2 L -5 6 L -2 9 L 0 8 L 3 7 L 5 7 M -4 -2 L -4 6 L -2 8 M -3 -3 L -3 5 L 0 8 M -2 -9 L -2 -12 L -1 -9 L 5 -2 L 5 7 M -2 -9 L 4 -2 L 4 6 M -2 -9 L -5 -9 L -2 -8 L 3 -2 L 3 7","-7 6 M -4 -2 L -4 7 L -2 9 L 0 7 M -3 -2 L -3 7 L -2 8 M -2 -3 L -2 6 L -1 7 L 0 7 M -4 -2 L 2 -5 L 5 -1 L -2 3 M 1 -4 L 4 -1 M 0 -4 L 3 0","-7 5 M -3 -9 L -3 6 L -4 7 L -2 9 M -2 -9 L -2 6 L -3 7 L -2 8 L -1 7 L -2 6 M -1 -10 L -1 6 L 0 7 L -2 9 M -3 -9 L 3 -12 L 5 -10 L 3 -9 L 1 -11 M 2 -11 L 4 -10 M -6 -5 L -3 -5 M -1 -5 L 3 -5","-8 9 M -5 -2 L -5 6 L -2 9 L 3 7 M -4 -2 L -4 6 L -2 8 M -3 -3 L -3 5 L 0 8 M -5 -2 L -3 -3 L 2 -5 L 5 -2 L 5 11 L 4 13 L 3 14 L 1 15 L -1 15 L -3 14 L -5 15 L -3 16 L -1 15 M 2 -4 L 4 -2 L 4 11 L 3 13 M -2 15 L -4 15 M 0 -4 L 3 -1 L 3 12 L 2 14 L 1 15","-9 9 M -4 -10 L -6 -12 L -5 -8 L -5 6 L -6 7 L -4 9 M -4 -10 L -4 6 L -5 7 L -4 8 L -3 7 L -4 6 M -4 -10 L -2 -12 L -3 -8 L -3 6 L -2 7 L -4 9 M -3 -3 L 0 -4 L 2 -5 L 5 -2 L 5 7 L 2 11 L 2 14 L 3 16 L 4 16 L 2 14 M 2 -4 L 4 -2 L 4 7 L 3 9 M 0 -4 L 3 -1 L 3 8 L 2 11","-5 5 M 0 -12 L -2 -10 L 0 -8 L 2 -10 L 0 -12 M 0 -11 L -1 -10 L 0 -9 L 1 -10 L 0 -11 M 0 -5 L -2 -3 L -1 -2 L -1 6 L -2 7 L 0 9 M 0 -2 L 1 -3 L 0 -4 L -1 -3 L 0 -2 L 0 6 L -1 7 L 0 8 L 1 7 L 0 6 M 0 -5 L 2 -3 L 1 -2 L 1 6 L 2 7 L 0 9","-5 5 M 0 -12 L -2 -10 L 0 -8 L 2 -10 L 0 -12 M 0 -11 L -1 -10 L 0 -9 L 1 -10 L 0 -11 M 0 -5 L -2 -3 L -1 -2 L -1 7 L 2 11 M 0 -2 L 1 -3 L 0 -4 L -1 -3 L 0 -2 L 0 7 L 1 9 M 0 -5 L 2 -3 L 1 -2 L 1 8 L 2 11 L 2 14 L 0 16 L -2 15 L -2 16 L 0 16","-9 8 M -4 -10 L -6 -12 L -5 -8 L -5 6 L -6 7 L -4 9 M -4 -10 L -4 6 L -5 7 L -4 8 L -3 7 L -4 6 M -4 -10 L -2 -12 L -3 -8 L -3 6 L -2 7 L -4 9 M -3 -2 L 0 -4 L 2 -5 L 4 -2 L 1 0 L -3 3 M 1 -4 L 3 -2 M 0 -4 L 2 -1 M 0 1 L 1 2 L 2 7 L 4 9 L 6 7 M 1 1 L 2 3 L 3 7 L 4 8 M 1 0 L 2 1 L 4 6 L 5 7 L 6 7","-5 5 M 0 -10 L -2 -12 L -1 -8 L -1 6 L -2 7 L 0 9 M 0 -10 L 0 6 L -1 7 L 0 8 L 1 7 L 0 6 M 0 -10 L 2 -12 L 1 -8 L 1 6 L 2 7 L 0 9","-13 13 M -11 -3 L -10 -3 L -9 -2 L -9 6 L -10 7 L -8 9 M -9 -4 L -8 -3 L -8 6 L -9 7 L -8 8 L -7 7 L -8 6 M -11 -3 L -9 -5 L -7 -3 L -7 6 L -6 7 L -8 9 M -7 -3 L -4 -4 L -2 -5 L 1 -3 L 1 6 L 2 7 L 0 9 M -2 -4 L 0 -3 L 0 6 L -1 7 L 0 8 L 1 7 L 0 6 M -4 -4 L -1 -2 L -1 6 L -2 7 L 0 9 M 1 -3 L 4 -4 L 6 -5 L 9 -3 L 9 6 L 10 7 L 8 9 M 6 -4 L 8 -3 L 8 6 L 7 7 L 8 8 L 9 7 L 8 6 M 4 -4 L 7 -2 L 7 6 L 6 7 L 8 9","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 6 L -6 7 L -4 9 M -5 -4 L -4 -3 L -4 6 L -5 7 L -4 8 L -3 7 L -4 6 M -7 -3 L -5 -5 L -3 -3 L -3 6 L -2 7 L -4 9 M -3 -3 L 0 -4 L 2 -5 L 5 -3 L 5 6 L 6 7 L 4 9 M 2 -4 L 4 -3 L 4 6 L 3 7 L 4 8 L 5 7 L 4 6 M 0 -4 L 3 -2 L 3 6 L 2 7 L 4 9","-8 8 M -5 -2 L -5 6 L -2 9 L 3 7 L 5 6 M -4 -2 L -4 6 L -2 8 M -3 -3 L -3 5 L 0 8 M -5 -2 L -3 -3 L 2 -5 L 5 -2 L 5 6 M 2 -4 L 4 -2 L 4 6 M 0 -4 L 3 -1 L 3 7","-9 8 M -6 -5 L -5 -3 L -5 6 L -7 7 L -5 7 L -5 13 L -6 16 L -4 14 M -4 -3 L -4 14 M -6 -5 L -4 -4 L -3 -3 L -3 6 L -1 7 L 0 8 M -4 7 L -3 7 L -1 8 M -3 8 L -2 9 L 3 7 L 5 6 M -3 8 L -3 13 L -2 16 L -4 14 M -3 -3 L 0 -4 L 2 -5 L 5 -2 L 5 6 M 2 -4 L 4 -2 L 4 6 M 0 -4 L 3 -1 L 3 7","-8 9 M -5 -2 L -5 6 L -2 9 L 3 7 M -4 -2 L -4 6 L -2 8 M -3 -3 L -3 5 L 0 8 M -5 -2 L -3 -3 L 2 -5 L 5 -2 L 5 13 L 6 16 L 4 14 M 2 -4 L 4 -2 L 4 14 M 0 -4 L 3 -1 L 3 13 L 2 16 L 4 14","-7 6 M -5 -3 L -4 -3 L -3 -2 L -3 6 L -4 7 L -2 9 M -3 -4 L -2 -3 L -2 6 L -3 7 L -2 8 L -1 7 L -2 6 M -5 -3 L -3 -5 L -1 -3 L -1 6 L 0 7 L -2 9 M -1 -3 L 3 -5 L 5 -3 L 3 -2 L 1 -4 M 2 -4 L 4 -3","-8 8 M -5 -2 L -5 1 L -3 3 L 3 0 L 5 2 L 5 6 M -4 -2 L -4 1 L -3 2 M -3 -3 L -3 1 L -2 2 M 3 1 L 4 2 L 4 6 M 2 1 L 3 2 L 3 7 M -5 -2 L 1 -5 L 4 -4 L 2 -3 L -1 -4 M 0 -4 L 3 -4 M 5 6 L -1 9 L -5 7 L -3 6 L 1 8 M -3 7 L -1 8","-5 5 M 0 -10 L -2 -12 L -1 -8 L -1 6 L -2 7 L 0 9 M 0 -10 L 0 6 L -1 7 L 0 8 L 1 7 L 0 6 M 0 -10 L 2 -12 L 1 -8 L 1 6 L 2 7 L 0 9 M -4 -5 L -1 -5 M 1 -5 L 4 -5","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 7 L -2 9 L 3 7 M -5 -4 L -4 -3 L -4 7 L -2 8 M -7 -3 L -5 -5 L -3 -3 L -3 6 L 0 8 M 4 -5 L 6 -3 L 5 -2 L 5 6 L 6 7 L 7 7 M 4 -2 L 5 -3 L 4 -4 L 3 -3 L 4 -2 L 4 7 L 5 8 M 4 -5 L 2 -3 L 3 -2 L 3 7 L 5 9 L 7 7","-9 9 M -6 -5 L -5 -3 L -5 6 L -1 9 L 1 7 L 5 5 M -5 -4 L -4 -3 L -4 6 L -1 8 M -6 -5 L -4 -4 L -3 -3 L -3 5 L 0 7 L 1 7 M 4 -5 L 6 -3 L 5 -2 L 5 5 M 4 -2 L 5 -3 L 4 -4 L 3 -3 L 4 -2 L 4 5 M 4 -5 L 2 -3 L 3 -2 L 3 6","-13 13 M -10 -5 L -9 -3 L -9 6 L -5 9 L -3 7 L -1 6 M -9 -4 L -8 -3 L -8 6 L -5 8 M -10 -5 L -8 -4 L -7 -3 L -7 5 L -4 7 L -3 7 M 0 -5 L -2 -3 L -1 -2 L -1 6 L 3 9 L 5 7 L 9 5 M 0 -2 L 1 -3 L 0 -4 L -1 -3 L 0 -2 L 0 6 L 3 8 M 0 -5 L 2 -3 L 1 -2 L 1 5 L 4 7 L 5 7 M 8 -5 L 10 -3 L 9 -2 L 9 5 M 8 -2 L 9 -3 L 8 -4 L 7 -3 L 8 -2 L 8 5 M 8 -5 L 6 -3 L 7 -2 L 7 6","-9 9 M -6 -3 L -4 -2 L 3 8 L 4 9 L 6 7 M -5 -4 L -3 -3 L 3 7 L 5 8 M -6 -3 L -4 -5 L -3 -4 L 4 6 L 6 7 M 6 -5 L 4 -5 L 4 -3 L 6 -3 L 6 -5 L 4 -3 L 1 1 M -1 3 L -4 7 L -6 9 L -4 9 L -4 7 L -6 7 L -6 9 M -4 2 L -1 2 M 1 2 L 4 2","-9 9 M -7 -3 L -6 -3 L -5 -2 L -5 7 L -2 9 L 3 7 M -5 -4 L -4 -3 L -4 7 L -2 8 M -7 -3 L -5 -5 L -3 -3 L -3 6 L 0 8 M 4 -5 L 6 -3 L 5 -2 L 5 11 L 4 13 L 3 14 L 1 15 L -1 15 L -3 14 L -5 15 L -3 16 L -1 15 M 4 -2 L 5 -3 L 4 -4 L 3 -3 L 4 -2 L 4 12 L 3 13 M -2 15 L -4 15 M 4 -5 L 2 -3 L 3 -2 L 3 12 L 2 14 L 1 15","-6 9 M 0 -4 L -3 -2 L -3 -3 L 0 -4 L 2 -5 L 5 -3 L 5 1 L 0 3 M 2 -4 L 4 -3 L 4 1 M 0 -4 L 3 -2 L 3 1 L 2 2 M 0 3 L 5 5 L 5 11 L 4 13 L 3 14 L 1 15 L -1 15 L -3 14 L -5 15 L -3 16 L -1 15 M 4 5 L 4 12 L 3 13 M -2 15 L -4 15 M 2 4 L 3 5 L 3 12 L 2 14 L 1 15","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
greek = ["-8 8","-5 5 M 0 -12 L 0 2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-8 8 M -4 -12 L -4 -5 M 4 -12 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -6 9 L -8 8 L -9 7 L -10 5 L -10 3 L -9 1 L -8 0 L -1 -4 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 7 9 L 9 9 L 10 8 L 10 7","-5 5 M 0 -10 L -1 -11 L 0 -12 L 1 -11 L 1 -9 L 0 -7 L -1 -6","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L 0 -4 L 3 -4 L 5 -3 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 3 -12 L -7 2 L 8 2 M 3 -12 L 3 9","-10 10 M 5 -12 L -5 -12 L -6 -3 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2","-10 10 M 7 -12 L -3 9 M -7 -12 L 7 -12","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 1 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -1 -3 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-9 9 M 0 -12 L -8 9 M 0 -12 L 8 9 M -5 2 L 5 2","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 M -7 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -7 9","-10 10 M -7 -12 L 7 9 M -7 9 L 7 -12","-9 9 M 0 -12 L -8 9 M 0 -12 L 8 9 M -8 9 L 8 9","-10 9 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2 M -6 9 L 7 9","-10 10 M 0 -12 L 0 9 M -2 -7 L -5 -6 L -6 -5 L -7 -3 L -7 0 L -6 2 L -5 3 L -2 4 L 2 4 L 5 3 L 6 2 L 7 0 L 7 -3 L 6 -5 L 5 -6 L 2 -7 L -2 -7","-10 7 M -6 -12 L -6 9 M -6 -12 L 6 -12","-11 11 M -7 -12 L -7 9 M 7 -12 L 7 9 M -7 -2 L 7 -2","-4 4 M 0 -12 L 0 9","-2 3 M 0 -1 L 0 0 L 1 0 L 1 -1 L 0 -1","-11 10 M -7 -12 L -7 9 M 7 -12 L -7 2 M -2 -3 L 7 9","-9 9 M 0 -12 L -8 9 M 0 -12 L 8 9","-12 12 M -8 -12 L -8 9 M -8 -12 L 0 9 M 8 -12 L 0 9 M 8 -12 L 8 9","-11 11 M -7 -12 L -7 9 M -7 -12 L 7 9 M 7 -12 L 7 9","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12","-11 11 M -7 -12 L -7 9 M 7 -12 L 7 9 M -7 -12 L 7 -12","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12 M -3 -2 L 3 -2","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 2 -1 L -7 -1","-9 9 M -7 -12 L 0 -2 L -7 9 M -7 -12 L 7 -12 M -7 9 L 7 9","-8 8 M 0 -12 L 0 9 M -7 -12 L 7 -12","-9 9 M -7 -7 L -7 -9 L -6 -11 L -5 -12 L -3 -12 L -2 -11 L -1 -9 L 0 -5 L 0 9 M 7 -7 L 7 -9 L 6 -11 L 5 -12 L 3 -12 L 2 -11 L 1 -9 L 0 -5","-7 7 M -1 -12 L -3 -11 L -4 -9 L -4 -7 L -3 -5 L -1 -4 L 1 -4 L 3 -5 L 4 -7 L 4 -9 L 3 -11 L 1 -12 L -1 -12","-10 10 M -7 9 L -3 9 L -6 2 L -7 -2 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -6 L 7 -2 L 6 2 L 3 9 L 7 9","-9 9 M -7 -12 L 7 -12 M -3 -2 L 3 -2 M -7 9 L 7 9","-11 11 M 0 -12 L 0 9 M -9 -6 L -8 -6 L -7 -5 L -6 -1 L -5 1 L -4 2 L -1 3 L 1 3 L 4 2 L 5 1 L 6 -1 L 7 -5 L 8 -6 L 9 -6","-10 10 M 7 -12 L -7 9 M -7 -12 L 7 -12 M -7 9 L 7 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-8 8 M 0 -14 L -8 0 M 0 -14 L 8 0","-9 9 M -9 16 L 9 16","-4 4 M 1 -7 L -1 -5 L -1 -3 L 0 -2 L 1 -3 L 0 -4 L -1 -3","-10 11 M -1 -5 L -3 -4 L -5 -2 L -6 0 L -7 3 L -7 6 L -6 8 L -4 9 L -2 9 L 0 8 L 3 5 L 5 2 L 7 -2 L 8 -5 M -1 -5 L 1 -5 L 2 -4 L 3 -2 L 5 6 L 6 8 L 7 9 L 8 9","-9 10 M 3 -12 L 1 -11 L -1 -9 L -3 -5 L -4 -2 L -5 2 L -6 8 L -7 16 M 3 -12 L 5 -12 L 7 -10 L 7 -7 L 6 -5 L 5 -4 L 3 -3 L 0 -3 M 0 -3 L 2 -2 L 4 0 L 5 2 L 5 5 L 4 7 L 3 8 L 1 9 L -1 9 L -3 8 L -4 7 L -5 4","-9 9 M -7 -5 L -5 -5 L -3 -3 L 3 14 L 5 16 L 7 16 M 8 -5 L 7 -3 L 5 0 L -5 11 L -7 14 L -8 16","-9 9 M 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 2 8 L 4 6 L 5 3 L 5 0 L 4 -3 L 2 -5 L 0 -7 L -1 -9 L -1 -11 L 0 -12 L 2 -12 L 4 -11 L 6 -9","-8 8 M 5 -3 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -3 -2 L -2 0 L 1 1 M 1 1 L -3 2 L -5 4 L -5 6 L -4 8 L -2 9 L 1 9 L 3 8 L 5 6","-11 11 M -3 -4 L -5 -3 L -7 -1 L -8 2 L -8 5 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 5 6 L 7 3 L 8 0 L 8 -3 L 6 -5 L 4 -5 L 2 -3 L 0 1 L -2 6 L -5 16","-9 10 M -8 -2 L -6 -4 L -4 -5 L -3 -5 L -1 -4 L 0 -3 L 1 0 L 1 4 L 0 9 M 8 -5 L 7 -2 L 6 0 L 0 9 L -2 13 L -3 16","-10 10 M -9 -1 L -8 -3 L -6 -5 L -4 -5 L -3 -4 L -3 -2 L -4 2 L -6 9 M -4 2 L -2 -2 L 0 -4 L 2 -5 L 4 -5 L 6 -3 L 6 0 L 5 5 L 2 16","-6 5 M 0 -5 L -2 2 L -3 6 L -3 8 L -2 9 L 0 9 L 2 7 L 3 5","-11 11 M -7 -7 L 7 7 M 7 -7 L -7 7","-9 9 M -3 -5 L -7 9 M 7 -4 L 6 -5 L 5 -5 L 3 -4 L -1 0 L -3 1 L -4 1 M -4 1 L -2 2 L -1 3 L 1 8 L 2 9 L 3 9 L 4 8","-8 8 M -7 -12 L -5 -12 L -3 -11 L -2 -10 L 6 9 M 0 -5 L -6 9","-10 11 M -3 -5 L -9 16 M -4 -1 L -5 4 L -5 7 L -3 9 L -1 9 L 1 8 L 3 6 L 5 2 M 7 -5 L 5 2 L 4 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5","-9 9 M -6 -5 L -3 -5 L -4 1 L -5 6 L -6 9 M 7 -5 L 6 -2 L 5 0 L 3 3 L 0 6 L -3 8 L -6 9","-8 9 M 0 -5 L -2 -4 L -4 -2 L -5 1 L -5 4 L -4 7 L -3 8 L -1 9 L 1 9 L 3 8 L 5 6 L 6 3 L 6 0 L 5 -3 L 4 -4 L 2 -5 L 0 -5","-11 11 M -2 -5 L -6 9 M 3 -5 L 4 1 L 5 6 L 6 9 M -9 -2 L -7 -4 L -4 -5 L 9 -5","-11 10 M -10 -1 L -9 -3 L -7 -5 L -5 -5 L -4 -4 L -4 -2 L -5 3 L -5 6 L -4 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 3 L 5 0 L 6 -5 L 6 -8 L 5 -11 L 3 -12 L 1 -12 L 0 -10 L 0 -8 L 1 -5 L 3 -2 L 5 0 L 8 2","-9 9 M -5 1 L -5 4 L -4 7 L -3 8 L -1 9 L 1 9 L 3 8 L 5 6 L 6 3 L 6 0 L 5 -3 L 4 -4 L 2 -5 L 0 -5 L -2 -4 L -4 -2 L -5 1 L -9 16","-9 11 M 9 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 2 8 L 4 6 L 5 3 L 5 0 L 4 -3 L 3 -4 L 1 -5","-10 10 M 1 -5 L -2 9 M -8 -2 L -6 -4 L -3 -5 L 8 -5","-10 10 M -9 -1 L -8 -3 L -6 -5 L -4 -5 L -3 -4 L -3 -2 L -5 4 L -5 7 L -3 9 L -1 9 L 2 8 L 4 6 L 6 2 L 7 -2 L 7 -5","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 0 L 9 0 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-12 11 M -4 -5 L -6 -4 L -8 -1 L -9 2 L -9 5 L -8 8 L -7 9 L -5 9 L -3 8 L -1 5 M 0 1 L -1 5 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5 L 8 2 L 8 -1 L 7 -4 L 6 -5","-8 8 M 2 -12 L 0 -11 L -1 -10 L -1 -9 L 0 -8 L 3 -7 L 6 -7 M 3 -7 L 0 -6 L -2 -5 L -3 -3 L -3 -1 L -1 1 L 2 2 L 4 2 M 2 2 L -2 3 L -4 4 L -5 6 L -5 8 L -3 10 L 1 12 L 2 13 L 2 15 L 0 16 L -2 16","-12 11 M 4 -12 L -4 16 M -11 -1 L -10 -3 L -8 -5 L -6 -5 L -5 -4 L -5 -2 L -6 3 L -6 6 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 8 -2 L 9 -5","-8 7 M 2 -12 L 0 -11 L -1 -10 L -1 -9 L 0 -8 L 3 -7 L 6 -7 M 6 -7 L 2 -5 L -1 -3 L -4 0 L -5 3 L -5 5 L -4 7 L -2 9 L 1 11 L 2 13 L 2 15 L 1 16 L -1 16 L -2 14","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
japanese = ["-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 9 L -11 8 L -10 7 L -9 8 L -9 10 L -10 12 L -11 13","-14 13 M -10 -3 L -8 -1 L 8 -2 L 10 -1 M -9 -2 L 10 -1","-14 13 M -5 -10 L -7 -11 L -7 10 M -6 -10 L -6 10 M -6 8 L 6 8 M -6 -10 L 6 -10 M 5 -10 L 6 -11 L 8 -10 L 7 -8 M 6 -10 L 6 10 M 7 -10 L 7 10 M -6 -1 L 6 -1","-14 13 M -7 -11 L -9 -12 L -9 9 M -8 -11 L -8 9 M -8 -11 L 7 -11 M 6 -11 L 7 -12 L 9 -11 L 8 -9 M 7 -11 L 7 5 L 6 7 L 5 8 M 7 6 L 7 7 L 6 8 M 8 -11 L 8 7 L 7 9 L 6 9 L 5 8 L 3 7 M -1 -11 L -1 -2 M 0 -11 L 0 -2 M -8 -2 L 7 -2","-14 13 M -6 -12 L -8 -7 L -11 -1 M -6 -12 L -5 -11 L -6 -9 L -9 -4 L -11 -1 M -6 -9 L 10 -9 L 8 -11 L 6 -9 M 6 -9 L 9 -10 M 0 -9 L 0 10 M 1 -9 L 1 10 M -4 -3 L -6 -4 L -6 3 M -5 -3 L -5 3 M -5 -3 L 9 -3 L 7 -5 L 5 -3 M 5 -3 L 8 -4 M -11 3 L 11 3 L 9 1 L 7 3 M 7 3 L 10 2","-14 13 M -1 -12 L -1 -6 L -2 -1 L -4 3 L -6 6 L -8 8 L -11 10 M 0 -11 L 0 -7 M -1 -12 L 1 -11 L 0 -4 L -1 0 L -3 4 L -6 7 L -9 9 L -11 10 M -11 -5 L 11 -5 L 9 -7 L 7 -5 M 7 -5 L 10 -6 M 1 -5 L 2 -1 L 3 2 L 4 4 L 6 7 L 9 10 L 11 9 M 7 7 L 9 9 M 1 -5 L 2 -2 L 4 2 L 6 5 L 8 7 L 11 9","-14 13 M -8 -11 L -10 -12 L -10 10 M -9 -11 L -9 10 M -9 -11 L 9 -11 M 8 -11 L 9 -12 L 11 -11 L 10 -9 M 9 -11 L 9 10 M 10 -11 L 10 10 M -7 -7 L 7 -7 L 6 -8 L 5 -7 M -1 -7 L -1 5 M 0 -7 L 0 5 M -6 -1 L 6 -1 L 5 -2 L 4 -1 M -7 5 L 7 5 L 6 4 L 5 5 M 2 1 L 3 3 L 4 3 L 4 2 L 2 1 M -9 9 L 9 9","-14 13 M -1 -12 L -1 -6 L -2 -1 L -4 3 L -6 6 L -8 8 L -11 10 M 0 -11 L 0 -7 M -1 -12 L 1 -11 L 0 -4 L -1 0 L -3 4 L -6 7 L -9 9 L -11 10 M 1 -11 L 1 -7 L 2 -1 L 3 2 L 4 4 L 6 7 L 9 10 L 11 9 M 7 7 L 9 9 M 1 -7 L 2 -2 L 4 2 L 6 5 L 8 7 L 11 9","-14 13 M 0 -11 L 1 -12 L -1 -12 L -1 10 M 0 -11 L 0 10 M -11 -10 L 11 -10 L 9 -11 L 8 -10 M -6 -6 L -8 -7 L -8 3 M -7 -6 L -7 3 M -7 -6 L 6 -6 M 5 -6 L 6 -7 L 8 -6 L 7 -4 M 6 -6 L 6 3 M 7 -6 L 7 3 M -7 -2 L 6 -2 M -7 2 L 6 2 M -1 2 L -4 5 L -7 7 L -11 9 M -1 4 L -4 6 L -6 7 L -11 9 M 0 2 L 3 6 L 6 8 L 9 9 L 11 8 M 0 2 L 3 5 L 7 7 L 11 8","-14 13 M 0 -10 L 1 -11 L -1 -12 L -1 11 M 0 -11 L 0 11 M -8 -6 L -10 -7 L -10 4 M -9 -6 L -9 4 M -9 -6 L 8 -6 M 7 -6 L 8 -7 L 10 -6 L 9 -4 M 8 -6 L 8 4 M 9 -6 L 9 4 M -9 3 L 8 3","-14 13 M 0 -10 L 1 -11 L -1 -12 L -1 10 M 0 -11 L 0 10 M -11 -6 L 11 -6 L 9 -8 L 7 -6 M 7 -6 L 10 -7 M -2 -6 L -5 0 L -8 4 L -11 7 M -1 -5 L -3 -1 L -5 2 L -7 4 L -11 7 M 1 -5 L 2 -2 L 3 0 L 6 4 L 9 7 L 11 6 M 7 4 L 9 6 M 1 -5 L 2 -3 L 5 1 L 8 4 L 11 6 M -5 5 L 4 5 L 3 4 L 2 5","-14 13 M 0 -11 L 0 -12 L 1 -13 L -1 -13 L -1 -11 M -11 -11 L 11 -11 L 9 -13 L 7 -11 M 7 -11 L 10 -12 M -6 -7 L -8 -8 L -8 0 M -7 -7 L -7 0 M -7 -7 L 6 -7 M 5 -7 L 6 -8 L 8 -7 L 7 -5 M 6 -7 L 6 0 M 7 -7 L 7 0 M -7 -1 L 6 -1 M -1 -1 L -1 6 L -2 8 L -3 9 M -1 7 L -1 8 L -2 9 M 0 -1 L 0 8 L -1 10 L -2 10 L -3 9 L -5 8 M -6 2 L -11 7 M -6 2 L -5 3 L -11 7 M 4 2 L 6 4 L 8 7 L 9 7 L 9 6 L 8 5 L 4 2","-14 13 M -1 -12 L -1 9 M -1 -12 L 0 -12 L 0 9 M -8 -10 L -8 -2 M -8 -10 L -7 -10 L -7 -2 M -7 -3 L 6 -3 M 6 -10 L 6 -2 M 6 -10 L 7 -10 L 7 -2 M -10 1 L -10 10 M -10 1 L -9 1 L -9 10 M -9 9 L 8 9 M 8 1 L 8 10 M 8 1 L 9 1 L 9 10","-14 13 M -10 -12 L -10 5 M -10 -12 L -9 -11 L -9 5 M -9 -11 L -5 -11 M -5 -11 L -5 4 M -6 -11 L -5 -12 L -4 -11 L -4 4 M -9 -4 L -5 -4 M -9 3 L -5 3 M 3 -11 L 4 -12 L 2 -12 L 2 -4 M 3 -11 L 3 -4 M -2 -8 L 9 -8 L 7 -9 L 6 -8 M -4 -4 L 11 -4 L 9 -5 L 8 -4 M 5 -4 L 5 8 L 4 9 M 6 -4 L 6 8 L 5 10 L 4 9 L 2 8 M -4 0 L 11 0 L 9 -1 L 8 0 M -1 2 L 0 3 L 1 5 L 2 5 L 2 4 L 1 3 L -1 2","-14 13 M 0 -10 L 1 -11 L -1 -12 L -1 9 M 0 -11 L 0 9 M 0 -2 L 9 -2 L 7 -4 L 5 -2 M 5 -2 L 8 -3 M -11 9 L 11 9 L 9 7 L 7 9 M 7 9 L 10 8","-14 13 M -1 -11 L 0 -12 L -2 -12 L -2 -5 M -1 -11 L -1 -5 M -9 -9 L 3 -9 L 2 -10 L 1 -9 M -11 -5 L 11 -5 L 9 -6 L 8 -5 M 6 -11 L 3 -7 L 0 -4 L -4 -1 L -9 2 M 6 -11 L 7 -10 L 2 -5 L -2 -2 L -5 0 L -9 2 L -11 3 M -3 -1 L -5 -2 L -5 10 M -4 -1 L -4 10 M -4 -1 L 6 -1 M 5 -1 L 6 -2 L 8 -1 L 7 1 M 6 -1 L 6 10 M 7 -1 L 7 10 M -4 4 L 6 4 M -4 9 L 6 9","-14 13 M 0 -10 L 1 -11 L -1 -12 L -1 10 M 0 -11 L 0 10 M -11 -3 L 11 -3 L 9 -5 L 7 -3 M 7 -3 L 10 -4","-14 13 M -11 -1 L 11 -1 L 8 -3 L 6 -1 M 6 -1 L 9 -2","-14 13 M -8 -8 L 8 -8 L 6 -10 L 4 -8 M 4 -8 L 7 -9 M -11 6 L 11 6 L 9 4 L 7 6 M 7 6 L 10 5","-14 13 M -9 -9 L 9 -9 L 7 -11 L 5 -9 M 5 -9 L 8 -10 M -7 -1 L 7 -1 L 5 -3 L 3 -1 M 3 -1 L 6 -2 M -11 8 L 11 8 L 9 6 L 7 8 M 7 8 L 10 7","-14 13 M -8 -9 L -10 -10 L -10 8 M -9 -9 L -9 8 M -9 -9 L 9 -9 M 8 -9 L 9 -10 L 11 -9 L 10 -7 M 9 -9 L 9 8 M 10 -9 L 10 8 M -3 -9 L -3 -4 L -4 0 L -5 2 M -2 -9 L -2 -4 L -3 -1 L -5 2 L -7 4 M 1 -9 L 1 1 L 2 2 L 6 2 L 7 1 L 6 0 M 2 -9 L 2 0 L 3 1 L 5 1 L 6 0 L 6 -2 M -9 7 L 9 7","-14 13 M -9 -10 L 8 -10 L 6 -12 L 4 -10 M 4 -10 L 7 -11 M -1 -10 L -4 8 M 0 -10 L -3 8 M -9 -2 L 4 -2 M 3 -2 L 4 -3 L 6 -2 L 5 0 M 4 -2 L 3 8 M 5 -2 L 5 0 L 4 8 M -11 8 L 11 8 L 9 6 L 7 8 M 7 8 L 10 7","-14 13 M 0 -9 L 1 -10 L -1 -11 L -1 -5 M 0 -10 L 0 -5 M -11 -5 L 11 -5 L 9 -7 L 7 -5 M 7 -5 L 10 -6 M -5 -1 L -6 2 L -8 6 L -10 9 M -4 0 L -5 2 M -5 -1 L -3 0 L -5 3 L -8 7 L -10 9 M 2 -1 L 4 1 L 7 5 L 8 7 L 9 8 L 10 7 L 9 5 L 6 2 L 2 -1 M 7 4 L 9 7","-14 13 M -5 -9 L -4 -10 L -6 -11 L -6 8 L -5 9 L 7 9 L 8 8 L 7 6 M 6 8 L 7 8 L 7 7 M -5 -10 L -5 7 L -4 8 L 5 8 L 7 6 L 8 3 M -10 -1 L -4 -2 L 1 -3 L 9 -5 L 6 -6 L 5 -4 M 5 -4 L 7 -5","-14 13 M 0 -6 L -1 -3 L -3 2 L -5 5 L -8 8 L -11 10 M 0 -6 L 1 -5 L 0 -2 L -2 2 L -4 5 L -6 7 L -9 9 L -11 10 M -6 -11 L 3 -11 M 0 -11 L 1 -12 L 3 -11 L 1 -9 M 1 -11 L 1 -6 L 2 -1 L 3 2 L 4 4 L 6 7 L 9 10 L 11 9 M 7 7 L 9 9 M 1 -6 L 2 -2 L 4 2 L 6 5 L 8 7 L 11 9","-14 13 M -4 -9 L -3 -10 L -5 -11 L -5 0 L -6 4 L -8 7 L -11 10 M -4 -10 L -4 0 L -5 4 L -7 7 L -11 10 M -11 -4 L 2 -5 M 1 -5 L 2 -6 L 4 -5 L 3 -3 M 2 -5 L 2 8 L 3 9 L 10 9 L 11 8 L 10 6 M 9 8 L 10 8 L 10 7 M 3 -5 L 3 7 L 4 8 L 8 8 L 10 6 L 11 3","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -3 -12 L -1 -11 L -1 -9 L -2 -6 M -2 -11 L -2 0 L -1 4 M -7 -7 L -5 -6 L 0 -6 L 3 -7 L 6 -8 M 3 -7 L 4 -8 L 6 -8 M 1 1 L 2 -3 L 3 -2 L 1 1 L -2 5 L -4 7 L -6 8 L -8 8 L -9 7 L -9 4 L -8 2 L -6 0 L -4 -1 L -1 -2 L 4 -2 L 7 -1 L 9 1 L 10 3 L 10 5 L 9 7 L 7 9 L 4 10 L 2 10 M -7 8 L -8 7 L -8 4 L -7 2 L -5 0 L -1 -2 M 4 -2 L 6 -1 L 8 1 L 9 3 L 9 5 L 8 7 L 6 9 L 4 10","-14 13 M -10 -10 L -8 -9 L -8 -7 L -9 -5 L -10 -2 M -9 -9 L -9 -7 L -10 -2 L -10 1 L -9 4 L -8 5 L -6 6 L -5 6 L -5 4 L -4 1 L -3 -1 M -8 5 L -6 5 L -5 4 M 5 -6 L 7 -5 L 9 -2 L 10 1 L 10 3 L 8 2 L 5 3 M 9 -2 L 9 1 L 8 2","-14 13 M -4 -13 L -3 -12 L -1 -11 L 3 -11 M -3 -12 L 2 -12 L 3 -11 L -1 -9 M -7 -5 L -7 -4 L -6 -3 L -5 -3 L -2 -5 L 0 -6 M -7 -4 L -6 -4 L -3 -5 L 0 -6 L 2 -6 L 5 -5 L 6 -3 L 6 0 L 5 3 L 3 6 L 0 8 L -4 10 M 2 -6 L 4 -5 L 5 -3 L 5 0 L 4 3 L 3 5 L 1 7 L -2 9","-14 13 M -4 -13 L -3 -12 L -1 -11 L 3 -11 M -3 -12 L 2 -12 L 3 -11 L -1 -9 M -8 -5 L -8 -4 L -7 -3 L -5 -3 L 0 -5 L 3 -6 L 4 -5 M -8 -4 L -5 -4 L 0 -5 M 4 -5 L 0 -2 L -6 4 L -10 8 M 3 -6 L 0 -2 M -10 8 L -10 7 L -6 4 L -4 3 L 0 3 L 1 4 L 2 8 L 3 9 L 10 9 M 5 9 L 8 8 L 9 8 L 10 9","-14 13 M -5 -12 L -3 -11 L -3 -9 L -4 -5 M -4 -11 L -4 9 M -4 2 L -3 8 L -4 9 L -5 7 L -7 6 L -10 5 M -10 -5 L -8 -4 L -4 -4 L -1 -5 L 1 -6 M -4 -4 L -2 -5 L -1 -6 L 1 -6 M -10 6 L -6 3 L -1 0 L 2 -1 L 4 -1 L 7 0 L 8 2 L 8 4 L 7 6 L 5 7 L 3 7 L 1 6 L 0 4 M -10 6 L -10 5 L -6 3 M 4 -1 L 6 0 L 7 2 L 7 4 L 6 6 L 5 7 M 5 -7 L 7 -7 L 9 -6 L 10 -5 L 8 -5 L 7 -4 M 7 -7 L 8 -6 L 8 -5","-14 13 M -4 -12 L -2 -11 L -2 -9 L -3 -6 L -5 -1 L -10 9 M -3 -11 L -3 -9 L -5 -3 L -7 2 L -10 9 M -10 -5 L -10 -4 L -9 -3 L -8 -3 L -5 -5 L -3 -6 L 0 -6 L 2 -5 L 3 -3 L 3 0 L 2 4 L 0 8 L -1 9 L -2 9 L -2 8 L -3 7 L -5 6 M -10 -4 L -8 -4 L -5 -5 M 0 -6 L 2 -4 L 2 0 L 1 4 L 0 6 L -2 8 M 5 -5 L 7 -4 L 9 -2 L 10 0 L 10 2 L 9 1 L 7 2 M 8 -3 L 9 -1 L 9 1","-14 13 M -4 -12 L -1 -11 L 0 -7 L 1 -4 L 3 0 L 6 4 L 5 5 M -2 -11 L 0 -7 M 3 0 L 5 5 M -6 -7 L -4 -6 L -1 -6 L 2 -7 M -9 -3 L -8 -2 L -5 -1 L 0 -1 L 5 -2 L 8 -3 M 5 -2 L 7 -4 L 8 -3 M 5 5 L 3 4 L 0 3 L -4 3 L -6 4 L -7 5 L -7 7 L -6 8 L -4 9 L -1 10 L 5 10 M -4 9 L 4 9 L 5 10","-14 13 M 2 -12 L 4 -11 L 4 -10 L -4 -2 M 3 -11 L 2 -9 L -4 -2 L -4 -1 L 1 4 L 3 7 L 4 9 M -4 -1 L 4 6 L 5 8 L 4 9","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 L -4 -3 L -3 -4 L -1 -5 L 8 -5 L 10 -6 M -9 3 L -8 5 L -7 6 M 4 -5 L 8 -6 L 9 -7 L 10 -6 M 4 -12 L 6 -11 L 6 3 L 5 6 L 3 8 L 0 10 M 5 -11 L 6 -8 M 6 0 L 5 4 L 3 7 L 0 10","-14 13 M -5 -10 L -3 -9 L 0 -8 L 2 -8 L 5 -9 M -3 -9 L 2 -9 L 4 -10 L 5 -9 L -1 -6 M -7 1 L -7 3 L -6 5 L -4 6 L 0 7 L 7 7 M -4 6 L 6 6 L 7 7","-14 13 M -8 -7 L -7 -6 L -4 -5 L 0 -5 L 4 -6 L 6 -7 L 7 -8 M 4 -6 L 6 -8 L 7 -8 M -2 -12 L -1 -9 L 0 -7 L 3 -3 L 5 0 L 6 2 M -2 -12 L -1 -12 L -1 -10 L 0 -7 M 3 -3 L 6 0 L 7 2 L 7 3 M 7 3 L 6 2 L 4 1 L 0 0 L -4 0 L -7 1 L -8 3 L -8 5 L -7 7 L -5 8 L -1 9 L 3 9 M -8 5 L -7 6 L -5 7 L -1 8 L 4 8 L 3 9","-14 13 M -6 -12 L -4 -11 L -5 1 L -5 6 L -4 8 M -5 -11 L -6 1 L -6 5 L -5 7 L -4 8 L -2 9 L 1 9 L 4 8 L 7 6 L 9 4","-14 13 M 0 -12 L 2 -11 L 2 1 L 1 3 L -1 4 L -3 3 L -4 1 L -4 0 L -3 -2 L -1 -3 L 1 -2 L 2 0 L 2 4 L 1 8 L -1 10 M 1 -11 L 2 -6 M 2 4 L 1 7 L -1 10 M -10 -8 L -8 -6 L -5 -6 L 4 -7 L 8 -8 L 10 -7 M -9 -7 L -5 -6 M 4 -7 L 10 -7","-14 13 M -6 -8 L -4 -7 L -4 4 L -3 6 L -2 7 L 0 8 L 8 8 M -5 -7 L -4 -4 M 3 8 L 6 7 L 7 7 L 8 8 M 3 -11 L 5 -10 L 5 2 L 4 4 L 3 3 L 0 1 M 4 -10 L 5 -7 M 5 -1 L 4 2 L 3 3 M -10 -4 L -8 -2 L -6 -2 L -2 -3 L 3 -4 L 7 -5 L 9 -5 L 10 -4 M -9 -3 L -2 -3 M 3 -4 L 10 -4","-14 13 M -4 -11 L -2 -9 L 4 -11 M -3 -10 L -1 -10 L 4 -11 L 5 -10 M 5 -10 L 2 -7 L -4 -3 L -8 -1 M 4 -11 L 3 -9 L 1 -7 L -4 -3 M -9 -2 L -7 0 L -3 -2 M -8 -1 L -3 -2 L 3 -3 L 8 -4 L 9 -3 M 3 -3 L 9 -3 M 3 -3 L 1 -2 L -1 0 L -2 2 L -2 4 L -1 6 L 0 7 L 3 8 L 7 8 M -1 6 L 2 7 L 6 7 L 7 8","-14 13 M -4 -12 L -2 -11 L -2 -9 L -4 -3 L -5 0 L -7 5 L -9 9 M -3 -11 L -3 -8 L -4 -3 M -5 0 L -7 4 L -9 7 L -9 9 M -10 -5 L -8 -4 L -5 -4 L -2 -5 L 0 -6 L 2 -7 M 0 -6 L 1 -8 L 2 -7 M 3 -4 L 6 -4 L 9 -3 L 7 -3 L 5 -2 M 6 -4 L 7 -3 M 0 4 L 1 6 L 2 7 L 4 8 L 9 8 M 1 6 L 3 7 L 10 7 L 9 8","-14 13 M -5 -12 L -3 -11 L -3 -9 L -5 -4 L -6 0 L -6 2 L -5 3 M -4 -11 L -4 -7 M -5 -4 L -5 3 M -10 -8 L -7 -7 L -3 -7 L 1 -8 L 3 -9 M 1 -8 L 2 -10 L 3 -9 M -5 3 L -3 1 L 0 -1 L 3 -2 L 6 -2 L 8 -1 L 9 1 L 9 4 L 8 6 L 5 8 L 1 9 L -3 9 M 6 -2 L 7 -1 L 8 1 L 8 4 L 7 6 L 5 8","-14 13 M -10 -6 L -8 -4 L -3 -6 L 1 -7 L 5 -7 L 8 -6 L 9 -5 L 10 -3 L 10 0 L 9 2 L 8 3 L 6 4 L 3 5 L -2 6 M -9 -5 L -3 -6 M 5 -7 L 7 -6 L 8 -5 L 9 -3 L 9 0 L 8 2 L 6 4","-14 13 M -10 -9 L -8 -7 L -6 -7 L -2 -8 L 3 -9 L 7 -10 L 9 -10 L 10 -9 M -9 -8 L -2 -8 M 3 -9 L 10 -9 M 7 -9 L 4 -8 L 1 -6 L -1 -3 L -2 0 L -2 3 L -1 6 L 0 7 L 2 8 L 6 9 L 9 9 M -2 3 L -1 5 L 0 6 L 2 7 L 6 8 L 8 8 L 9 9","-14 13 M -3 -12 L -1 -11 L -1 -1 M -2 -11 L -2 -5 L -1 -1 M 5 -4 L 7 -2 L -1 -1 M 6 -3 L 2 -2 L -1 -1 L -4 0 L -6 1 L -7 3 L -7 5 L -6 7 L -5 8 L -3 9 L 8 9 M -6 7 L -4 8 L 7 8 L 8 9","-14 13 M -5 -12 L -3 -11 L -3 -9 L -5 -3 L -6 0 L -8 5 L -10 9 M -4 -11 L -4 -8 L -5 -3 M -6 0 L -8 4 L -10 7 L -10 9 M -10 -5 L -8 -4 L -6 -4 L -3 -5 L -1 -6 L 1 -7 M -1 -6 L 0 -8 L 1 -7 M 4 -8 L 6 -8 L 8 -7 L 10 -5 L 8 -6 L 6 -5 M 6 -8 L 8 -6 M 4 -3 L 4 -1 L 5 2 L 6 4 L 6 6 L 5 8 L 3 9 L 0 9 L -2 8 L -3 6 L -2 4 L 0 3 L 3 3 L 5 4 L 9 8 M 4 -1 L 5 4 L 5 7 L 3 9 M 7 6 L 8 8 L 9 8","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M 1 -8 L 4 -9 L 7 -9 L 9 -8 L 7 -8 L 5 -7 M 5 -9 L 7 -8 M -1 1 L -1 3 L 0 5 L 3 6 L 10 6 M -1 3 L 0 4 L 3 5 L 8 5 L 10 6","-14 13 M -8 -9 L -6 -8 L -6 -3 M -7 -8 L -6 -3 L -5 0 L -4 2 L -3 4 L -2 5 M -4 2 L -2 4 L -2 5 M 0 -11 L 2 -10 L 2 -8 L 0 -3 L -3 4 L -5 7 L -7 8 L -9 8 L -10 6 L -10 4 L -9 1 L -8 -1 L -6 -3 L -3 -5 L 1 -6 L 4 -6 L 7 -5 L 9 -3 L 10 0 L 10 3 L 9 6 L 8 7 L 6 8 L 4 8 L 2 7 L 1 6 L 1 5 L 2 4 L 4 3 L 6 3 L 8 4 L 10 7 M 1 -10 L 1 -8 L 0 -3 M -8 8 L -9 6 L -9 3 L -8 0 L -6 -3 M 4 -6 L 6 -5 L 8 -3 L 9 0 L 9 4 L 8 7 M 8 4 L 10 6 L 10 7","-14 13 M -5 -12 L -3 -11 L -3 -9 L -5 9 M -4 -11 L -4 9 L -5 9 L -6 6 L -7 5 L -9 4 M -10 -6 L -9 -4 L -7 -4 L -3 -6 L -3 -5 M -9 -5 L -6 -5 L -4 -6 L -5 -2 M -3 -5 L -5 -2 L -7 1 L -10 5 L -10 4 L -7 1 L -3 -3 L 1 -6 L 4 -7 L 6 -7 L 8 -6 L 9 -4 L 9 3 L 8 6 L 7 7 L 5 8 L 3 8 L 1 7 L 0 6 L 0 5 L 1 4 L 3 3 L 5 3 L 7 4 L 8 5 L 10 8 M 6 -7 L 7 -6 L 8 -4 L 8 4 L 7 7 M 8 5 L 10 7 L 10 8","-14 13 M -1 -10 L 0 -8 L 0 -5 L -1 -2 L -2 0 L -4 3 L -6 5 L -8 5 L -9 4 L -10 2 L -10 -1 L -9 -4 L -7 -7 L -4 -9 L -1 -10 L 2 -10 L 5 -9 L 7 -8 L 9 -6 L 10 -3 L 10 0 L 9 3 L 7 5 L 5 6 L 2 7 L -1 7 M -4 3 L -6 4 L -8 4 L -9 2 L -9 -1 L -8 -5 L -7 -7 M 5 -9 L 8 -6 L 9 -3 L 9 0 L 8 3 L 5 6","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M 3 -11 L 5 -10 L 5 5 L 4 7 L 2 8 L 0 8 L -2 7 L -3 5 L -2 3 L 0 2 L 2 2 L 4 3 L 9 7 M 4 -10 L 5 -6 M 4 3 L 9 6 L 9 7 M -2 -5 L 0 -4 L 3 -4 L 7 -5 L 9 -6 M 7 -5 L 8 -7 L 9 -6","-14 13 M -9 -11 L -8 -10 L -6 -9 L -2 -9 M -8 -10 L -3 -10 L -2 -9 M -2 -9 L -5 -7 L -7 -5 L -9 -2 L -10 1 L -10 4 L -9 6 L -8 7 L -6 8 L -3 8 L 0 7 L 2 5 L 3 3 L 4 -1 L 4 -5 L 3 -9 L 4 -9 M -10 3 L -9 5 L -8 6 L -6 7 L -3 7 L 0 6 L 2 4 L 3 2 L 4 -1 M 4 -9 L 6 -6 L 7 -4 L 9 -1 L 10 1 L 8 1 L 7 2 M 3 -9 L 6 -6 M 7 -4 L 8 -1 L 8 1","-14 13 M -2 -12 L -1 -9 L 1 -8 M -1 -10 L 1 -9 L 2 -9 L 2 -8 M 2 -8 L -1 -7 L -3 -6 L -4 -5 L -4 -3 L -3 -2 L -1 -1 L 1 0 L 2 1 L 3 3 L 3 5 L 2 7 L 0 8 L -2 8 L -5 7 L -7 5 M -1 -1 L 1 1 L 2 3 L 2 5 L 1 7 L 0 8 M -9 7 L -6 4 L -3 2 L 0 1 M 4 1 L 7 2 L 9 4 L 10 6 L 7 6 M -9 7 L -9 6 L -6 4 M 4 1 L 6 2 L 8 4 L 9 6","-14 13 M -10 -2 L -8 0 L -5 -5 M -9 -1 L -4 -6 L -2 -6 L 3 -1 L 7 2 L 9 3 L 10 4 L 8 4 L 6 5 M 3 -1 L 8 4","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M -1 -11 L 1 -10 L 3 -10 L 7 -11 M 3 -10 L 5 -11 L 6 -12 L 7 -11 M -2 -3 L 1 -2 L 4 -2 L 7 -3 L 9 -4 M 7 -3 L 8 -5 L 9 -4 M 3 -10 L 5 -9 L 5 5 L 4 7 L 2 8 L 0 8 L -2 7 L -3 5 L -2 3 L 0 2 L 2 2 L 4 3 L 9 7 M 4 -9 L 5 -5 M 4 3 L 9 6 L 9 7","-14 13 M 0 -12 L 2 -11 L 2 6 L 1 8 L -1 9 L -3 9 L -5 8 L -6 6 L -5 4 L -3 3 L -1 3 L 2 4 L 5 6 L 8 9 M 1 -11 L 2 -7 M 5 6 L 8 8 L 8 9 M -10 -9 L -8 -7 L 1 -7 L 8 -8 M -9 -8 L -4 -7 M 1 -7 L 5 -8 L 7 -9 L 8 -8 M -5 -2 L -3 -1 L 1 -1 L 5 -2 L 7 -3 M 5 -2 L 6 -4 L 7 -3","-14 13 M -8 -11 L -7 -9 L -5 -9 L -2 -10 L 1 -12 L 2 -11 M -7 -10 L -2 -10 M 2 -11 L -2 -5 L -5 1 L -7 4 L -8 5 L -9 5 L -10 4 L -10 2 L -9 0 L -7 -1 L -2 -1 L 2 0 L 5 1 L 10 3 M 1 -12 L -2 -5 M 2 0 L 10 2 L 10 3 M 4 -5 L 6 -4 L 6 2 L 5 5 L 3 7 L 1 8 L -2 9 M 5 -4 L 5 3 L 4 6","-14 13 M -5 -12 L -3 -11 L -3 -9 L -4 -5 L -5 -1 L -6 2 L -7 4 L -8 5 L -9 5 L -10 4 L -10 2 L -9 0 L -8 -1 L -7 -1 L -6 0 L -6 5 L -5 8 L -3 9 L 3 9 L 6 8 L 7 7 L 6 6 L 5 4 L 4 0 L 4 -4 L 5 -5 L 7 -5 L 9 -4 L 10 -2 L 10 -1 L 9 -1 L 7 0 M -4 -11 L -4 -5 M -6 5 L -5 7 L -3 8 L 3 8 L 5 7 L 6 6 M 7 -5 L 9 -3 L 9 -1 M -10 -7 L -7 -6 L -4 -6 L -1 -7 L 1 -8 M -1 -7 L 0 -9 L 1 -8","-14 13 M -8 -9 L -6 -8 L -6 -3 M -7 -8 L -6 -3 L -5 0 L -4 2 L -3 4 L -2 5 M -4 2 L -2 4 L -2 5 M 1 -11 L 3 -10 L 3 -8 L 2 -5 L 0 0 L -1 2 L -3 5 L -5 7 L -7 8 L -9 8 L -10 7 L -10 5 L -9 2 L -8 0 L -6 -2 L -3 -4 L 0 -5 L 4 -5 L 7 -4 L 9 -2 L 10 1 L 10 4 L 9 6 L 8 7 L 6 8 L 3 9 L 0 9 M 2 -10 L 2 -8 L 0 0 M -8 8 L -9 7 L -9 4 L -8 1 L -6 -2 M 4 -5 L 6 -4 L 8 -2 L 9 1 L 9 4 L 8 6 L 6 8","-14 13 M -3 -12 L -1 -11 L -1 -9 L -2 -5 M -2 -11 L -2 2 L -1 6 L 0 8 L 2 9 L 6 9 L 8 8 L 9 6 L 9 4 L 8 2 L 6 0 L 3 -2 M 5 9 L 7 8 L 8 6 L 8 3 L 7 1 M -6 -8 L -5 -7 L -2 -6 L 1 -6 M -5 -7 L 0 -7 L 1 -6 M 1 -6 L -2 -5 L -4 -4 L -6 -2 L -7 0 L -6 2 L -4 3 L 1 3","-14 13 M -2 -12 L 0 -11 L 1 -10 L 2 -8 L 1 -7 L -2 -8 L -5 -8 L -6 -7 L -6 -5 L -3 2 L -1 9 M 0 -11 L 1 -9 L 1 -7 M -3 2 L 0 8 L -1 9 M -10 -4 L -9 -2 L -7 -2 L -4 -4 L 0 -6 L 4 -7 L 7 -7 L 9 -6 L 10 -4 L 10 -2 L 9 0 L 8 1 L 5 2 L 2 2 L -1 1 M -9 -3 L -7 -3 L -4 -4 M 7 -7 L 8 -6 L 9 -4 L 9 -2 L 8 0 L 7 1 L 5 2","-14 13 M -10 -10 L -8 -9 L -8 -7 L -9 -5 L -10 -2 M -9 -9 L -9 -7 L -10 -2 L -10 1 L -9 4 L -8 5 L -6 6 L -5 6 L -5 4 L -4 1 L -3 -1 M -8 5 L -6 5 L -5 4 M 5 -6 L 7 -5 L 9 -2 L 10 1 L 10 3 L 8 2 L 5 3 M 9 -2 L 9 1 L 8 2","-14 13 M -10 -8 L -8 -7 L -8 -5 L -9 -2 M -9 -7 L -9 2 L -8 5 L -7 6 L -7 4 L -6 1 L -5 -1 L -3 -4 L 0 -7 L 3 -8 L 6 -8 L 8 -7 L 9 -6 L 10 -4 L 10 -1 L 9 1 L 7 3 L 5 4 L 2 4 L 0 3 L -2 1 L -3 -2 L -3 -5 L -2 -9 L -1 -11 L 1 -12 L 3 -12 L 4 -10 L 4 1 L 3 5 L 2 7 L -1 9 M -9 2 L -8 4 L -7 4 M 8 -7 L 9 -4 L 9 -1 L 8 2 M 4 1 L 3 4 L 2 6 L -1 9","-14 13 M -4 -13 L -3 -12 L -1 -11 L 3 -11 M -3 -12 L 2 -12 L 3 -11 L -1 -9 M -8 -5 L -8 -4 L -7 -3 L -5 -3 L 0 -5 L 3 -6 L 4 -5 M -8 -4 L -5 -4 L 0 -5 M 4 -5 L 0 -2 L -6 4 L -10 8 M 3 -6 L 0 -2 M -10 8 L -10 7 L -6 4 L -4 3 L 0 3 L 1 4 L 2 8 L 3 9 L 10 9 M 5 9 L 8 8 L 9 8 L 10 9","-14 13 M -2 -12 L 1 -11 L 1 -9 L 0 -4 M 0 -11 L 0 6 L -1 8 L -3 9 L -6 9 L -8 8 L -9 7 L -9 5 L -8 4 L -6 3 L -3 3 L 0 4 L 4 6 L 9 9 M 0 4 L 5 6 L 9 8 L 9 9 M 0 -4 L 3 -4 L 7 -5 M 3 -4 L 5 -5 L 6 -6 L 7 -5","-14 13 M -3 -12 L -1 -12 L 1 -11 L 2 -10 L 0 -10 L -2 -9 M -1 -12 L 0 -11 L 0 -10 M -6 -6 L -7 -4 L -8 0 L -8 2 L -7 3 L -3 0 L -1 -1 L 2 -2 L 5 -2 L 7 -1 L 8 1 L 8 3 L 7 5 L 5 7 L 3 8 L -1 9 L -3 9 M -8 0 L -7 2 L -6 2 M 5 -2 L 6 -1 L 7 1 L 7 3 L 6 5 L 4 7 L 2 8 L -1 9","-14 13 M -6 -12 L -4 -11 L -4 -9 L -6 -5 M -5 -11 L -5 -9 L -6 -5 L -6 -2 L -5 1 L -4 2 L -4 0 L -3 -3 L -1 -6 L 1 -8 L 3 -9 L 5 -9 L 6 -8 L 7 -5 L 7 0 L 6 4 L 4 7 L 1 9 L -3 10 M -6 -2 L -5 0 L -4 0 M 4 -9 L 5 -8 L 6 -5 L 6 0 L 5 4 L 3 7 L 1 9","-14 13 M -5 -11 L -4 -9 L -2 -9 L 3 -11 M -4 -10 L -2 -10 L 3 -11 L 4 -10 M 4 -10 L 0 -7 L -4 -2 L -7 3 M 3 -11 L 0 -7 M -4 -2 L -7 1 L -7 3 M -7 3 L -5 1 L -2 -1 L 1 -2 L 4 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 4 9 L 1 9 L -1 8 L -2 7 L -2 6 L -1 5 L 1 5 L 3 6 L 5 8 M 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 4 9","-14 13 M -5 -12 L -3 -11 L -3 -9 L -5 9 M -4 -11 L -4 9 L -5 9 L -6 6 L -7 5 L -9 4 M -10 -6 L -9 -4 L -7 -4 L -3 -6 L -3 -5 M -9 -5 L -6 -5 L -3 -6 L -5 -2 M -3 -5 L -5 -2 L -7 1 L -10 5 L -10 4 L -7 1 L -3 -3 L 1 -6 L 4 -7 L 5 -7 L 7 -6 L 8 -4 L 7 6 L 7 8 L 8 9 M 5 -7 L 6 -6 L 7 -4 L 6 6 L 6 8 L 7 9 L 8 9 L 9 8 L 10 6","-14 13 M -5 -11 L -4 -9 L -2 -9 L 3 -11 M -4 -10 L -2 -10 L 3 -11 L 4 -10 M 4 -10 L 0 -7 L -4 -2 L -7 3 M 3 -11 L 0 -7 M -4 -2 L -7 1 L -7 3 M -7 3 L -5 1 L -2 -1 L 1 -2 L 4 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 5 9 L 2 10 L 0 10 M 4 -2 L 6 0 L 7 2 L 7 5 L 6 8","-14 13 M -5 -12 L -3 -11 L -3 -9 L -5 9 M -4 -11 L -4 9 L -5 9 L -6 6 L -7 5 L -9 4 M -10 -6 L -9 -4 L -7 -4 L -3 -6 L -3 -5 M -9 -5 L -6 -5 L -3 -6 L -5 -2 M -3 -5 L -5 -2 L -7 1 L -10 5 L -10 4 L -7 1 L -4 -2 L -1 -4 L 2 -5 L 5 -5 L 7 -4 L 8 -3 L 9 -1 L 9 2 L 8 5 L 6 7 L 4 8 L 1 9 M 5 -5 L 7 -3 L 8 -1 L 8 2 L 7 5 L 4 8","-14 13 M -5 -11 L -4 -9 L -2 -9 L 2 -11 M -4 -10 L -2 -10 L 2 -11 L 3 -10 M 3 -10 L -1 -4 L -5 4 L -6 6 L -7 7 L -9 7 L -10 5 L -10 3 L -9 1 L -7 -1 L -4 -3 L 0 -4 L 4 -4 L 7 -3 L 9 -1 L 10 1 L 10 4 L 9 6 L 7 8 L 5 9 L 2 9 L 0 8 L -1 7 L -1 6 L 0 5 L 2 5 L 4 6 L 6 8 M 2 -11 L -1 -4 M -8 7 L -9 5 L -9 3 L -8 0 M 8 -2 L 9 1 L 9 4 L 8 7","-14 13 M -4 -13 L -3 -12 L -1 -11 L 3 -11 M -3 -12 L 2 -12 L 3 -11 L -1 -9 M -7 -5 L -7 -4 L -6 -3 L -5 -3 L -2 -5 L 0 -6 M -7 -4 L -6 -4 L -3 -5 L 0 -6 L 2 -6 L 5 -5 L 6 -3 L 6 0 L 5 3 L 3 6 L 0 8 L -4 10 M 2 -6 L 4 -5 L 5 -3 L 5 0 L 4 3 L 3 5 L 1 7 L -2 9","-14 13 M -6 -11 L -5 -9 L -3 -9 L -1 -10 L 2 -12 M -5 -10 L -3 -10 L 0 -11 L 2 -12 L 3 -11 M 3 -11 L -1 -8 L -5 -4 L -8 0 M 2 -12 L -1 -8 M -8 0 L -8 -2 L -5 -4 L -3 -5 L 0 -6 L 3 -6 L 5 -5 L 6 -3 L 6 -1 L 5 1 L 3 2 L -2 2 L -3 1 L -3 -1 L -2 -2 L 0 -2 L 1 -1 L 1 1 L 0 2 L -4 3 L -7 5 L -10 8 L -10 9 L -9 9 L -7 5 M -8 7 L -6 6 L -4 6 L -2 8 L -1 8 L 1 6 L 4 5 L 7 5 L 9 6 L 10 7 L 10 9 L 9 8 L 7 8 M -4 6 L -2 7 L -1 7 L 1 6 M 7 5 L 9 7 L 9 8","-14 13 M -2 -12 L 0 -11 L 0 -10 L -2 -6 L -4 -3 L -7 0 L -10 3 M -1 -11 L -1 -10 L -2 -6 M -7 0 L -10 2 L -10 3 M -5 -2 L -3 -3 L -1 -3 L 1 -2 L 2 0 L 2 4 M -1 -3 L 0 -2 L 1 0 L 1 5 L 2 4 M -9 -8 L -6 -7 L -3 -7 L 1 -8 L 5 -9 M 1 -8 L 4 -10 L 5 -9 M 9 -3 L 10 -1 L 2 0 L -1 1 L -3 2 L -4 4 L -4 6 L -3 8 L -1 9 L 7 9 M 9 -2 L 2 0 M 2 9 L 6 8 L 7 9","-14 13 M -1 -12 L 1 -10 L -2 -5 L -6 2 L -10 9 M 0 -11 L -2 -5 M -10 9 L -10 7 L -6 2 L -4 0 L -2 -1 L 0 -1 L 2 0 L 2 5 L 3 7 L 4 8 M 0 -1 L 1 0 L 1 5 L 2 7 L 4 8 L 6 8 L 8 7 L 9 5 L 10 2","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -4 -12 L -2 -11 L -2 -9 L -3 -6 L -5 -1 L -10 9 M -3 -11 L -3 -9 L -5 -3 L -7 2 L -10 9 M -10 -5 L -10 -4 L -9 -3 L -8 -3 L -5 -5 L -3 -6 L 0 -6 L 2 -5 L 3 -3 L 3 0 L 2 4 L 0 8 L -1 9 L -2 9 L -2 8 L -3 7 L -5 6 M -10 -4 L -8 -4 L -5 -5 M 0 -6 L 2 -4 L 2 0 L 1 4 L 0 6 L -2 8 M 5 -5 L 7 -4 L 9 -2 L 10 0 L 10 2 L 9 1 L 7 2 M 8 -3 L 9 -1 L 9 1 M 5 -10 L 7 -8 M 7 -12 L 9 -10","-14 13 M -4 -12 L -1 -11 L 0 -7 L 1 -4 L 3 0 L 6 4 L 5 5 M -2 -11 L 0 -7 M 3 0 L 5 5 M -6 -7 L -4 -6 L -1 -6 L 2 -7 M -9 -3 L -8 -2 L -5 -1 L 0 -1 L 5 -2 L 8 -3 M 5 -2 L 7 -4 L 8 -3 M 5 5 L 3 4 L 0 3 L -4 3 L -6 4 L -7 5 L -7 7 L -6 8 L -4 9 L -1 10 L 5 10 M -4 9 L 4 9 L 5 10 M 5 -10 L 7 -8 M 7 -12 L 9 -10","-14 13 M 2 -12 L 4 -11 L 4 -10 L -4 -2 M 3 -11 L 2 -9 L -4 -2 L -4 -1 L 1 4 L 3 7 L 4 9 M -4 -1 L 4 6 L 5 8 L 4 9 M 7 -10 L 9 -8 M 9 -12 L 11 -10","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 L -4 -3 L -3 -4 L -1 -5 L 8 -5 L 10 -6 M -9 3 L -8 5 L -7 6 M 4 -5 L 8 -6 L 9 -7 L 10 -6 M 4 -12 L 6 -11 L 6 3 L 5 6 L 3 8 L 0 10 M 5 -11 L 6 -8 M 6 0 L 5 4 L 3 7 L 0 10 M 9 -11 L 11 -9 M 11 -13 L 13 -11","-14 13 M -5 -10 L -3 -9 L 0 -8 L 2 -8 L 5 -9 M -3 -9 L 2 -9 L 4 -10 L 5 -9 L -1 -6 M -7 1 L -7 3 L -6 5 L -4 6 L 0 7 L 7 7 M -4 6 L 6 6 L 7 7 M 7 -11 L 9 -9 M 9 -13 L 11 -11","-14 13 M -8 -7 L -7 -6 L -4 -5 L 0 -5 L 4 -6 L 6 -7 L 7 -8 M 4 -6 L 6 -8 L 7 -8 M -2 -12 L -1 -9 L 0 -7 L 3 -3 L 5 0 L 6 2 M -2 -12 L -1 -12 L -1 -10 L 0 -7 M 3 -3 L 6 0 L 7 2 L 7 3 M 7 3 L 6 2 L 4 1 L 0 0 L -4 0 L -7 1 L -8 3 L -8 5 L -7 7 L -5 8 L -1 9 L 3 9 M -8 5 L -7 6 L -5 7 L -1 8 L 4 8 L 3 9 M 8 -11 L 10 -9 M 10 -13 L 12 -11","-14 13 M -6 -12 L -4 -11 L -5 1 L -5 6 L -4 8 M -5 -11 L -6 1 L -6 5 L -5 7 L -4 8 L -2 9 L 1 9 L 4 8 L 7 6 L 9 4 M 1 -10 L 3 -8 M 3 -12 L 5 -10","-14 13 M 0 -12 L 2 -11 L 2 1 L 1 3 L -1 4 L -3 3 L -4 1 L -4 0 L -3 -2 L -1 -3 L 1 -2 L 2 0 L 2 4 L 1 8 L -1 10 M 1 -11 L 2 -6 M 2 4 L 1 7 L -1 10 M -10 -8 L -8 -6 L -5 -6 L 4 -7 L 8 -8 L 10 -7 M -9 -7 L -5 -6 M 4 -7 L 10 -7 M 6 -12 L 8 -10 M 9 -13 L 11 -11","-14 13 M -6 -8 L -4 -7 L -4 4 L -3 6 L -2 7 L 0 8 L 8 8 M -5 -7 L -4 -4 M 3 8 L 6 7 L 7 7 L 8 8 M 3 -11 L 5 -10 L 5 2 L 4 4 L 3 3 L 0 1 M 4 -10 L 5 -7 M 5 -1 L 4 2 L 3 3 M -10 -4 L -8 -2 L -6 -2 L -2 -3 L 3 -4 L 7 -5 L 9 -5 L 10 -4 M -9 -3 L -2 -3 M 3 -4 L 10 -4 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -4 -11 L -2 -9 L 4 -11 M -3 -10 L -1 -10 L 4 -11 L 5 -10 M 5 -10 L 2 -7 L -4 -3 L -8 -1 M 4 -11 L 3 -9 L 1 -7 L -4 -3 M -9 -2 L -7 0 L -3 -2 M -8 -1 L -3 -2 L 3 -3 L 8 -4 L 9 -3 M 3 -3 L 9 -3 M 3 -3 L 1 -2 L -1 0 L -2 2 L -2 4 L -1 6 L 0 7 L 3 8 L 7 8 M -1 6 L 2 7 L 6 7 L 7 8 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -4 -12 L -2 -11 L -2 -9 L -4 -3 L -5 0 L -7 5 L -9 9 M -3 -11 L -3 -8 L -4 -3 M -5 0 L -7 4 L -9 7 L -9 9 M -10 -5 L -8 -4 L -5 -4 L -2 -5 L 0 -6 L 2 -7 M 0 -6 L 1 -8 L 2 -7 M 3 -4 L 6 -4 L 9 -3 L 7 -3 L 5 -2 M 6 -4 L 7 -3 M 0 4 L 1 6 L 2 7 L 4 8 L 9 8 M 1 6 L 3 7 L 10 7 L 9 8 M 6 -10 L 8 -8 M 8 -12 L 10 -10","-14 13 M -5 -12 L -3 -11 L -3 -9 L -5 -4 L -6 0 L -6 2 L -5 3 M -4 -11 L -4 -7 M -5 -4 L -5 3 M -10 -8 L -7 -7 L -3 -7 L 1 -8 L 3 -9 M 1 -8 L 2 -10 L 3 -9 M -5 3 L -3 1 L 0 -1 L 3 -2 L 6 -2 L 8 -1 L 9 1 L 9 4 L 8 6 L 5 8 L 1 9 L -3 9 M 6 -2 L 7 -1 L 8 1 L 8 4 L 7 6 L 5 8 M 6 -9 L 8 -7 M 8 -11 L 10 -9","-14 13 M -10 -6 L -8 -4 L -3 -6 L 1 -7 L 5 -7 L 8 -6 L 9 -5 L 10 -3 L 10 0 L 9 2 L 8 3 L 6 4 L 3 5 L -2 6 M -9 -5 L -3 -6 M 5 -7 L 7 -6 L 8 -5 L 9 -3 L 9 0 L 8 2 L 6 4 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -10 -9 L -8 -7 L -6 -7 L -2 -8 L 3 -9 L 7 -10 L 9 -10 L 10 -9 M -9 -8 L -2 -8 M 3 -9 L 10 -9 M 7 -9 L 4 -8 L 1 -6 L -1 -3 L -2 0 L -2 3 L -1 6 L 0 7 L 2 8 L 6 9 L 9 9 M -2 3 L -1 5 L 0 6 L 2 7 L 6 8 L 8 8 L 9 9 M 8 -5 L 10 -3 M 10 -7 L 12 -5","-14 13 M -3 -12 L -1 -11 L -1 -1 M -2 -11 L -2 -5 L -1 -1 M 5 -4 L 7 -2 L -1 -1 M 6 -3 L 2 -2 L -1 -1 L -4 0 L -6 1 L -7 3 L -7 5 L -6 7 L -5 8 L -3 9 L 8 9 M -6 7 L -4 8 L 7 8 L 8 9 M 6 -9 L 8 -7 M 8 -11 L 10 -9","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M 3 -11 L 5 -10 L 5 5 L 4 7 L 2 8 L 0 8 L -2 7 L -3 5 L -2 3 L 0 2 L 2 2 L 4 3 L 9 7 M 4 -10 L 5 -6 M 4 3 L 9 6 L 9 7 M -2 -5 L 0 -4 L 3 -4 L 7 -5 L 9 -6 M 7 -5 L 8 -7 L 9 -6 M 8 -11 L 10 -9 M 10 -13 L 12 -11","-14 13 M -9 -11 L -8 -10 L -6 -9 L -2 -9 M -8 -10 L -3 -10 L -2 -9 M -2 -9 L -5 -7 L -7 -5 L -9 -2 L -10 1 L -10 4 L -9 6 L -8 7 L -6 8 L -3 8 L 0 7 L 2 5 L 3 3 L 4 -1 L 4 -5 L 3 -9 L 4 -9 M -10 3 L -9 5 L -8 6 L -6 7 L -3 7 L 0 6 L 2 4 L 3 2 L 4 -1 M 4 -9 L 6 -6 L 7 -4 L 9 -1 L 10 1 L 8 1 L 7 2 M 3 -9 L 6 -6 M 7 -4 L 8 -1 L 8 1 M 7 -10 L 9 -8 M 9 -12 L 11 -10","-14 13 M -2 -12 L -1 -9 L 1 -8 M -1 -10 L 1 -9 L 2 -9 L 2 -8 M 2 -8 L -1 -7 L -3 -6 L -4 -5 L -4 -3 L -3 -2 L -1 -1 L 1 0 L 2 1 L 3 3 L 3 5 L 2 7 L 0 8 L -2 8 L -5 7 L -7 5 M -1 -1 L 1 1 L 2 3 L 2 5 L 1 7 L 0 8 M -9 7 L -6 4 L -3 2 L 0 1 M 4 1 L 7 2 L 9 4 L 10 6 L 7 6 M -9 7 L -9 6 L -6 4 M 4 1 L 6 2 L 8 4 L 9 6 M 5 -9 L 7 -7 M 7 -11 L 9 -9","-14 13 M -10 -2 L -8 0 L -5 -5 M -9 -1 L -4 -6 L -2 -6 L 3 -1 L 7 2 L 9 3 L 10 4 L 8 4 L 6 5 M 3 -1 L 8 4 M 3 -8 L 5 -6 M 5 -10 L 7 -8","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M -1 -11 L 1 -10 L 3 -10 L 7 -11 M 3 -10 L 5 -11 L 6 -12 L 7 -11 M -2 -3 L 1 -2 L 4 -2 L 7 -3 L 9 -4 M 7 -3 L 8 -5 L 9 -4 M 3 -10 L 5 -9 L 5 5 L 4 7 L 2 8 L 0 8 L -2 7 L -3 5 L -2 3 L 0 2 L 2 2 L 4 3 L 9 7 M 4 -9 L 5 -5 M 4 3 L 9 6 L 9 7 M 9 -9 L 11 -7 M 11 -11 L 13 -9","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M 3 -11 L 5 -10 L 5 5 L 4 7 L 2 8 L 0 8 L -2 7 L -3 5 L -2 3 L 0 2 L 2 2 L 4 3 L 9 7 M 4 -10 L 5 -6 M 4 3 L 9 6 L 9 7 M -2 -5 L 0 -4 L 3 -4 L 7 -5 L 9 -6 M 7 -5 L 8 -7 L 9 -6 M 9 -13 L 8 -12 L 8 -10 L 9 -9 L 11 -9 L 12 -10 L 12 -12 L 11 -13 L 9 -13","-14 13 M -9 -11 L -8 -10 L -6 -9 L -2 -9 M -8 -10 L -3 -10 L -2 -9 M -2 -9 L -5 -7 L -7 -5 L -9 -2 L -10 1 L -10 4 L -9 6 L -8 7 L -6 8 L -3 8 L 0 7 L 2 5 L 3 3 L 4 -1 L 4 -5 L 3 -9 L 4 -9 M -10 3 L -9 5 L -8 6 L -6 7 L -3 7 L 0 6 L 2 4 L 3 2 L 4 -1 M 4 -9 L 6 -6 L 7 -4 L 9 -1 L 10 1 L 8 1 L 7 2 M 3 -9 L 6 -6 M 7 -4 L 8 -1 L 8 1 M 8 -12 L 7 -11 L 7 -9 L 8 -8 L 10 -8 L 11 -9 L 11 -11 L 10 -12 L 8 -12","-14 13 M -2 -12 L -1 -9 L 1 -8 M -1 -10 L 1 -9 L 2 -9 L 2 -8 M 2 -8 L -1 -7 L -3 -6 L -4 -5 L -4 -3 L -3 -2 L -1 -1 L 1 0 L 2 1 L 3 3 L 3 5 L 2 7 L 0 8 L -2 8 L -5 7 L -7 5 M -1 -1 L 1 1 L 2 3 L 2 5 L 1 7 L 0 8 M -9 7 L -6 4 L -3 2 L 0 1 M 4 1 L 7 2 L 9 4 L 10 6 L 7 6 M -9 7 L -9 6 L -6 4 M 4 1 L 6 2 L 8 4 L 9 6 M 6 -11 L 5 -10 L 5 -8 L 6 -7 L 8 -7 L 9 -8 L 9 -10 L 8 -11 L 6 -11","-14 13 M -10 -2 L -8 0 L -5 -5 M -9 -1 L -4 -6 L -2 -6 L 3 -1 L 7 2 L 9 3 L 10 4 L 8 4 L 6 5 M 3 -1 L 8 4 M 4 -10 L 3 -9 L 3 -7 L 4 -6 L 6 -6 L 7 -7 L 7 -9 L 6 -10 L 4 -10","-14 13 M -9 -11 L -7 -10 L -7 -8 L -8 -5 L -9 -1 M -8 -10 L -8 -7 L -9 -1 L -9 3 L -8 7 L -7 8 L -7 6 L -6 2 L -5 -1 M -9 3 L -8 5 L -7 6 M -1 -11 L 1 -10 L 3 -10 L 7 -11 M 3 -10 L 5 -11 L 6 -12 L 7 -11 M -2 -3 L 1 -2 L 4 -2 L 7 -3 L 9 -4 M 7 -3 L 8 -5 L 9 -4 M 3 -10 L 5 -9 L 5 5 L 4 7 L 2 8 L 0 8 L -2 7 L -3 5 L -2 3 L 0 2 L 2 2 L 4 3 L 9 7 M 4 -9 L 5 -5 M 4 3 L 9 6 L 9 7 M 10 -11 L 9 -10 L 9 -8 L 10 -7 L 12 -7 L 13 -8 L 13 -10 L 12 -11 L 10 -11","-14 13 M -10 -11 L -8 -9 L -3 -10 L 3 -11 L 8 -12 L 10 -10 M -9 -10 L -3 -10 M 3 -11 L 9 -11 M 10 -10 L 8 -8 L 4 -5 L 2 -4 M 9 -11 L 7 -8 L 5 -6 L 2 -4 M 0 -5 L 2 -4 L 2 -1 L 1 3 L -1 6 L -4 9 M 0 -5 L 1 -4 L 1 -1 L 0 3 L -2 7","-14 13 M 4 -12 L 6 -10 L 3 -6 L 0 -3 L -4 0 L -7 2 M 5 -11 L 4 -9 L 1 -5 L -3 -1 L -7 2 M 1 -4 L 3 -3 L 3 10 M 1 -4 L 2 -3 L 2 9 L 3 10","-14 13 M -2 -12 L 1 -11 L 1 -9 L 0 -7 M -2 -12 L 0 -11 L 0 -7 M -8 -9 L -7 -7 L -7 -2 L -6 -1 M -6 -7 L -6 -1 M -6 -7 L 7 -7 M -8 -9 L -7 -8 L -3 -7 M 3 -7 L 6 -8 L 8 -6 M 8 -6 L 5 0 L 3 3 L 0 6 L -3 8 L -5 9 M 7 -7 L 6 -4 L 4 0 L 1 4 L -2 7 L -5 9","-14 13 M -1 -7 L 1 -6 L 1 5 M 0 -6 L 0 5 M -8 -8 L -6 -6 L 6 -8 L 8 -7 M -7 -7 L 8 -7 M -10 4 L -8 6 L 8 4 L 10 5 M -9 5 L 10 5","-14 13 M 0 -12 L 3 -11 L 3 7 L 2 9 L 1 7 L -2 5 M 2 -11 L 2 6 L 1 7 M -10 -6 L -8 -4 L -3 -5 L 3 -6 L 8 -7 L 10 -6 M -9 -5 L -3 -5 M 3 -6 L 10 -6 M 1 -5 L -2 -1 L -6 3 L -10 6 M 2 -5 L 0 -2 L -3 1 L -7 4 L -10 6","-14 13 M -1 -12 L 1 -10 L 0 -7 L -2 -2 L -4 2 L -6 5 L -9 9 M 0 -11 L -1 -8 L -3 -2 L -5 3 L -9 9 M -9 -6 L -7 -4 L -3 -5 L 2 -6 L 6 -7 L 8 -5 M -8 -5 L -3 -5 M 2 -6 L 7 -6 M 8 -5 L 7 1 L 6 5 L 5 7 L 3 9 L 2 8 L 0 7 M 7 -6 L 6 1 L 5 5 L 4 7 L 2 8","-14 13 M -3 -12 L 0 -11 L 2 9 M -1 -11 L 1 10 L 2 9 M -8 -6 L -6 -4 L -2 -5 L 2 -6 L 6 -7 L 8 -6 M -7 -5 L -2 -5 M 2 -6 L 8 -6 M -10 0 L -8 2 L -3 1 L 3 0 L 8 -1 L 10 0 M -9 1 L -3 1 M 3 0 L 10 0","-14 13 M -2 -12 L 0 -10 L -2 -6 L -4 -3 L -6 -1 L -8 1 M -1 -11 L -2 -8 L -4 -4 L -6 -1 M -1 -8 L 1 -7 L 6 -7 M 3 -7 L 5 -8 L 7 -6 M 7 -6 L 4 0 L 1 4 L -2 7 L -5 9 L -7 10 M 6 -7 L 5 -4 L 3 0 L 0 4 L -3 7 L -7 10","-14 13 M -4 -12 L -2 -10 L -4 -6 L -6 -3 L -8 -1 L -10 1 M -3 -11 L -4 -8 L -6 -4 L -8 -1 M -6 -3 L 2 -4 L 7 -5 L 10 -4 M 2 -4 L 10 -4 M 0 -3 L 2 -1 L 0 3 L -2 6 L -4 8 L -6 10 M 1 -2 L 0 1 L -2 5 L -4 8","-14 13 M -8 -8 L -6 -6 L 6 -8 L 8 -6 M -7 -7 L 7 -7 M 8 -6 L 7 -3 L 6 4 M 7 -7 L 6 -2 L 6 4 M -8 4 L -6 6 L 6 4 L 7 5 M -7 5 L 7 5","-14 13 M -6 -9 L -4 -8 L -4 -3 L -5 1 M -5 -8 L -5 1 M 2 -12 L 5 -11 L 5 -6 L 4 -1 L 3 2 L 2 4 L 0 7 L -2 9 M 4 -11 L 4 -6 L 3 -1 L 2 3 L 0 7 M -10 -5 L -8 -3 L -3 -4 L 3 -5 L 8 -6 L 10 -5 M -9 -4 L -3 -4 M 3 -5 L 10 -5","-14 13 M -5 -11 L -3 -10 L -2 -9 L -2 -8 L -3 -8 L -4 -10 L -5 -11 M -10 -4 L -8 -3 L -7 -2 L -7 -1 L -8 -1 L -9 -3 L -10 -4 M -9 6 L -7 8 L -3 6 L 1 3 L 5 -1 L 9 -6 M -8 7 L -3 5 L 1 2 L 9 -6","-14 13 M -8 -9 L -6 -7 L 5 -9 L 7 -7 M -7 -8 L 6 -8 M 7 -7 L 5 -4 L 2 -1 L -1 1 L -3 2 L -8 4 M 6 -8 L 5 -6 L 3 -3 L 1 -1 L -2 1 L -8 4 M 3 1 L 6 3 L 8 5 L 8 6 L 7 6 L 6 4 L 3 1","-14 13 M -3 -11 L 0 -10 L 0 -8 L -1 1 M -1 -10 L -1 4 L 0 6 L 2 7 L 9 7 M 4 7 L 8 6 L 9 7 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -3 M -9 -3 L -3 -3 M 3 -4 L 9 -4 M 10 -3 L 7 -1 L 4 2 M 9 -4 L 4 2","-14 13 M -9 -9 L -7 -8 L -6 -7 L -6 -6 L -7 -6 L -8 -8 L -9 -9 M 6 -10 L 8 -8 L 5 -2 L 2 2 L -1 5 L -4 7 L -6 8 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -6 8","-14 13 M -2 -12 L 0 -10 L -2 -6 L -4 -3 L -6 -1 L -8 1 M -1 -11 L -2 -8 L -4 -4 L -6 -1 M -1 -8 L 1 -7 L 6 -7 M 3 -7 L 5 -8 L 7 -6 M 7 -6 L 4 0 L 1 4 L -2 7 L -5 9 L -7 10 M 6 -7 L 5 -4 L 3 0 L 0 4 L -3 7 L -7 10 M -4 -2 L -1 -1 L 1 0 L 4 2 L 5 3 L 5 4 L 4 4 L 3 2 L 1 0","-14 13 M -6 -8 L -3 -8 L 2 -9 L 6 -11 M -3 -8 L 0 -9 L 2 -10 L 5 -12 L 6 -11 M -2 -8 L 1 -7 L 1 -1 L 0 3 L -2 6 L -5 9 M 0 -7 L 0 -1 L -1 3 L -3 7 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -4 M -9 -3 L -3 -3 M 3 -4 L 10 -4","-14 13 M -9 -9 L -7 -8 L -6 -7 L -6 -6 L -7 -6 L -8 -8 L -9 -9 M -3 -10 L -1 -9 L 0 -8 L 0 -7 L -1 -7 L -2 -9 L -3 -10 M 6 -10 L 8 -8 L 5 -2 L 2 2 L -1 5 L -4 7 L -6 8 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -6 8","-14 13 M -6 -12 L -4 -10 L 5 -12 L 6 -11 M -5 -11 L 6 -11 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -4 M -9 -3 L -3 -3 M 3 -4 L 10 -4 M 1 -3 L 1 -1 L 0 3 L -2 6 L -5 9 M 0 -3 L 0 -1 L -1 3 L -3 7","-14 13 M -5 -12 L -2 -11 L -2 10 M -3 -11 L -3 9 L -2 10 M -2 -3 L 0 -3 L 3 -2 L 4 -1 L 4 0 L 3 0 L 2 -2 L 0 -3","-14 13 M -1 -12 L 2 -11 L 2 -6 L 1 -1 L 0 2 L -1 4 L -3 7 L -5 9 M 1 -11 L 1 -6 L 0 -1 L -1 3 L -3 7 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -4 M -9 -3 L -3 -3 M 3 -4 L 10 -4","-14 13 M -6 -8 L -4 -6 L 5 -8 L 6 -7 M -5 -7 L 6 -7 M -10 4 L -8 6 L 8 4 L 10 5 M -9 5 L 10 5","-14 13 M -8 -9 L -6 -7 L 5 -9 L 7 -7 M -7 -8 L 6 -8 M 7 -7 L 5 -4 L 2 -1 L -1 1 L -3 2 L -8 4 M 6 -8 L 5 -6 L 3 -3 L 1 -1 L -2 1 L -8 4 M -5 -3 L -2 -2 L 2 0 L 5 2 L 7 4 L 7 5 L 6 5 L 4 2 L 2 0","-14 13 M -2 -12 L 0 -11 L 1 -10 L 1 -9 L 0 -9 L -1 -11 L -2 -12 M -8 -6 L -6 -4 L 4 -6 L 6 -4 M -7 -5 L 5 -5 M 6 -4 L 2 0 L -1 2 L -3 3 L -8 5 M 5 -5 L 3 -2 L 1 0 L -2 2 L -8 5 M 0 1 L 1 2 L 1 10 M 0 1 L 0 9 L 1 10 M 6 3 L 8 4 L 9 5 L 9 6 L 8 6 L 7 4 L 6 3","-14 13 M 5 -10 L 7 -8 L 4 -2 L 1 2 L -2 5 L -5 7 L -7 8 M 6 -9 L 5 -6 L 2 -1 L -1 3 L -4 6 L -7 8","-14 13 M -6 -6 L -4 -4 L -5 -1 L -6 1 L -8 3 L -10 4 M -5 -5 L -6 -1 L -8 3 M 4 -6 L 6 -4 L 8 -1 L 10 3 L 10 4 L 9 4 L 8 0 L 6 -4","-14 13 M -9 -11 L -6 -10 L -6 -8 L -7 1 M -7 -10 L -7 4 L -6 6 L -4 7 L 7 7 M -1 7 L 3 6 L 5 6 L 7 7 M -7 0 L -3 -1 L 0 -2 L 6 -4 M 0 -2 L 4 -4 L 6 -4","-14 13 M -8 -11 L -6 -9 L 7 -9 M -7 -10 L -3 -9 M 3 -9 L 6 -10 L 8 -8 M 8 -8 L 5 -2 L 3 1 L 0 4 L -3 6 L -5 7 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -5 7","-14 13 M -11 -1 L -9 1 L -2 -6 L -1 -6 L 9 4 M -10 0 L -8 -1 L -4 -4 M 3 -2 L 8 2 L 10 3 L 9 4","-14 13 M -2 -12 L 1 -11 L 1 7 L 0 9 L -1 7 L -3 6 M 0 -11 L 0 6 L -1 7 M -10 -6 L -8 -4 L -3 -5 L 3 -6 L 8 -7 L 10 -6 M -9 -5 L -3 -5 M 3 -6 L 10 -6 M -6 1 L -8 4 L -9 5 L -10 5 L -10 4 L -8 3 L -6 1 M 6 1 L 9 3 L 10 4 L 10 5 L 9 5 L 8 3 L 6 1","-14 13 M -10 -6 L -8 -4 L -3 -5 L 3 -6 L 8 -7 L 10 -5 M -9 -5 L -3 -5 M 3 -6 L 9 -6 M 10 -5 L 8 -3 L 4 0 L 2 1 M 9 -6 L 7 -3 L 5 -1 L 2 1 M -1 0 L 2 2 L 4 4 L 4 5 L 3 5 L 2 3 L -1 0","-14 13 M -2 -12 L 1 -11 L 3 -10 L 4 -9 L 4 -8 L 3 -8 L 1 -10 L -2 -12 M -5 -5 L -2 -4 L 0 -3 L 1 -2 L 1 -1 L 0 -1 L -2 -3 L -5 -5 M -4 4 L 1 6 L 3 7 L 4 8 L 4 9 L 3 9 L 1 7 L -2 5 L -4 4","-14 13 M 0 -9 L 2 -7 L -5 5 M 1 -8 L -5 5 M -10 5 L -8 7 L 7 4 M -9 6 L 7 4 M 4 1 L 6 3 L 8 6 L 9 6 L 9 5 L 7 3 L 4 1","-14 13 M 5 -10 L 7 -8 L 4 -2 L 1 2 L -2 5 L -5 7 L -7 8 M 6 -9 L 5 -6 L 3 -2 L 0 2 L -3 5 L -7 8 M -3 -4 L 1 -2 L 4 0 L 6 2 L 6 3 L 5 3 L 4 1 L 2 -1 L -1 -3","-14 13 M -6 -9 L -4 -7 L 5 -9 L 6 -8 M -5 -8 L 6 -8 M -1 -7 L -1 4 L 0 6 L 2 7 L 9 7 M 0 -7 L 0 -5 L -1 1 M 4 7 L 8 6 L 9 7 M -10 -1 L -8 1 L -3 0 L 3 -1 L 8 -2 L 10 -1 M -9 0 L -3 0 M 3 -1 L 10 -1","-14 13 M -3 -12 L 0 -11 L 2 9 M -1 -11 L 1 10 L 2 9 M -10 -6 L -8 -4 L -3 -5 L 3 -6 L 8 -7 L 10 -5 M -9 -5 L -3 -5 M 3 -6 L 9 -6 M 10 -5 L 7 -2 L 4 0 L 2 1 M 9 -6 L 8 -4 L 5 -1 L 2 1","-14 13 M 4 -12 L 6 -10 L 3 -6 L 0 -3 L -4 0 L -7 2 M 5 -11 L 4 -9 L 1 -5 L -3 -1 L -7 2 M 1 -4 L 3 -3 L 3 10 M 1 -4 L 2 -3 L 2 9 L 3 10","-14 13 M -9 -8 L -7 -6 L 3 -8 L 5 -6 M -8 -7 L 4 -7 M 5 -6 L 4 -3 L 3 4 M 4 -7 L 3 -2 L 3 4 M -10 4 L -8 6 L 8 4 L 10 5 M -9 5 L 10 5","-14 13 M -1 -7 L 1 -6 L 1 5 M 0 -6 L 0 5 M -8 -8 L -6 -6 L 6 -8 L 8 -7 M -7 -7 L 8 -7 M -10 4 L -8 6 L 8 4 L 10 5 M -9 5 L 10 5","-14 13 M -8 -8 L -6 -6 L 6 -8 L 8 -6 M -7 -7 L 7 -7 M -8 -2 L -6 0 L 6 -2 M -7 -1 L 6 -1 M -8 4 L -6 6 L 6 4 M -7 5 L 6 5 M 8 -6 L 7 -3 L 7 7 M 7 -7 L 6 -2 L 6 7","-14 13 M -6 -12 L -4 -10 L 5 -12 L 6 -11 M -5 -11 L 6 -11 M -8 -5 L -6 -3 L 5 -5 L 7 -3 M -7 -4 L 6 -4 M 7 -3 L 5 0 L 2 3 L -1 5 L -3 6 L -6 7 M 6 -4 L 5 -2 L 3 1 L 1 3 L -2 5 L -6 7","-14 13 M -6 -9 L -4 -8 L -4 -3 L -5 1 M -5 -8 L -5 1 M 2 -12 L 5 -11 L 5 -1 L 4 3 L 2 6 L -1 9 M 4 -11 L 4 -1 L 3 3 L 2 5 L -1 9","-14 13 M -6 -8 L -4 -7 L -4 -4 L -5 0 L -7 3 L -10 6 M -5 -7 L -5 -4 L -6 0 L -7 2 L -10 6 M -1 -9 L 1 -8 L 1 -5 L 0 1 M 0 -8 L 0 4 L 1 6 L 3 6 L 5 5 L 7 3 L 10 -1 M 0 4 L 1 5 L 4 5 L 6 4","-14 13 M -10 -9 L -7 -8 L -7 -5 L -8 1 M -8 -8 L -8 4 L -7 6 L -4 6 L -1 5 L 2 3 L 6 0 L 9 -3 M -8 4 L -7 5 L -4 5 L -1 4 L 3 2 L 6 0","-14 13 M -8 -8 L -6 -6 L 6 -8 L 8 -6 M -7 -7 L 7 -7 M -7 -7 L -7 8 M -6 -6 L -6 6 L -7 8 M 8 -6 L 7 -3 L 6 4 M 7 -7 L 6 -2 L 6 4 M -6 6 L 6 4 L 7 5 M -6 5 L 7 5","-14 13 M -8 -11 L -7 -9 L -7 -4 L -6 -3 M -6 -9 L -6 -3 M -6 -9 L 7 -9 M -8 -11 L -7 -10 L -3 -9 M 3 -9 L 6 -10 L 8 -8 M 8 -8 L 5 -2 L 3 1 L 0 4 L -3 6 L -5 7 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -5 7","-14 13 M -1 -12 L 2 -11 L 2 9 M 1 -11 L 1 10 L 2 9 M -8 -8 L -6 -6 L 6 -8 L 8 -7 M -7 -7 L 8 -7 M -6 -6 L -4 -5 L -4 0 M -5 -5 L -5 0 M -10 -1 L -8 1 L 8 -1 L 10 0 M -9 0 L 10 0","-14 13 M -2 -12 L 1 -11 L 1 -9 L 0 -7 M -2 -12 L 0 -11 L 0 -7 M -8 -9 L -7 -7 L -7 -2 L -6 -1 M -6 -7 L -6 -1 M -6 -7 L 7 -7 M -8 -9 L -7 -8 L -3 -7 M 3 -7 L 6 -8 L 8 -6 M 8 -6 L 5 0 L 3 3 L 0 6 L -3 8 L -5 9 M 7 -7 L 6 -4 L 4 0 L 1 4 L -2 7 L -5 9","-14 13 M -8 -8 L -6 -6 L 6 -8 L 8 -6 M -7 -7 L 7 -7 M 8 -6 L 5 -4 L 1 -1 M 7 -7 L 1 -1 M -1 -2 L 1 -1 L 1 5 M 0 -1 L 0 5 M -10 4 L -8 6 L 8 4 L 10 5 M -9 5 L 10 5","-14 13 M -8 -11 L -6 -9 L 7 -9 M -7 -10 L -3 -9 M 3 -9 L 6 -10 L 8 -8 M -6 -4 L -4 -2 L 4 -3 M -5 -3 L 4 -3 M 8 -8 L 5 -2 L 3 1 L 0 4 L -3 6 L -5 7 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -5 7","-14 13 M -8 -10 L -6 -9 L -5 -8 L -5 -7 L -6 -7 L -7 -9 L -8 -10 M -9 5 L -7 7 L -3 5 L 1 2 L 5 -2 L 9 -7 M -8 6 L -3 4 L 1 1 L 9 -7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -10 7 L -11 8 L -10 9 L -9 8 L -10 7","-14 13 M -1 -12 L 1 -10 L 0 -7 L -2 -2 L -4 2 L -6 5 L -9 9 M 0 -11 L -1 -8 L -3 -2 L -5 3 L -9 9 M -9 -6 L -7 -4 L -3 -5 L 2 -6 L 6 -7 L 8 -5 M -8 -5 L -3 -5 M 2 -6 L 7 -6 M 8 -5 L 7 1 L 6 5 L 5 7 L 3 9 L 2 8 L 0 7 M 7 -6 L 6 1 L 5 5 L 4 7 L 2 8 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -3 -12 L 0 -11 L 2 9 M -1 -11 L 1 10 L 2 9 M -8 -6 L -6 -4 L -2 -5 L 2 -6 L 6 -7 L 8 -6 M -7 -5 L -2 -5 M 2 -6 L 8 -6 M -10 0 L -8 2 L -3 1 L 3 0 L 8 -1 L 10 0 M -9 1 L -3 1 M 3 0 L 10 0 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -2 -12 L 0 -10 L -2 -6 L -4 -3 L -6 -1 L -8 1 M -1 -11 L -2 -8 L -4 -4 L -6 -1 M -1 -8 L 1 -7 L 6 -7 M 3 -7 L 5 -8 L 7 -6 M 7 -6 L 4 0 L 1 4 L -2 7 L -5 9 L -7 10 M 6 -7 L 5 -4 L 3 0 L 0 4 L -3 7 L -7 10 M 7 -10 L 9 -8 M 9 -12 L 11 -10","-14 13 M -4 -12 L -2 -10 L -4 -6 L -6 -3 L -8 -1 L -10 1 M -3 -11 L -4 -8 L -6 -4 L -8 -1 M -6 -3 L 2 -4 L 7 -5 L 10 -4 M 2 -4 L 10 -4 M 0 -3 L 2 -1 L 0 3 L -2 6 L -4 8 L -6 10 M 1 -2 L 0 1 L -2 5 L -4 8 M 7 -10 L 9 -8 M 9 -12 L 11 -10","-14 13 M -8 -8 L -6 -6 L 6 -8 L 8 -6 M -7 -7 L 7 -7 M 8 -6 L 7 -3 L 6 4 M 7 -7 L 6 -2 L 6 4 M -8 4 L -6 6 L 6 4 L 7 5 M -7 5 L 7 5 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -6 -9 L -4 -8 L -4 -3 L -5 1 M -5 -8 L -5 1 M 2 -12 L 5 -11 L 5 -6 L 4 -1 L 3 2 L 2 4 L 0 7 L -2 9 M 4 -11 L 4 -6 L 3 -1 L 2 3 L 0 7 M -10 -5 L -8 -3 L -3 -4 L 3 -5 L 8 -6 L 10 -5 M -9 -4 L -3 -4 M 3 -5 L 10 -5 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -5 -11 L -3 -10 L -2 -9 L -2 -8 L -3 -8 L -4 -10 L -5 -11 M -10 -4 L -8 -3 L -7 -2 L -7 -1 L -8 -1 L -9 -3 L -10 -4 M -9 6 L -7 8 L -3 6 L 1 3 L 5 -1 L 9 -6 M -8 7 L -3 5 L 1 2 L 9 -6 M 4 -10 L 6 -8 M 6 -12 L 8 -10","-14 13 M -8 -9 L -6 -7 L 5 -9 L 7 -7 M -7 -8 L 6 -8 M 7 -7 L 5 -4 L 2 -1 L -1 1 L -3 2 L -8 4 M 6 -8 L 5 -6 L 3 -3 L 1 -1 L -2 1 L -8 4 M 3 1 L 6 3 L 8 5 L 8 6 L 7 6 L 6 4 L 3 1 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -3 -11 L 0 -10 L 0 -8 L -1 1 M -1 -10 L -1 4 L 0 6 L 2 7 L 9 7 M 4 7 L 8 6 L 9 7 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -3 M -9 -3 L -3 -3 M 3 -4 L 9 -4 M 10 -3 L 7 -1 L 4 2 M 9 -4 L 4 2 M 7 -10 L 9 -8 M 9 -12 L 11 -10","-14 13 M -9 -9 L -7 -8 L -6 -7 L -6 -6 L -7 -6 L -8 -8 L -9 -9 M 6 -10 L 8 -8 L 5 -2 L 2 2 L -1 5 L -4 7 L -6 8 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -6 8 M 9 -11 L 11 -9 M 11 -13 L 13 -11","-14 13 M -2 -12 L 0 -10 L -2 -6 L -4 -3 L -6 -1 L -8 1 M -1 -11 L -2 -8 L -4 -4 L -6 -1 M -1 -8 L 1 -7 L 6 -7 M 3 -7 L 5 -8 L 7 -6 M 7 -6 L 4 0 L 1 4 L -2 7 L -5 9 L -7 10 M 6 -7 L 5 -4 L 3 0 L 0 4 L -3 7 L -7 10 M -4 -2 L -1 -1 L 1 0 L 4 2 L 5 3 L 5 4 L 4 4 L 3 2 L 1 0 M 7 -10 L 9 -8 M 9 -12 L 11 -10","-14 13 M -6 -8 L -3 -8 L 2 -9 L 6 -11 M -3 -8 L 0 -9 L 2 -10 L 5 -12 L 6 -11 M -2 -8 L 1 -7 L 1 -1 L 0 3 L -2 6 L -5 9 M 0 -7 L 0 -1 L -1 3 L -3 7 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -4 M -9 -3 L -3 -3 M 3 -4 L 10 -4 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -9 -9 L -7 -8 L -6 -7 L -6 -6 L -7 -6 L -8 -8 L -9 -9 M -3 -10 L -1 -9 L 0 -8 L 0 -7 L -1 -7 L -2 -9 L -3 -10 M 6 -10 L 8 -8 L 5 -2 L 2 2 L -1 5 L -4 7 L -6 8 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -6 8 M 9 -11 L 11 -9 M 11 -13 L 13 -11","-14 13 M -6 -12 L -4 -10 L 5 -12 L 6 -11 M -5 -11 L 6 -11 M -10 -4 L -8 -2 L -3 -3 L 3 -4 L 8 -5 L 10 -4 M -9 -3 L -3 -3 M 3 -4 L 10 -4 M 1 -3 L 1 -1 L 0 3 L -2 6 L -5 9 M 0 -3 L 0 -1 L -1 3 L -3 7 M 8 -10 L 10 -8 M 10 -12 L 12 -10","-14 13 M -5 -12 L -2 -11 L -2 10 M -3 -11 L -3 9 L -2 10 M -2 -3 L 0 -3 L 3 -2 L 4 -1 L 4 0 L 3 0 L 2 -2 L 0 -3 M 2 -10 L 4 -8 M 4 -12 L 6 -10","-14 13 M -6 -6 L -4 -4 L -5 -1 L -6 1 L -8 3 L -10 4 M -5 -5 L -6 -1 L -8 3 M 4 -6 L 6 -4 L 8 -1 L 10 3 L 10 4 L 9 4 L 8 0 L 6 -4 M 7 -9 L 9 -7 M 9 -11 L 11 -9","-14 13 M -9 -11 L -6 -10 L -6 -8 L -7 1 M -7 -10 L -7 4 L -6 6 L -4 7 L 7 7 M -1 7 L 3 6 L 5 6 L 7 7 M -7 0 L -3 -1 L 0 -2 L 6 -4 M 0 -2 L 4 -4 L 6 -4 M 7 -9 L 9 -7 M 9 -11 L 11 -9","-14 13 M -8 -11 L -6 -9 L 7 -9 M -7 -10 L -3 -9 M 3 -9 L 6 -10 L 8 -8 M 8 -8 L 5 -2 L 3 1 L 0 4 L -3 6 L -5 7 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -5 7 M 9 -11 L 11 -9 M 11 -13 L 13 -11","-14 13 M -11 -1 L -9 1 L -2 -6 L -1 -6 L 9 4 M -10 0 L -8 -1 L -4 -4 M 3 -2 L 8 2 L 10 3 L 9 4 M 4 -8 L 6 -6 M 6 -10 L 8 -8","-14 13 M -2 -12 L 1 -11 L 1 7 L 0 9 L -1 7 L -3 6 M 0 -11 L 0 6 L -1 7 M -10 -6 L -8 -4 L -3 -5 L 3 -6 L 8 -7 L 10 -6 M -9 -5 L -3 -5 M 3 -6 L 10 -6 M -6 1 L -8 4 L -9 5 L -10 5 L -10 4 L -8 3 L -6 1 M 6 1 L 9 3 L 10 4 L 10 5 L 9 5 L 8 3 L 6 1 M 8 -11 L 10 -9 M 10 -13 L 12 -11","-14 13 M -6 -6 L -4 -4 L -5 -1 L -6 1 L -8 3 L -10 4 M -5 -5 L -6 -1 L -8 3 M 4 -6 L 6 -4 L 8 -1 L 10 3 L 10 4 L 9 4 L 8 0 L 6 -4 M 8 -11 L 7 -10 L 7 -8 L 8 -7 L 10 -7 L 11 -8 L 11 -10 L 10 -11 L 8 -11","-14 13 M -9 -11 L -6 -10 L -6 -8 L -7 1 M -7 -10 L -7 4 L -6 6 L -4 7 L 7 7 M -1 7 L 3 6 L 5 6 L 7 7 M -7 0 L -3 -1 L 0 -2 L 6 -4 M 0 -2 L 4 -4 L 6 -4 M 8 -11 L 7 -10 L 7 -8 L 8 -7 L 10 -7 L 11 -8 L 11 -10 L 10 -11 L 8 -11","-14 13 M -8 -11 L -6 -9 L 7 -9 M -7 -10 L -3 -9 M 3 -9 L 6 -10 L 8 -8 M 8 -8 L 5 -2 L 3 1 L 0 4 L -3 6 L -5 7 M 7 -9 L 6 -6 L 4 -2 L 1 2 L -2 5 L -5 7 M 10 -13 L 9 -12 L 9 -10 L 10 -9 L 12 -9 L 13 -10 L 13 -12 L 12 -13 L 10 -13","-14 13 M -11 -1 L -9 1 L -2 -6 L -1 -6 L 9 4 M -10 0 L -8 -1 L -4 -4 M 3 -2 L 8 2 L 10 3 L 9 4 M 5 -10 L 4 -9 L 4 -7 L 5 -6 L 7 -6 L 8 -7 L 8 -9 L 7 -10 L 5 -10","-14 13 M -2 -12 L 1 -11 L 1 7 L 0 9 L -1 7 L -3 6 M 0 -11 L 0 6 L -1 7 M -10 -6 L -8 -4 L -3 -5 L 3 -6 L 8 -7 L 10 -6 M -9 -5 L -3 -5 M 3 -6 L 10 -6 M -6 1 L -8 4 L -9 5 L -10 5 L -10 4 L -8 3 L -6 1 M 6 1 L 9 3 L 10 4 L 10 5 L 9 5 L 8 3 L 6 1 M 9 -13 L 8 -12 L 8 -10 L 9 -9 L 11 -9 L 12 -10 L 12 -12 L 11 -13 L 9 -13"]
markers = ["-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-7 7 M -1 -7 L -4 -6 L -6 -4 L -7 -1 L -7 1 L -6 4 L -4 6 L -1 7 L 1 7 L 4 6 L 6 4 L 7 1 L 7 -1 L 6 -4 L 4 -6 L 1 -7 L -1 -7","-6 6 M -6 -6 L -6 6 L 6 6 L 6 -6 L -6 -6","-7 7 M 0 -8 L -7 4 L 7 4 L 0 -8","-6 6 M 0 -10 L -6 0 L 0 10 L 6 0 L 0 -10","-8 8 M 0 -9 L -2 -3 L -8 -3 L -3 1 L -5 7 L 0 3 L 5 7 L 3 1 L 8 -3 L 2 -3 L 0 -9","-6 6 M -2 -6 L -2 -2 L -6 -2 L -6 2 L -2 2 L -2 6 L 2 6 L 2 2 L 6 2 L 6 -2 L 2 -2 L 2 -6 L -2 -6","-7 7 M 0 -7 L 0 7 M -7 0 L 7 0","-5 5 M -5 -5 L 5 5 M 5 -5 L -5 5","-5 5 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-4 4 M -1 -4 L -3 -3 L -4 -1 L -4 1 L -3 3 L -1 4 L 1 4 L 3 3 L 4 1 L 4 -1 L 3 -3 L 1 -4 L -1 -4 M -3 -1 L -3 1 M -2 -2 L -2 2 M -1 -3 L -1 3 M 0 -3 L 0 3 M 1 -3 L 1 3 M 2 -2 L 2 2 M 3 -1 L 3 1","-4 4 M -4 -4 L -4 4 L 4 4 L 4 -4 L -4 -4 M -3 -3 L -3 3 M -2 -3 L -2 3 M -1 -3 L -1 3 M 0 -3 L 0 3 M 1 -3 L 1 3 M 2 -3 L 2 3 M 3 -3 L 3 3","-5 5 M 0 -6 L -5 3 L 5 3 L 0 -6 M 0 -3 L -3 2 M 0 -3 L 3 2 M 0 0 L -1 2 M 0 0 L 1 2","-6 3 M -6 0 L 3 5 L 3 -5 L -6 0 M -3 0 L 2 3 M -3 0 L 2 -3 M 0 0 L 2 1 M 0 0 L 2 -1","-5 5 M 0 6 L 5 -3 L -5 -3 L 0 6 M 0 3 L 3 -2 M 0 3 L -3 -2 M 0 0 L 1 -2 M 0 0 L -1 -2","-3 6 M 6 0 L -3 -5 L -3 5 L 6 0 M 3 0 L -2 -3 M 3 0 L -2 3 M 0 0 L -2 -1 M 0 0 L -2 1","-14 14 M -14 0 L 14 0 M -14 0 L 0 16 M 14 0 L 0 16","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-7 7 M -1 -7 L -4 -6 L -6 -4 L -7 -1 L -7 1 L -6 4 L -4 6 L -1 7 L 1 7 L 4 6 L 6 4 L 7 1 L 7 -1 L 6 -4 L 4 -6 L 1 -7 L -1 -7","-6 6 M -6 -6 L -6 6 L 6 6 L 6 -6 L -6 -6","-7 7 M 0 -8 L -7 4 L 7 4 L 0 -8","-6 6 M 0 -10 L -6 0 L 0 10 L 6 0 L 0 -10","-8 8 M 0 -9 L -2 -3 L -8 -3 L -3 1 L -5 7 L 0 3 L 5 7 L 3 1 L 8 -3 L 2 -3 L 0 -9","-6 6 M -2 -6 L -2 -2 L -6 -2 L -6 2 L -2 2 L -2 6 L 2 6 L 2 2 L 6 2 L 6 -2 L 2 -2 L 2 -6 L -2 -6","-7 7 M 0 -7 L 0 7 M -7 0 L 7 0","-5 5 M -5 -5 L 5 5 M 5 -5 L -5 5","-5 5 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-4 4 M -1 -4 L -3 -3 L -4 -1 L -4 1 L -3 3 L -1 4 L 1 4 L 3 3 L 4 1 L 4 -1 L 3 -3 L 1 -4 L -1 -4 M -3 -1 L -3 1 M -2 -2 L -2 2 M -1 -3 L -1 3 M 0 -3 L 0 3 M 1 -3 L 1 3 M 2 -2 L 2 2 M 3 -1 L 3 1","-4 4 M -4 -4 L -4 4 L 4 4 L 4 -4 L -4 -4 M -3 -3 L -3 3 M -2 -3 L -2 3 M -1 -3 L -1 3 M 0 -3 L 0 3 M 1 -3 L 1 3 M 2 -3 L 2 3 M 3 -3 L 3 3","-5 5 M 0 -6 L -5 3 L 5 3 L 0 -6 M 0 -3 L -3 2 M 0 -3 L 3 2 M 0 0 L -1 2 M 0 0 L 1 2","-6 3 M -6 0 L 3 5 L 3 -5 L -6 0 M -3 0 L 2 3 M -3 0 L 2 -3 M 0 0 L 2 1 M 0 0 L 2 -1","-5 5 M 0 6 L 5 -3 L -5 -3 L 0 6 M 0 3 L 3 -2 M 0 3 L -3 -2 M 0 0 L 1 -2 M 0 0 L -1 -2","-3 6 M 6 0 L -3 -5 L -3 5 L 6 0 M 3 0 L -2 -3 M 3 0 L -2 3 M 0 0 L -2 -1 M 0 0 L -2 1","-14 14 M -14 0 L 14 0 M -14 0 L 0 16 M 14 0 L 0 16","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8","-8 8"]
mathlow = ["-8 8","-12 12 M 0 -8 L 0 9 M -8 0 L 8 0 M -8 9 L 8 9","-12 12 M 0 -8 L 0 9 M -8 -8 L 8 -8 M -8 0 L 8 0","-11 11 M -7 -7 L 7 7 M 7 -7 L -7 7","-2 3 M 0 -1 L 0 0 L 1 0 L 1 -1 L 0 -1","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-12 12 M 8 -12 L -8 -5 L 8 2 M -8 4 L 8 4 M -8 9 L 8 9","-12 12 M -8 -12 L 8 -5 L -8 2 M -8 4 L 8 4 M -8 9 L 8 9","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16 M 2 -14 L 0 -10 L -1 -7 L -2 -2 L -2 2 L -1 7 L 0 10 L 2 14","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 M -2 -14 L 0 -10 L 1 -7 L 2 -2 L 2 2 L 1 7 L 0 10 L -2 14","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L 0 -4 L 3 -4 L 5 -3 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 3 -12 L -7 2 L 8 2 M 3 -12 L 3 9","-10 10 M 5 -12 L -5 -12 L -6 -3 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2","-10 10 M 7 -12 L -3 9 M -7 -12 L 7 -12","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 1 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -1 -3 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6","-17 17 M -10 -16 L -10 16 M -9 -16 L -9 16 M 9 -16 L 9 16 M 10 -16 L 10 16 M -14 -16 L 14 -16 M -14 16 L -5 16 M 5 16 L 14 16","-16 15 M -11 -16 L -1 -2 L -12 16 M -12 -16 L -2 -2 M -13 -16 L -2 -1 M -13 -16 L 10 -16 L 12 -9 L 9 -16 M -11 15 L 10 15 M -12 16 L 10 16 L 12 9 L 9 16","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-13 13 M 7 -9 L -7 9 M -9 -3 L 9 -3 M -9 3 L 9 3","-13 13 M -9 -5 L 9 -5 M -9 0 L 9 0 M -9 5 L 9 5","-9 10 M 6 -5 L 6 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-10 9 M -6 -12 L -6 9 M -6 -2 L -4 -4 L -2 -5 L 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -6 6","-9 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 10 M 6 -12 L 6 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 9 M -6 1 L 6 1 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-5 7 M 5 -12 L 3 -12 L 1 -11 L 0 -8 L 0 9 M -3 -5 L 4 -5","-9 10 M 6 -5 L 6 11 L 5 14 L 4 15 L 2 16 L -1 16 L -3 15 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 10 M -5 -12 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9","-4 4 M -1 -12 L 0 -11 L 1 -12 L 0 -13 L -1 -12 M 0 -5 L 0 9","-5 5 M 0 -12 L 1 -11 L 2 -12 L 1 -13 L 0 -12 M 1 -5 L 1 12 L 0 15 L -2 16 L -4 16","-9 8 M -5 -12 L -5 9 M 5 -5 L -5 5 M -1 1 L 6 9","-4 4 M 0 -12 L 0 9","-15 15 M -11 -5 L -11 9 M -11 -1 L -8 -4 L -6 -5 L -3 -5 L -1 -4 L 0 -1 L 0 9 M 0 -1 L 3 -4 L 5 -5 L 8 -5 L 10 -4 L 11 -1 L 11 9","-9 10 M -5 -5 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9","-9 10 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 2 -5 L -1 -5","-10 9 M -6 -5 L -6 16 M -6 -2 L -4 -4 L -2 -5 L 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -6 6","-9 10 M 6 -5 L 6 16 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-7 6 M -3 -5 L -3 9 M -3 1 L -2 -2 L 0 -4 L 2 -5 L 5 -5","-8 9 M 6 -2 L 5 -4 L 2 -5 L -1 -5 L -4 -4 L -5 -2 L -4 0 L -2 1 L 3 2 L 5 3 L 6 5 L 6 6 L 5 8 L 2 9 L -1 9 L -4 8 L -5 6","-5 7 M 0 -12 L 0 5 L 1 8 L 3 9 L 5 9 M -3 -5 L 4 -5","-9 10 M -5 -5 L -5 5 L -4 8 L -2 9 L 1 9 L 3 8 L 6 5 M 6 -5 L 6 9","-8 8 M -6 -5 L 0 9 M 6 -5 L 0 9","-11 11 M -8 -5 L -4 9 M 0 -5 L -4 9 M 0 -5 L 4 9 M 8 -5 L 4 9","-8 9 M -5 -5 L 6 9 M 6 -5 L -5 9","-8 8 M -6 -5 L 0 9 M 6 -5 L 0 9 L -2 13 L -4 15 L -6 16 L -7 16","-8 9 M 6 -5 L -5 9 M -5 -5 L 6 -5 M -5 9 L 6 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-12 13 M 9 5 L 7 5 L 5 4 L 3 2 L 0 -2 L -1 -3 L -3 -4 L -5 -4 L -7 -3 L -8 -1 L -8 1 L -7 3 L -5 4 L -3 4 L -1 3 L 0 2 L 3 -2 L 5 -4 L 7 -5 L 9 -5","-12 13 M 10 1 L 9 3 L 7 4 L 5 4 L 3 3 L 2 2 L -1 -2 L -2 -3 L -4 -4 L -6 -4 L -8 -3 L -9 -1 L -9 1 L -8 3 L -6 4 L -4 4 L -2 3 L -1 2 L 2 -2 L 3 -3 L 5 -4 L 7 -4 L 9 -3 L 10 -1 L 10 1","-7 7 M -1 -12 L -3 -11 L -4 -9 L -4 -7 L -3 -5 L -1 -4 L 1 -4 L 3 -5 L 4 -7 L 4 -9 L 3 -11 L 1 -12 L -1 -12","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-13 9 M -10 -5 L -6 -5 L 0 7 M -7 -5 L 0 9 M 9 -16 L 0 9","-17 16 M -14 -5 L -9 -5 L 0 7 M -10 -4 L 0 9 M 16 -24 L 0 9","-12 12 M 8 -8 L 1 -8 L -3 -7 L -5 -6 L -7 -4 L -8 -1 L -8 1 L -7 4 L -5 6 L -3 7 L 1 8 L 8 8","-12 12 M -8 -8 L -8 -1 L -7 3 L -6 5 L -4 7 L -1 8 L 1 8 L 4 7 L 6 5 L 7 3 L 8 -1 L 8 -8","-12 12 M -8 -8 L -1 -8 L 3 -7 L 5 -6 L 7 -4 L 8 -1 L 8 1 L 7 4 L 5 6 L 3 7 L -1 8 L -8 8","-12 12 M -8 8 L -8 1 L -7 -3 L -6 -5 L -4 -7 L -1 -8 L 1 -8 L 4 -7 L 6 -5 L 7 -3 L 8 1 L 8 8","-12 12 M 8 -8 L 1 -8 L -3 -7 L -5 -6 L -7 -4 L -8 -1 L -8 1 L -7 4 L -5 6 L -3 7 L 1 8 L 8 8 M -8 0 L 4 0","-13 13 M 6 -2 L 9 0 L 6 2 M 3 -5 L 8 0 L 3 5 M -9 0 L 8 0","-8 8 M -2 -6 L 0 -9 L 2 -6 M -5 -3 L 0 -8 L 5 -3 M 0 -8 L 0 9","-13 13 M -6 -2 L -9 0 L -6 2 M -3 -5 L -8 0 L -3 5 M -8 0 L 9 0","-8 8 M -2 6 L 0 9 L 2 6 M -5 3 L 0 8 L 5 3 M 0 -9 L 0 8","-9 10 M 6 0 L 5 -3 L 4 -4 L 2 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 6 L 6 3 L 7 -2 L 7 -7 L 6 -10 L 5 -11 L 3 -12 L 0 -12 L -2 -11 L -3 -10 L -3 -9 L -2 -9 L -2 -10 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8 M 0 9 L 2 8 L 4 6 L 5 3 L 6 -2 L 6 -7 L 5 -10 L 3 -12","-10 10 M -8 -12 L 0 9 M -7 -12 L 0 7 M 8 -12 L 0 9 M -8 -12 L 8 -12 M -7 -11 L 7 -11","-17 16 M -14 -5 L -9 -5 L 0 7 M -10 -4 L 0 9 M 16 -24 L 0 9","-12 12 M 9 -15 L 8 -14 L 9 -13 L 10 -14 L 10 -15 L 9 -16 L 7 -16 L 5 -15 L 3 -13 L 2 -11 L 1 -8 L 0 -4 L -2 8 L -3 12 L -4 14 M 4 -14 L 3 -12 L 2 -8 L 0 4 L -1 8 L -2 11 L -3 13 L -5 15 L -7 16 L -9 16 L -10 15 L -10 14 L -9 13 L -8 14 L -9 15","-15 15 M 11 -36 L 10 -36 L 9 -35 L 9 -34 L 10 -33 L 11 -33 L 12 -34 L 12 -36 L 11 -38 L 9 -39 L 7 -39 L 5 -38 L 3 -36 L 2 -34 L 1 -31 L 0 -24 L -1 -8 L -1 24 L -2 33 L -3 36 M 10 -35 L 10 -34 L 11 -34 L 11 -35 L 10 -35 M 0 -24 L 0 24 M 3 -36 L 2 -33 L 1 -24 L 1 8 L 0 24 L -1 31 L -2 34 L -3 36 L -5 38 L -7 39 L -9 39 L -11 38 L -12 36 L -12 34 L -11 33 L -10 33 L -9 34 L -9 35 L -10 36 L -11 36 M -11 34 L -11 35 L -10 35 L -10 34 L -11 34","-9 9 M 6 -39 L 3 -33 L 0 -26 L -2 -21 L -3 -17 L -4 -12 L -5 -4 L -5 4 L -4 12 L -3 17 L -2 21 L 0 26 L 3 33 L 6 39 M 3 -33 L 1 -28 L -1 -22 L -2 -18 L -3 -12 L -4 -4 L -4 4 L -3 12 L -2 18 L -1 22 L 1 28 L 3 33","-9 9 M -6 -39 L -3 -33 L 0 -26 L 2 -21 L 3 -17 L 4 -12 L 5 -4 L 5 4 L 4 12 L 3 17 L 2 21 L 0 26 L -3 33 L -6 39 M -3 -33 L -1 -28 L 1 -22 L 2 -18 L 3 -12 L 4 -4 L 4 4 L 3 12 L 2 18 L 1 22 L -1 28 L -3 33","-9 9 M -5 -39 L -5 0 L -5 39 M -4 -39 L -4 0 L -4 39 M -5 -39 L 6 -39 M -5 39 L 6 39","-9 9 M 4 -39 L 4 0 L 4 39 M 5 -39 L 5 0 L 5 39 M -6 -39 L 5 -39 M -6 39 L 5 39","-9 10 M 6 -12 L 6 9 M -7 -12 L 6 -12 M -2 -2 L 6 -2 M -7 9 L 6 9","-10 10 M -7 -9 L -6 -7 L 6 5 L 7 7 L 7 9 M -6 -6 L 6 6 M -7 -9 L -7 -7 L -6 -5 L 6 7 L 7 9 M -2 -2 L -6 2 L -7 4 L -7 6 L -6 8 L -7 9 M -7 4 L -5 8 M -6 2 L -6 4 L -5 6 L -5 8 L -7 9 M 1 1 L 6 -4 M 4 -9 L 4 -6 L 5 -4 L 7 -4 L 7 -6 L 5 -7 L 4 -9 M 4 -9 L 5 -6 L 7 -4","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 0 L 9 0 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-7 7 M -3 -16 L -3 16 M 3 -16 L 3 16","-12 12 M 0 -16 L 0 9 M -9 9 L 9 9","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-12 12 M 9 -16 L -9 9 L 9 9","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 7 L -10 8 L -9 9 L -8 8 L -9 7 M 9 7 L 8 8 L 9 9 L 10 8 L 9 7","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3"]
mathupp = ["-8 8","-12 12 M 0 -8 L 0 9 M -8 0 L 8 0 M -8 9 L 8 9","-12 12 M 0 -8 L 0 9 M -8 -8 L 8 -8 M -8 0 L 8 0","-11 11 M -7 -7 L 7 7 M 7 -7 L -7 7","-2 3 M 0 -1 L 0 0 L 1 0 L 1 -1 L 0 -1","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-12 12 M 8 -12 L -8 -5 L 8 2 M -8 4 L 8 4 M -8 9 L 8 9","-12 12 M -8 -12 L 8 -5 L -8 2 M -8 4 L 8 4 M -8 9 L 8 9","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16 M 2 -14 L 0 -10 L -1 -7 L -2 -2 L -2 2 L -1 7 L 0 10 L 2 14","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 M -2 -14 L 0 -10 L 1 -7 L 2 -2 L 2 2 L 1 7 L 0 10 L -2 14","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-5 5 M 1 8 L 0 9 L -1 8 L 0 7 L 1 8 L 1 10 L 0 12 L -1 13","-13 13 M -9 0 L 9 0","-5 5 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L 0 -4 L 3 -4 L 5 -3 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 3 -12 L -7 2 L 8 2 M 3 -12 L 3 9","-10 10 M 5 -12 L -5 -12 L -6 -3 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2","-10 10 M 7 -12 L -3 9 M -7 -12 L 7 -12","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 1 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -1 -3 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6","-17 17 M -10 -16 L -10 16 M -9 -16 L -9 16 M 9 -16 L 9 16 M 10 -16 L 10 16 M -14 -16 L 14 -16 M -14 16 L -5 16 M 5 16 L 14 16","-16 15 M -11 -16 L -1 -2 L -12 16 M -12 -16 L -2 -2 M -13 -16 L -2 -1 M -13 -16 L 10 -16 L 12 -9 L 9 -16 M -11 15 L 10 15 M -12 16 L 10 16 L 12 9 L 9 16","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-13 13 M 7 -9 L -7 9 M -9 -3 L 9 -3 M -9 3 L 9 3","-13 13 M -9 -5 L 9 -5 M -9 0 L 9 0 M -9 5 L 9 5","-9 9 M 0 -12 L -8 9 M 0 -12 L 8 9 M -5 2 L 5 2","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 M -7 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -7 9","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4","-11 10 M -7 -12 L -7 9 M -7 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 3 8 L 0 9 L -7 9","-10 9 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2 M -6 9 L 7 9","-10 8 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4 L 8 1 M 3 1 L 8 1","-11 11 M -7 -12 L -7 9 M 7 -12 L 7 9 M -7 -2 L 7 -2","-4 4 M 0 -12 L 0 9","-8 8 M 4 -12 L 4 4 L 3 7 L 2 8 L 0 9 L -2 9 L -4 8 L -5 7 L -6 4 L -6 2","-11 10 M -7 -12 L -7 9 M 7 -12 L -7 2 M -2 -3 L 7 9","-10 7 M -6 -12 L -6 9 M -6 9 L 6 9","-12 12 M -8 -12 L -8 9 M -8 -12 L 0 9 M 8 -12 L 0 9 M 8 -12 L 8 9","-11 11 M -7 -12 L -7 9 M -7 -12 L 7 9 M 7 -12 L 7 9","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 2 -1 L -7 -1","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12 M 1 5 L 7 11","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 L -7 -2 M 0 -2 L 7 9","-10 10 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-8 8 M 0 -12 L 0 9 M -7 -12 L 7 -12","-11 11 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -12","-9 9 M -8 -12 L 0 9 M 8 -12 L 0 9","-12 12 M -10 -12 L -5 9 M 0 -12 L -5 9 M 0 -12 L 5 9 M 10 -12 L 5 9","-10 10 M -7 -12 L 7 9 M 7 -12 L -7 9","-9 9 M -8 -12 L 0 -2 L 0 9 M 8 -12 L 0 -2","-10 10 M 7 -12 L -7 9 M -7 -12 L 7 -12 M -7 9 L 7 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-12 13 M 9 5 L 7 5 L 5 4 L 3 2 L 0 -2 L -1 -3 L -3 -4 L -5 -4 L -7 -3 L -8 -1 L -8 1 L -7 3 L -5 4 L -3 4 L -1 3 L 0 2 L 3 -2 L 5 -4 L 7 -5 L 9 -5","-12 13 M 10 1 L 9 3 L 7 4 L 5 4 L 3 3 L 2 2 L -1 -2 L -2 -3 L -4 -4 L -6 -4 L -8 -3 L -9 -1 L -9 1 L -8 3 L -6 4 L -4 4 L -2 3 L -1 2 L 2 -2 L 3 -3 L 5 -4 L 7 -4 L 9 -3 L 10 -1 L 10 1","-7 7 M -1 -12 L -3 -11 L -4 -9 L -4 -7 L -3 -5 L -1 -4 L 1 -4 L 3 -5 L 4 -7 L 4 -9 L 3 -11 L 1 -12 L -1 -12","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 9 M -10 -5 L -6 -5 L 0 7 M -7 -5 L 0 9 M 9 -16 L 0 9","-17 16 M -14 -5 L -9 -5 L 0 7 M -10 -4 L 0 9 M 16 -24 L 0 9","-12 12 M 8 -8 L 1 -8 L -3 -7 L -5 -6 L -7 -4 L -8 -1 L -8 1 L -7 4 L -5 6 L -3 7 L 1 8 L 8 8","-12 12 M -8 -8 L -8 -1 L -7 3 L -6 5 L -4 7 L -1 8 L 1 8 L 4 7 L 6 5 L 7 3 L 8 -1 L 8 -8","-12 12 M -8 -8 L -1 -8 L 3 -7 L 5 -6 L 7 -4 L 8 -1 L 8 1 L 7 4 L 5 6 L 3 7 L -1 8 L -8 8","-12 12 M -8 8 L -8 1 L -7 -3 L -6 -5 L -4 -7 L -1 -8 L 1 -8 L 4 -7 L 6 -5 L 7 -3 L 8 1 L 8 8","-12 12 M 8 -8 L 1 -8 L -3 -7 L -5 -6 L -7 -4 L -8 -1 L -8 1 L -7 4 L -5 6 L -3 7 L 1 8 L 8 8 M -8 0 L 4 0","-13 13 M 6 -2 L 9 0 L 6 2 M 3 -5 L 8 0 L 3 5 M -9 0 L 8 0","-8 8 M -2 -6 L 0 -9 L 2 -6 M -5 -3 L 0 -8 L 5 -3 M 0 -8 L 0 9","-13 13 M -6 -2 L -9 0 L -6 2 M -3 -5 L -8 0 L -3 5 M -8 0 L 9 0","-8 8 M -2 6 L 0 9 L 2 6 M -5 3 L 0 8 L 5 3 M 0 -9 L 0 8","-9 10 M 6 0 L 5 -3 L 4 -4 L 2 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 6 L 6 3 L 7 -2 L 7 -7 L 6 -10 L 5 -11 L 3 -12 L 0 -12 L -2 -11 L -3 -10 L -3 -9 L -2 -9 L -2 -10 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8 M 0 9 L 2 8 L 4 6 L 5 3 L 6 -2 L 6 -7 L 5 -10 L 3 -12","-10 10 M -8 -12 L 0 9 M -7 -12 L 0 7 M 8 -12 L 0 9 M -8 -12 L 8 -12 M -7 -11 L 7 -11","-17 16 M -14 -5 L -9 -5 L 0 7 M -10 -4 L 0 9 M 16 -24 L 0 9","-12 12 M 9 -15 L 8 -14 L 9 -13 L 10 -14 L 10 -15 L 9 -16 L 7 -16 L 5 -15 L 3 -13 L 2 -11 L 1 -8 L 0 -4 L -2 8 L -3 12 L -4 14 M 4 -14 L 3 -12 L 2 -8 L 0 4 L -1 8 L -2 11 L -3 13 L -5 15 L -7 16 L -9 16 L -10 15 L -10 14 L -9 13 L -8 14 L -9 15","-15 15 M 11 -36 L 10 -36 L 9 -35 L 9 -34 L 10 -33 L 11 -33 L 12 -34 L 12 -36 L 11 -38 L 9 -39 L 7 -39 L 5 -38 L 3 -36 L 2 -34 L 1 -31 L 0 -24 L -1 -8 L -1 24 L -2 33 L -3 36 M 10 -35 L 10 -34 L 11 -34 L 11 -35 L 10 -35 M 0 -24 L 0 24 M 3 -36 L 2 -33 L 1 -24 L 1 8 L 0 24 L -1 31 L -2 34 L -3 36 L -5 38 L -7 39 L -9 39 L -11 38 L -12 36 L -12 34 L -11 33 L -10 33 L -9 34 L -9 35 L -10 36 L -11 36 M -11 34 L -11 35 L -10 35 L -10 34 L -11 34","-9 9 M 6 -39 L 3 -33 L 0 -26 L -2 -21 L -3 -17 L -4 -12 L -5 -4 L -5 4 L -4 12 L -3 17 L -2 21 L 0 26 L 3 33 L 6 39 M 3 -33 L 1 -28 L -1 -22 L -2 -18 L -3 -12 L -4 -4 L -4 4 L -3 12 L -2 18 L -1 22 L 1 28 L 3 33","-9 9 M -6 -39 L -3 -33 L 0 -26 L 2 -21 L 3 -17 L 4 -12 L 5 -4 L 5 4 L 4 12 L 3 17 L 2 21 L 0 26 L -3 33 L -6 39 M -3 -33 L -1 -28 L 1 -22 L 2 -18 L 3 -12 L 4 -4 L 4 4 L 3 12 L 2 18 L 1 22 L -1 28 L -3 33","-9 9 M -5 -39 L -5 0 L -5 39 M -4 -39 L -4 0 L -4 39 M -5 -39 L 6 -39 M -5 39 L 6 39","-9 9 M 4 -39 L 4 0 L 4 39 M 5 -39 L 5 0 L 5 39 M -6 -39 L 5 -39 M -6 39 L 5 39","-9 10 M 6 -12 L 6 9 M -7 -12 L 6 -12 M -2 -2 L 6 -2 M -7 9 L 6 9","-10 10 M -7 -9 L -6 -7 L 6 5 L 7 7 L 7 9 M -6 -6 L 6 6 M -7 -9 L -7 -7 L -6 -5 L 6 7 L 7 9 M -2 -2 L -6 2 L -7 4 L -7 6 L -6 8 L -7 9 M -7 4 L -5 8 M -6 2 L -6 4 L -5 6 L -5 8 L -7 9 M 1 1 L 6 -4 M 4 -9 L 4 -6 L 5 -4 L 7 -4 L 7 -6 L 5 -7 L 4 -9 M 4 -9 L 5 -6 L 7 -4","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 0 L 9 0 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-7 7 M -3 -16 L -3 16 M 3 -16 L 3 16","-12 12 M 0 -16 L 0 9 M -9 9 L 9 9","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-12 12 M 9 -16 L -9 9 L 9 9","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 7 L -10 8 L -9 9 L -8 8 L -9 7 M 9 7 L 8 8 L 9 9 L 10 8 L 9 7","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3"]
meteorology = ["-8 8","-2 1 M 1 0 L 0 1 L -1 1 L -2 0 L -2 -1 L -1 -2 L 0 -2 L 1 -1 L 1 1 L 0 3 L -1 4 M -1 -1 L -1 0 L 0 0 L 0 -1 L -1 -1","-2 2 M -1 -2 L -2 -1 L -2 1 L -1 2 L 1 2 L 2 1 L 2 -1 L 1 -2 L -1 -2 M 0 -1 L -1 0 L 0 1 L 1 0 L 0 -1","-4 4 M -2 -3 L 2 3 M 2 -3 L -2 3 M -4 0 L 4 0","-5 5 M 0 -7 L -1 -5 L -3 -2 L -5 0 M 0 -7 L 1 -5 L 3 -2 L 5 0 M 0 -5 L -3 -1 M 0 -5 L 3 -1 M 0 -3 L -2 -1 M 0 -3 L 2 -1 M -1 -1 L 1 -1 M -5 0 L 5 0","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-5 5 M -5 0 L -5 -1 L -4 -3 L -3 -4 L -1 -5 L 1 -5 L 3 -4 L 4 -3 L 5 -1 L 5 0 M -2 -4 L 2 -4 M -3 -3 L 3 -3 M -4 -2 L 4 -2 M -4 -1 L 4 -1 M -5 0 L 5 0","-6 0 M -6 -12 L -6 0 L 0 0 L -6 -12 M -6 -9 L -2 -1 M -6 -6 L -3 0 M -6 -3 L -5 -1","-5 5 M 0 -7 L -1 -5 L -3 -2 L -5 0 M 0 -7 L 1 -5 L 3 -2 L 5 0","-5 5 M 5 0 L 5 -1 L 4 -3 L 3 -4 L 1 -5 L -1 -5 L -3 -4 L -4 -3 L -5 -1 L -5 0","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-11 11 M 11 0 L 11 -2 L 10 -5 L 8 -8 L 5 -10 L 2 -11 L -2 -11 L -5 -10 L -8 -8 L -10 -5 L -11 -2 L -11 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9","-10 10 M -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 3 -1 L -7 9 L 7 9","-10 10 M -5 -12 L 6 -12 L 0 -4 L 3 -4 L 5 -3 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 3 -12 L -7 2 L 8 2 M 3 -12 L 3 9","-10 10 M 5 -12 L -5 -12 L -6 -3 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5","-10 10 M 6 -9 L 5 -11 L 2 -12 L 0 -12 L -3 -11 L -5 -8 L -6 -3 L -6 2 L -5 6 L -3 8 L 0 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2","-10 10 M 7 -12 L -3 9 M -7 -12 L 7 -12","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 1 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 2 L -6 0 L -4 -2 L -1 -3 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 2 -12 L -2 -12","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -5 L 6 0 L 5 5 L 3 8 L 0 9 L -2 9 L -5 8 L -6 6","-5 5 M -5 0 L -5 1 L -4 3 L -3 4 L -1 5 L 1 5 L 3 4 L 4 3 L 5 1 L 5 0","-6 6 M -6 -2 L -4 0 L -1 1 L 1 1 L 4 0 L 6 -2","0 3 M 0 3 L 2 2 L 3 0 L 2 -2 L 0 -3","0 4 M 0 0 L 3 -2 L 4 -4 L 4 -6 L 3 -7 L 2 -7","-4 0 M 0 0 L -3 -2 L -4 -4 L -4 -6 L -3 -7 L -2 -7","-9 9 M -5 -8 L -4 -7 L -5 -6 L -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 1 -12 L 3 -11 L 4 -10 L 5 -8 L 5 -6 L 4 -4 L 2 -2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-9 9 M 0 -12 L -8 9 M 0 -12 L 8 9 M -5 2 L 5 2","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 M -7 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -7 9","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4","-11 10 M -7 -12 L -7 9 M -7 -12 L 0 -12 L 3 -11 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 3 8 L 0 9 L -7 9","-10 9 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2 M -6 9 L 7 9","-10 8 M -6 -12 L -6 9 M -6 -12 L 7 -12 M -6 -2 L 2 -2","-10 11 M 8 -7 L 7 -9 L 5 -11 L 3 -12 L -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 L 3 9 L 5 8 L 7 6 L 8 4 L 8 1 M 3 1 L 8 1","-11 11 M -7 -12 L -7 9 M 7 -12 L 7 9 M -7 -2 L 7 -2","-4 4 M 0 -12 L 0 9","-8 8 M 4 -12 L 4 4 L 3 7 L 2 8 L 0 9 L -2 9 L -4 8 L -5 7 L -6 4 L -6 2","-11 10 M -7 -12 L -7 9 M 7 -12 L -7 2 M -2 -3 L 7 9","-10 7 M -6 -12 L -6 9 M -6 9 L 6 9","-12 12 M -8 -12 L -8 9 M -8 -12 L 0 9 M 8 -12 L 0 9 M 8 -12 L 8 9","-11 11 M -7 -12 L -7 9 M -7 -12 L 7 9 M 7 -12 L 7 9","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 2 -1 L -7 -1","-11 11 M -2 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -2 9 L 2 9 L 4 8 L 6 6 L 7 4 L 8 1 L 8 -4 L 7 -7 L 6 -9 L 4 -11 L 2 -12 L -2 -12 M 1 5 L 7 11","-11 10 M -7 -12 L -7 9 M -7 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 2 -2 L -7 -2 M 0 -2 L 7 9","-10 10 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-8 8 M 0 -12 L 0 9 M -7 -12 L 7 -12","-11 11 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -12","-9 9 M -8 -12 L 0 9 M 8 -12 L 0 9","-12 12 M -10 -12 L -5 9 M 0 -12 L -5 9 M 0 -12 L 5 9 M 10 -12 L 5 9","-10 10 M -7 -12 L 7 9 M 7 -12 L -7 9","-9 9 M -8 -12 L 0 -2 L 0 9 M 8 -12 L 0 -2","-10 10 M 7 -12 L -7 9 M -7 -12 L 7 -12 M -7 9 L 7 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-10 10 M 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 1 L 7 3 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6","-11 11 M 0 0 L 2 3 L 3 4 L 5 5 L 7 5 L 9 4 L 10 3 L 11 1 L 11 -1 L 10 -3 L 9 -4 L 7 -5 L 5 -5 L 3 -4 L 2 -3 L -2 3 L -3 4 L -5 5 L -7 5 L -9 4 L -10 3 L -11 1 L -11 -1 L -10 -3 L -9 -4 L -7 -5 L -5 -5 L -3 -4 L -2 -3 L 0 0","-11 11 M -9 5 L -10 4 L -11 2 L -11 -1 L -10 -3 L -9 -4 L -7 -5 L -5 -5 L -3 -4 L -2 -3 L 2 3 L 3 4 L 5 5 L 7 5 L 9 4 L 10 3 L 11 1 L 11 -2 L 10 -4 L 9 -5","-9 10 M 6 -5 L 6 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-10 9 M -6 -12 L -6 9 M -6 -2 L -4 -4 L -2 -5 L 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -6 6","-9 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 10 M 6 -12 L 6 9 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 9 M -6 1 L 6 1 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-5 7 M 5 -12 L 3 -12 L 1 -11 L 0 -8 L 0 9 M -3 -5 L 4 -5","-9 10 M 6 -5 L 6 11 L 5 14 L 4 15 L 2 16 L -1 16 L -3 15 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-9 10 M -5 -12 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9","-4 4 M -1 -12 L 0 -11 L 1 -12 L 0 -13 L -1 -12 M 0 -5 L 0 9","-5 5 M 0 -12 L 1 -11 L 2 -12 L 1 -13 L 0 -12 M 1 -5 L 1 12 L 0 15 L -2 16 L -4 16","-9 8 M -5 -12 L -5 9 M 5 -5 L -5 5 M -1 1 L 6 9","-4 4 M 0 -12 L 0 9","-15 15 M -11 -5 L -11 9 M -11 -1 L -8 -4 L -6 -5 L -3 -5 L -1 -4 L 0 -1 L 0 9 M 0 -1 L 3 -4 L 5 -5 L 8 -5 L 10 -4 L 11 -1 L 11 9","-9 10 M -5 -5 L -5 9 M -5 -1 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -1 L 6 9","-9 10 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 2 -5 L -1 -5","-10 9 M -6 -5 L -6 16 M -6 -2 L -4 -4 L -2 -5 L 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 L -2 9 L -4 8 L -6 6","-9 10 M 6 -5 L 6 16 M 6 -2 L 4 -4 L 2 -5 L -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 L 2 9 L 4 8 L 6 6","-7 6 M -3 -5 L -3 9 M -3 1 L -2 -2 L 0 -4 L 2 -5 L 5 -5","-8 9 M 6 -2 L 5 -4 L 2 -5 L -1 -5 L -4 -4 L -5 -2 L -4 0 L -2 1 L 3 2 L 5 3 L 6 5 L 6 6 L 5 8 L 2 9 L -1 9 L -4 8 L -5 6","-5 7 M 0 -12 L 0 5 L 1 8 L 3 9 L 5 9 M -3 -5 L 4 -5","-9 10 M -5 -5 L -5 5 L -4 8 L -2 9 L 1 9 L 3 8 L 6 5 M 6 -5 L 6 9","-8 8 M -6 -5 L 0 9 M 6 -5 L 0 9","-11 11 M -8 -5 L -4 9 M 0 -5 L -4 9 M 0 -5 L 4 9 M 8 -5 L 4 9","-8 9 M -5 -5 L 6 9 M 6 -5 L -5 9","-8 8 M -6 -5 L 0 9 M 6 -5 L 0 9 L -2 13 L -4 15 L -6 16 L -7 16","-8 9 M 6 -5 L -5 9 M -5 -5 L 6 -5 M -5 9 L 6 9","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-10 10 M -7 -12 L -7 9 M -10 -12 L 9 -12 L -1 -2 L 9 8 M 8 4 L 9 7 L 10 9 M 8 4 L 8 7 M 5 7 L 8 7 M 5 7 L 8 8 L 10 9","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-7 7 M 3 -17 L 0 -16 L -2 -15 L -4 -13 L -6 -10 L -7 -6 L -7 0 L -6 3 L -4 5 L -1 6 L 1 6 L 4 5 L 6 3 L 7 0 M -7 -2 L -6 -5 L -4 -7 L -1 -8 L 1 -8 L 4 -7 L 6 -5 L 7 -2 L 7 4 L 6 8 L 4 11 L 2 13 L 0 14 L -3 15","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3"]
music = ["-8 8","-5 5 M 0 -12 L -1 -10 L 0 2 L 1 -10 L 0 -12 M 0 -10 L 0 -4 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-8 8 M -5 -2 L -1 0 L 2 2 L 4 4 L 5 7 L 5 9 L 4 11 L 3 12 M -5 -1 L 1 2 M -5 0 L -2 1 L 2 3 L 4 5 L 5 7","-8 8 M 5 -7 L 4 -5 L 2 -3 L -2 -1 L -5 0 M 1 -2 L -5 1 M 3 -12 L 4 -11 L 5 -9 L 5 -7 L 4 -4 L 2 -2 L -1 0 L -5 2","-10 10 M 1 -5 L -3 -4 L -6 -2 L -7 0 L -7 2 L -6 4 L -4 5 L -1 5 L 3 4 L 6 2 L 7 0 L 7 -2 L 6 -4 L 4 -5 L 1 -5 M 6 -4 L 1 -5 M 4 -5 L -1 -4 L -6 -2 M -3 -4 L -7 0 M -6 4 L -1 5 M -4 5 L 1 4 L 6 2 M 3 4 L 7 0","-10 10 M 1 -5 L -3 -4 L -6 -2 L -7 0 L -7 2 L -6 4 L -4 5 L -1 5 L 3 4 L 6 2 L 7 0 L 7 -2 L 6 -4 L 4 -5 L 1 -5 M 6 -4 L 1 -5 M 4 -5 L -1 -4 L -6 -2 M -3 -4 L -7 0 M -6 4 L -1 5 M -4 5 L 1 4 L 6 2 M 3 4 L 7 0","-8 9 M 1 -5 L -2 -4 L -4 -2 L -5 0 L -5 2 L -4 4 L -2 5 L 0 5 L 3 4 L 5 2 L 6 0 L 6 -2 L 5 -4 L 3 -5 L 1 -5 M -3 -2 L 3 -5 M -4 0 L 4 -4 M -5 2 L 5 -3 M -4 3 L 6 -2 M -3 4 L 5 0 M -2 5 L 4 2","-8 8 M -3 -11 L -3 12 M 3 -12 L 3 11 M -5 -4 L 5 -6 M -5 -3 L 5 -5 M -5 5 L 5 3 M -5 6 L 5 4","-8 8 M -4 -12 L -4 6 M 4 -6 L 4 12 M -4 -4 L 4 -6 M -4 -3 L 4 -5 M -4 5 L 4 3 M -4 6 L 4 4","-8 8 M -4 -16 L -4 5 M -4 -4 L -1 -6 L 2 -6 L 4 -5 L 5 -3 L 5 -1 L 4 1 L 1 3 L -1 4 L -4 5 M -4 -4 L -1 -5 L 2 -5 L 4 -4 M 3 -5 L 4 -3 L 4 -1 L 3 1 L 1 3","-13 13 M -10 -9 L -10 -6 M 10 -9 L 10 -6 M -10 -9 L 10 -9 M -10 -8 L 10 -8 M -10 -7 L 10 -7 M -10 -6 L 10 -6","-8 8 M -5 -4 L -5 -1 M 5 -4 L 5 -1 M -5 -4 L 5 -4 M -5 -3 L 5 -3 M -5 -2 L 5 -2 M -5 -1 L 5 -1","-8 8 M -5 -6 L 5 6 M -5 -6 L -3 -4 L -1 -3 L 2 -3 L 4 -4 L 5 -5 L 5 -7 L 3 -7 L 3 -5 L 2 -3 M -3 -4 L 2 -3 M -1 -3 L 5 -5 M 4 -7 L 4 -4 M 3 -6 L 5 -6 M 5 6 L 3 4 L 1 3 L -2 3 L -4 4 L -5 5 L -5 7 L -3 7 L -3 5 L -2 3 M 3 4 L -2 3 M 1 3 L -5 5 M -4 4 L -4 7 M -5 6 L -3 6","-8 8 M -2 -3 L -3 -5 L -3 -7 L -5 -7 L -5 -5 L -4 -4 L -2 -3 L 1 -3 L 3 -4 L 5 -6 M -4 -7 L -4 -4 M -5 -6 L -3 -6 M -5 -5 L 1 -3 M -2 -3 L 3 -4 M 5 -6 L 5 7","-8 8 M -1 -15 L 4 -5 L 0 2 L 0 3 M 3 -6 L -1 1 M 2 -9 L 2 -7 L -2 0 L 0 3 L 3 7 M 5 10 L 3 7 L 1 6 L -1 6 L -3 7 L -4 9 L -4 11 L -3 13 L 0 15 M 5 10 L 3 8 L 1 7 L -3 7 L -3 11 L -2 13 L 0 15 M 1 6 L -2 8 L -4 11","-13 20 M -4 1 L -3 3 L -1 4 L 1 4 L 3 3 L 4 1 L 4 -1 L 3 -3 L 1 -4 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 4 L -4 7 L -2 9 L 1 10 L 4 10 L 7 9 L 9 7 L 10 5 L 11 2 L 11 -2 L 10 -5 L 8 -8 L 6 -9 L 3 -10 L 0 -10 L -3 -9 L -5 -8 L -7 -6 L -9 -3 L -10 1 L -10 6 L -9 11 L -7 15 L -5 17 L -2 19 L 2 20 L 7 20 L 11 19 L 14 17 L 16 15 M -7 -6 L -8 -4 L -9 0 L -9 6 L -8 10 L -6 14 L -4 16 L -1 18 L 3 19 L 7 19 L 11 18 L 13 17 L 16 15 M -2 -3 L 2 -3 M -3 -2 L 3 -2 M -4 -1 L 4 -1 M -4 0 L 4 0 M -4 1 L 4 1 M -3 2 L 3 2 M -2 3 L 2 3 M 15 -6 L 15 -4 L 17 -4 L 17 -6 L 15 -6 M 16 -6 L 16 -4 M 15 -5 L 17 -5 M 15 4 L 15 6 L 17 6 L 17 4 L 15 4 M 16 4 L 16 6 M 15 5 L 17 5","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -4 -10 L -5 -8 L -6 -3 L -6 0 L -5 5 L -4 7 L -3 8 L -1 9 M 1 9 L 3 8 L 4 7 L 5 5 L 6 0 L 6 -3 L 5 -8 L 4 -10 L 3 -11 L 1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9 M 0 -11 L 0 9 M -4 9 L 5 9","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 3 -2 L -2 0 L -4 1 L -6 3 L -7 6 L -7 9 M 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 2 -2 L -2 0 M -7 7 L -6 6 L -4 6 L 1 8 L 4 8 L 6 7 L 7 6 M -4 6 L 1 9 L 5 9 L 6 8 L 7 6 L 7 4","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -9 L 6 -6 L 5 -4 L 2 -3 L -1 -3 M 2 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -4 L 2 -3 M 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 5 -1 L 6 2 L 6 5 L 5 7 L 4 8 L 2 9","-10 10 M 2 -10 L 2 9 M 3 -12 L 3 9 M 3 -12 L -8 3 L 8 3 M -1 9 L 6 9","-10 10 M -5 -12 L -7 -2 M -7 -2 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -5 -12 L 5 -12 M -5 -11 L 0 -11 L 5 -12","-10 10 M 5 -9 L 4 -8 L 5 -7 L 6 -8 L 6 -9 L 5 -11 L 3 -12 L 0 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2 M 0 -12 L -2 -11 L -4 -9 L -5 -7 L -6 -3 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 2 L 5 -1 L 3 -3 L 1 -4","-10 10 M -7 -12 L -7 -6 M -7 -8 L -6 -10 L -4 -12 L -2 -12 L 3 -9 L 5 -9 L 6 -10 L 7 -12 M -6 -10 L -4 -11 L -2 -11 L 3 -9 M 7 -12 L 7 -9 L 6 -6 L 2 -1 L 1 1 L 0 4 L 0 9 M 6 -6 L 1 -1 L 0 1 L -1 4 L -1 9","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -6 L -5 -4 L -2 -3 L 2 -3 L 5 -4 L 6 -6 L 6 -9 L 5 -11 L 2 -12 L -2 -12 M -2 -12 L -4 -11 L -5 -9 L -5 -6 L -4 -4 L -2 -3 M 2 -3 L 4 -4 L 5 -6 L 5 -9 L 4 -11 L 2 -12 M -2 -3 L -5 -2 L -6 -1 L -7 1 L -7 5 L -6 7 L -5 8 L -2 9 L 2 9 L 5 8 L 6 7 L 7 5 L 7 1 L 6 -1 L 5 -2 L 2 -3 M -2 -3 L -4 -2 L -5 -1 L -6 1 L -6 5 L -5 7 L -4 8 L -2 9 M 2 9 L 4 8 L 5 7 L 6 5 L 6 1 L 5 -1 L 4 -2 L 2 -3","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -6 L 7 0 L 6 4 L 5 6 L 3 8 L 0 9 L -3 9 L -5 8 L -6 6 L -6 5 L -5 4 L -4 5 L -5 6 M -1 1 L -3 0 L -5 -2 L -6 -5 L -6 -6 L -5 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 5 -9 L 6 -6 L 6 0 L 5 4 L 4 6 L 2 8 L 0 9","-5 5 M 0 -5 L -1 -4 L 0 -3 L 1 -4 L 0 -5 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-17 12 M -11 20 L -10 20 L -9 19 L -9 18 L -10 17 L -11 17 L -12 18 L -12 20 L -11 22 L -9 23 L -7 23 L -4 22 L -2 20 L -1 18 L 0 14 L 0 3 L -1 -23 L -1 -30 L 0 -35 L 1 -37 L 3 -38 L 4 -38 L 6 -37 L 7 -35 L 7 -31 L 6 -28 L 5 -26 L 3 -23 L -2 -19 L -8 -15 L -10 -13 L -12 -10 L -13 -8 L -14 -4 L -14 0 L -13 4 L -11 7 L -8 9 L -4 10 L 0 10 L 4 9 L 6 8 L 8 5 L 9 2 L 9 -2 L 8 -5 L 7 -7 L 5 -9 L 2 -10 L -2 -10 L -5 -9 L -7 -7 L -8 -4 L -8 0 L -7 3 L -5 5 M -11 18 L -11 19 L -10 19 L -10 18 L -11 18 M 3 -23 L -1 -19 L -6 -15 L -9 -12 L -11 -9 L -12 -7 L -13 -4 L -13 0 L -12 4 L -11 6 L -8 9 M 0 10 L 3 9 L 5 8 L 7 5 L 8 2 L 8 -2 L 7 -5 L 6 -7 L 4 -9 L 2 -10","-13 20 M -4 1 L -3 3 L -1 4 L 1 4 L 3 3 L 4 1 L 4 -1 L 3 -3 L 1 -4 L -1 -4 L -3 -3 L -4 -2 L -5 1 L -5 4 L -4 7 L -2 9 L 1 10 L 4 10 L 7 9 L 9 7 L 10 5 L 11 2 L 11 -2 L 10 -5 L 8 -8 L 6 -9 L 3 -10 L 0 -10 L -3 -9 L -5 -8 L -7 -6 L -9 -3 L -10 1 L -10 6 L -9 11 L -7 15 L -5 17 L -2 19 L 2 20 L 7 20 L 11 19 L 14 17 L 16 15 M -7 -6 L -8 -4 L -9 0 L -9 6 L -8 10 L -6 14 L -4 16 L -1 18 L 3 19 L 7 19 L 11 18 L 13 17 L 16 15 M -2 -3 L 2 -3 M -3 -2 L 3 -2 M -4 -1 L 4 -1 M -4 0 L 4 0 M -4 1 L 4 1 M -3 2 L 3 2 M -2 3 L 2 3 M 15 -6 L 15 -4 L 17 -4 L 17 -6 L 15 -6 M 16 -6 L 16 -4 M 15 -5 L 17 -5 M 15 4 L 15 6 L 17 6 L 17 4 L 15 4 M 16 4 L 16 6 M 15 5 L 17 5","-9 24 M -4 -1 L -3 -3 L -1 -4 L 1 -4 L 3 -3 L 4 -1 L 4 1 L 3 3 L 1 4 L -1 4 L -3 3 L -4 2 L -5 -1 L -5 -4 L -4 -7 L -2 -9 L 1 -10 L 5 -10 L 9 -9 L 12 -7 L 14 -4 L 15 0 L 15 5 L 14 9 L 13 11 L 11 14 L 8 17 L 4 20 L -1 23 L -5 25 M 5 -10 L 8 -9 L 11 -7 L 13 -4 L 14 0 L 14 5 L 13 9 L 12 11 L 10 14 L 7 17 L 2 21 L -1 23 M -2 -3 L 2 -3 M -3 -2 L 3 -2 M -4 -1 L 4 -1 M -4 0 L 4 0 M -4 1 L 4 1 M -3 2 L 3 2 M -2 3 L 2 3 M 19 -6 L 19 -4 L 21 -4 L 21 -6 L 19 -6 M 20 -6 L 20 -4 M 19 -5 L 21 -5 M 19 4 L 19 6 L 21 6 L 21 4 L 19 4 M 20 4 L 20 6 M 19 5 L 21 5","-14 14 M -10 -18 L -10 18 M -5 -18 L -5 18 M 5 -18 L 5 18 M 10 -18 L 10 18 M -5 -5 L 5 -7 M -5 -4 L 5 -6 M -5 -3 L 5 -5 M -5 5 L 5 3 M -5 6 L 5 4 M -5 7 L 5 5","-14 14 M -10 -20 L -10 20 M -9 -20 L -9 20 M -5 -20 L -5 20 M -1 -16 L 1 -16 L 1 -14 L -1 -14 L -1 -17 L 0 -19 L 2 -20 L 5 -20 L 7 -19 L 9 -17 L 10 -14 L 10 -9 L 9 -6 L 7 -4 L 5 -3 L 3 -3 L 1 -4 L 0 -6 L -1 -4 L -3 -1 L -4 0 L -3 1 L -1 4 L 0 6 L 1 4 L 3 3 L 5 3 L 7 4 L 9 6 L 10 9 L 10 14 L 9 17 L 7 19 L 5 20 L 2 20 L 0 19 L -1 17 L -1 14 L 1 14 L 1 16 L -1 16 M 0 -16 L 0 -14 M -1 -15 L 1 -15 M 7 -19 L 8 -17 L 9 -14 L 9 -9 L 8 -6 L 7 -4 M 0 -6 L 0 -4 L -2 -1 L -4 0 L -2 1 L 0 4 L 0 6 M 7 4 L 8 6 L 9 9 L 9 14 L 8 17 L 7 19 M 0 14 L 0 16 M -1 15 L 1 15","-8 8 M -5 -4 L -5 -1 M 5 -4 L 5 -1 M -5 -4 L 5 -4 M -5 -3 L 5 -3 M -5 -2 L 5 -2 M -5 -1 L 5 -1","-10 10 M 3 -12 L -10 9 M 3 -12 L 4 9 M 2 -10 L 3 9 M -6 3 L 3 3 M -12 9 L -6 9 M 0 9 L 6 9","-12 12 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 7 -3 L 4 -2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -4 L 6 -3 L 4 -2 M -5 -2 L 4 -2 L 6 -1 L 7 1 L 7 3 L 6 6 L 4 8 L 0 9 L -12 9 M 4 -2 L 5 -1 L 6 1 L 6 3 L 5 6 L 3 8 L 0 9","-10 11 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -2 9 L 1 9 L 3 8 L 5 6 L 6 4 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -4 8 L -2 9","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -7 L 8 -3 L 7 1 L 5 5 L 3 7 L 1 8 L -3 9 L -12 9 M 3 -12 L 5 -11 L 6 -10 L 7 -7 L 7 -3 L 6 1 L 4 5 L 2 7 L 0 8 L -3 9","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M 2 -6 L 0 2 M -6 -12 L 9 -12 L 8 -6 L 8 -12 M -5 -2 L 1 -2 M -12 9 L 3 9 L 5 4 L 2 9","-12 10 M -3 -12 L -9 9 M -2 -12 L -8 9 M 2 -6 L 0 2 M -6 -12 L 9 -12 L 8 -6 L 8 -12 M -5 -2 L 1 -2 M -12 9 L -5 9","-10 12 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -2 9 L 0 9 L 3 8 L 5 6 L 7 2 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -4 8 L -2 9 M 0 9 L 2 8 L 4 6 L 6 2 M 3 2 L 10 2","-13 13 M -4 -12 L -10 9 M -3 -12 L -9 9 M 9 -12 L 3 9 M 10 -12 L 4 9 M -7 -12 L 0 -12 M 6 -12 L 13 -12 M -6 -2 L 6 -2 M -13 9 L -6 9 M 0 9 L 7 9","-6 7 M 3 -12 L -3 9 M 4 -12 L -2 9 M 0 -12 L 7 -12 M -6 9 L 1 9","-9 9 M 6 -12 L 1 5 L 0 7 L -1 8 L -3 9 L -5 9 L -7 8 L -8 6 L -8 4 L -7 3 L -6 4 L -7 5 M 5 -12 L 0 5 L -1 7 L -3 9 M 2 -12 L 9 -12","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M 11 -12 L -6 1 M 1 -3 L 5 9 M 0 -3 L 4 9 M -6 -12 L 1 -12 M 7 -12 L 13 -12 M -12 9 L -5 9 M 1 9 L 7 9","-10 10 M -1 -12 L -7 9 M 0 -12 L -6 9 M -4 -12 L 3 -12 M -10 9 L 5 9 L 7 3 L 4 9","-13 14 M -4 -12 L -10 9 M -4 -12 L -3 9 M -3 -12 L -2 7 M 10 -12 L -3 9 M 10 -12 L 4 9 M 11 -12 L 5 9 M -7 -12 L -3 -12 M 10 -12 L 14 -12 M -13 9 L -7 9 M 1 9 L 8 9","-12 13 M -3 -12 L -9 9 M -3 -12 L 4 6 M -3 -9 L 4 9 M 10 -12 L 4 9 M -6 -12 L -3 -12 M 7 -12 L 13 -12 M -12 9 L -6 9","-11 11 M 1 -12 L -2 -11 L -4 -9 L -6 -6 L -7 -3 L -8 1 L -8 4 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -4 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 6 -12 L 9 -11 L 10 -9 L 10 -7 L 9 -4 L 7 -2 L 3 -1 L -5 -1 M 6 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 6 -2 L 3 -1 M -12 9 L -5 9","-11 11 M 1 -12 L -2 -11 L -4 -9 L -6 -6 L -7 -3 L -8 1 L -8 4 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -4 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12 M -6 7 L -6 6 L -5 4 L -3 3 L -2 3 L 0 4 L 1 6 L 1 13 L 2 14 L 4 14 L 5 12 L 5 11 M 1 6 L 2 12 L 3 13 L 4 13 L 5 12","-12 12 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 7 -3 L 4 -2 L -5 -2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -4 L 6 -3 L 4 -2 M 0 -2 L 2 -1 L 3 0 L 4 8 L 5 9 L 7 9 L 8 7 L 8 6 M 3 0 L 5 7 L 6 8 L 7 8 L 8 7 M -12 9 L -5 9","-11 12 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -7 L -4 -5 L -3 -4 L 4 0 L 6 2 M -5 -7 L -3 -5 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 3 L -9 9 L -8 7 L -7 7","-10 11 M 3 -12 L -3 9 M 4 -12 L -2 9 M -3 -12 L -6 -6 L -4 -12 L 11 -12 L 10 -6 L 10 -12 M -6 9 L 1 9","-12 13 M -4 -12 L -7 -1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 3 8 L 5 6 L 6 3 L 10 -12 M -3 -12 L -6 -1 L -7 3 L -7 6 L -6 8 L -4 9 M -7 -12 L 0 -12 M 7 -12 L 13 -12","-10 10 M -4 -12 L -3 9 M -3 -12 L -2 7 M 10 -12 L -3 9 M -6 -12 L 0 -12 M 6 -12 L 12 -12","-13 13 M -5 -12 L -7 9 M -4 -12 L -6 7 M 3 -12 L -7 9 M 3 -12 L 1 9 M 4 -12 L 2 7 M 11 -12 L 1 9 M -8 -12 L -1 -12 M 8 -12 L 14 -12","-11 11 M -4 -12 L 3 9 M -3 -12 L 4 9 M 10 -12 L -10 9 M -6 -12 L 0 -12 M 6 -12 L 12 -12 M -12 9 L -6 9 M 0 9 L 6 9","-10 11 M -4 -12 L 0 -2 L -3 9 M -3 -12 L 1 -2 L -2 9 M 11 -12 L 1 -2 M -6 -12 L 0 -12 M 7 -12 L 13 -12 M -6 9 L 1 9","-11 11 M 9 -12 L -10 9 M 10 -12 L -9 9 M -3 -12 L -6 -6 L -4 -12 L 10 -12 M -10 9 L 4 9 L 6 3 L 3 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-6 6 M 2 -12 L -3 -6 M 2 -12 L 3 -11 L -3 -6","-13 13 M -9 0 L 9 0","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-10 11 M 6 -5 L 4 2 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 7 -5 L 5 2 L 4 6 L 4 8 L 5 9 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8","-10 9 M -2 -12 L -6 1 L -6 4 L -5 7 L -4 8 M -1 -12 L -5 1 M -5 1 L -4 -2 L -2 -4 L 0 -5 L 2 -5 L 4 -4 L 5 -3 L 6 -1 L 6 2 L 5 5 L 3 8 L 0 9 L -2 9 L -4 8 L -5 5 L -5 1 M 4 -4 L 5 -2 L 5 2 L 4 5 L 2 8 L 0 9 M -5 -12 L -1 -12","-9 9 M 5 -2 L 5 -1 L 6 -1 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8","-10 11 M 8 -12 L 4 2 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 9 -12 L 5 2 L 4 6 L 4 8 L 5 9 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8 M 5 -12 L 9 -12","-9 9 M -5 4 L -1 3 L 2 2 L 5 0 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 6 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8","-7 8 M 8 -11 L 7 -10 L 8 -9 L 9 -10 L 9 -11 L 8 -12 L 6 -12 L 4 -11 L 3 -10 L 2 -8 L 1 -5 L -2 9 L -3 13 L -4 15 M 6 -12 L 4 -10 L 3 -8 L 2 -4 L 0 5 L -1 9 L -2 12 L -3 14 L -4 15 L -6 16 L -8 16 L -9 15 L -9 14 L -8 13 L -7 14 L -8 15 M -3 -5 L 7 -5","-10 10 M 7 -5 L 3 9 L 2 12 L 0 15 L -3 16 L -6 16 L -8 15 L -9 14 L -9 13 L -8 12 L -7 13 L -8 14 M 6 -5 L 2 9 L 1 12 L -1 15 L -3 16 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8","-10 11 M -2 -12 L -8 9 M -1 -12 L -7 9 M -5 2 L -3 -2 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -3 L 6 -1 L 4 5 L 4 8 L 5 9 M 3 -5 L 5 -3 L 5 -1 L 3 5 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M -5 -12 L -1 -12","-6 7 M 3 -12 L 2 -11 L 3 -10 L 4 -11 L 3 -12 M -5 -1 L -4 -3 L -2 -5 L 1 -5 L 2 -4 L 2 -1 L 0 5 L 0 8 L 1 9 M 0 -5 L 1 -4 L 1 -1 L -1 5 L -1 8 L 0 9 L 3 9 L 5 7 L 6 5","-6 7 M 4 -12 L 3 -11 L 4 -10 L 5 -11 L 4 -12 M -4 -1 L -3 -3 L -1 -5 L 2 -5 L 3 -4 L 3 -1 L 0 9 L -1 12 L -2 14 L -3 15 L -5 16 L -7 16 L -8 15 L -8 14 L -7 13 L -6 14 L -7 15 M 1 -5 L 2 -4 L 2 -1 L -1 9 L -2 12 L -3 14 L -5 16","-10 10 M -2 -12 L -8 9 M -1 -12 L -7 9 M 6 -4 L 5 -3 L 6 -2 L 7 -3 L 7 -4 L 6 -5 L 5 -5 L 3 -4 L -1 0 L -3 1 L -5 1 M -3 1 L -1 2 L 1 8 L 2 9 M -3 1 L -2 2 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5 M -5 -12 L -1 -12","-5 7 M 3 -12 L -1 2 L -2 6 L -2 8 L -1 9 L 2 9 L 4 7 L 5 5 M 4 -12 L 0 2 L -1 6 L -1 8 L 0 9 M 0 -12 L 4 -12","-17 16 M -16 -1 L -15 -3 L -13 -5 L -10 -5 L -9 -4 L -9 -2 L -10 2 L -12 9 M -11 -5 L -10 -4 L -10 -2 L -11 2 L -13 9 M -10 2 L -8 -2 L -6 -4 L -4 -5 L -2 -5 L 0 -4 L 1 -3 L 1 -1 L -2 9 M -2 -5 L 0 -3 L 0 -1 L -3 9 M 0 2 L 2 -2 L 4 -4 L 6 -5 L 8 -5 L 10 -4 L 11 -3 L 11 -1 L 9 5 L 9 8 L 10 9 M 8 -5 L 10 -3 L 10 -1 L 8 5 L 8 8 L 9 9 L 12 9 L 14 7 L 15 5","-12 11 M -11 -1 L -10 -3 L -8 -5 L -5 -5 L -4 -4 L -4 -2 L -5 2 L -7 9 M -6 -5 L -5 -4 L -5 -2 L -6 2 L -8 9 M -5 2 L -3 -2 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -3 L 6 -1 L 4 5 L 4 8 L 5 9 M 3 -5 L 5 -3 L 5 -1 L 3 5 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5","-9 9 M 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 L 6 2 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L 0 -5 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8 M 0 9 L 2 8 L 4 5 L 5 2 L 5 -2 L 4 -4","-11 10 M -10 -1 L -9 -3 L -7 -5 L -4 -5 L -3 -4 L -3 -2 L -4 2 L -8 16 M -5 -5 L -4 -4 L -4 -2 L -5 2 L -9 16 M -4 2 L -3 -1 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -3 L 7 -1 L 7 2 L 6 5 L 4 8 L 1 9 L -1 9 L -3 8 L -4 5 L -4 2 M 5 -4 L 6 -2 L 6 2 L 5 5 L 3 8 L 1 9 M -12 16 L -5 16","-10 10 M 6 -5 L 0 16 M 7 -5 L 1 16 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8 M -3 16 L 4 16","-9 8 M -8 -1 L -7 -3 L -5 -5 L -2 -5 L -1 -4 L -1 -2 L -2 2 L -4 9 M -3 -5 L -2 -4 L -2 -2 L -3 2 L -5 9 M -2 2 L 0 -2 L 2 -4 L 4 -5 L 6 -5 L 7 -4 L 7 -3 L 6 -2 L 5 -3 L 6 -4","-8 9 M 6 -3 L 6 -2 L 7 -2 L 7 -3 L 6 -4 L 3 -5 L 0 -5 L -3 -4 L -4 -3 L -4 -1 L -3 0 L 4 4 L 5 5 M -4 -2 L -3 -1 L 4 3 L 5 4 L 5 7 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -6 6 L -5 6 L -5 7","-7 7 M 2 -12 L -2 2 L -3 6 L -3 8 L -2 9 L 1 9 L 3 7 L 4 5 M 3 -12 L -1 2 L -2 6 L -2 8 L -1 9 M -4 -5 L 5 -5","-12 11 M -11 -1 L -10 -3 L -8 -5 L -5 -5 L -4 -4 L -4 -1 L -6 5 L -6 7 L -4 9 M -6 -5 L -5 -4 L -5 -1 L -7 5 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 2 6 L 4 2 M 6 -5 L 4 2 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 7 -5 L 5 2 L 4 6 L 4 8 L 5 9","-10 10 M -9 -1 L -8 -3 L -6 -5 L -3 -5 L -2 -4 L -2 -1 L -4 5 L -4 7 L -2 9 M -4 -5 L -3 -4 L -3 -1 L -5 5 L -5 7 L -4 8 L -2 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 -1 L 7 -5 L 6 -5 L 7 -3","-15 14 M -14 -1 L -13 -3 L -11 -5 L -8 -5 L -7 -4 L -7 -1 L -9 5 L -9 7 L -7 9 M -9 -5 L -8 -4 L -8 -1 L -10 5 L -10 7 L -9 8 L -7 9 L -5 9 L -3 8 L -1 6 L 0 4 M 2 -5 L 0 4 L 0 7 L 1 8 L 3 9 L 5 9 L 7 8 L 9 6 L 10 4 L 11 0 L 11 -5 L 10 -5 L 11 -3 M 3 -5 L 1 4 L 1 7 L 3 9","-10 10 M -7 -1 L -5 -4 L -3 -5 L 0 -5 L 1 -3 L 1 0 M -1 -5 L 0 -3 L 0 0 L -1 4 L -2 6 L -4 8 L -6 9 L -7 9 L -8 8 L -8 7 L -7 6 L -6 7 L -7 8 M -1 4 L -1 7 L 0 9 L 3 9 L 5 8 L 7 5 M 7 -4 L 6 -3 L 7 -2 L 8 -3 L 8 -4 L 7 -5 L 6 -5 L 4 -4 L 2 -2 L 1 0 L 0 4 L 0 7 L 1 9","-11 10 M -10 -1 L -9 -3 L -7 -5 L -4 -5 L -3 -4 L -3 -1 L -5 5 L -5 7 L -3 9 M -5 -5 L -4 -4 L -4 -1 L -6 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 6 L 5 2 M 8 -5 L 4 9 L 3 12 L 1 15 L -2 16 L -5 16 L -7 15 L -8 14 L -8 13 L -7 12 L -6 13 L -7 14 M 7 -5 L 3 9 L 2 12 L 0 15 L -2 16","-10 10 M 7 -5 L 6 -3 L 4 -1 L -4 5 L -6 7 L -7 9 M -6 -1 L -5 -3 L -3 -5 L 0 -5 L 4 -3 M -5 -3 L -3 -4 L 0 -4 L 4 -3 L 6 -3 M -6 7 L -4 7 L 0 8 L 3 8 L 5 7 M -4 7 L 0 9 L 3 9 L 5 7 L 6 5","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
scriptc = ["-8 8","-5 6 M 3 -12 L 2 -11 L 0 1 M 3 -11 L 0 1 M 3 -12 L 4 -11 L 0 1 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-9 9 M -2 -12 L -4 -5 M -1 -12 L -4 -5 M 7 -12 L 5 -5 M 8 -12 L 5 -5","-10 11 M 1 -12 L -6 16 M 7 -12 L 0 16 M -6 -1 L 8 -1 M -7 5 L 7 5","-10 11 M 2 -16 L -6 13 M 7 -16 L -1 13 M 8 -8 L 7 -7 L 8 -6 L 9 -7 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -7 L -4 -5 L -3 -4 L 4 0 L 6 2 M -5 -7 L -3 -5 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 10 -4 L 9 -3 L 10 -2 L 11 -3 L 11 -4 L 10 -5 L 9 -5 L 7 -4 L 5 -2 L 0 6 L -2 8 L -4 9 L -7 9 L -10 8 L -11 6 L -11 4 L -10 2 L -9 1 L -7 0 L -2 -2 L 0 -3 L 2 -5 L 3 -7 L 3 -9 L 2 -11 L 0 -12 L -2 -11 L -3 -9 L -3 -6 L -2 0 L -1 3 L 1 6 L 3 8 L 5 9 L 7 9 L 8 7 L 8 6 M -7 9 L -9 8 L -10 6 L -10 4 L -9 2 L -8 1 L -2 -2 M -3 -6 L -2 -1 L -1 2 L 1 5 L 3 7 L 5 8 L 7 8 L 8 7","-5 6 M 3 -10 L 2 -11 L 3 -12 L 4 -11 L 4 -10 L 3 -8 L 1 -6","-7 8 M 8 -16 L 4 -13 L 1 -10 L -1 -7 L -3 -3 L -4 2 L -4 6 L -3 11 L -2 14 L -1 16 M 4 -13 L 1 -9 L -1 -5 L -2 -2 L -3 3 L -3 8 L -2 13 L -1 16","-8 7 M 1 -16 L 2 -14 L 3 -11 L 4 -6 L 4 -2 L 3 3 L 1 7 L -1 10 L -4 13 L -8 16 M 1 -16 L 2 -13 L 3 -8 L 3 -3 L 2 2 L 1 5 L -1 9 L -4 13","-8 9 M 2 -12 L 2 0 M -3 -9 L 7 -3 M 7 -9 L -3 -3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-5 6 M -2 9 L -3 8 L -2 7 L -1 8 L -1 9 L -2 11 L -4 13","-13 13 M -9 0 L 9 0","-5 6 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-11 11 M 13 -16 L -13 16","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -3 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12","-10 11 M 2 -8 L -3 9 M 4 -12 L -2 9 M 4 -12 L 1 -9 L -2 -7 L -4 -6 M 3 -9 L -1 -7 L -4 -6","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 5 -3 L 2 -1 L -2 1 L -5 3 L -7 5 L -9 9 M 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 L -2 1 M -8 7 L -7 6 L -5 6 L 0 8 L 3 8 L 5 7 L 6 5 M -5 6 L 0 9 L 3 9 L 5 8 L 6 5","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 4 -3 L 1 -2 M 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 M -1 -2 L 1 -2 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5 M 1 -2 L 3 -1 L 4 0 L 5 2 L 5 5 L 4 7 L 3 8 L 1 9","-10 11 M 6 -11 L 0 9 M 7 -12 L 1 9 M 7 -12 L -8 3 L 8 3","-10 11 M -1 -12 L -6 -2 M -1 -12 L 9 -12 M -1 -11 L 4 -11 L 9 -12 M -6 -2 L -5 -3 L -2 -4 L 1 -4 L 4 -3 L 5 -2 L 6 0 L 6 3 L 5 6 L 3 8 L 0 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5 M 1 -4 L 3 -3 L 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 L 0 9","-10 11 M 7 -9 L 6 -8 L 7 -7 L 8 -8 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 5 L -6 7 L -5 8 L -3 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 1 L 5 -1 L 4 -2 L 2 -3 L -1 -3 L -3 -2 L -5 0 L -6 2 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 6 L -5 8 M 0 9 L 2 8 L 4 6 L 5 4 L 5 0 L 4 -2","-10 11 M -4 -12 L -6 -6 M 9 -12 L 8 -9 L 6 -6 L 1 0 L -1 3 L -2 5 L -3 9 M 6 -6 L 0 0 L -2 3 L -3 5 L -4 9 M -5 -9 L -2 -12 L 0 -12 L 5 -9 M -4 -10 L -2 -11 L 0 -11 L 5 -9 L 7 -9 L 8 -10 L 9 -12","-10 11 M 1 -12 L -2 -11 L -3 -10 L -4 -8 L -4 -5 L -3 -3 L -1 -2 L 2 -2 L 6 -3 L 7 -4 L 8 -6 L 8 -9 L 7 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -2 -10 L -3 -8 L -3 -5 L -2 -3 L -1 -2 M 2 -2 L 5 -3 L 6 -4 L 7 -6 L 7 -9 L 6 -11 L 4 -12 M -1 -2 L -5 -1 L -7 1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 4 8 L 5 7 L 6 5 L 6 2 L 5 0 L 4 -1 L 2 -2 M -1 -2 L -4 -1 L -6 1 L -7 3 L -7 6 L -6 8 L -4 9 M 0 9 L 3 8 L 4 7 L 5 5 L 5 1 L 4 -1","-10 11 M 7 -5 L 6 -3 L 4 -1 L 2 0 L -1 0 L -3 -1 L -4 -2 L -5 -4 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 4 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -4 L 7 0 L 6 3 L 4 6 L 2 8 L -1 9 L -4 9 L -6 8 L -7 6 L -7 5 L -6 4 L -5 5 L -6 6 M -3 -1 L -4 -3 L -4 -7 L -3 -9 L -1 -11 L 1 -12 M 6 -11 L 7 -9 L 7 -4 L 6 0 L 5 3 L 3 6 L 1 8 L -1 9","-5 6 M 1 -5 L 0 -4 L 1 -3 L 2 -4 L 1 -5 M -2 7 L -3 8 L -2 9 L -1 8","-5 6 M 1 -5 L 0 -4 L 1 -3 L 2 -4 L 1 -5 M -2 9 L -3 8 L -2 7 L -1 8 L -1 9 L -2 11 L -4 13","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 1 -2 L -1 -1 L -1 1 L 0 2 L 2 2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-13 10 M 6 -12 L 4 -10 L 2 -7 L -1 -2 L -3 1 L -6 5 L -9 8 L -11 9 L -13 9 L -14 8 L -14 6 L -13 5 L -12 6 L -13 7 M 6 -12 L 5 -8 L 3 2 L 2 9 M 6 -12 L 3 9 M 2 9 L 2 7 L 1 4 L 0 2 L -2 0 L -4 -1 L -6 -1 L -7 0 L -7 2 L -6 5 L -3 8 L 0 9 L 4 9 L 6 8","-12 12 M 3 -11 L 2 -10 L 1 -8 L -1 -3 L -3 3 L -4 5 L -6 8 L -8 9 M 2 -10 L 1 -7 L -1 1 L -2 4 L -3 6 L -5 8 L -8 9 L -10 9 L -11 8 L -11 6 L -10 5 L -9 6 L -10 7 M -3 -6 L -4 -4 L -5 -3 L -7 -3 L -8 -4 L -8 -6 L -7 -8 L -5 -10 L -3 -11 L 0 -12 L 6 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 6 -4 L 2 -3 L 0 -3 M 6 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 M 2 -3 L 5 -2 L 6 -1 L 7 1 L 7 4 L 6 7 L 5 8 L 3 9 L 1 9 L 0 8 L 0 6 L 1 3 M 2 -3 L 4 -2 L 5 -1 L 6 1 L 6 4 L 5 7 L 3 9","-10 11 M -7 -10 L -8 -8 L -8 -6 L -7 -4 L -4 -3 L -1 -3 L 3 -4 L 5 -5 L 7 -7 L 8 -9 L 8 -11 L 7 -12 L 5 -12 L 2 -11 L -1 -8 L -3 -5 L -5 -1 L -6 3 L -6 6 L -5 8 L -2 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 2 L 5 0 L 3 0 L 1 1 L 0 3 M 5 -12 L 3 -11 L 0 -8 L -2 -5 L -4 -1 L -5 3 L -5 6 L -4 8 L -2 9","-12 11 M 3 -11 L 2 -10 L 1 -8 L -1 -3 L -3 3 L -4 5 L -6 8 L -8 9 M 2 -10 L 1 -7 L -1 1 L -2 4 L -3 6 L -5 8 L -8 9 L -10 9 L -11 8 L -11 6 L -10 5 L -8 5 L -6 6 L -4 8 L -2 9 L 1 9 L 3 8 L 5 6 L 7 2 L 8 -3 L 8 -6 L 7 -9 L 5 -11 L 3 -12 L -2 -12 L -5 -11 L -7 -9 L -8 -7 L -8 -5 L -7 -4 L -5 -4 L -4 -5 L -3 -7","-9 10 M 5 -9 L 4 -8 L 4 -6 L 5 -5 L 7 -5 L 8 -7 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L 0 -11 L -1 -10 L -2 -8 L -2 -6 L -1 -4 L 1 -3 M 2 -12 L 0 -10 L -1 -8 L -1 -5 L 1 -3 M 1 -3 L -1 -3 L -4 -2 L -6 0 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 2 L 5 0 L 3 0 L 1 1 L 0 3 M -1 -3 L -3 -2 L -5 0 L -6 2 L -6 6 L -5 8","-11 10 M 5 -10 L 4 -8 L 2 -3 L 0 3 L -1 5 L -3 8 L -5 9 M -1 -6 L -2 -4 L -4 -3 L -6 -3 L -7 -5 L -7 -7 L -6 -9 L -4 -11 L -1 -12 L 9 -12 L 6 -11 L 5 -10 L 4 -7 L 2 1 L 1 4 L 0 6 L -2 8 L -5 9 L -7 9 L -9 8 L -10 7 L -10 6 L -9 5 L -8 6 L -9 7 M 1 -12 L 5 -11 L 6 -11 M -3 1 L -2 0 L 0 -1 L 4 -1 L 6 -2 L 8 -5 L 6 2","-11 11 M -8 -9 L -9 -7 L -9 -5 L -8 -3 L -6 -2 L -3 -2 L 0 -3 L 2 -4 L 5 -7 L 6 -10 L 6 -11 L 5 -12 L 4 -12 L 2 -11 L 0 -9 L -1 -7 L -2 -4 L -2 -1 L -1 1 L 1 2 L 3 2 L 5 1 L 7 -1 L 8 -3 M 5 -12 L 3 -11 L 1 -9 L 0 -7 L -1 -4 L -1 0 L 1 2 M 8 -3 L 7 1 L 5 5 L 3 7 L 1 8 L -3 9 L -6 9 L -8 8 L -9 6 L -9 5 L -8 4 L -7 5 L -8 6 M 7 1 L 5 4 L 3 6 L 0 8 L -3 9","-12 12 M -6 -6 L -7 -7 L -7 -9 L -6 -11 L -3 -12 L 0 -12 L -3 -1 L -5 5 L -6 7 L -7 8 L -9 9 L -11 9 L -12 8 L -12 6 L -11 5 L -10 6 L -11 7 M 0 -12 L -3 -3 L -4 0 L -6 5 L -7 7 L -9 9 M -8 2 L -7 1 L -5 0 L 4 -3 L 6 -4 L 9 -6 L 11 -8 L 12 -10 L 12 -11 L 11 -12 L 10 -12 L 8 -11 L 6 -8 L 5 -6 L 3 0 L 2 4 L 2 7 L 4 9 L 5 9 L 7 8 L 9 6 M 10 -12 L 8 -10 L 6 -6 L 4 0 L 3 4 L 3 7 L 4 9","-9 7 M 5 -10 L 3 -7 L 1 -2 L -1 3 L -2 5 L -4 8 L -6 9 M 7 -6 L 5 -4 L 2 -3 L -1 -3 L -3 -4 L -4 -6 L -4 -8 L -3 -10 L -1 -11 L 3 -12 L 7 -12 L 5 -10 L 4 -8 L 2 -2 L 0 4 L -1 6 L -3 8 L -6 9 L -8 9 L -9 8 L -9 6 L -8 5 L -7 6 L -8 7","-9 8 M 7 -12 L 5 -10 L 3 -7 L 1 -2 L -2 7 L -4 11 M 7 -5 L 5 -3 L 2 -2 L -1 -2 L -3 -3 L -4 -5 L -4 -7 L -3 -9 L -1 -11 L 3 -12 L 7 -12 L 5 -9 L 4 -7 L 1 2 L -1 6 L -2 8 L -4 11 L -5 12 L -7 13 L -8 12 L -8 10 L -7 8 L -5 6 L -3 5 L 0 4 L 4 3","-12 12 M -6 -6 L -7 -7 L -7 -9 L -5 -11 L -2 -12 L 0 -12 L -3 -1 L -5 5 L -6 7 L -7 8 L -9 9 L -11 9 L -12 8 L -12 6 L -11 5 L -10 6 L -11 7 M 0 -12 L -3 -3 L -4 0 L -6 5 L -7 7 L -9 9 M 8 -11 L 5 -7 L 3 -5 L 1 -4 L -2 -3 M 11 -11 L 10 -10 L 11 -9 L 12 -10 L 12 -11 L 11 -12 L 10 -12 L 8 -11 L 5 -6 L 4 -5 L 2 -4 L -2 -3 M -2 -3 L 1 -2 L 2 0 L 3 7 L 4 9 M -2 -3 L 0 -2 L 1 0 L 2 7 L 4 9 L 5 9 L 7 8 L 9 6","-9 9 M -5 -9 L -6 -7 L -6 -5 L -5 -3 L -3 -2 L 0 -2 L 3 -3 L 5 -4 L 8 -7 L 9 -10 L 9 -11 L 8 -12 L 7 -12 L 5 -11 L 4 -10 L 2 -7 L -2 3 L -3 5 L -5 8 L -7 9 M 4 -10 L 2 -6 L 0 1 L -1 4 L -2 6 L -4 8 L -7 9 L -9 9 L -10 8 L -10 6 L -9 5 L -7 5 L -5 6 L -2 8 L 0 9 L 3 9 L 5 8 L 7 6","-14 14 M 0 -12 L -4 -3 L -7 3 L -9 6 L -11 8 L -13 9 L -15 9 L -16 8 L -16 6 L -15 5 L -14 6 L -15 7 M 0 -12 L -2 -5 L -3 -1 L -4 4 L -4 8 L -2 9 M 0 -12 L -1 -8 L -2 -3 L -3 4 L -3 8 L -2 9 M 9 -12 L 5 -3 L 0 6 L -2 9 M 9 -12 L 7 -5 L 6 -1 L 5 4 L 5 8 L 7 9 L 8 9 L 10 8 L 12 6 M 9 -12 L 8 -8 L 7 -3 L 6 4 L 6 8 L 7 9","-11 12 M 0 -12 L -1 -8 L -3 -2 L -5 3 L -6 5 L -8 8 L -10 9 L -12 9 L -13 8 L -13 6 L -12 5 L -11 6 L -12 7 M 0 -12 L 0 -7 L 1 4 L 2 9 M 0 -12 L 1 -7 L 2 4 L 2 9 M 14 -11 L 13 -10 L 14 -9 L 15 -10 L 15 -11 L 14 -12 L 12 -12 L 10 -11 L 8 -8 L 7 -6 L 5 -1 L 3 5 L 2 9","-10 11 M 1 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -4 L -7 0 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 1 L 8 -3 L 8 -7 L 7 -10 L 6 -11 L 5 -11 L 3 -10 L 1 -8 L -1 -4 L -2 1 L -2 4 M -1 -11 L -3 -8 L -5 -4 L -6 0 L -6 4 L -5 7 L -3 9","-12 11 M 3 -11 L 2 -10 L 1 -8 L -1 -3 L -3 3 L -4 5 L -6 8 L -8 9 M 2 -10 L 1 -7 L -1 1 L -2 4 L -3 6 L -5 8 L -8 9 L -10 9 L -11 8 L -11 6 L -10 5 L -9 6 L -10 7 M -3 -6 L -4 -4 L -5 -3 L -7 -3 L -8 -4 L -8 -6 L -7 -8 L -5 -10 L -3 -11 L 0 -12 L 4 -12 L 7 -11 L 8 -10 L 9 -8 L 9 -5 L 8 -3 L 7 -2 L 4 -1 L 2 -1 L 0 -2 M 4 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 4 -1","-10 11 M 3 -8 L 3 -6 L 2 -4 L 1 -3 L -1 -2 L -3 -2 L -4 -4 L -4 -6 L -3 -9 L -1 -11 L 2 -12 L 5 -12 L 7 -11 L 8 -9 L 8 -5 L 7 -2 L 5 1 L 1 5 L -2 7 L -4 8 L -7 9 L -9 9 L -10 8 L -10 6 L -9 5 L -7 5 L -5 6 L -2 8 L 1 9 L 4 9 L 6 8 L 8 6 M 5 -12 L 6 -11 L 7 -9 L 7 -5 L 6 -2 L 4 1 L 1 4 L -3 7 L -7 9","-12 12 M 3 -11 L 2 -10 L 1 -8 L -1 -3 L -3 3 L -4 5 L -6 8 L -8 9 M 2 -10 L 1 -7 L -1 1 L -2 4 L -3 6 L -5 8 L -8 9 L -10 9 L -11 8 L -11 6 L -10 5 L -9 6 L -10 7 M -3 -6 L -4 -4 L -5 -3 L -7 -3 L -8 -4 L -8 -6 L -7 -8 L -5 -10 L -3 -11 L 0 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 4 -3 L 0 -3 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 M 0 -3 L 3 -2 L 4 0 L 5 7 L 6 9 M 0 -3 L 2 -2 L 3 0 L 4 7 L 6 9 L 7 9 L 9 8 L 11 6","-10 10 M -4 -9 L -5 -7 L -5 -5 L -4 -3 L -2 -2 L 1 -2 L 4 -3 L 6 -4 L 9 -7 L 10 -10 L 10 -11 L 9 -12 L 8 -12 L 6 -11 L 5 -10 L 4 -8 L 3 -5 L 1 2 L 0 5 L -2 8 L -4 9 M 4 -8 L 3 -4 L 2 3 L 1 6 L -1 8 L -4 9 L -7 9 L -9 8 L -10 6 L -10 5 L -9 4 L -8 5 L -9 6","-9 9 M 7 -10 L 6 -8 L 4 -3 L 2 3 L 1 5 L -1 8 L -3 9 M 1 -6 L 0 -4 L -2 -3 L -4 -3 L -5 -5 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 10 -12 L 8 -11 L 7 -10 L 6 -7 L 4 1 L 3 4 L 2 6 L 0 8 L -3 9 L -5 9 L -7 8 L -8 7 L -8 6 L -7 5 L -6 6 L -7 7 M 3 -12 L 7 -11 L 8 -11","-11 11 M -10 -8 L -8 -11 L -6 -12 L -5 -12 L -3 -10 L -3 -7 L -4 -4 L -7 4 L -7 7 L -6 9 M -5 -12 L -4 -10 L -4 -7 L -7 1 L -8 4 L -8 7 L -6 9 L -4 9 L -2 8 L 1 5 L 3 2 L 4 0 M 8 -12 L 4 0 L 3 4 L 3 7 L 5 9 L 6 9 L 8 8 L 10 6 M 9 -12 L 5 0 L 4 4 L 4 7 L 5 9","-11 10 M -10 -8 L -8 -11 L -6 -12 L -5 -12 L -3 -10 L -3 -7 L -4 -3 L -6 4 L -6 7 L -5 9 M -5 -12 L -4 -10 L -4 -7 L -6 0 L -7 4 L -7 7 L -5 9 L -4 9 L -1 8 L 2 5 L 4 2 L 6 -2 L 7 -5 L 8 -9 L 8 -11 L 7 -12 L 6 -12 L 5 -11 L 4 -9 L 4 -6 L 5 -4 L 7 -2 L 9 -1 L 11 -1","-12 11 M -9 -6 L -10 -6 L -11 -7 L -11 -9 L -10 -11 L -8 -12 L -4 -12 L -5 -10 L -6 -6 L -7 3 L -8 9 M -6 -6 L -6 3 L -7 9 M 4 -12 L 2 -10 L 0 -6 L -3 3 L -5 7 L -7 9 M 4 -12 L 3 -10 L 2 -6 L 1 3 L 0 9 M 2 -6 L 2 3 L 1 9 M 14 -12 L 12 -11 L 10 -9 L 8 -6 L 5 3 L 3 7 L 1 9","-10 10 M -2 -7 L -3 -6 L -5 -6 L -6 -7 L -6 -9 L -5 -11 L -3 -12 L -1 -12 L 1 -11 L 2 -9 L 2 -6 L 1 -2 L -1 3 L -3 6 L -5 8 L -8 9 L -10 9 L -11 8 L -11 6 L -10 5 L -9 6 L -10 7 M -1 -12 L 0 -11 L 1 -9 L 1 -6 L 0 -2 L -2 3 L -4 6 L -6 8 L -8 9 M 11 -11 L 10 -10 L 11 -9 L 12 -10 L 12 -11 L 11 -12 L 9 -12 L 7 -11 L 5 -9 L 3 -6 L 1 -2 L 0 3 L 0 6 L 1 8 L 2 9 L 3 9 L 5 8 L 7 6","-11 11 M -8 -8 L -6 -11 L -4 -12 L -3 -12 L -1 -11 L -1 -9 L -3 -3 L -3 0 L -2 2 M -3 -12 L -2 -11 L -2 -9 L -4 -3 L -4 0 L -2 2 L 0 2 L 3 1 L 5 -1 L 7 -4 L 8 -6 M 10 -12 L 8 -6 L 5 2 L 3 6 M 11 -12 L 9 -6 L 7 -1 L 5 3 L 3 6 L 1 8 L -2 9 L -6 9 L -8 8 L -9 6 L -9 5 L -8 4 L -7 5 L -8 6","-11 10 M 8 -10 L 7 -8 L 5 -3 L 4 0 L 3 2 L 1 5 L -1 7 L -3 8 L -6 9 M 1 -6 L 0 -4 L -2 -3 L -4 -3 L -5 -5 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 11 -12 L 9 -11 L 8 -10 L 7 -7 L 6 -3 L 4 3 L 2 6 L -1 8 L -6 9 L -10 9 L -11 8 L -11 6 L -10 5 L -8 5 L -6 6 L -3 8 L -1 9 L 2 9 L 5 8 L 7 6 M 4 -12 L 8 -11 L 9 -11","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-8 8 M -2 -6 L 0 -9 L 2 -6 M -5 -3 L 0 -8 L 5 -3 M 0 -8 L 0 9","-8 8 M -8 11 L 8 11","-5 6 M 4 -12 L 2 -10 L 1 -8 L 1 -7 L 2 -6 L 3 -7 L 2 -8","-7 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 M -2 0 L -4 2 L -5 4 L -5 7 L -3 9 M 4 0 L 2 6 L 2 8 L 4 9 L 6 8 L 7 7 L 9 4 M 5 0 L 3 6 L 3 8 L 4 9","-6 8 M -6 4 L -4 1 L -2 -3 M 1 -12 L -5 6 L -5 8 L -3 9 L -2 9 L 0 8 L 2 6 L 3 3 L 3 0 L 4 4 L 5 5 L 6 5 L 8 4 M 2 -12 L -4 6 L -4 8 L -3 9","-6 6 M 2 1 L 1 2 L 2 2 L 2 1 L 1 0 L -1 0 L -3 1 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9 L 1 9 L 4 7 L 6 4 M -1 0 L -3 2 L -4 4 L -4 7 L -2 9","-7 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 M -2 0 L -4 2 L -5 4 L -5 7 L -3 9 M 8 -12 L 2 6 L 2 8 L 4 9 L 6 8 L 7 7 L 9 4 M 9 -12 L 3 6 L 3 8 L 4 9","-6 6 M -3 7 L -1 6 L 0 5 L 1 3 L 1 1 L 0 0 L -1 0 L -3 1 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9 L 1 9 L 4 7 L 6 4 M -1 0 L -3 2 L -4 4 L -4 7 L -2 9","-3 6 M 0 0 L 3 -3 L 5 -6 L 6 -9 L 6 -11 L 5 -12 L 3 -11 L 2 -9 L -7 18 L -7 20 L -6 21 L -4 20 L -3 17 L -2 8 L -1 9 L 1 9 L 3 8 L 4 7 L 6 4 M 2 -9 L 1 -4 L 0 0 L -3 9 L -5 14 L -7 18","-7 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 M -2 0 L -4 2 L -5 4 L -5 7 L -3 9 M 4 0 L -2 18 M 5 0 L 2 9 L 0 14 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -3 13 L 0 11 L 4 9 L 7 7 L 9 4","-6 9 M -6 4 L -4 1 L -2 -3 M 1 -12 L -6 9 M 2 -12 L -5 9 M -3 3 L -1 1 L 1 0 L 2 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 M 2 0 L 3 1 L 3 3 L 2 6 L 2 8 L 4 9 L 6 8 L 7 7 L 9 4","-4 4 M 1 -6 L 0 -5 L 1 -4 L 2 -5 L 1 -6 M -1 0 L -3 6 L -3 8 L -1 9 L 1 8 L 2 7 L 4 4 M 0 0 L -2 6 L -2 8 L -1 9","-4 4 M 1 -6 L 0 -5 L 1 -4 L 2 -5 L 1 -6 M -1 0 L -7 18 M 0 0 L -3 9 L -5 14 L -7 18 L -8 20 L -10 21 L -11 20 L -11 18 L -10 15 L -8 13 L -5 11 L -1 9 L 2 7 L 4 4","-6 8 M -6 4 L -4 1 L -2 -3 M 1 -12 L -6 9 M 2 -12 L -5 9 M 3 0 L 3 1 L 4 1 L 3 0 L 2 0 L 0 2 L -3 3 M -3 3 L 0 4 L 1 8 L 2 9 M -3 3 L -1 4 L 0 8 L 2 9 L 3 9 L 6 7 L 8 4","-4 4 M -4 4 L -2 1 L 0 -3 M 3 -12 L -3 6 L -3 8 L -1 9 L 1 8 L 2 7 L 4 4 M 4 -12 L -2 6 L -2 8 L -1 9","-13 12 M -13 4 L -11 1 L -9 0 L -7 1 L -7 3 L -9 9 M -9 0 L -8 1 L -8 3 L -10 9 M -7 3 L -5 1 L -3 0 L -2 0 L 0 1 L 0 3 L -2 9 M -2 0 L -1 1 L -1 3 L -3 9 M 0 3 L 2 1 L 4 0 L 5 0 L 7 1 L 7 3 L 6 6 L 6 8 L 7 9 M 5 0 L 6 1 L 6 3 L 5 6 L 5 8 L 7 9 L 9 8 L 10 7 L 12 4","-9 9 M -9 4 L -7 1 L -5 0 L -3 1 L -3 3 L -5 9 M -5 0 L -4 1 L -4 3 L -6 9 M -3 3 L -1 1 L 1 0 L 2 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 M 2 0 L 3 1 L 3 3 L 2 6 L 2 8 L 4 9 L 6 8 L 7 7 L 9 4","-7 7 M 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 L 3 5 L 3 3 L 2 1 L 0 0 L -1 1 L -1 3 L 0 5 L 2 6 L 4 6 L 6 5 L 7 4 M -2 0 L -4 2 L -5 4 L -5 7 L -3 9","-6 9 M -6 4 L -4 1 L -2 -3 M -1 -6 L -10 21 M 0 -6 L -9 21 M -3 3 L -1 1 L 1 0 L 2 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 M 2 0 L 3 1 L 3 3 L 2 6 L 2 8 L 4 9 L 6 8 L 7 7 L 9 4","-7 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 M -2 0 L -4 2 L -5 4 L -5 7 L -3 9 M 4 0 L -2 18 L -2 20 L -1 21 L 1 20 L 2 17 L 2 9 L 4 9 L 7 7 L 9 4 M 5 0 L 2 9 L 0 14 L -2 18","-6 8 M -6 4 L -4 1 L -2 0 L 0 1 L 0 3 L -2 9 M -2 0 L -1 1 L -1 3 L -3 9 M 0 3 L 2 1 L 4 0 L 5 0 L 4 3 M 4 0 L 4 3 L 5 5 L 6 5 L 8 4","-4 8 M -4 4 L -2 1 L -1 -1 L -1 1 L 2 3 L 3 5 L 3 7 L 2 8 L 0 9 M -1 1 L 1 3 L 2 5 L 2 7 L 0 9 M -4 8 L -2 9 L 3 9 L 6 7 L 8 4","-4 4 M -4 4 L -2 1 L 0 -3 M 3 -12 L -3 6 L -3 8 L -1 9 L 1 8 L 2 7 L 4 4 M 4 -12 L -2 6 L -2 8 L -1 9 M -2 -4 L 4 -4","-7 9 M -4 0 L -6 6 L -6 8 L -4 9 L -3 9 L -1 8 L 1 6 L 3 3 M -3 0 L -5 6 L -5 8 L -4 9 M 4 0 L 2 6 L 2 8 L 4 9 L 6 8 L 7 7 L 9 4 M 5 0 L 3 6 L 3 8 L 4 9","-7 8 M -4 0 L -5 2 L -6 5 L -6 8 L -4 9 L -3 9 L 0 8 L 2 6 L 3 3 L 3 0 M -3 0 L -4 2 L -5 5 L -5 8 L -4 9 M 3 0 L 4 4 L 5 5 L 6 5 L 8 4","-10 11 M -6 0 L -8 2 L -9 5 L -9 8 L -7 9 L -6 9 L -4 8 L -2 6 M -5 0 L -7 2 L -8 5 L -8 8 L -7 9 M 0 0 L -2 6 L -2 8 L 0 9 L 1 9 L 3 8 L 5 6 L 6 3 L 6 0 M 1 0 L -1 6 L -1 8 L 0 9 M 6 0 L 7 4 L 8 5 L 9 5 L 11 4","-8 8 M -8 4 L -6 1 L -4 0 L -2 0 L -1 1 L -1 3 L -2 6 L -3 8 L -5 9 L -6 9 L -7 8 L -7 7 L -6 7 L -7 8 M 5 1 L 4 2 L 5 2 L 5 1 L 4 0 L 3 0 L 1 1 L 0 3 L -1 6 L -1 8 L 0 9 L 3 9 L 6 7 L 8 4 M -1 1 L 0 3 M 1 1 L -1 3 M -2 6 L -1 8 M -1 6 L -3 8","-7 9 M -4 0 L -6 6 L -6 8 L -4 9 L -3 9 L -1 8 L 1 6 L 3 3 M -3 0 L -5 6 L -5 8 L -4 9 M 4 0 L -2 18 M 5 0 L 2 9 L 0 14 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -3 13 L 0 11 L 4 9 L 7 7 L 9 4","-6 7 M -6 4 L -4 1 L -2 0 L 0 0 L 2 1 L 2 4 L 1 6 L -2 8 L -4 9 M 0 0 L 1 1 L 1 4 L 0 6 L -2 8 M -4 9 L -2 10 L -1 12 L -1 15 L -2 18 L -4 20 L -6 21 L -7 20 L -7 18 L -6 15 L -3 12 L 0 10 L 4 7 L 7 4 M -4 9 L -3 10 L -2 12 L -2 15 L -3 18 L -4 20","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-7 8 M 1 -12 L -1 -11 L -2 -9 L -2 -7 L -1 -5 L 1 -4 L 3 -4 L 5 -5 L 6 -7 L 6 -9 L 5 -11 L 3 -12 L 1 -12"]
scripts = ["-8 8","-5 6 M 3 -12 L 2 -11 L 0 1 M 3 -11 L 0 1 M 3 -12 L 4 -11 L 0 1 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-9 9 M -2 -12 L -4 -5 M -1 -12 L -4 -5 M 7 -12 L 5 -5 M 8 -12 L 5 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 11 M 2 -16 L -6 13 M 7 -16 L -1 13 M 8 -8 L 7 -7 L 8 -6 L 9 -7 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -7 L -4 -5 L -3 -4 L 4 0 L 6 2 M -5 -7 L -3 -5 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 10 -4 L 9 -3 L 10 -2 L 11 -3 L 11 -4 L 10 -5 L 9 -5 L 7 -4 L 5 -2 L 0 6 L -2 8 L -4 9 L -7 9 L -10 8 L -11 6 L -11 4 L -10 2 L -9 1 L -7 0 L -2 -2 L 0 -3 L 2 -5 L 3 -7 L 3 -9 L 2 -11 L 0 -12 L -2 -11 L -3 -9 L -3 -6 L -2 0 L -1 3 L 1 6 L 3 8 L 5 9 L 7 9 L 8 7 L 8 6 M -7 9 L -9 8 L -10 6 L -10 4 L -9 2 L -8 1 L -2 -2 M -3 -6 L -2 -1 L -1 2 L 1 5 L 3 7 L 5 8 L 7 8 L 8 7","-5 6 M 3 -10 L 2 -11 L 3 -12 L 4 -11 L 4 -10 L 3 -8 L 1 -6","-7 8 M 8 -16 L 4 -13 L 1 -10 L -1 -7 L -3 -3 L -4 2 L -4 6 L -3 11 L -2 14 L -1 16 M 4 -13 L 1 -9 L -1 -5 L -2 -2 L -3 3 L -3 8 L -2 13 L -1 16","-8 7 M 1 -16 L 2 -14 L 3 -11 L 4 -6 L 4 -2 L 3 3 L 1 7 L -1 10 L -4 13 L -8 16 M 1 -16 L 2 -13 L 3 -8 L 3 -3 L 2 2 L 1 5 L -1 9 L -4 13","-8 9 M 2 -12 L 2 0 M -3 -9 L 7 -3 M 7 -9 L -3 -3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-5 6 M -2 9 L -3 8 L -2 7 L -1 8 L -1 9 L -2 11 L -4 13","-13 13 M -9 0 L 9 0","-5 5 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-11 11 M 13 -16 L -13 16","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -3 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12","-10 11 M 2 -8 L -3 9 M 4 -12 L -2 9 M 4 -12 L 1 -9 L -2 -7 L -4 -6 M 3 -9 L -1 -7 L -4 -6","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 5 -3 L 2 -1 L -2 1 L -5 3 L -7 5 L -9 9 M 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 L -2 1 M -8 7 L -7 6 L -5 6 L 0 8 L 3 8 L 5 7 L 6 5 M -5 6 L 0 9 L 3 9 L 5 8 L 6 5","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 4 -3 L 1 -2 M 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 M -1 -2 L 1 -2 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5 M 1 -2 L 3 -1 L 4 0 L 5 2 L 5 5 L 4 7 L 3 8 L 1 9","-10 11 M 6 -11 L 0 9 M 7 -12 L 1 9 M 7 -12 L -8 3 L 8 3","-10 11 M -1 -12 L -6 -2 M -1 -12 L 9 -12 M -1 -11 L 4 -11 L 9 -12 M -6 -2 L -5 -3 L -2 -4 L 1 -4 L 4 -3 L 5 -2 L 6 0 L 6 3 L 5 6 L 3 8 L 0 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5 M 1 -4 L 3 -3 L 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 L 0 9","-10 11 M 7 -9 L 6 -8 L 7 -7 L 8 -8 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 5 L -6 7 L -5 8 L -3 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 1 L 5 -1 L 4 -2 L 2 -3 L -1 -3 L -3 -2 L -5 0 L -6 2 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 6 L -5 8 M 0 9 L 2 8 L 4 6 L 5 4 L 5 0 L 4 -2","-10 11 M -4 -12 L -6 -6 M 9 -12 L 8 -9 L 6 -6 L 1 0 L -1 3 L -2 5 L -3 9 M 6 -6 L 0 0 L -2 3 L -3 5 L -4 9 M -5 -9 L -2 -12 L 0 -12 L 5 -9 M -4 -10 L -2 -11 L 0 -11 L 5 -9 L 7 -9 L 8 -10 L 9 -12","-10 11 M 1 -12 L -2 -11 L -3 -10 L -4 -8 L -4 -5 L -3 -3 L -1 -2 L 2 -2 L 6 -3 L 7 -4 L 8 -6 L 8 -9 L 7 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -2 -10 L -3 -8 L -3 -5 L -2 -3 L -1 -2 M 2 -2 L 5 -3 L 6 -4 L 7 -6 L 7 -9 L 6 -11 L 4 -12 M -1 -2 L -5 -1 L -7 1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 4 8 L 5 7 L 6 5 L 6 2 L 5 0 L 4 -1 L 2 -2 M -1 -2 L -4 -1 L -6 1 L -7 3 L -7 6 L -6 8 L -4 9 M 0 9 L 3 8 L 4 7 L 5 5 L 5 1 L 4 -1","-10 11 M 7 -5 L 6 -3 L 4 -1 L 2 0 L -1 0 L -3 -1 L -4 -2 L -5 -4 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 4 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -4 L 7 0 L 6 3 L 4 6 L 2 8 L -1 9 L -4 9 L -6 8 L -7 6 L -7 5 L -6 4 L -5 5 L -6 6 M -3 -1 L -4 -3 L -4 -7 L -3 -9 L -1 -11 L 1 -12 M 6 -11 L 7 -9 L 7 -4 L 6 0 L 5 3 L 3 6 L 1 8 L -1 9","-5 6 M 1 -5 L 0 -4 L 1 -3 L 2 -4 L 1 -5 M -2 7 L -3 8 L -2 9 L -1 8","-5 6 M 1 -5 L 0 -4 L 1 -3 L 2 -4 L 1 -5 M -2 9 L -3 8 L -2 7 L -1 8 L -1 9 L -2 11 L -4 13","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 1 -2 L -1 -1 L -1 1 L 0 2 L 2 2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-11 9 M -11 9 L -9 8 L -6 5 L -3 1 L 1 -6 L 4 -12 L 4 9 L 3 6 L 1 3 L -1 1 L -4 -1 L -6 -1 L -7 0 L -7 2 L -6 4 L -4 6 L -1 8 L 2 9 L 7 9","-12 11 M 1 -10 L 2 -9 L 2 -6 L 1 -2 L 0 1 L -1 3 L -3 6 L -5 8 L -7 9 L -8 9 L -9 8 L -9 5 L -8 0 L -7 -3 L -6 -5 L -4 -8 L -2 -10 L 0 -11 L 3 -12 L 6 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 5 -3 L 2 -2 M 1 -2 L 2 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9 L 0 9 L -2 8 L -3 6","-10 10 M 2 -6 L 2 -5 L 3 -4 L 5 -4 L 7 -5 L 8 -7 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -4 L -7 0 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 5 4","-11 12 M 2 -12 L 0 -11 L -1 -9 L -2 -5 L -3 1 L -4 4 L -5 6 L -7 8 L -9 9 L -11 9 L -12 8 L -12 6 L -11 5 L -9 5 L -7 6 L -5 8 L -2 9 L 1 9 L 4 8 L 6 6 L 8 2 L 9 -3 L 9 -7 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L 0 -10 L 0 -8 L 1 -5 L 3 -2 L 5 0 L 8 2 L 10 3","-10 10 M 4 -8 L 4 -7 L 5 -6 L 7 -6 L 8 -7 L 8 -9 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -4 -9 L -4 -6 L -3 -4 L -2 -3 L 1 -2 L -2 -2 L -5 -1 L -6 0 L -7 2 L -7 5 L -6 7 L -5 8 L -2 9 L 1 9 L 4 8 L 6 6 L 7 4","-10 10 M 0 -6 L -2 -6 L -4 -7 L -5 -9 L -4 -11 L -1 -12 L 2 -12 L 6 -11 L 9 -11 L 11 -12 M 6 -11 L 4 -4 L 2 2 L 0 6 L -2 8 L -4 9 L -6 9 L -8 8 L -9 6 L -9 4 L -8 3 L -6 3 L -4 4 M -1 -2 L 8 -2","-11 12 M -11 9 L -9 8 L -5 4 L -2 -1 L -1 -4 L 0 -8 L 0 -11 L -1 -12 L -2 -12 L -3 -11 L -4 -9 L -4 -6 L -3 -4 L -1 -3 L 3 -3 L 6 -4 L 7 -5 L 8 -7 L 8 -1 L 7 4 L 6 6 L 4 8 L 1 9 L -3 9 L -6 8 L -8 6 L -9 4 L -9 2","-12 12 M -5 -5 L -7 -6 L -8 -8 L -8 -9 L -7 -11 L -5 -12 L -4 -12 L -2 -11 L -1 -9 L -1 -7 L -2 -3 L -4 3 L -6 7 L -8 9 L -10 9 L -11 8 L -11 6 M -5 0 L 4 -3 L 6 -4 L 9 -6 L 11 -8 L 12 -10 L 12 -11 L 11 -12 L 10 -12 L 8 -10 L 6 -6 L 4 0 L 3 5 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-9 8 M 5 4 L 3 2 L 1 -1 L 0 -3 L -1 -6 L -1 -9 L 0 -11 L 1 -12 L 3 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -1 L 2 4 L 1 6 L -1 8 L -3 9 L -5 9 L -7 8 L -8 6 L -8 4 L -7 3 L -5 3 L -3 4","-8 7 M 2 12 L 0 9 L -2 4 L -3 -2 L -3 -8 L -2 -11 L 0 -12 L 2 -12 L 3 -11 L 4 -8 L 4 -5 L 3 0 L 0 9 L -2 15 L -3 18 L -4 20 L -6 21 L -7 20 L -7 18 L -6 15 L -4 12 L -2 10 L 1 8 L 5 6","-12 12 M -5 -5 L -7 -6 L -8 -8 L -8 -9 L -7 -11 L -5 -12 L -4 -12 L -2 -11 L -1 -9 L -1 -7 L -2 -3 L -4 3 L -6 7 L -8 9 L -10 9 L -11 8 L -11 6 M 12 -9 L 12 -11 L 11 -12 L 10 -12 L 8 -11 L 6 -9 L 4 -6 L 2 -4 L 0 -3 L -2 -3 M 0 -3 L 1 -1 L 1 6 L 2 8 L 3 9 L 4 9 L 6 8 L 7 7 L 9 4","-9 10 M -5 0 L -3 0 L 1 -1 L 4 -3 L 6 -5 L 7 -7 L 7 -10 L 6 -12 L 4 -12 L 3 -11 L 2 -9 L 1 -4 L 0 1 L -1 4 L -2 6 L -4 8 L -6 9 L -8 9 L -9 8 L -9 6 L -8 5 L -6 5 L -4 6 L -1 8 L 2 9 L 4 9 L 7 8 L 9 6","-18 15 M -13 -5 L -15 -6 L -16 -8 L -16 -9 L -15 -11 L -13 -12 L -12 -12 L -10 -11 L -9 -9 L -9 -7 L -10 -2 L -11 2 L -13 9 M -11 2 L -8 -6 L -6 -10 L -5 -11 L -3 -12 L -2 -12 L 0 -11 L 1 -9 L 1 -7 L 0 -2 L -1 2 L -3 9 M -1 2 L 2 -6 L 4 -10 L 5 -11 L 7 -12 L 8 -12 L 10 -11 L 11 -9 L 11 -7 L 10 -2 L 8 5 L 8 8 L 9 9 L 10 9 L 12 8 L 13 7 L 15 4","-13 11 M -8 -5 L -10 -6 L -11 -8 L -11 -9 L -10 -11 L -8 -12 L -7 -12 L -5 -11 L -4 -9 L -4 -7 L -5 -2 L -6 2 L -8 9 M -6 2 L -3 -6 L -1 -10 L 0 -11 L 2 -12 L 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -2 L 4 5 L 4 8 L 5 9 L 6 9 L 8 8 L 9 7 L 11 4","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -4 L -7 0 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 1 L 8 -3 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 L 0 -10 L 0 -7 L 1 -4 L 3 -1 L 5 1 L 8 3 L 10 4","-12 13 M 1 -10 L 2 -9 L 2 -6 L 1 -2 L 0 1 L -1 3 L -3 6 L -5 8 L -7 9 L -8 9 L -9 8 L -9 5 L -8 0 L -7 -3 L -6 -5 L -4 -8 L -2 -10 L 0 -11 L 3 -12 L 8 -12 L 10 -11 L 11 -10 L 12 -8 L 12 -5 L 11 -3 L 10 -2 L 8 -1 L 5 -1 L 3 -2 L 2 -3","-10 12 M 3 -6 L 2 -4 L 1 -3 L -1 -2 L -3 -2 L -4 -4 L -4 -6 L -3 -9 L -1 -11 L 2 -12 L 5 -12 L 7 -11 L 8 -9 L 8 -5 L 7 -2 L 5 1 L 1 5 L -2 7 L -4 8 L -7 9 L -9 9 L -10 8 L -10 6 L -9 5 L -7 5 L -5 6 L -2 8 L 1 9 L 4 9 L 7 8 L 9 6","-12 13 M 1 -10 L 2 -9 L 2 -6 L 1 -2 L 0 1 L -1 3 L -3 6 L -5 8 L -7 9 L -8 9 L -9 8 L -9 5 L -8 0 L -7 -3 L -6 -5 L -4 -8 L -2 -10 L 0 -11 L 3 -12 L 7 -12 L 9 -11 L 10 -10 L 11 -8 L 11 -5 L 10 -3 L 9 -2 L 7 -1 L 4 -1 L 1 -2 L 2 -1 L 3 1 L 3 6 L 4 8 L 6 9 L 8 8 L 9 7 L 11 4","-10 10 M -10 9 L -8 8 L -6 6 L -3 2 L -1 -1 L 1 -5 L 2 -8 L 2 -11 L 1 -12 L 0 -12 L -1 -11 L -2 -9 L -2 -7 L -1 -5 L 1 -3 L 4 -1 L 6 1 L 7 3 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6 L -8 4 L -8 2","-10 9 M 0 -6 L -2 -6 L -4 -7 L -5 -9 L -4 -11 L -1 -12 L 2 -12 L 6 -11 L 9 -11 L 11 -12 M 6 -11 L 4 -4 L 2 2 L 0 6 L -2 8 L -4 9 L -6 9 L -8 8 L -9 6 L -9 4 L -8 3 L -6 3 L -4 4","-13 11 M -8 -5 L -10 -6 L -11 -8 L -11 -9 L -10 -11 L -8 -12 L -7 -12 L -5 -11 L -4 -9 L -4 -7 L -5 -3 L -6 0 L -7 4 L -7 6 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 3 3 L 6 -5 L 8 -12 M 6 -5 L 5 -1 L 4 5 L 4 8 L 5 9 L 6 9 L 8 8 L 9 7 L 11 4","-12 11 M -7 -5 L -9 -6 L -10 -8 L -10 -9 L -9 -11 L -7 -12 L -6 -12 L -4 -11 L -3 -9 L -3 -7 L -4 -3 L -5 0 L -6 4 L -6 7 L -5 9 L -3 9 L -1 8 L 2 5 L 4 2 L 6 -2 L 7 -5 L 8 -9 L 8 -11 L 7 -12 L 6 -12 L 5 -11 L 4 -9 L 4 -7 L 5 -4 L 7 -2 L 9 -1","-15 13 M -10 -5 L -12 -6 L -13 -8 L -13 -9 L -12 -11 L -10 -12 L -9 -12 L -7 -11 L -6 -9 L -6 -6 L -7 9 M 3 -12 L -7 9 M 3 -12 L 1 9 M 15 -12 L 13 -11 L 10 -8 L 7 -4 L 4 2 L 1 9","-12 12 M -4 -6 L -6 -6 L -7 -7 L -7 -9 L -6 -11 L -4 -12 L -2 -12 L 0 -11 L 1 -9 L 1 -6 L -1 3 L -1 6 L 0 8 L 2 9 L 4 9 L 6 8 L 7 6 L 7 4 L 6 3 L 4 3 M 11 -9 L 11 -11 L 10 -12 L 8 -12 L 6 -11 L 4 -9 L 2 -6 L -2 3 L -4 6 L -6 8 L -8 9 L -10 9 L -11 8 L -11 6","-12 11 M -7 -5 L -9 -6 L -10 -8 L -10 -9 L -9 -11 L -7 -12 L -6 -12 L -4 -11 L -3 -9 L -3 -7 L -4 -3 L -5 0 L -6 4 L -6 6 L -5 8 L -4 9 L -2 9 L 0 8 L 2 6 L 4 3 L 5 1 L 7 -5 M 9 -12 L 7 -5 L 4 5 L 2 11 L 0 16 L -2 20 L -4 21 L -5 20 L -5 18 L -4 15 L -2 12 L 1 9 L 4 7 L 9 4","-10 11 M 3 -6 L 2 -4 L 1 -3 L -1 -2 L -3 -2 L -4 -4 L -4 -6 L -3 -9 L -1 -11 L 2 -12 L 5 -12 L 7 -11 L 8 -9 L 8 -5 L 7 -2 L 5 2 L 2 5 L -2 8 L -4 9 L -7 9 L -8 8 L -8 6 L -7 5 L -4 5 L -2 6 L -1 7 L 0 9 L 0 12 L -1 15 L -2 17 L -4 20 L -6 21 L -7 20 L -7 18 L -6 15 L -4 12 L -1 9 L 2 7 L 8 4","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-8 8 M -2 -6 L 0 -9 L 2 -6 M -5 -3 L 0 -8 L 5 -3 M 0 -8 L 0 9","-8 8 M -8 11 L 8 11","-5 6 M 4 -12 L 2 -10 L 1 -8 L 1 -7 L 2 -6 L 3 -7 L 2 -8","-6 10 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 L 4 0 L 3 5 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-5 9 M -5 4 L -3 1 L 0 -4 L 1 -6 L 2 -9 L 2 -11 L 1 -12 L -1 -11 L -2 -9 L -3 -5 L -4 2 L -4 8 L -3 9 L -2 9 L 0 8 L 2 6 L 3 3 L 3 0 L 4 4 L 5 5 L 7 5 L 9 4","-5 6 M 2 2 L 2 1 L 1 0 L -1 0 L -3 1 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9 L 1 9 L 4 7 L 6 4","-6 10 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 6 L 8 -12 M 4 0 L 3 5 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-4 6 M -3 7 L -1 6 L 0 5 L 1 3 L 1 1 L 0 0 L -1 0 L -3 1 L -4 3 L -4 6 L -3 8 L -1 9 L 1 9 L 3 8 L 4 7 L 6 4","-3 5 M -3 4 L 1 -1 L 3 -4 L 4 -6 L 5 -9 L 5 -11 L 4 -12 L 2 -11 L 1 -9 L -1 -1 L -4 8 L -7 15 L -8 18 L -8 20 L -7 21 L -5 20 L -4 17 L -3 8 L -2 9 L 0 9 L 2 8 L 3 7 L 5 4","-6 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 M 4 0 L 2 7 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -2 12 L 1 10 L 3 9 L 6 7 L 9 4","-5 10 M -5 4 L -3 1 L 0 -4 L 1 -6 L 2 -9 L 2 -11 L 1 -12 L -1 -11 L -2 -9 L -3 -5 L -4 1 L -5 9 M -5 9 L -4 6 L -3 4 L -1 1 L 1 0 L 3 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-2 5 M 1 -5 L 1 -4 L 2 -4 L 2 -5 L 1 -5 M -2 4 L 0 0 L -2 6 L -2 8 L -1 9 L 0 9 L 2 8 L 3 7 L 5 4","-2 5 M 1 -5 L 1 -4 L 2 -4 L 2 -5 L 1 -5 M -2 4 L 0 0 L -6 18 L -7 20 L -9 21 L -10 20 L -10 18 L -9 15 L -6 12 L -3 10 L -1 9 L 2 7 L 5 4","-5 9 M -5 4 L -3 1 L 0 -4 L 1 -6 L 2 -9 L 2 -11 L 1 -12 L -1 -11 L -2 -9 L -3 -5 L -4 1 L -5 9 M -5 9 L -4 6 L -3 4 L -1 1 L 1 0 L 3 0 L 4 1 L 4 3 L 2 4 L -1 4 M -1 4 L 1 5 L 2 8 L 3 9 L 4 9 L 6 8 L 7 7 L 9 4","-3 5 M -3 4 L -1 1 L 2 -4 L 3 -6 L 4 -9 L 4 -11 L 3 -12 L 1 -11 L 0 -9 L -1 -5 L -2 2 L -2 8 L -1 9 L 0 9 L 2 8 L 3 7 L 5 4","-13 12 M -13 4 L -11 1 L -9 0 L -8 1 L -8 2 L -9 6 L -10 9 M -9 6 L -8 4 L -6 1 L -4 0 L -2 0 L -1 1 L -1 2 L -2 6 L -3 9 M -2 6 L -1 4 L 1 1 L 3 0 L 5 0 L 6 1 L 6 3 L 5 6 L 5 8 L 6 9 L 7 9 L 9 8 L 10 7 L 12 4","-8 10 M -8 4 L -6 1 L -4 0 L -3 1 L -3 2 L -4 6 L -5 9 M -4 6 L -3 4 L -1 1 L 1 0 L 3 0 L 4 1 L 4 3 L 3 6 L 3 8 L 4 9 L 5 9 L 7 8 L 8 7 L 10 4","-6 8 M 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 L 3 5 L 3 3 L 2 1 L 0 0 L -1 1 L -1 3 L 0 5 L 2 6 L 5 6 L 7 5 L 8 4","-7 8 M -7 4 L -5 1 L -4 -1 L -5 3 L -11 21 M -5 3 L -4 1 L -2 0 L 0 0 L 2 1 L 3 3 L 3 5 L 2 7 L 1 8 L -1 9 M -5 8 L -3 9 L 0 9 L 3 8 L 5 7 L 8 4","-6 9 M 3 3 L 2 1 L 0 0 L -2 0 L -4 1 L -5 2 L -6 4 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 M 4 0 L 3 3 L 1 8 L -2 15 L -3 18 L -3 20 L -2 21 L 0 20 L 1 17 L 1 10 L 3 9 L 6 7 L 9 4","-5 8 M -5 4 L -3 1 L -2 -1 L -2 1 L 1 1 L 2 2 L 2 4 L 1 7 L 1 8 L 2 9 L 3 9 L 5 8 L 6 7 L 8 4","-4 7 M -4 4 L -2 1 L -1 -1 L -1 1 L 1 4 L 2 6 L 2 8 L 0 9 M -4 8 L -2 9 L 2 9 L 4 8 L 5 7 L 7 4","-3 6 M -3 4 L -1 1 L 1 -3 M 4 -12 L -2 6 L -2 8 L -1 9 L 1 9 L 3 8 L 4 7 L 6 4 M -2 -4 L 5 -4","-6 9 M -6 4 L -4 0 L -6 6 L -6 8 L -5 9 L -3 9 L -1 8 L 1 6 L 3 3 M 4 0 L 2 6 L 2 8 L 3 9 L 4 9 L 6 8 L 7 7 L 9 4","-6 9 M -6 4 L -4 0 L -5 5 L -5 8 L -4 9 L -3 9 L 0 8 L 2 6 L 3 3 L 3 0 M 3 0 L 4 4 L 5 5 L 7 5 L 9 4","-9 12 M -6 0 L -8 2 L -9 5 L -9 7 L -8 9 L -6 9 L -4 8 L -2 6 M 0 0 L -2 6 L -2 8 L -1 9 L 1 9 L 3 8 L 5 6 L 6 3 L 6 0 M 6 0 L 7 4 L 8 5 L 10 5 L 12 4","-8 8 M -8 4 L -6 1 L -4 0 L -2 0 L -1 1 L -1 8 L 0 9 L 3 9 L 6 7 L 8 4 M 5 1 L 4 0 L 2 0 L 1 1 L -3 8 L -4 9 L -6 9 L -7 8","-6 9 M -6 4 L -4 0 L -6 6 L -6 8 L -5 9 L -3 9 L -1 8 L 1 6 L 3 3 M 4 0 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -2 12 L 1 10 L 3 9 L 6 7 L 9 4","-6 8 M -6 4 L -4 1 L -2 0 L 0 0 L 2 2 L 2 4 L 1 6 L -1 8 L -4 9 L -2 10 L -1 12 L -1 15 L -2 18 L -3 20 L -5 21 L -6 20 L -6 18 L -5 15 L -2 12 L 1 10 L 5 7 L 8 4","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-7 7 M -1 -12 L -3 -11 L -4 -9 L -4 -7 L -3 -5 L -1 -4 L 1 -4 L 3 -5 L 4 -7 L 4 -9 L 3 -11 L 1 -12 L -1 -12"]
symbolic = ["-8 8","-14 14 M -14 0 L 14 0","-14 14 M -14 14 L 14 -14","0 0 M 0 -20 L 0 20","-14 14 M -14 -14 L 14 14","-14 14 M -14 0 L 14 0","-12 12 M -12 7 L 12 -7","-7 7 M -7 12 L 7 -12","0 0 M 0 -14 L 0 14","-7 7 M -7 -12 L 7 12","-12 12 M -12 -7 L 12 7","-7 7 M -7 0 L 7 0","-5 5 M -5 5 L 5 -5","0 0 M 0 -7 L 0 7","-5 5 M -5 -5 L 5 5","-11 0 M 0 -11 L -2 -11 L -5 -10 L -8 -8 L -10 -5 L -11 -2 L -11 0","-11 0 M -11 0 L -11 2 L -10 5 L -8 8 L -5 10 L -2 11 L 0 11","0 11 M 0 11 L 2 11 L 5 10 L 8 8 L 10 5 L 11 2 L 11 0","0 11 M 11 0 L 11 -2 L 10 -5 L 8 -8 L 5 -10 L 2 -11 L 0 -11","-14 14 M -14 -3 L -11 -1 L -7 1 L -2 2 L 2 2 L 7 1 L 11 -1 L 14 -3","-2 3 M 3 -14 L 1 -11 L -1 -7 L -2 -2 L -2 2 L -1 7 L 1 11 L 3 14","-3 2 M -3 -14 L -1 -11 L 1 -7 L 2 -2 L 2 2 L 1 7 L -1 11 L -3 14","-14 14 M -14 3 L -11 1 L -7 -1 L -2 -2 L 2 -2 L 7 -1 L 11 1 L 14 3","-7 7 M 0 -8 L 7 -4 L -7 4 L 0 8","-8 8 M -8 0 L -4 -7 L 4 7 L 8 0","-7 7 M -7 4 L -7 -4 L 7 4 L 7 -4","-8 8 M -6 6 L -8 -2 L 8 2 L 6 -6","-8 8 M -8 11 L -6 11 L -3 10 L -1 9 L 2 6 L 3 4 L 4 1 L 4 -3 L 3 -6 L 2 -8 L 1 -9 L -1 -9 L -2 -8 L -3 -6 L -4 -3 L -4 1 L -3 4 L -2 6 L 1 9 L 3 10 L 6 11 L 8 11","-9 11 M 11 8 L 11 6 L 10 3 L 9 1 L 6 -2 L 4 -3 L 1 -4 L -3 -4 L -6 -3 L -8 -2 L -9 -1 L -9 1 L -8 2 L -6 3 L -3 4 L 1 4 L 4 3 L 6 2 L 9 -1 L 10 -3 L 11 -6 L 11 -8","-8 8 M 8 -11 L 6 -11 L 3 -10 L 1 -9 L -2 -6 L -3 -4 L -4 -1 L -4 3 L -3 6 L -2 8 L -1 9 L 1 9 L 2 8 L 3 6 L 4 3 L 4 -1 L 3 -4 L 2 -6 L -1 -9 L -3 -10 L -6 -11 L -8 -11","-11 9 M -11 -8 L -11 -6 L -10 -3 L -9 -1 L -6 2 L -4 3 L -1 4 L 3 4 L 6 3 L 8 2 L 9 1 L 9 -1 L 8 -2 L 6 -3 L 3 -4 L -1 -4 L -4 -3 L -6 -2 L -9 1 L -10 3 L -11 6 L -11 8","-13 9 M -13 -2 L -12 0 L -10 2 L -8 3 L -5 4 L -1 4 L 3 3 L 6 1 L 8 -2 L 9 -4 L 8 -6 L 5 -6 L 1 -5 L -1 -4 L -4 -2 L -6 1 L -7 4 L -7 7 L -6 10 L -5 12","-13 7 M -13 2 L -10 4 L -7 5 L -2 5 L 1 4 L 4 2 L 6 -1 L 7 -4 L 7 -6 L 6 -7 L 4 -7 L 1 -6 L -2 -4 L -4 -1 L -5 2 L -5 7 L -4 10 L -2 13","-3 3 M -1 -3 L -3 -1 L -3 1 L -1 3 L 1 3 L 3 1 L 3 -1 L 1 -3 L -1 -3 M -1 -2 L -2 -1 L -2 1 L -1 2 L 1 2 L 2 1 L 2 -1 L 1 -2 L -1 -2 M 0 -1 L -1 0 L 0 1 L 1 0 L 0 -1","0 5 M 0 -5 L 1 -5 L 3 -4 L 4 -3 L 5 -1 L 5 1 L 4 3 L 3 4 L 1 5 L 0 5","-14 14 M -14 0 L -8 0 M -3 0 L 3 0 M 8 0 L 14 0","-14 14 M -14 3 L -14 -3 L 14 -3 L 14 3","-8 8 M 0 -14 L -8 0 M 0 -14 L 8 0","-14 14 M -14 0 L 14 0 M -8 7 L 8 7 M -2 14 L 2 14","-14 14 M -14 0 L 14 0 M -14 0 L 0 16 M 14 0 L 0 16","-7 7 M -1 -7 L -4 -6 L -6 -4 L -7 -1 L -7 1 L -6 4 L -4 6 L -1 7 L 1 7 L 4 6 L 6 4 L 7 1 L 7 -1 L 6 -4 L 4 -6 L 1 -7 L -1 -7","-6 6 M -6 -6 L -6 6 L 6 6 L 6 -6 L -6 -6","-7 7 M 0 -8 L -7 4 L 7 4 L 0 -8","-6 6 M 0 -10 L -6 0 L 0 10 L 6 0 L 0 -10","-8 8 M 0 -9 L -2 -3 L -8 -3 L -3 1 L -5 7 L 0 3 L 5 7 L 3 1 L 8 -3 L 2 -3 L 0 -9","-7 7 M 0 -7 L 0 7 M -7 0 L 7 0","-5 5 M -5 -5 L 5 5 M 5 -5 L -5 5","-5 5 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-4 4 M -1 -4 L -3 -3 L -4 -1 L -4 1 L -3 3 L -1 4 L 1 4 L 3 3 L 4 1 L 4 -1 L 3 -3 L 1 -4 L -1 -4 M -3 -1 L -3 1 M -2 -2 L -2 2 M -1 -3 L -1 3 M 0 -3 L 0 3 M 1 -3 L 1 3 M 2 -2 L 2 2 M 3 -1 L 3 1","-4 4 M -4 -4 L -4 4 L 4 4 L 4 -4 L -4 -4 M -3 -3 L -3 3 M -2 -3 L -2 3 M -1 -3 L -1 3 M 0 -3 L 0 3 M 1 -3 L 1 3 M 2 -3 L 2 3 M 3 -3 L 3 3","-5 5 M 0 -6 L -5 3 L 5 3 L 0 -6 M 0 -3 L -3 2 M 0 -3 L 3 2 M 0 0 L -1 2 M 0 0 L 1 2","-6 3 M -6 0 L 3 5 L 3 -5 L -6 0 M -3 0 L 2 3 M -3 0 L 2 -3 M 0 0 L 2 1 M 0 0 L 2 -1","-5 5 M 0 6 L 5 -3 L -5 -3 L 0 6 M 0 3 L 3 -2 M 0 3 L -3 -2 M 0 0 L 1 -2 M 0 0 L -1 -2","-3 6 M 6 0 L -3 -5 L -3 5 L 6 0 M 3 0 L -2 -3 M 3 0 L -2 3 M 0 0 L -2 -1 M 0 0 L -2 1","0 7 M 0 -7 L 0 7 M 0 -7 L 7 -4 L 0 -1 M 1 -5 L 4 -4 L 1 -3","-9 9 M 0 -11 L 0 4 M -5 -8 L 5 -2 M 5 -8 L -5 -2 M -9 4 L -6 10 M 9 4 L 6 10 M -9 4 L 9 4 M -6 10 L 6 10","-5 5 M 0 -6 L 0 6 M -3 -3 L 3 -3 M -5 3 L -3 5 L -1 6 L 1 6 L 3 5 L 5 3","-6 6 M 0 -6 L 0 6 M -6 -1 L -5 -3 L 5 -3 L 6 -1 M -2 5 L 2 5","-7 7 M -5 -4 L 5 6 M 5 -4 L -5 6 M -3 -6 L -6 -3 L -7 -1 M 3 -6 L 6 -3 L 7 -1","-9 9 M -4 -9 L -9 9 M 4 -9 L 9 9 M -5 -5 L 9 9 M 5 -5 L -9 9 M -4 -9 L 4 -9 M -5 -5 L 5 -5","-7 7 M -7 -12 L 7 12","-11 9 M -5 -8 L 1 4 M -7 -2 L 1 -6 M -11 10 L 9 10 L 9 0 L -11 10","-6 6 M -2 -6 L -2 -2 L -6 -2 L -6 2 L -2 2 L -2 6 L 2 6 L 2 2 L 6 2 L 6 -2 L 2 -2 L 2 -6 L -2 -6","-7 7 M 7 -2 L 6 -4 L 4 -6 L 1 -7 L -1 -7 L -4 -6 L -6 -4 L -7 -1 L -7 1 L -6 4 L -4 6 L -1 7 L 1 7 L 4 6 L 6 4 L 7 2 M 7 -2 L 5 -4 L 3 -5 L 1 -5 L -1 -4 L -2 -3 L -3 -1 L -3 1 L -2 3 L -1 4 L 1 5 L 3 5 L 5 4 L 7 2","-7 7 M 0 -8 L -7 4 L 7 4 L 0 -8 M 0 8 L 7 -4 L -7 -4 L 0 8","-11 11 M -2 -9 L -2 -11 L -1 -12 L 1 -12 L 2 -11 L 2 -9 M -11 8 L -10 6 L -8 4 L -7 2 L -6 -2 L -6 -7 L -5 -8 L -3 -9 L 3 -9 L 5 -8 L 6 -7 L 6 -2 L 7 2 L 8 4 L 10 6 L 11 8 M -11 8 L 11 8 M -1 8 L -2 9 L -1 10 L 1 10 L 2 9 L 1 8","-8 8 M 0 -5 L 0 1 M 0 1 L -1 10 M 0 1 L 1 10 M -1 10 L 1 10 M 0 -5 L -1 -8 L -2 -10 L -4 -11 M -1 -8 L -4 -11 M 0 -5 L 1 -8 L 2 -10 L 4 -11 M 1 -8 L 4 -11 M 0 -5 L -4 -7 L -6 -7 L -8 -5 M -2 -6 L -6 -6 L -8 -5 M 0 -5 L 4 -7 L 6 -7 L 8 -5 M 2 -6 L 6 -6 L 8 -5 M 0 -5 L -2 -4 L -3 -3 L -3 0 M 0 -5 L -2 -3 L -3 0 M 0 -5 L 2 -4 L 3 -3 L 3 0 M 0 -5 L 2 -3 L 3 0","-8 8 M 0 -9 L 0 -7 M 0 -4 L 0 -2 M 0 1 L 0 3 M 0 7 L -1 10 M 0 7 L 1 10 M -1 10 L 1 10 M 0 -11 L -1 -9 L -2 -8 M 0 -11 L 1 -9 L 2 -8 M -2 -8 L 0 -9 L 2 -8 M 0 -7 L -2 -4 L -4 -3 L -5 -4 M 0 -7 L 2 -4 L 4 -3 L 5 -4 M -4 -3 L -2 -3 L 0 -4 L 2 -3 L 4 -3 M 0 -2 L -2 1 L -4 2 L -6 2 L -7 0 L -7 1 L -6 2 M 0 -2 L 2 1 L 4 2 L 6 2 L 7 0 L 7 1 L 6 2 M -4 2 L -2 2 L 0 1 L 2 2 L 4 2 M 0 3 L -2 6 L -3 7 L -5 8 L -6 8 L -7 7 L -8 5 L -8 7 L -6 8 M 0 3 L 2 6 L 3 7 L 5 8 L 6 8 L 7 7 L 8 5 L 8 7 L 6 8 M -5 8 L -3 8 L 0 7 L 3 8 L 5 8","-8 8 M 0 7 L -1 10 M 0 7 L 1 10 M -1 10 L 1 10 M 0 7 L 3 8 L 6 8 L 8 6 L 8 3 L 7 2 L 5 2 L 7 0 L 8 -3 L 7 -5 L 5 -6 L 3 -5 L 4 -8 L 3 -10 L 1 -11 L -1 -11 L -3 -10 L -4 -8 L -3 -5 L -5 -6 L -7 -5 L -8 -3 L -7 0 L -5 2 L -7 2 L -8 3 L -8 6 L -6 8 L -3 8 L 0 7","-8 8 M 0 7 L -1 10 M 0 7 L 1 10 M -1 10 L 1 10 M 0 7 L 4 6 L 4 4 L 6 3 L 6 0 L 8 -1 L 8 -6 L 7 -9 L 6 -10 L 4 -10 L 2 -11 L -2 -11 L -4 -10 L -6 -10 L -7 -9 L -8 -6 L -8 -1 L -6 0 L -6 3 L -4 4 L -4 6 L 0 7","-9 9 M -9 -2 L -7 0 M -6 -7 L -4 -2 M 0 -11 L 0 -3 M 6 -7 L 4 -2 M 9 -2 L 7 0","-11 11 M -9 -9 L -8 -7 L -7 -3 L -7 3 L -8 7 L -9 9 M 9 -9 L 8 -7 L 7 -3 L 7 3 L 8 7 L 9 9 M -9 -9 L -7 -8 L -3 -7 L 3 -7 L 7 -8 L 9 -9 M -9 9 L -7 8 L -3 7 L 3 7 L 7 8 L 9 9","-12 12 M 0 0 L 0 9 L -1 10 M 0 4 L -1 10 M 0 -9 L -1 -10 L -3 -10 L -4 -9 L -4 -7 L -3 -4 L 0 0 M 0 -9 L 1 -10 L 3 -10 L 4 -9 L 4 -7 L 3 -4 L 0 0 M 0 0 L -4 -3 L -6 -4 L -8 -4 L -9 -3 L -9 -1 L -8 0 M 0 0 L 4 -3 L 6 -4 L 8 -4 L 9 -3 L 9 -1 L 8 0 M 0 0 L -4 3 L -6 4 L -8 4 L -9 3 L -9 1 L -8 0 M 0 0 L 4 3 L 6 4 L 8 4 L 9 3 L 9 1 L 8 0","-8 8 M 3 -9 L 2 -8 L 3 -7 L 4 -8 L 4 -9 L 3 -11 L 1 -12 L -1 -12 L -3 -11 L -4 -9 L -4 -7 L -3 -5 L -1 -3 L 4 0 M -3 -5 L 2 -2 L 4 0 L 5 2 L 5 4 L 4 6 L 2 8 M -2 -4 L -4 -2 L -5 0 L -5 2 L -4 4 L -2 6 L 3 9 M -4 4 L 1 7 L 3 9 L 4 11 L 4 13 L 3 15 L 1 16 L -1 16 L -3 15 L -4 13 L -4 12 L -3 11 L -2 12 L -3 13","-8 8 M 0 -12 L -1 -10 L 0 -8 L 1 -10 L 0 -12 M 0 -12 L 0 16 M 0 -1 L -1 2 L 0 16 L 1 2 L 0 -1 M -6 -5 L -4 -4 L -2 -5 L -4 -6 L -6 -5 M -6 -5 L 6 -5 M 2 -5 L 4 -4 L 6 -5 L 4 -6 L 2 -5","-8 8 M 0 -12 L -1 -10 L 0 -8 L 1 -10 L 0 -12 M 0 -12 L 0 2 M 0 -2 L -1 0 L 1 4 L 0 6 L -1 4 L 1 0 L 0 -2 M 0 2 L 0 16 M 0 12 L -1 14 L 0 16 L 1 14 L 0 12 M -6 -5 L -4 -4 L -2 -5 L -4 -6 L -6 -5 M -6 -5 L 6 -5 M 2 -5 L 4 -4 L 6 -5 L 4 -6 L 2 -5 M -6 9 L -4 10 L -2 9 L -4 8 L -6 9 M -6 9 L 6 9 M 2 9 L 4 10 L 6 9 L 4 8 L 2 9","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 7 L -10 8 L -9 9 L -8 8 L -9 7 M 9 7 L 8 8 L 9 9 L 10 8 L 9 7","-12 12 M 0 -10 L -4 -6 L -7 -2 L -8 1 L -8 3 L -7 5 L -5 6 L -3 6 L -1 5 L 0 3 M 0 -10 L 4 -6 L 7 -2 L 8 1 L 8 3 L 7 5 L 5 6 L 3 6 L 1 5 L 0 3 M 0 3 L -1 7 L -2 10 M 0 3 L 1 7 L 2 10 M -2 10 L 2 10","-12 12 M 0 -4 L -1 -7 L -2 -9 L -4 -10 L -5 -10 L -7 -9 L -8 -7 L -8 -3 L -7 0 L -6 2 L -4 5 L 0 10 M 0 -4 L 1 -7 L 2 -9 L 4 -10 L 5 -10 L 7 -9 L 8 -7 L 8 -3 L 7 0 L 6 2 L 4 5 L 0 10","-12 12 M 0 -11 L -2 -8 L -6 -3 L -9 0 M 0 -11 L 2 -8 L 6 -3 L 9 0 M -9 0 L -6 3 L -2 8 L 0 11 M 9 0 L 6 3 L 2 8 L 0 11","-12 12 M 0 2 L 2 5 L 4 6 L 6 6 L 8 5 L 9 3 L 9 1 L 8 -1 L 6 -2 L 4 -2 L 1 -1 M 1 -1 L 3 -3 L 4 -5 L 4 -7 L 3 -9 L 1 -10 L -1 -10 L -3 -9 L -4 -7 L -4 -5 L -3 -3 L -1 -1 M -1 -1 L -4 -2 L -6 -2 L -8 -1 L -9 1 L -9 3 L -8 5 L -6 6 L -4 6 L -2 5 L 0 2 M 0 2 L -1 7 L -2 10 M 0 2 L 1 7 L 2 10 M -2 10 L 2 10","-9 9 M 4 -39 L 1 -37 L -1 -35 L -2 -33 L -3 -30 L -3 -26 L -2 -22 L 2 -14 L 3 -11 L 3 -8 L 2 -5 L 0 -2 M 1 -37 L -1 -34 L -2 -30 L -2 -26 L -1 -23 L 3 -15 L 4 -11 L 4 -8 L 3 -5 L 0 -2 L -4 0 L 0 2 L 3 5 L 4 8 L 4 11 L 3 15 L -1 23 L -2 26 L -2 30 L -1 34 L 1 37 M 0 2 L 2 5 L 3 8 L 3 11 L 2 14 L -2 22 L -3 26 L -3 30 L -2 33 L -1 35 L 1 37 L 4 39","-9 9 M -4 -39 L -1 -37 L 1 -35 L 2 -33 L 3 -30 L 3 -26 L 2 -22 L -2 -14 L -3 -11 L -3 -8 L -2 -5 L 0 -2 M -1 -37 L 1 -34 L 2 -30 L 2 -26 L 1 -23 L -3 -15 L -4 -11 L -4 -8 L -3 -5 L 0 -2 L 4 0 L 0 2 L -3 5 L -4 8 L -4 11 L -3 15 L 1 23 L 2 26 L 2 30 L 1 34 L -1 37 M 0 2 L -2 5 L -3 8 L -3 11 L -2 14 L 2 22 L 3 26 L 3 30 L 2 33 L 1 35 L -1 37 L -4 39","-9 9 M 4 -36 L 1 -33 L -1 -30 L -3 -26 L -4 -21 L -4 -15 L -3 -9 L -2 -5 L 1 6 L 2 10 L 3 16 L 3 21 L 2 26 L 1 29 L -1 33 M 1 -33 L -1 -29 L -2 -26 L -3 -21 L -3 -16 L -2 -10 L -1 -6 L 2 5 L 3 9 L 4 15 L 4 21 L 3 26 L 1 30 L -1 33 L -4 36","-9 9 M -4 -36 L -1 -33 L 1 -30 L 3 -26 L 4 -21 L 4 -15 L 3 -9 L 2 -5 L -1 6 L -2 10 L -3 16 L -3 21 L -2 26 L -1 29 L 1 33 M -1 -33 L 1 -29 L 2 -26 L 3 -21 L 3 -16 L 2 -10 L 1 -6 L -2 5 L -3 9 L -4 15 L -4 21 L -3 26 L -1 30 L 1 33 L 4 36","-27 8 M -24 0 L -17 0 L 0 29 M -18 0 L -1 29 M -19 0 L 0 32 M 8 -48 L 4 -8 L 0 32","-9 9 M 2 -5 L 4 -4 L 6 -2 L 6 -3 L 5 -4 L 2 -5 L -1 -5 L -4 -4 L -5 -3 L -6 -1 L -6 1 L -5 3 L -3 5 L 1 8 M -1 -5 L -3 -4 L -4 -3 L -5 -1 L -5 1 L -4 3 L 1 8 L 2 10 L 2 12 L 1 13 L -1 13","-11 11 M -6 -5 L -7 -4 L -8 -2 L -8 0 L -7 3 L -3 7 L -2 9 M -8 0 L -7 2 L -3 6 L -2 9 L -2 11 L -3 14 L -5 16 L -6 16 L -7 15 L -8 13 L -8 10 L -7 6 L -5 2 L -3 -1 L 0 -4 L 2 -5 L 4 -5 L 7 -4 L 8 -2 L 8 2 L 7 6 L 5 8 L 3 9 L 2 9 L 1 8 L 1 6 L 2 5 L 3 6 L 2 7 M 4 -5 L 6 -4 L 7 -2 L 7 2 L 6 6 L 5 8","-13 13 M 7 -11 L 6 -10 L 7 -9 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -4 -7 L -5 -4 L -6 0 L -8 9 L -9 13 L -10 15 M 2 -12 L 0 -11 L -2 -9 L -3 -7 L -4 -4 L -6 5 L -7 9 L -8 12 L -9 14 L -10 15 L -12 16 L -14 16 L -15 15 L -15 14 L -14 13 L -13 14 L -14 15 M 13 -11 L 12 -10 L 13 -9 L 14 -10 L 14 -11 L 13 -12 L 11 -12 L 9 -11 L 8 -10 L 7 -8 L 6 -5 L 3 9 L 2 13 L 1 15 M 11 -12 L 9 -10 L 8 -8 L 7 -4 L 5 5 L 4 9 L 3 12 L 2 14 L 1 15 L -1 16 L -3 16 L -4 15 L -4 14 L -3 13 L -2 14 L -3 15 M -9 -5 L 12 -5","-12 12 M 9 -11 L 8 -10 L 9 -9 L 10 -10 L 9 -11 L 6 -12 L 3 -12 L 0 -11 L -2 -9 L -3 -7 L -4 -4 L -5 0 L -7 9 L -8 13 L -9 15 M 3 -12 L 1 -11 L -1 -9 L -2 -7 L -3 -4 L -5 5 L -6 9 L -7 12 L -8 14 L -9 15 L -11 16 L -13 16 L -14 15 L -14 14 L -13 13 L -12 14 L -13 15 M 7 -5 L 5 2 L 4 6 L 4 8 L 5 9 L 8 9 L 10 7 L 11 5 M 8 -5 L 6 2 L 5 6 L 5 8 L 6 9 M -8 -5 L 8 -5","-12 12 M 7 -11 L 6 -10 L 7 -9 L 8 -10 L 8 -11 L 6 -12 M 10 -12 L 3 -12 L 0 -11 L -2 -9 L -3 -7 L -4 -4 L -5 0 L -7 9 L -8 13 L -9 15 M 3 -12 L 1 -11 L -1 -9 L -2 -7 L -3 -4 L -5 5 L -6 9 L -7 12 L -8 14 L -9 15 L -11 16 L -13 16 L -14 15 L -14 14 L -13 13 L -12 14 L -13 15 M 9 -12 L 5 2 L 4 6 L 4 8 L 5 9 L 8 9 L 10 7 L 11 5 M 10 -12 L 6 2 L 5 6 L 5 8 L 6 9 M -8 -5 L 7 -5","-18 17 M 2 -11 L 1 -10 L 2 -9 L 3 -10 L 2 -11 L 0 -12 L -3 -12 L -6 -11 L -8 -9 L -9 -7 L -10 -4 L -11 0 L -13 9 L -14 13 L -15 15 M -3 -12 L -5 -11 L -7 -9 L -8 -7 L -9 -4 L -11 5 L -12 9 L -13 12 L -14 14 L -15 15 L -17 16 L -19 16 L -20 15 L -20 14 L -19 13 L -18 14 L -19 15 M 14 -11 L 13 -10 L 14 -9 L 15 -10 L 14 -11 L 11 -12 L 8 -12 L 5 -11 L 3 -9 L 2 -7 L 1 -4 L 0 0 L -2 9 L -3 13 L -4 15 M 8 -12 L 6 -11 L 4 -9 L 3 -7 L 2 -4 L 0 5 L -1 9 L -2 12 L -3 14 L -4 15 L -6 16 L -8 16 L -9 15 L -9 14 L -8 13 L -7 14 L -8 15 M 12 -5 L 10 2 L 9 6 L 9 8 L 10 9 L 13 9 L 15 7 L 16 5 M 13 -5 L 11 2 L 10 6 L 10 8 L 11 9 M -14 -5 L 13 -5","-18 17 M 2 -11 L 1 -10 L 2 -9 L 3 -10 L 2 -11 L 0 -12 L -3 -12 L -6 -11 L -8 -9 L -9 -7 L -10 -4 L -11 0 L -13 9 L -14 13 L -15 15 M -3 -12 L -5 -11 L -7 -9 L -8 -7 L -9 -4 L -11 5 L -12 9 L -13 12 L -14 14 L -15 15 L -17 16 L -19 16 L -20 15 L -20 14 L -19 13 L -18 14 L -19 15 M 12 -11 L 11 -10 L 12 -9 L 13 -10 L 13 -11 L 11 -12 M 15 -12 L 8 -12 L 5 -11 L 3 -9 L 2 -7 L 1 -4 L 0 0 L -2 9 L -3 13 L -4 15 M 8 -12 L 6 -11 L 4 -9 L 3 -7 L 2 -4 L 0 5 L -1 9 L -2 12 L -3 14 L -4 15 L -6 16 L -8 16 L -9 15 L -9 14 L -8 13 L -7 14 L -8 15 M 14 -12 L 10 2 L 9 6 L 9 8 L 10 9 L 13 9 L 15 7 L 16 5 M 15 -12 L 11 2 L 10 6 L 10 8 L 11 9 M -14 -5 L 12 -5","-6 7 M -5 -1 L -4 -3 L -2 -5 L 1 -5 L 2 -4 L 2 -1 L 0 5 L 0 8 L 1 9 M 0 -5 L 1 -4 L 1 -1 L -1 5 L -1 8 L 0 9 L 3 9 L 5 7 L 6 5","-6 6 M 0 -6 L -4 5 L 6 -2 L -6 -2 L 4 5 L 0 -6 M 0 0 L 0 -6 M 0 0 L -6 -2 M 0 0 L -4 5 M 0 0 L 4 5 M 0 0 L 6 -2","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3"]
timesg = ["-8 8","-5 5 M 0 -12 L -1 -10 L 0 2 L 1 -10 L 0 -12 M 0 -10 L 0 -4 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-8 8 M -4 -12 L -5 -5 M -3 -12 L -5 -5 M 4 -12 L 3 -5 M 5 -12 L 3 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 6 -9 L 5 -8 L 6 -7 L 7 -8 L 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 7 2 M -7 -7 L -5 -5 L -3 -4 L 3 -2 L 5 -1 L 6 0 L 7 2 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6 L -7 5 L -6 4 L -5 5 L -6 6","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-12 13 M 9 -4 L 8 -3 L 9 -2 L 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -5 9 L -8 8 L -9 6 L -9 3 L -8 1 L -2 -3 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 8 9 L 9 9 L 10 8 L 10 7 M -5 9 L -7 8 L -8 6 L -8 3 L -7 1 L -5 -1 M -5 -7 L -4 -5 L 4 6 L 6 8 L 8 9","-4 4 M 0 -12 L -1 -5 M 1 -12 L -1 -5","-7 7 M 3 -16 L 1 -14 L -1 -11 L -3 -7 L -4 -2 L -4 2 L -3 7 L -1 11 L 1 14 L 3 16 L 4 16 M 3 -16 L 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 L -3 16 M -4 -16 L -3 -16 L -1 -14 L 1 -11 L 3 -7 L 4 -2 L 4 2 L 3 7 L 1 11 L -1 14 L -3 16","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -4 -10 L -5 -8 L -6 -3 L -6 0 L -5 5 L -4 7 L -3 8 L -1 9 M 1 9 L 3 8 L 4 7 L 5 5 L 6 0 L 6 -3 L 5 -8 L 4 -10 L 3 -11 L 1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9 M 0 -11 L 0 9 M -4 9 L 5 9","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 3 -2 L -2 0 L -4 1 L -6 3 L -7 6 L -7 9 M 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 2 -2 L -2 0 M -7 7 L -6 6 L -4 6 L 1 8 L 4 8 L 6 7 L 7 6 M -4 6 L 1 9 L 5 9 L 6 8 L 7 6 L 7 4","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -9 L 6 -6 L 5 -4 L 2 -3 L -1 -3 M 2 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -4 L 2 -3 M 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 5 -1 L 6 2 L 6 5 L 5 7 L 4 8 L 2 9","-10 10 M 2 -10 L 2 9 M 3 -12 L 3 9 M 3 -12 L -8 3 L 8 3 M -1 9 L 6 9","-10 10 M -5 -12 L -7 -2 M -7 -2 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -5 -12 L 5 -12 M -5 -11 L 0 -11 L 5 -12","-10 10 M 5 -9 L 4 -8 L 5 -7 L 6 -8 L 6 -9 L 5 -11 L 3 -12 L 0 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2 M 0 -12 L -2 -11 L -4 -9 L -5 -7 L -6 -3 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 2 L 5 -1 L 3 -3 L 1 -4","-10 10 M -7 -12 L -7 -6 M -7 -8 L -6 -10 L -4 -12 L -2 -12 L 3 -9 L 5 -9 L 6 -10 L 7 -12 M -6 -10 L -4 -11 L -2 -11 L 3 -9 M 7 -12 L 7 -9 L 6 -6 L 2 -1 L 1 1 L 0 4 L 0 9 M 6 -6 L 1 -1 L 0 1 L -1 4 L -1 9","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -6 L -5 -4 L -2 -3 L 2 -3 L 5 -4 L 6 -6 L 6 -9 L 5 -11 L 2 -12 L -2 -12 M -2 -12 L -4 -11 L -5 -9 L -5 -6 L -4 -4 L -2 -3 M 2 -3 L 4 -4 L 5 -6 L 5 -9 L 4 -11 L 2 -12 M -2 -3 L -5 -2 L -6 -1 L -7 1 L -7 5 L -6 7 L -5 8 L -2 9 L 2 9 L 5 8 L 6 7 L 7 5 L 7 1 L 6 -1 L 5 -2 L 2 -3 M -2 -3 L -4 -2 L -5 -1 L -6 1 L -6 5 L -5 7 L -4 8 L -2 9 M 2 9 L 4 8 L 5 7 L 6 5 L 6 1 L 5 -1 L 4 -2 L 2 -3","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -6 L 7 0 L 6 4 L 5 6 L 3 8 L 0 9 L -3 9 L -5 8 L -6 6 L -6 5 L -5 4 L -4 5 L -5 6 M -1 1 L -3 0 L -5 -2 L -6 -5 L -6 -6 L -5 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 5 -9 L 6 -6 L 6 0 L 5 4 L 4 6 L 2 8 L 0 9","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -5 -8 L -4 -7 L -5 -6 L -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 1 -12 L 3 -11 L 4 -10 L 5 -8 L 5 -6 L 4 -4 L 2 -2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 0 -12 L -7 9 M 0 -12 L 7 9 M 0 -9 L 6 9 M -5 3 L 4 3 M -9 9 L -3 9 M 3 9 L 9 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 3 -2 M -5 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -9 9 M 3 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9","-10 10 M -7 -12 L 6 9 M -6 -12 L 7 9 M 7 -12 L -7 9 M -9 -12 L -3 -12 M 3 -12 L 9 -12 M -9 9 L -3 9 M 3 9 L 9 9","-10 10 M 0 -12 L -8 9 M 0 -12 L 8 9 M 0 -9 L 7 9 M -7 8 L 7 8 M -8 9 L 8 9","-11 10 M -6 -12 L -6 9 M -5 -12 L -5 9 M 1 -6 L 1 2 M -9 -12 L 7 -12 L 7 -6 L 6 -12 M -5 -2 L 1 -2 M -9 9 L 7 9 L 7 3 L 6 9","-10 11 M 0 -12 L 0 9 M 1 -12 L 1 9 M -2 -7 L -5 -6 L -6 -5 L -7 -3 L -7 0 L -6 2 L -5 3 L -2 4 L 3 4 L 6 3 L 7 2 L 8 0 L 8 -3 L 7 -5 L 6 -6 L 3 -7 L -2 -7 M -2 -7 L -4 -6 L -5 -5 L -6 -3 L -6 0 L -5 2 L -4 3 L -2 4 M 3 4 L 5 3 L 6 2 L 7 0 L 7 -3 L 6 -5 L 5 -6 L 3 -7 M -3 -12 L 4 -12 M -3 9 L 4 9","-9 9 M -4 -12 L -4 9 M -3 -12 L -3 9 M -7 -12 L 8 -12 L 8 -6 L 7 -12 M -7 9 L 0 9","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L -3 -12 M 3 -12 L 10 -12 M -6 -2 L 6 -2 M -10 9 L -3 9 M 3 9 L 10 9","-5 6 M 0 -12 L 0 9 M 1 -12 L 1 9 M -3 -12 L 4 -12 M -3 9 L 4 9","-2 3 M 0 -1 L 0 0 L 1 0 L 1 -1 L 0 -1","-12 10 M -7 -12 L -7 9 M -6 -12 L -6 9 M 7 -12 L -6 1 M -1 -3 L 7 9 M -2 -3 L 6 9 M -10 -12 L -3 -12 M 3 -12 L 9 -12 M -10 9 L -3 9 M 3 9 L 9 9","-10 10 M 0 -12 L -7 9 M 0 -12 L 7 9 M 0 -9 L 6 9 M -9 9 L -3 9 M 3 9 L 9 9","-12 13 M -7 -12 L -7 9 M -6 -12 L 0 6 M -7 -12 L 0 9 M 7 -12 L 0 9 M 7 -12 L 7 9 M 8 -12 L 8 9 M -10 -12 L -6 -12 M 7 -12 L 11 -12 M -10 9 L -4 9 M 4 9 L 11 9","-11 12 M -6 -12 L -6 9 M -5 -12 L 7 7 M -5 -10 L 7 9 M 7 -12 L 7 9 M -9 -12 L -5 -12 M 4 -12 L 10 -12 M -9 9 L -3 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 0 L -6 4 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 4 L 7 0 L 7 -3 L 6 -7 L 5 -9 L 3 -11 L 1 -12","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L 10 -12 M -10 9 L -3 9 M 3 9 L 10 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 0 L -6 4 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 4 L 7 0 L 7 -3 L 6 -7 L 5 -9 L 3 -11 L 1 -12 M -3 -5 L -3 2 M 3 -5 L 3 2 M -3 -2 L 3 -2 M -3 -1 L 3 -1","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 3 -1 L -5 -1 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 3 -1 M -9 9 L -2 9","-10 11 M -7 -12 L 0 -2 L -8 9 M -8 -12 L -1 -2 M -8 -12 L 7 -12 L 8 -6 L 6 -12 M -7 8 L 6 8 M -8 9 L 7 9 L 8 3 L 6 9","-9 10 M 0 -12 L 0 9 M 1 -12 L 1 9 M -6 -12 L -7 -6 L -7 -12 L 8 -12 L 8 -6 L 7 -12 M -3 9 L 4 9","-9 10 M -7 -7 L -7 -9 L -6 -11 L -5 -12 L -3 -12 L -2 -11 L -1 -9 L 0 -5 L 0 9 M -7 -9 L -5 -11 L -3 -11 L -1 -9 M 8 -7 L 8 -9 L 7 -11 L 6 -12 L 4 -12 L 3 -11 L 2 -9 L 1 -5 L 1 9 M 8 -9 L 6 -11 L 4 -11 L 2 -9 M -3 9 L 4 9","-7 7 M -1 -12 L -3 -11 L -4 -9 L -4 -7 L -3 -5 L -1 -4 L 1 -4 L 3 -5 L 4 -7 L 4 -9 L 3 -11 L 1 -12 L -1 -12","-11 11 M -8 6 L -7 9 L -3 9 L -5 5 L -7 1 L -8 -2 L -8 -6 L -7 -9 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 7 -9 L 8 -6 L 8 -2 L 7 1 L 5 5 L 3 9 L 7 9 L 8 6 M -5 5 L -6 2 L -7 -2 L -7 -6 L -6 -9 L -4 -11 L -2 -12 M 2 -12 L 4 -11 L 6 -9 L 7 -6 L 7 -2 L 6 2 L 5 5 M -7 8 L -4 8 M 4 8 L 7 8","-11 11 M -7 -13 L -8 -8 M 8 -13 L 7 -8 M -3 -4 L -4 1 M 4 -4 L 3 1 M -7 5 L -8 10 M 8 5 L 7 10 M -7 -11 L 7 -11 M -7 -10 L 7 -10 M -3 -2 L 3 -2 M -3 -1 L 3 -1 M -7 7 L 7 7 M -7 8 L 7 8","-11 12 M 0 -12 L 0 9 M 1 -12 L 1 9 M -9 -5 L -8 -6 L -6 -5 L -5 -1 L -4 1 L -3 2 L -1 3 M -8 -6 L -7 -5 L -6 -1 L -5 1 L -4 2 L -1 3 L 2 3 L 5 2 L 6 1 L 7 -1 L 8 -5 L 9 -6 M 2 3 L 4 2 L 5 1 L 6 -1 L 7 -5 L 9 -6 L 10 -5 M -3 -12 L 4 -12 M -3 9 L 4 9","-10 10 M 6 -12 L -7 9 M 7 -12 L -6 9 M -6 -12 L -7 -6 L -7 -12 L 7 -12 M -7 9 L 7 9 L 7 3 L 6 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-10 10 M -10 16 L 10 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-11 12 M -1 -5 L -4 -4 L -6 -2 L -7 0 L -8 3 L -8 6 L -7 8 L -4 9 L -2 9 L 0 8 L 3 5 L 5 2 L 7 -2 L 8 -5 M -1 -5 L -3 -4 L -5 -2 L -6 0 L -7 3 L -7 6 L -6 8 L -4 9 M -1 -5 L 1 -5 L 3 -4 L 4 -2 L 6 6 L 7 8 L 8 9 M 1 -5 L 2 -4 L 3 -2 L 5 6 L 6 8 L 8 9 L 9 9","-11 10 M 2 -12 L -1 -11 L -3 -9 L -5 -5 L -6 -2 L -7 2 L -8 8 L -9 16 M 2 -12 L 0 -11 L -2 -9 L -4 -5 L -5 -2 L -6 2 L -7 8 L -8 16 M 2 -12 L 4 -12 L 6 -11 L 7 -10 L 7 -7 L 6 -5 L 5 -4 L 2 -3 L -2 -3 M 4 -12 L 6 -10 L 6 -7 L 5 -5 L 4 -4 L 2 -3 M -2 -3 L 2 -2 L 4 0 L 5 2 L 5 5 L 4 7 L 3 8 L 0 9 L -2 9 L -4 8 L -5 7 L -6 4 M -2 -3 L 1 -2 L 3 0 L 4 2 L 4 5 L 3 7 L 2 8 L 0 9","-9 9 M -7 -5 L -5 -5 L -3 -4 L -2 -2 L 3 13 L 4 15 L 5 16 M -5 -5 L -4 -4 L -3 -2 L 2 13 L 3 15 L 5 16 L 7 16 M 8 -5 L 7 -3 L 5 0 L -5 11 L -7 14 L -8 16","-9 10 M 4 -4 L 2 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 L 6 2 L 6 -1 L 5 -3 L 1 -8 L 0 -10 L 0 -12 L 1 -13 L 3 -13 L 5 -12 L 7 -10 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8 M 0 9 L 2 8 L 4 5 L 5 2 L 5 -2 L 4 -4 L 2 -7 L 1 -9 L 1 -11 L 2 -12 L 4 -12 L 7 -10","-9 9 M 6 -2 L 4 -4 L 2 -5 L -2 -5 L -4 -4 L -4 -2 L -2 0 L 1 1 M -2 -5 L -3 -4 L -3 -2 L -1 0 L 1 1 M 1 1 L -4 2 L -6 4 L -6 6 L -5 8 L -2 9 L 1 9 L 3 8 L 5 6 M 1 1 L -3 2 L -5 4 L -5 6 L -4 8 L -2 9","-11 11 M -3 -4 L -5 -3 L -7 -1 L -8 2 L -8 5 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 5 6 L 7 3 L 8 0 L 8 -3 L 6 -5 L 4 -5 L 2 -3 L 0 1 L -2 6 L -5 16 M -8 5 L -6 7 L -4 8 L -1 8 L 2 7 L 5 5 L 7 3 M 8 -3 L 6 -4 L 4 -4 L 2 -2 L 0 1 L -2 7 L -4 16","-10 10 M -9 -2 L -7 -4 L -5 -5 L -3 -5 L -1 -4 L 0 -3 L 1 0 L 1 4 L 0 8 L -3 16 M -8 -3 L -6 -4 L -2 -4 L 0 -3 M 8 -5 L 7 -2 L 6 0 L 1 7 L -2 12 L -4 16 M 7 -5 L 6 -2 L 5 0 L 1 7","-11 11 M -10 -1 L -9 -3 L -7 -5 L -4 -5 L -3 -4 L -3 -2 L -4 2 L -6 9 M -5 -5 L -4 -4 L -4 -2 L -5 2 L -7 9 M -4 2 L -2 -2 L 0 -4 L 2 -5 L 4 -5 L 6 -4 L 7 -3 L 7 0 L 6 5 L 3 16 M 4 -5 L 6 -3 L 6 0 L 5 5 L 2 16","-6 6 M 0 -5 L -2 2 L -3 6 L -3 8 L -2 9 L 1 9 L 3 7 L 4 5 M 1 -5 L -1 2 L -2 6 L -2 8 L -1 9","-11 11 M -7 -7 L 7 7 M 7 -7 L -7 7","-10 10 M -4 -5 L -8 9 M -3 -5 L -7 9 M 6 -5 L 7 -4 L 8 -4 L 7 -5 L 5 -5 L 3 -4 L -1 0 L -3 1 L -5 1 M -3 1 L -1 2 L 1 8 L 2 9 M -3 1 L -2 2 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5","-10 10 M -7 -12 L -5 -12 L -3 -11 L -2 -10 L -1 -8 L 5 6 L 6 8 L 7 9 M -5 -12 L -3 -10 L -2 -8 L 4 6 L 5 8 L 7 9 L 8 9 M 0 -5 L -8 9 M 0 -5 L -7 9","-12 11 M -5 -5 L -11 16 M -4 -5 L -10 16 M -5 -2 L -6 4 L -6 7 L -4 9 L -2 9 L 0 8 L 2 6 L 4 3 M 6 -5 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 7 -5 L 4 6 L 4 8 L 5 9","-10 10 M -4 -5 L -6 9 M -3 -5 L -4 1 L -5 6 L -6 9 M 7 -5 L 6 -1 L 4 3 M 8 -5 L 7 -2 L 6 0 L 4 3 L 2 5 L -1 7 L -3 8 L -6 9 M -7 -5 L -3 -5","-9 9 M 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 L 6 2 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L 0 -5 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8 M 0 9 L 2 8 L 4 5 L 5 2 L 5 -2 L 4 -4","-11 11 M -2 -4 L -6 9 M -2 -4 L -5 9 M 4 -4 L 4 9 M 4 -4 L 5 9 M -9 -2 L -7 -4 L -4 -5 L 9 -5 M -9 -2 L -7 -3 L -4 -4 L 9 -4","-12 11 M -11 -1 L -10 -3 L -8 -5 L -5 -5 L -4 -4 L -4 -2 L -5 3 L -5 6 L -4 8 L -3 9 M -6 -5 L -5 -4 L -5 -2 L -6 3 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -5 L 7 -9 L 6 -11 L 4 -12 L 2 -12 L 0 -10 L 0 -8 L 1 -5 L 3 -2 L 5 0 L 8 2 M 1 8 L 3 5 L 4 3 L 5 0 L 6 -5 L 6 -9 L 5 -11 L 4 -12","-10 9 M -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 L 6 2 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -10 16 M 0 9 L 2 8 L 4 5 L 5 2 L 5 -2 L 4 -4 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -9 16","-10 11 M 9 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 5 L 5 2 L 5 -1 L 4 -3 L 3 -4 L 1 -5 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8 M -1 9 L 1 8 L 3 5 L 4 2 L 4 -2 L 3 -4 M 3 -4 L 9 -4","-10 10 M 1 -4 L -2 9 M 1 -4 L -1 9 M -8 -2 L -6 -4 L -3 -5 L 8 -5 M -8 -2 L -6 -3 L -3 -4 L 8 -4","-10 10 M -9 -1 L -8 -3 L -6 -5 L -3 -5 L -2 -4 L -2 -2 L -4 4 L -4 7 L -2 9 M -4 -5 L -3 -4 L -3 -2 L -5 4 L -5 7 L -4 8 L -2 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 7 -3 L 6 -5 L 5 -4 L 6 -3 L 7 0 M 6 3 L 7 -3","-13 13 M 0 -9 L -1 -8 L 0 -7 L 1 -8 L 0 -9 M -9 0 L 9 0 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-12 11 M -8 -1 L -6 -3 L -3 -4 L -4 -5 L -6 -4 L -8 -1 L -9 2 L -9 5 L -8 8 L -7 9 L -5 9 L -3 8 L -1 5 L 0 2 M -9 5 L -8 7 L -7 8 L -5 8 L -3 7 L -1 5 M -1 2 L -1 5 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5 L 8 2 L 8 -1 L 7 -4 L 6 -5 L 5 -4 L 7 -3 L 8 -1 M -1 5 L 0 7 L 1 8 L 3 8 L 5 7 L 7 5","-9 8 M 2 -12 L 0 -11 L -1 -10 L -1 -9 L 0 -8 L 3 -7 L 6 -7 M 3 -7 L -1 -6 L -3 -5 L -4 -3 L -4 -1 L -2 1 L 1 2 L 4 2 M 3 -7 L 0 -6 L -2 -5 L -3 -3 L -3 -1 L -1 1 L 1 2 M 1 2 L -3 3 L -5 4 L -6 6 L -6 8 L -4 10 L 1 12 L 2 13 L 2 15 L 0 16 L -2 16 M 1 2 L -2 3 L -4 4 L -5 6 L -5 8 L -3 10 L 1 12","-12 11 M 3 -12 L -3 16 M 4 -12 L -4 16 M -11 -1 L -10 -3 L -8 -5 L -5 -5 L -4 -4 L -4 -2 L -5 3 L -5 6 L -3 8 L 0 8 L 2 7 L 5 4 L 7 1 M -6 -5 L -5 -4 L -5 -2 L -6 3 L -6 6 L -5 8 L -3 9 L 0 9 L 2 8 L 4 6 L 6 3 L 7 1 L 9 -5","-9 9 M 2 -12 L 0 -11 L -1 -10 L -1 -9 L 0 -8 L 3 -7 L 8 -7 L 8 -8 L 5 -7 L 1 -5 L -2 -3 L -5 0 L -6 3 L -6 5 L -5 7 L -2 9 L 1 11 L 2 13 L 2 15 L 1 16 L -1 16 L -2 15 M 3 -6 L -1 -3 L -4 0 L -5 3 L -5 5 L -4 7 L -2 9","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
timesi = ["-8 8","-5 6 M 3 -12 L 2 -11 L 0 1 M 3 -11 L 0 1 M 3 -12 L 4 -11 L 0 1 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-9 9 M -2 -12 L -4 -5 M -1 -12 L -4 -5 M 7 -12 L 5 -5 M 8 -12 L 5 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 11 M 2 -16 L -6 13 M 7 -16 L -1 13 M 8 -8 L 7 -7 L 8 -6 L 9 -7 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -7 L -4 -5 L -3 -4 L 4 0 L 6 2 M -5 -7 L -3 -5 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-12 13 M 9 -4 L 8 -3 L 9 -2 L 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -5 9 L -8 8 L -9 6 L -9 3 L -8 1 L -2 -3 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 8 9 L 9 9 L 10 8 L 10 7 M -5 9 L -7 8 L -8 6 L -8 3 L -7 1 L -5 -1 M -5 -7 L -4 -5 L 4 6 L 6 8 L 8 9","-4 5 M 3 -12 L 1 -5 M 4 -12 L 1 -5","-7 8 M 8 -16 L 4 -13 L 1 -10 L -1 -7 L -3 -3 L -4 2 L -4 6 L -3 11 L -2 14 L -1 16 M 4 -13 L 1 -9 L -1 -5 L -2 -2 L -3 3 L -3 8 L -2 13 L -1 16","-8 7 M 1 -16 L 2 -14 L 3 -11 L 4 -6 L 4 -2 L 3 3 L 1 7 L -1 10 L -4 13 L -8 16 M 1 -16 L 2 -13 L 3 -8 L 3 -3 L 2 2 L 1 5 L -1 9 L -4 13","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-5 6 M -2 9 L -3 8 L -2 7 L -1 8 L -1 9 L -2 11 L -4 13","-13 13 M -9 0 L 9 0","-5 6 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-11 11 M 9 -16 L -9 16","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -3 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12","-10 11 M 2 -8 L -3 9 M 4 -12 L -2 9 M 4 -12 L 1 -9 L -2 -7 L -4 -6 M 3 -9 L -1 -7 L -4 -6","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 5 -3 L 2 -1 L -2 1 L -5 3 L -7 5 L -9 9 M 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 L -2 1 M -8 7 L -7 6 L -5 6 L 0 8 L 3 8 L 5 7 L 6 5 M -5 6 L 0 9 L 3 9 L 5 8 L 6 5","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 4 -3 L 1 -2 M 4 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 M -1 -2 L 1 -2 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5 M 1 -2 L 3 -1 L 4 0 L 5 2 L 5 5 L 4 7 L 3 8 L 1 9","-10 11 M 6 -11 L 0 9 M 7 -12 L 1 9 M 7 -12 L -8 3 L 8 3","-10 11 M -1 -12 L -6 -2 M -1 -12 L 9 -12 M -1 -11 L 4 -11 L 9 -12 M -6 -2 L -5 -3 L -2 -4 L 1 -4 L 4 -3 L 5 -2 L 6 0 L 6 3 L 5 6 L 3 8 L 0 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 4 L -7 3 L -6 4 L -7 5 M 1 -4 L 3 -3 L 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 L 0 9","-10 11 M 7 -9 L 6 -8 L 7 -7 L 8 -8 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 5 L -6 7 L -5 8 L -3 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 1 L 5 -1 L 4 -2 L 2 -3 L -1 -3 L -3 -2 L -5 0 L -6 2 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 6 L -5 8 M 0 9 L 2 8 L 4 6 L 5 4 L 5 0 L 4 -2","-10 11 M -4 -12 L -6 -6 M 9 -12 L 8 -9 L 6 -6 L 1 0 L -1 3 L -2 5 L -3 9 M 6 -6 L 0 0 L -2 3 L -3 5 L -4 9 M -5 -9 L -2 -12 L 0 -12 L 5 -9 M -4 -10 L -2 -11 L 0 -11 L 5 -9 L 7 -9 L 8 -10 L 9 -12","-10 11 M 1 -12 L -2 -11 L -3 -10 L -4 -8 L -4 -5 L -3 -3 L -1 -2 L 2 -2 L 6 -3 L 7 -4 L 8 -6 L 8 -9 L 7 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -2 -10 L -3 -8 L -3 -5 L -2 -3 L -1 -2 M 2 -2 L 5 -3 L 6 -4 L 7 -6 L 7 -9 L 6 -11 L 4 -12 M -1 -2 L -5 -1 L -7 1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 4 8 L 5 7 L 6 5 L 6 2 L 5 0 L 4 -1 L 2 -2 M -1 -2 L -4 -1 L -6 1 L -7 3 L -7 6 L -6 8 L -4 9 M 0 9 L 3 8 L 4 7 L 5 5 L 5 1 L 4 -1","-10 11 M 7 -5 L 6 -3 L 4 -1 L 2 0 L -1 0 L -3 -1 L -4 -2 L -5 -4 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 4 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -4 L 7 0 L 6 3 L 4 6 L 2 8 L -1 9 L -4 9 L -6 8 L -7 6 L -7 5 L -6 4 L -5 5 L -6 6 M -3 -1 L -4 -3 L -4 -7 L -3 -9 L -1 -11 L 1 -12 M 6 -11 L 7 -9 L 7 -4 L 6 0 L 5 3 L 3 6 L 1 8 L -1 9","-5 6 M 1 -5 L 0 -4 L 1 -3 L 2 -4 L 1 -5 M -2 7 L -3 8 L -2 9 L -1 8","-5 6 M 1 -5 L 0 -4 L 1 -3 L 2 -4 L 1 -5 M -2 9 L -3 8 L -2 7 L -1 8 L -1 9 L -2 11 L -4 13","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-10 11 M -3 -8 L -2 -7 L -3 -6 L -4 -7 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 1 -2 L -1 -1 L -1 1 L 0 2 L 2 2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 M -2 7 L -3 8 L -2 9 L -1 8 L -2 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 3 -12 L -10 9 M 3 -12 L 4 9 M 2 -10 L 3 9 M -6 3 L 3 3 M -12 9 L -6 9 M 0 9 L 6 9","-12 12 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 7 -3 L 4 -2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -4 L 6 -3 L 4 -2 M -5 -2 L 4 -2 L 6 -1 L 7 1 L 7 3 L 6 6 L 4 8 L 0 9 L -12 9 M 4 -2 L 5 -1 L 6 1 L 6 3 L 5 6 L 3 8 L 0 9","-10 11 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -2 9 L 1 9 L 3 8 L 5 6 L 6 4 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -4 8 L -2 9","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -7 L 8 -3 L 7 1 L 5 5 L 3 7 L 1 8 L -3 9 L -12 9 M 3 -12 L 5 -11 L 6 -10 L 7 -7 L 7 -3 L 6 1 L 4 5 L 2 7 L 0 8 L -3 9","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M 2 -6 L 0 2 M -6 -12 L 9 -12 L 8 -6 L 8 -12 M -5 -2 L 1 -2 M -12 9 L 3 9 L 5 4 L 2 9","-12 10 M -3 -12 L -9 9 M -2 -12 L -8 9 M 2 -6 L 0 2 M -6 -12 L 9 -12 L 8 -6 L 8 -12 M -5 -2 L 1 -2 M -12 9 L -5 9","-10 12 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -2 9 L 0 9 L 3 8 L 5 6 L 7 2 M 2 -12 L 0 -11 L -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 4 L -5 7 L -4 8 L -2 9 M 0 9 L 2 8 L 4 6 L 6 2 M 3 2 L 10 2","-13 13 M -4 -12 L -10 9 M -3 -12 L -9 9 M 9 -12 L 3 9 M 10 -12 L 4 9 M -7 -12 L 0 -12 M 6 -12 L 13 -12 M -6 -2 L 6 -2 M -13 9 L -6 9 M 0 9 L 7 9","-6 7 M 3 -12 L -3 9 M 4 -12 L -2 9 M 0 -12 L 7 -12 M -6 9 L 1 9","-9 9 M 6 -12 L 1 5 L 0 7 L -1 8 L -3 9 L -5 9 L -7 8 L -8 6 L -8 4 L -7 3 L -6 4 L -7 5 M 5 -12 L 0 5 L -1 7 L -3 9 M 2 -12 L 9 -12","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M 11 -12 L -6 1 M 1 -3 L 5 9 M 0 -3 L 4 9 M -6 -12 L 1 -12 M 7 -12 L 13 -12 M -12 9 L -5 9 M 1 9 L 7 9","-10 10 M -1 -12 L -7 9 M 0 -12 L -6 9 M -4 -12 L 3 -12 M -10 9 L 5 9 L 7 3 L 4 9","-13 14 M -4 -12 L -10 9 M -4 -12 L -3 9 M -3 -12 L -2 7 M 10 -12 L -3 9 M 10 -12 L 4 9 M 11 -12 L 5 9 M -7 -12 L -3 -12 M 10 -12 L 14 -12 M -13 9 L -7 9 M 1 9 L 8 9","-12 13 M -3 -12 L -9 9 M -3 -12 L 4 6 M -3 -9 L 4 9 M 10 -12 L 4 9 M -6 -12 L -3 -12 M 7 -12 L 13 -12 M -12 9 L -6 9","-11 11 M 1 -12 L -2 -11 L -4 -9 L -6 -6 L -7 -3 L -8 1 L -8 4 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -4 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 6 -12 L 9 -11 L 10 -9 L 10 -7 L 9 -4 L 7 -2 L 3 -1 L -5 -1 M 6 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 6 -2 L 3 -1 M -12 9 L -5 9","-11 11 M 1 -12 L -2 -11 L -4 -9 L -6 -6 L -7 -3 L -8 1 L -8 4 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 1 -12 M 1 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -4 9 M -1 9 L 1 8 L 3 6 L 5 3 L 6 0 L 7 -4 L 7 -7 L 6 -10 L 4 -12 M -6 7 L -6 6 L -5 4 L -3 3 L -2 3 L 0 4 L 1 6 L 1 13 L 2 14 L 4 14 L 5 12 L 5 11 M 1 6 L 2 12 L 3 13 L 4 13 L 5 12","-12 12 M -3 -12 L -9 9 M -2 -12 L -8 9 M -6 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 7 -3 L 4 -2 L -5 -2 M 5 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -4 L 6 -3 L 4 -2 M 0 -2 L 2 -1 L 3 0 L 4 8 L 5 9 L 7 9 L 8 7 L 8 6 M 3 0 L 5 7 L 6 8 L 7 8 L 8 7 M -12 9 L -5 9","-11 12 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -7 L -4 -5 L -3 -4 L 4 0 L 6 2 M -5 -7 L -3 -5 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 3 L -9 9 L -8 7 L -7 7","-10 11 M 3 -12 L -3 9 M 4 -12 L -2 9 M -3 -12 L -6 -6 L -4 -12 L 11 -12 L 10 -6 L 10 -12 M -6 9 L 1 9","-12 13 M -4 -12 L -7 -1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 3 8 L 5 6 L 6 3 L 10 -12 M -3 -12 L -6 -1 L -7 3 L -7 6 L -6 8 L -4 9 M -7 -12 L 0 -12 M 7 -12 L 13 -12","-10 10 M -4 -12 L -3 9 M -3 -12 L -2 7 M 10 -12 L -3 9 M -6 -12 L 0 -12 M 6 -12 L 12 -12","-13 13 M -5 -12 L -7 9 M -4 -12 L -6 7 M 3 -12 L -7 9 M 3 -12 L 1 9 M 4 -12 L 2 7 M 11 -12 L 1 9 M -8 -12 L -1 -12 M 8 -12 L 14 -12","-11 11 M -4 -12 L 3 9 M -3 -12 L 4 9 M 10 -12 L -10 9 M -6 -12 L 0 -12 M 6 -12 L 12 -12 M -12 9 L -6 9 M 0 9 L 6 9","-10 11 M -4 -12 L 0 -2 L -3 9 M -3 -12 L 1 -2 L -2 9 M 11 -12 L 1 -2 M -6 -12 L 0 -12 M 7 -12 L 13 -12 M -6 9 L 1 9","-11 11 M 9 -12 L -10 9 M 10 -12 L -9 9 M -3 -12 L -6 -6 L -4 -12 L 10 -12 M -10 9 L 4 9 L 6 3 L 3 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-10 10 M -10 16 L 10 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-10 11 M 6 -5 L 4 2 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 7 -5 L 5 2 L 4 6 L 4 8 L 5 9 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8","-10 9 M -2 -12 L -6 1 L -6 4 L -5 7 L -4 8 M -1 -12 L -5 1 M -5 1 L -4 -2 L -2 -4 L 0 -5 L 2 -5 L 4 -4 L 5 -3 L 6 -1 L 6 2 L 5 5 L 3 8 L 0 9 L -2 9 L -4 8 L -5 5 L -5 1 M 4 -4 L 5 -2 L 5 2 L 4 5 L 2 8 L 0 9 M -5 -12 L -1 -12","-9 9 M 5 -2 L 5 -1 L 6 -1 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8","-10 11 M 8 -12 L 4 2 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 9 -12 L 5 2 L 4 6 L 4 8 L 5 9 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8 M 5 -12 L 9 -12","-9 9 M -5 4 L -1 3 L 2 2 L 5 0 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 6 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8","-7 8 M 8 -11 L 7 -10 L 8 -9 L 9 -10 L 9 -11 L 8 -12 L 6 -12 L 4 -11 L 3 -10 L 2 -8 L 1 -5 L -2 9 L -3 13 L -4 15 M 6 -12 L 4 -10 L 3 -8 L 2 -4 L 0 5 L -1 9 L -2 12 L -3 14 L -4 15 L -6 16 L -8 16 L -9 15 L -9 14 L -8 13 L -7 14 L -8 15 M -3 -5 L 7 -5","-10 10 M 7 -5 L 3 9 L 2 12 L 0 15 L -3 16 L -6 16 L -8 15 L -9 14 L -9 13 L -8 12 L -7 13 L -8 14 M 6 -5 L 2 9 L 1 12 L -1 15 L -3 16 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8","-10 11 M -2 -12 L -8 9 M -1 -12 L -7 9 M -5 2 L -3 -2 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -3 L 6 -1 L 4 5 L 4 8 L 5 9 M 3 -5 L 5 -3 L 5 -1 L 3 5 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M -5 -12 L -1 -12","-6 7 M 3 -12 L 2 -11 L 3 -10 L 4 -11 L 3 -12 M -5 -1 L -4 -3 L -2 -5 L 1 -5 L 2 -4 L 2 -1 L 0 5 L 0 8 L 1 9 M 0 -5 L 1 -4 L 1 -1 L -1 5 L -1 8 L 0 9 L 3 9 L 5 7 L 6 5","-6 7 M 4 -12 L 3 -11 L 4 -10 L 5 -11 L 4 -12 M -4 -1 L -3 -3 L -1 -5 L 2 -5 L 3 -4 L 3 -1 L 0 9 L -1 12 L -2 14 L -3 15 L -5 16 L -7 16 L -8 15 L -8 14 L -7 13 L -6 14 L -7 15 M 1 -5 L 2 -4 L 2 -1 L -1 9 L -2 12 L -3 14 L -5 16","-10 10 M -2 -12 L -8 9 M -1 -12 L -7 9 M 6 -4 L 5 -3 L 6 -2 L 7 -3 L 7 -4 L 6 -5 L 5 -5 L 3 -4 L -1 0 L -3 1 L -5 1 M -3 1 L -1 2 L 1 8 L 2 9 M -3 1 L -2 2 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5 M -5 -12 L -1 -12","-5 7 M 3 -12 L -1 2 L -2 6 L -2 8 L -1 9 L 2 9 L 4 7 L 5 5 M 4 -12 L 0 2 L -1 6 L -1 8 L 0 9 M 0 -12 L 4 -12","-17 16 M -16 -1 L -15 -3 L -13 -5 L -10 -5 L -9 -4 L -9 -2 L -10 2 L -12 9 M -11 -5 L -10 -4 L -10 -2 L -11 2 L -13 9 M -10 2 L -8 -2 L -6 -4 L -4 -5 L -2 -5 L 0 -4 L 1 -3 L 1 -1 L -2 9 M -2 -5 L 0 -3 L 0 -1 L -3 9 M 0 2 L 2 -2 L 4 -4 L 6 -5 L 8 -5 L 10 -4 L 11 -3 L 11 -1 L 9 5 L 9 8 L 10 9 M 8 -5 L 10 -3 L 10 -1 L 8 5 L 8 8 L 9 9 L 12 9 L 14 7 L 15 5","-12 11 M -11 -1 L -10 -3 L -8 -5 L -5 -5 L -4 -4 L -4 -2 L -5 2 L -7 9 M -6 -5 L -5 -4 L -5 -2 L -6 2 L -8 9 M -5 2 L -3 -2 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -3 L 6 -1 L 4 5 L 4 8 L 5 9 M 3 -5 L 5 -3 L 5 -1 L 3 5 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5","-9 9 M 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 5 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 L 6 2 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L 0 -5 M 0 -5 L -2 -4 L -4 -1 L -5 2 L -5 6 L -4 8 M 0 9 L 2 8 L 4 5 L 5 2 L 5 -2 L 4 -4","-11 10 M -10 -1 L -9 -3 L -7 -5 L -4 -5 L -3 -4 L -3 -2 L -4 2 L -8 16 M -5 -5 L -4 -4 L -4 -2 L -5 2 L -9 16 M -4 2 L -3 -1 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -3 L 7 -1 L 7 2 L 6 5 L 4 8 L 1 9 L -1 9 L -3 8 L -4 5 L -4 2 M 5 -4 L 6 -2 L 6 2 L 5 5 L 3 8 L 1 9 M -12 16 L -5 16","-10 10 M 6 -5 L 0 16 M 7 -5 L 1 16 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 5 L 4 2 M -1 -5 L -3 -4 L -5 -1 L -6 2 L -6 6 L -5 8 M -3 16 L 4 16","-9 8 M -8 -1 L -7 -3 L -5 -5 L -2 -5 L -1 -4 L -1 -2 L -2 2 L -4 9 M -3 -5 L -2 -4 L -2 -2 L -3 2 L -5 9 M -2 2 L 0 -2 L 2 -4 L 4 -5 L 6 -5 L 7 -4 L 7 -3 L 6 -2 L 5 -3 L 6 -4","-8 9 M 6 -3 L 6 -2 L 7 -2 L 7 -3 L 6 -4 L 3 -5 L 0 -5 L -3 -4 L -4 -3 L -4 -1 L -3 0 L 4 4 L 5 5 M -4 -2 L -3 -1 L 4 3 L 5 4 L 5 7 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -6 6 L -5 6 L -5 7","-7 7 M 2 -12 L -2 2 L -3 6 L -3 8 L -2 9 L 1 9 L 3 7 L 4 5 M 3 -12 L -1 2 L -2 6 L -2 8 L -1 9 M -4 -5 L 5 -5","-12 11 M -11 -1 L -10 -3 L -8 -5 L -5 -5 L -4 -4 L -4 -1 L -6 5 L -6 7 L -4 9 M -6 -5 L -5 -4 L -5 -1 L -7 5 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 2 6 L 4 2 M 6 -5 L 4 2 L 3 6 L 3 8 L 4 9 L 7 9 L 9 7 L 10 5 M 7 -5 L 5 2 L 4 6 L 4 8 L 5 9","-10 10 M -9 -1 L -8 -3 L -6 -5 L -3 -5 L -2 -4 L -2 -1 L -4 5 L -4 7 L -2 9 M -4 -5 L -3 -4 L -3 -1 L -5 5 L -5 7 L -4 8 L -2 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 -1 L 7 -5 L 6 -5 L 7 -3","-15 14 M -14 -1 L -13 -3 L -11 -5 L -8 -5 L -7 -4 L -7 -1 L -9 5 L -9 7 L -7 9 M -9 -5 L -8 -4 L -8 -1 L -10 5 L -10 7 L -9 8 L -7 9 L -5 9 L -3 8 L -1 6 L 0 4 M 2 -5 L 0 4 L 0 7 L 1 8 L 3 9 L 5 9 L 7 8 L 9 6 L 10 4 L 11 0 L 11 -5 L 10 -5 L 11 -3 M 3 -5 L 1 4 L 1 7 L 3 9","-10 10 M -7 -1 L -5 -4 L -3 -5 L 0 -5 L 1 -3 L 1 0 M -1 -5 L 0 -3 L 0 0 L -1 4 L -2 6 L -4 8 L -6 9 L -7 9 L -8 8 L -8 7 L -7 6 L -6 7 L -7 8 M -1 4 L -1 7 L 0 9 L 3 9 L 5 8 L 7 5 M 7 -4 L 6 -3 L 7 -2 L 8 -3 L 8 -4 L 7 -5 L 6 -5 L 4 -4 L 2 -2 L 1 0 L 0 4 L 0 7 L 1 9","-11 10 M -10 -1 L -9 -3 L -7 -5 L -4 -5 L -3 -4 L -3 -1 L -5 5 L -5 7 L -3 9 M -5 -5 L -4 -4 L -4 -1 L -6 5 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 3 6 L 5 2 M 8 -5 L 4 9 L 3 12 L 1 15 L -2 16 L -5 16 L -7 15 L -8 14 L -8 13 L -7 12 L -6 13 L -7 14 M 7 -5 L 3 9 L 2 12 L 0 15 L -2 16","-10 10 M 7 -5 L 6 -3 L 4 -1 L -4 5 L -6 7 L -7 9 M -6 -1 L -5 -3 L -3 -5 L 0 -5 L 4 -3 M -5 -3 L -3 -4 L 0 -4 L 4 -3 L 6 -3 M -6 7 L -4 7 L 0 8 L 3 8 L 5 7 M -4 7 L 0 9 L 3 9 L 5 7 L 6 5","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
timesib = ["-8 8","-5 6 M 4 -12 L 3 -12 L 2 -11 L 0 2 M 4 -11 L 3 -11 L 0 2 M 4 -11 L 4 -10 L 0 2 M 4 -12 L 5 -11 L 5 -10 L 0 2 M -2 6 L -3 7 L -3 8 L -2 9 L -1 9 L 0 8 L 0 7 L -1 6 L -2 6 M -2 7 L -2 8 L -1 8 L -1 7 L -2 7","-9 9 M -2 -12 L -4 -5 M -1 -12 L -4 -5 M 7 -12 L 5 -5 M 8 -12 L 5 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 11 M 2 -16 L -6 13 M 7 -16 L -1 13 M 8 -7 L 8 -8 L 7 -8 L 7 -6 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -6 L -4 -4 L -2 -2 L 4 1 L 5 3 L 5 6 L 4 8 M -4 -6 L -3 -4 L 4 0 L 5 2 M -3 -11 L -4 -9 L -4 -7 L -3 -5 L 3 -2 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 3 L -6 3 L -6 5 L -7 5 L -7 4","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 10 -3 L 10 -4 L 9 -4 L 9 -2 L 11 -2 L 11 -4 L 10 -5 L 9 -5 L 7 -4 L 5 -2 L 0 6 L -2 8 L -4 9 L -7 9 L -10 8 L -11 6 L -11 4 L -10 2 L -9 1 L -7 0 L -2 -2 L 0 -3 L 2 -5 L 3 -7 L 3 -9 L 2 -11 L 0 -12 L -2 -11 L -3 -9 L -3 -6 L -2 0 L -1 3 L 0 5 L 2 8 L 4 9 L 6 9 L 7 7 L 7 6 M -6 9 L -10 8 M -9 8 L -10 6 L -10 4 L -9 2 L -8 1 L -6 0 M -2 -2 L -1 1 L 2 7 L 4 8 M -7 9 L -8 8 L -9 6 L -9 4 L -8 2 L -7 1 L -5 0 L 0 -3 M -3 -6 L -2 -3 L -1 0 L 1 4 L 3 7 L 5 8 L 6 8 L 7 7","-4 5 M 3 -12 L 1 -5 M 4 -12 L 1 -5","-8 8 M 8 -16 L 6 -15 L 3 -13 L 0 -10 L -2 -7 L -4 -3 L -5 1 L -5 6 L -4 10 L -3 13 L -1 16 M 1 -10 L -1 -7 L -3 -3 L -4 2 L -4 10 M 8 -16 L 5 -14 L 2 -11 L 0 -8 L -1 -6 L -2 -3 L -3 1 L -4 10 M -4 2 L -3 11 L -2 14 L -1 16","-8 8 M 1 -16 L 3 -13 L 4 -10 L 5 -6 L 5 -1 L 4 3 L 2 7 L 0 10 L -3 13 L -6 15 L -8 16 M 4 -10 L 4 -2 L 3 3 L 1 7 L -1 10 M 1 -16 L 2 -14 L 3 -11 L 4 -2 M 4 -10 L 3 -1 L 2 3 L 1 6 L 0 8 L -2 11 L -5 14 L -8 16","-8 9 M 2 -12 L 1 -11 L 3 -1 L 2 0 M 2 -12 L 2 0 M 2 -12 L 3 -11 L 1 -1 L 2 0 M -3 -9 L -2 -9 L 6 -3 L 7 -3 M -3 -9 L 7 -3 M -3 -9 L -3 -8 L 7 -4 L 7 -3 M 7 -9 L 6 -9 L -2 -3 L -3 -3 M 7 -9 L -3 -3 M 7 -9 L 7 -8 L -3 -4 L -3 -3","-12 13 M 0 -9 L 0 8 L 1 8 M 0 -9 L 1 -9 L 1 8 M -8 -1 L 9 -1 L 9 0 M -8 -1 L -8 0 L 9 0","-5 6 M -1 9 L -2 9 L -3 8 L -3 7 L -2 6 L -1 6 L 0 7 L 0 9 L -1 11 L -2 12 L -4 13 M -2 7 L -2 8 L -1 8 L -1 7 L -2 7 M -1 9 L -1 10 L -2 12","-13 13 M -9 0 L 9 0","-5 6 M -2 6 L -3 7 L -3 8 L -2 9 L -1 9 L 0 8 L 0 7 L -1 6 L -2 6 M -2 7 L -2 8 L -1 8 L -1 7 L -2 7","-11 12 M 9 -16 L -9 16 L -8 16 M 9 -16 L 10 -16 L -8 16","-10 11 M 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 2 -12 M -1 -10 L -3 -8 L -4 -6 L -5 -3 L -6 1 L -6 5 L -5 7 M 2 7 L 4 5 L 5 3 L 6 0 L 7 -4 L 7 -8 L 6 -10 M 2 -12 L 0 -11 L -2 -8 L -3 -6 L -4 -3 L -5 1 L -5 6 L -4 8 L -3 9 M -1 9 L 1 8 L 3 5 L 4 3 L 5 0 L 6 -4 L 6 -9 L 5 -11 L 4 -12","-10 11 M 2 -8 L -3 9 L -1 9 M 5 -12 L 3 -8 L -2 9 M 5 -12 L -1 9 M 5 -12 L 2 -9 L -1 -7 L -3 -6 M 2 -8 L 0 -7 L -3 -6","-10 11 M -3 -7 L -3 -8 L -2 -8 L -2 -6 L -4 -6 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 5 -3 L -5 3 L -7 5 L -9 9 M 6 -11 L 7 -9 L 7 -7 L 6 -5 L 4 -3 L 1 -1 M 4 -12 L 5 -11 L 6 -9 L 6 -7 L 5 -5 L 3 -3 L -5 3 M -8 7 L -7 6 L -5 6 L 0 7 L 5 7 L 6 6 M -5 6 L 0 8 L 5 8 M -5 6 L 0 9 L 3 9 L 5 8 L 6 6 L 6 5","-10 11 M -3 -7 L -3 -8 L -2 -8 L -2 -6 L -4 -6 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 4 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 L 1 -2 M 6 -11 L 7 -9 L 7 -7 L 6 -5 L 5 -4 M 4 -12 L 5 -11 L 6 -9 L 6 -7 L 5 -5 L 3 -3 L 1 -2 M -1 -2 L 1 -2 L 4 -1 L 5 0 L 6 2 L 6 5 L 5 7 L 3 8 L 0 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 3 L -6 3 L -6 5 L -7 5 L -7 4 M 4 0 L 5 2 L 5 5 L 4 7 M 1 -2 L 3 -1 L 4 1 L 4 5 L 3 7 L 2 8 L 0 9","-10 11 M 5 -8 L 0 9 L 2 9 M 8 -12 L 6 -8 L 1 9 M 8 -12 L 2 9 M 8 -12 L -8 3 L 8 3","-10 11 M -1 -12 L -6 -2 M -1 -12 L 9 -12 M -1 -11 L 7 -11 M -2 -10 L 3 -10 L 7 -11 L 9 -12 M -6 -2 L -5 -3 L -2 -4 L 1 -4 L 4 -3 L 5 -2 L 6 0 L 6 3 L 5 6 L 3 8 L -1 9 L -4 9 L -6 8 L -7 7 L -8 5 L -8 3 L -6 3 L -6 5 L -7 5 L -7 4 M 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 M 1 -4 L 3 -3 L 4 -1 L 4 3 L 3 6 L 1 8 L -1 9","-10 11 M 7 -8 L 7 -9 L 6 -9 L 6 -7 L 8 -7 L 8 -9 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -3 9 L 0 9 L 3 8 L 5 6 L 6 4 L 6 1 L 5 -1 L 4 -2 L 2 -3 L -1 -3 L -3 -2 L -4 -1 L -5 1 M -2 -9 L -4 -6 L -5 -3 L -6 1 L -6 5 L -5 7 M 4 6 L 5 4 L 5 1 L 4 -1 M 2 -12 L 0 -11 L -2 -8 L -3 -6 L -4 -3 L -5 1 L -5 6 L -4 8 L -3 9 M 0 9 L 2 8 L 3 7 L 4 4 L 4 0 L 3 -2 L 2 -3","-10 11 M -4 -12 L -6 -6 M 9 -12 L 8 -9 L 6 -6 L 2 -1 L 0 2 L -1 5 L -2 9 M 0 1 L -2 5 L -3 9 M 6 -6 L 0 0 L -2 3 L -3 5 L -4 9 L -2 9 M -5 -9 L -2 -12 L 0 -12 L 5 -9 M -3 -11 L 0 -11 L 5 -9 M -5 -9 L -3 -10 L 0 -10 L 5 -9 L 7 -9 L 8 -10 L 9 -12","-10 11 M 1 -12 L -2 -11 L -3 -10 L -4 -8 L -4 -5 L -3 -3 L -1 -2 L 2 -2 L 5 -3 L 7 -4 L 8 -6 L 8 -9 L 7 -11 L 5 -12 L 1 -12 M 3 -12 L -2 -11 M -2 -10 L -3 -8 L -3 -4 L -2 -3 M -3 -3 L 0 -2 M 1 -2 L 5 -3 M 6 -4 L 7 -6 L 7 -9 L 6 -11 M 7 -11 L 3 -12 M 1 -12 L -1 -10 L -2 -8 L -2 -4 L -1 -2 M 2 -2 L 4 -3 L 5 -4 L 6 -6 L 6 -10 L 5 -12 M -1 -2 L -5 -1 L -7 1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 4 8 L 5 7 L 6 5 L 6 2 L 5 0 L 4 -1 L 2 -2 M 0 -2 L -5 -1 M -4 -1 L -6 1 L -7 3 L -7 6 L -6 8 M -7 8 L -2 9 L 4 8 M 4 7 L 5 5 L 5 2 L 4 0 M 4 -1 L 1 -2 M -1 -2 L -3 -1 L -5 1 L -6 3 L -6 6 L -5 8 L -4 9 M 0 9 L 2 8 L 3 7 L 4 5 L 4 1 L 3 -1 L 2 -2","-10 11 M 6 -4 L 5 -2 L 4 -1 L 2 0 L -1 0 L -3 -1 L -4 -2 L -5 -4 L -5 -7 L -4 -9 L -2 -11 L 1 -12 L 4 -12 L 6 -11 L 7 -10 L 8 -7 L 8 -4 L 7 0 L 6 3 L 4 6 L 2 8 L -1 9 L -4 9 L -6 8 L -7 6 L -7 4 L -5 4 L -5 6 L -6 6 L -6 5 M -3 -2 L -4 -4 L -4 -7 L -3 -9 M 6 -10 L 7 -8 L 7 -4 L 6 0 L 5 3 L 3 6 M -1 0 L -2 -1 L -3 -3 L -3 -7 L -2 -10 L -1 -11 L 1 -12 M 4 -12 L 5 -11 L 6 -9 L 6 -4 L 5 0 L 4 3 L 3 5 L 1 8 L -1 9","-5 6 M 1 -5 L 0 -4 L 0 -3 L 1 -2 L 2 -2 L 3 -3 L 3 -4 L 2 -5 L 1 -5 M 1 -4 L 1 -3 L 2 -3 L 2 -4 L 1 -4 M -2 6 L -3 7 L -3 8 L -2 9 L -1 9 L 0 8 L 0 7 L -1 6 L -2 6 M -2 7 L -2 8 L -1 8 L -1 7 L -2 7","-5 6 M 1 -5 L 0 -4 L 0 -3 L 1 -2 L 2 -2 L 3 -3 L 3 -4 L 2 -5 L 1 -5 M 1 -4 L 1 -3 L 2 -3 L 2 -4 L 1 -4 M -1 9 L -2 9 L -3 8 L -3 7 L -2 6 L -1 6 L 0 7 L 0 9 L -1 11 L -2 12 L -4 13 M -2 7 L -2 8 L -1 8 L -1 7 L -2 7 M -1 9 L -1 10 L -2 12","-12 12 M 8 -9 L -8 0 L 8 9","-12 13 M -8 -5 L 9 -5 L 9 -4 M -8 -5 L -8 -4 L 9 -4 M -8 3 L 9 3 L 9 4 M -8 3 L -8 4 L 9 4","-12 12 M -8 -9 L 8 0 L -8 9","-10 11 M -3 -7 L -3 -8 L -2 -8 L -2 -6 L -4 -6 L -4 -8 L -3 -10 L -2 -11 L 1 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -5 L 7 -4 L 5 -3 L 1 -2 L -1 -1 L -1 1 L 1 2 L 2 2 M 3 -12 L 8 -11 M 7 -11 L 8 -9 L 8 -7 L 7 -5 L 6 -4 L 4 -3 M 5 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -5 L 5 -4 L 1 -2 L 0 -1 L 0 1 L 1 2 M -2 6 L -3 7 L -3 8 L -2 9 L -1 9 L 0 8 L 0 7 L -1 6 L -2 6 M -2 7 L -2 8 L -1 8 L -1 7 L -2 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 3 -12 L -9 8 M 1 -8 L 2 9 M 2 -10 L 3 8 M 3 -12 L 3 -10 L 4 7 L 4 9 M -6 3 L 2 3 M -12 9 L -6 9 M -1 9 L 6 9 M -9 8 L -11 9 M -9 8 L -7 9 M 2 8 L 0 9 M 2 7 L 1 9 M 4 7 L 5 9","-12 12 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M -6 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 7 -3 L 4 -2 M 7 -11 L 8 -9 L 8 -7 L 7 -4 L 6 -3 M 5 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -4 L 4 -2 M -4 -2 L 4 -2 L 6 -1 L 7 1 L 7 3 L 6 6 L 4 8 L 0 9 L -12 9 M 5 -1 L 6 1 L 6 3 L 5 6 L 3 8 M 4 -2 L 5 0 L 5 3 L 4 6 L 2 8 L 0 9 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9","-10 11 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -2 9 L 1 9 L 3 8 L 5 6 L 6 4 M -1 -10 L -3 -8 L -4 -6 L -5 -3 L -6 1 L -6 5 L -5 7 M 2 -12 L 0 -11 L -2 -8 L -3 -6 L -4 -3 L -5 1 L -5 6 L -4 8 L -2 9","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M -6 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -7 L 8 -3 L 7 1 L 5 5 L 3 7 L 1 8 L -3 9 L -12 9 M 5 -11 L 6 -10 L 7 -7 L 7 -3 L 6 1 L 4 5 L 2 7 M 3 -12 L 5 -10 L 6 -7 L 6 -3 L 5 1 L 3 5 L 0 8 L -3 9 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M 3 -6 L 1 2 M -6 -12 L 9 -12 L 8 -6 M -4 -2 L 2 -2 M -12 9 L 3 9 L 5 4 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M 5 -12 L 8 -11 M 6 -12 L 8 -10 M 7 -12 L 8 -9 M 8 -12 L 8 -6 M 3 -6 L 1 -2 L 1 2 M 2 -4 L 0 -2 L 1 0 M 2 -3 L -1 -2 L 1 -1 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9 M -2 9 L 3 8 M 0 9 L 3 7 M 3 7 L 5 4","-12 10 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M 3 -6 L 1 2 M -6 -12 L 9 -12 L 8 -6 M -4 -2 L 2 -2 M -12 9 L -4 9 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M 5 -12 L 8 -11 M 6 -12 L 8 -10 M 7 -12 L 8 -9 M 8 -12 L 8 -6 M 3 -6 L 1 -2 L 1 2 M 2 -4 L 0 -2 L 1 0 M 2 -3 L -1 -2 L 1 -1 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9","-10 12 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 5 -12 L 2 -12 L -1 -11 L -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 4 L -6 7 L -5 8 L -2 9 L 0 9 L 3 8 L 5 6 L 7 2 M -1 -10 L -3 -8 L -4 -6 L -5 -3 L -6 1 L -6 5 L -5 7 M 4 6 L 5 5 L 6 2 M 2 -12 L 0 -11 L -2 -8 L -3 -6 L -4 -3 L -5 1 L -5 6 L -4 8 L -2 9 M 0 9 L 2 8 L 4 5 L 5 2 M 2 2 L 10 2 M 3 2 L 5 3 M 4 2 L 5 5 M 8 2 L 6 4 M 9 2 L 6 3","-13 13 M -4 -12 L -10 9 M -3 -12 L -9 9 M -2 -12 L -8 9 M 8 -12 L 2 9 M 9 -12 L 3 9 M 10 -12 L 4 9 M -7 -12 L 1 -12 M 5 -12 L 13 -12 M -6 -2 L 6 -2 M -13 9 L -5 9 M -1 9 L 7 9 M -6 -12 L -3 -11 M -5 -12 L -4 -10 M -1 -12 L -3 -10 M 0 -12 L -3 -11 M 6 -12 L 9 -11 M 7 -12 L 8 -10 M 11 -12 L 9 -10 M 12 -12 L 9 -11 M -9 8 L -12 9 M -9 7 L -11 9 M -8 7 L -7 9 M -9 8 L -6 9 M 3 8 L 0 9 M 3 7 L 1 9 M 4 7 L 5 9 M 3 8 L 6 9","-7 7 M 2 -12 L -4 9 M 3 -12 L -3 9 M 4 -12 L -2 9 M -1 -12 L 7 -12 M -7 9 L 1 9 M 0 -12 L 3 -11 M 1 -12 L 2 -10 M 5 -12 L 3 -10 M 6 -12 L 3 -11 M -3 8 L -6 9 M -3 7 L -5 9 M -2 7 L -1 9 M -3 8 L 0 9","-9 10 M 5 -12 L 0 5 L -1 7 L -3 9 M 6 -12 L 2 1 L 1 4 L 0 6 M 7 -12 L 3 1 L 1 6 L -1 8 L -3 9 L -5 9 L -7 8 L -8 6 L -8 4 L -7 3 L -6 3 L -5 4 L -5 5 L -6 6 L -7 6 M -7 4 L -7 5 L -6 5 L -6 4 L -7 4 M 2 -12 L 10 -12 M 3 -12 L 6 -11 M 4 -12 L 5 -10 M 8 -12 L 6 -10 M 9 -12 L 6 -11","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M 10 -11 L -5 0 M -1 -3 L 3 9 M 0 -3 L 4 9 M 1 -4 L 5 8 M -6 -12 L 2 -12 M 7 -12 L 13 -12 M -12 9 L -4 9 M 0 9 L 7 9 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M 8 -12 L 10 -11 M 12 -12 L 10 -11 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9 M 3 8 L 1 9 M 3 7 L 2 9 M 4 7 L 6 9","-10 10 M -1 -12 L -7 9 M 0 -12 L -6 9 M 1 -12 L -5 9 M -4 -12 L 4 -12 M -10 9 L 5 9 L 7 3 M -3 -12 L 0 -11 M -2 -12 L -1 -10 M 2 -12 L 0 -10 M 3 -12 L 0 -11 M -6 8 L -9 9 M -6 7 L -8 9 M -5 7 L -4 9 M -6 8 L -3 9 M 0 9 L 5 8 M 2 9 L 6 6 M 4 9 L 7 3","-14 14 M -5 -12 L -11 8 M -5 -11 L -4 7 L -4 9 M -4 -12 L -3 7 M -3 -12 L -2 6 M 9 -12 L -2 6 L -4 9 M 9 -12 L 3 9 M 10 -12 L 4 9 M 11 -12 L 5 9 M -8 -12 L -3 -12 M 9 -12 L 14 -12 M -14 9 L -8 9 M 0 9 L 8 9 M -7 -12 L -5 -11 M -6 -12 L -5 -10 M 12 -12 L 10 -10 M 13 -12 L 10 -11 M -11 8 L -13 9 M -11 8 L -9 9 M 4 8 L 1 9 M 4 7 L 2 9 M 5 7 L 6 9 M 4 8 L 7 9","-12 13 M -3 -12 L -9 8 M -3 -12 L 4 9 M -2 -12 L 4 6 M -1 -12 L 5 6 M 10 -11 L 5 6 L 4 9 M -6 -12 L -1 -12 M 7 -12 L 13 -12 M -12 9 L -6 9 M -5 -12 L -2 -11 M -4 -12 L -2 -10 M 8 -12 L 10 -11 M 12 -12 L 10 -11 M -9 8 L -11 9 M -9 8 L -7 9","-11 11 M 1 -12 L -2 -11 L -4 -9 L -6 -6 L -7 -3 L -8 1 L -8 4 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 1 -12 M -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 5 L -6 7 M 3 6 L 5 3 L 6 0 L 7 -4 L 7 -8 L 6 -10 M 1 -12 L -1 -11 L -3 -8 L -4 -6 L -5 -3 L -6 1 L -6 6 L -5 8 L -4 9 M -1 9 L 1 8 L 3 5 L 4 3 L 5 0 L 6 -4 L 6 -9 L 5 -11 L 4 -12","-12 11 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M -6 -12 L 6 -12 L 9 -11 L 10 -9 L 10 -7 L 9 -4 L 7 -2 L 3 -1 L -5 -1 M 8 -11 L 9 -9 L 9 -7 L 8 -4 L 6 -2 M 6 -12 L 7 -11 L 8 -9 L 8 -7 L 7 -4 L 5 -2 L 3 -1 M -12 9 L -4 9 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9","-11 11 M 1 -12 L -2 -11 L -4 -9 L -6 -6 L -7 -3 L -8 1 L -8 4 L -7 7 L -6 8 L -4 9 L -1 9 L 2 8 L 4 6 L 6 3 L 7 0 L 8 -4 L 8 -7 L 7 -10 L 6 -11 L 4 -12 L 1 -12 M -3 -9 L -5 -6 L -6 -3 L -7 1 L -7 5 L -6 7 M 3 6 L 5 3 L 6 0 L 7 -4 L 7 -8 L 6 -10 M 1 -12 L -1 -11 L -3 -8 L -4 -6 L -5 -3 L -6 1 L -6 6 L -5 8 L -4 9 M -1 9 L 1 8 L 3 5 L 4 3 L 5 0 L 6 -4 L 6 -9 L 5 -11 L 4 -12 M -6 6 L -5 4 L -3 3 L -2 3 L 0 4 L 1 6 L 2 11 L 3 12 L 4 12 L 5 11 M 2 12 L 3 13 L 4 13 M 1 6 L 1 13 L 2 14 L 4 14 L 5 11 L 5 10","-12 12 M -3 -12 L -9 9 M -2 -12 L -8 9 M -1 -12 L -7 9 M -6 -12 L 5 -12 L 8 -11 L 9 -9 L 9 -7 L 8 -4 L 7 -3 L 4 -2 L -4 -2 M 7 -11 L 8 -9 L 8 -7 L 7 -4 L 6 -3 M 5 -12 L 6 -11 L 7 -9 L 7 -7 L 6 -4 L 4 -2 M 0 -2 L 2 -1 L 3 0 L 5 6 L 6 7 L 7 7 L 8 6 M 5 7 L 6 8 L 7 8 M 3 0 L 4 8 L 5 9 L 7 9 L 8 6 L 8 5 M -12 9 L -4 9 M -5 -12 L -2 -11 M -4 -12 L -3 -10 M 0 -12 L -2 -10 M 1 -12 L -2 -11 M -8 8 L -11 9 M -8 7 L -10 9 M -7 7 L -6 9 M -8 8 L -5 9","-11 12 M 8 -10 L 9 -10 L 10 -12 L 9 -6 L 9 -8 L 8 -10 L 7 -11 L 4 -12 L 0 -12 L -3 -11 L -5 -9 L -5 -6 L -4 -4 L -2 -2 L 4 1 L 5 3 L 5 6 L 4 8 M -4 -6 L -3 -4 L 4 0 L 5 2 M -3 -11 L -4 -9 L -4 -7 L -3 -5 L 3 -2 L 5 0 L 6 2 L 6 5 L 5 7 L 4 8 L 1 9 L -3 9 L -6 8 L -7 7 L -8 5 L -8 3 L -9 9 L -8 7 L -7 7","-11 11 M 2 -12 L -4 9 M 3 -12 L -3 9 M 4 -12 L -2 9 M -5 -12 L -7 -6 M 11 -12 L 10 -6 M -5 -12 L 11 -12 M -7 9 L 1 9 M -4 -12 L -7 -6 M -2 -12 L -6 -9 M 0 -12 L -5 -11 M 7 -12 L 10 -11 M 8 -12 L 10 -10 M 9 -12 L 10 -9 M 10 -12 L 10 -6 M -3 8 L -6 9 M -3 7 L -5 9 M -2 7 L -1 9 M -3 8 L 0 9","-12 13 M -4 -12 L -7 -1 L -8 3 L -8 6 L -7 8 L -4 9 L 0 9 L 3 8 L 5 6 L 6 3 L 10 -11 M -3 -12 L -6 -1 L -7 3 L -7 7 L -6 8 M -2 -12 L -5 -1 L -6 3 L -6 7 L -4 9 M -7 -12 L 1 -12 M 7 -12 L 13 -12 M -6 -12 L -3 -11 M -5 -12 L -4 -10 M -1 -12 L -3 -10 M 0 -12 L -3 -11 M 8 -12 L 10 -11 M 12 -12 L 10 -11","-10 10 M -4 -12 L -4 -10 L -3 7 L -3 9 M -3 -11 L -2 6 M -2 -12 L -1 5 M 9 -11 L -3 9 M -6 -12 L 1 -12 M 6 -12 L 12 -12 M -5 -12 L -4 -10 M -1 -12 L -2 -10 M 0 -12 L -3 -11 M 7 -12 L 9 -11 M 11 -12 L 9 -11","-13 13 M -5 -12 L -5 -10 L -7 7 L -7 9 M -4 -11 L -6 6 M -3 -12 L -5 5 M 3 -12 L -5 5 L -7 9 M 3 -12 L 3 -10 L 1 7 L 1 9 M 4 -11 L 2 6 M 5 -12 L 3 5 M 11 -11 L 3 5 L 1 9 M -8 -12 L 0 -12 M 3 -12 L 5 -12 M 8 -12 L 14 -12 M -7 -12 L -4 -11 M -6 -12 L -5 -10 M -2 -12 L -4 -9 M -1 -12 L -4 -11 M 9 -12 L 11 -11 M 13 -12 L 11 -11","-11 11 M -4 -12 L 2 9 M -3 -12 L 3 9 M -2 -12 L 4 9 M 9 -11 L -9 8 M -6 -12 L 1 -12 M 6 -12 L 12 -12 M -12 9 L -6 9 M -1 9 L 6 9 M -5 -12 L -3 -10 M -1 -12 L -2 -10 M 0 -12 L -2 -11 M 7 -12 L 9 -11 M 11 -12 L 9 -11 M -9 8 L -11 9 M -9 8 L -7 9 M 2 8 L 0 9 M 2 7 L 1 9 M 3 7 L 5 9","-11 11 M -5 -12 L -1 -2 L -4 9 M -4 -12 L 0 -2 L -3 9 M -3 -12 L 1 -2 L -2 9 M 10 -11 L 1 -2 M -7 -12 L 0 -12 M 7 -12 L 13 -12 M -7 9 L 1 9 M -6 -12 L -4 -11 M -2 -12 L -3 -10 M -1 -12 L -4 -11 M 8 -12 L 10 -11 M 12 -12 L 10 -11 M -3 8 L -6 9 M -3 7 L -5 9 M -2 7 L -1 9 M -3 8 L 0 9","-11 11 M 8 -12 L -10 9 M 9 -12 L -9 9 M 10 -12 L -8 9 M 10 -12 L -4 -12 L -6 -6 M -10 9 L 4 9 L 6 3 M -3 -12 L -6 -6 M -2 -12 L -5 -9 M 0 -12 L -4 -11 M 0 9 L 4 8 M 2 9 L 5 6 M 3 9 L 6 3","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-10 10 M -10 16 L 10 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-11 11 M 5 -5 L 3 2 L 3 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5 M 6 -5 L 4 2 L 4 8 M 5 -5 L 7 -5 L 5 2 L 4 6 M 3 2 L 3 -1 L 2 -4 L 0 -5 L -2 -5 L -5 -4 L -7 -1 L -8 2 L -8 4 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 2 5 L 3 2 M -4 -4 L -6 -1 L -7 2 L -7 5 L -6 7 M -2 -5 L -4 -3 L -5 -1 L -6 2 L -6 5 L -5 8 L -4 9","-9 10 M -2 -12 L -4 -5 L -5 1 L -5 5 L -4 7 L -3 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 2 L 7 0 L 6 -3 L 5 -4 L 3 -5 L 1 -5 L -1 -4 L -2 -3 L -3 -1 L -4 2 M -1 -12 L -3 -5 L -4 -1 L -4 5 L -3 8 M 4 7 L 5 5 L 6 2 L 6 -1 L 5 -3 M -5 -12 L 0 -12 L -2 -5 L -4 2 M 1 9 L 3 7 L 4 5 L 5 2 L 5 -1 L 4 -4 L 3 -5 M -4 -12 L -1 -11 M -3 -12 L -2 -10","-9 9 M 5 -1 L 5 -2 L 4 -2 L 4 0 L 6 0 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 5 M -3 -3 L -4 -1 L -5 2 L -5 5 L -4 7 M 0 -5 L -2 -3 L -3 -1 L -4 2 L -4 5 L -3 8 L -2 9","-11 11 M 7 -12 L 4 -1 L 3 3 L 3 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5 M 8 -12 L 5 -1 L 4 3 L 4 8 M 4 -12 L 9 -12 L 5 2 L 4 6 M 3 2 L 3 -1 L 2 -4 L 0 -5 L -2 -5 L -5 -4 L -7 -1 L -8 2 L -8 4 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 2 5 L 3 2 M -5 -3 L -6 -1 L -7 2 L -7 5 L -6 7 M -2 -5 L -4 -3 L -5 -1 L -6 2 L -6 5 L -5 8 L -4 9 M 5 -12 L 8 -11 M 6 -12 L 7 -10","-9 9 M -5 4 L -1 3 L 2 2 L 5 0 L 6 -2 L 5 -4 L 3 -5 L 0 -5 L -3 -4 L -5 -1 L -6 2 L -6 4 L -5 7 L -4 8 L -2 9 L 0 9 L 3 8 L 5 6 M -3 -3 L -4 -1 L -5 2 L -5 5 L -4 7 M 0 -5 L -2 -3 L -3 -1 L -4 2 L -4 5 L -3 8 L -2 9","-8 8 M 8 -10 L 8 -11 L 7 -11 L 7 -9 L 9 -9 L 9 -11 L 8 -12 L 6 -12 L 4 -11 L 2 -9 L 1 -7 L 0 -4 L -1 0 L -3 9 L -4 12 L -5 14 L -7 16 M 2 -8 L 1 -5 L 0 0 L -2 9 L -3 12 M 6 -12 L 4 -10 L 3 -8 L 2 -5 L 1 0 L -1 8 L -2 11 L -3 13 L -5 15 L -7 16 L -9 16 L -10 15 L -10 13 L -8 13 L -8 15 L -9 15 L -9 14 M -4 -5 L 7 -5","-10 11 M 6 -5 L 2 9 L 1 12 L -1 15 L -3 16 M 7 -5 L 3 9 L 1 13 M 6 -5 L 8 -5 L 4 9 L 2 13 L 0 15 L -3 16 L -6 16 L -8 15 L -9 14 L -9 12 L -7 12 L -7 14 L -8 14 L -8 13 M 4 2 L 4 -1 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 4 L -6 7 L -5 8 L -3 9 L -1 9 L 1 8 L 2 7 L 3 5 L 4 2 M -4 -3 L -5 -1 L -6 2 L -6 5 L -5 7 M -1 -5 L -3 -3 L -4 -1 L -5 2 L -5 5 L -4 8 L -3 9","-11 11 M -3 -12 L -9 9 L -7 9 M -2 -12 L -8 9 M -6 -12 L -1 -12 L -7 9 M -5 2 L -3 -2 L -1 -4 L 1 -5 L 3 -5 L 5 -4 L 6 -2 L 6 1 L 4 6 M 5 -4 L 5 0 L 4 4 L 4 8 M 5 -2 L 3 3 L 3 6 L 4 8 L 5 9 L 7 9 L 9 7 L 10 5 M -5 -12 L -2 -11 M -4 -12 L -3 -10","-7 6 M 1 -12 L 1 -10 L 3 -10 L 3 -12 L 1 -12 M 2 -12 L 2 -10 M 1 -11 L 3 -11 M -6 -1 L -5 -3 L -3 -5 L -1 -5 L 0 -4 L 1 -2 L 1 1 L -1 6 M 0 -4 L 0 0 L -1 4 L -1 8 M 0 -2 L -2 3 L -2 6 L -1 8 L 0 9 L 2 9 L 4 7 L 5 5","-7 6 M 3 -12 L 3 -10 L 5 -10 L 5 -12 L 3 -12 M 4 -12 L 4 -10 M 3 -11 L 5 -11 M -5 -1 L -4 -3 L -2 -5 L 0 -5 L 1 -4 L 2 -2 L 2 1 L 0 8 L -1 11 L -2 13 L -4 15 L -6 16 L -8 16 L -9 15 L -9 13 L -7 13 L -7 15 L -8 15 L -8 14 M 1 -4 L 1 1 L -1 8 L -2 11 L -3 13 M 1 -2 L 0 2 L -2 9 L -3 12 L -4 14 L -6 16","-11 11 M -3 -12 L -9 9 L -7 9 M -2 -12 L -8 9 M -6 -12 L -1 -12 L -7 9 M 7 -3 L 7 -4 L 6 -4 L 6 -2 L 8 -2 L 8 -4 L 7 -5 L 5 -5 L 3 -4 L -1 0 L -3 1 M -5 1 L -3 1 L -1 2 L 0 3 L 2 7 L 3 8 L 5 8 M -1 3 L 1 7 L 2 8 M -3 1 L -2 2 L 0 8 L 1 9 L 3 9 L 5 8 L 7 5 M -5 -12 L -2 -11 M -4 -12 L -3 -10","-6 6 M 2 -12 L -1 -1 L -2 3 L -2 6 L -1 8 L 0 9 L 2 9 L 4 7 L 5 5 M 3 -12 L 0 -1 L -1 3 L -1 8 M -1 -12 L 4 -12 L 0 2 L -1 6 M 0 -12 L 3 -11 M 1 -12 L 2 -10","-18 17 M -17 -1 L -16 -3 L -14 -5 L -12 -5 L -11 -4 L -10 -2 L -10 1 L -12 9 M -11 -4 L -11 1 L -13 9 M -11 -2 L -12 2 L -14 9 L -12 9 M -10 1 L -8 -2 L -6 -4 L -4 -5 L -2 -5 L 0 -4 L 1 -2 L 1 1 L -1 9 M 0 -4 L 0 1 L -2 9 M 0 -2 L -1 2 L -3 9 L -1 9 M 1 1 L 3 -2 L 5 -4 L 7 -5 L 9 -5 L 11 -4 L 12 -2 L 12 1 L 10 6 M 11 -4 L 11 0 L 10 4 L 10 8 M 11 -2 L 9 3 L 9 6 L 10 8 L 11 9 L 13 9 L 15 7 L 16 5","-12 12 M -11 -1 L -10 -3 L -8 -5 L -6 -5 L -5 -4 L -4 -2 L -4 1 L -6 9 M -5 -4 L -5 1 L -7 9 M -5 -2 L -6 2 L -8 9 L -6 9 M -4 1 L -2 -2 L 0 -4 L 2 -5 L 4 -5 L 6 -4 L 7 -2 L 7 1 L 5 6 M 6 -4 L 6 0 L 5 4 L 5 8 M 6 -2 L 4 3 L 4 6 L 5 8 L 6 9 L 8 9 L 10 7 L 11 5","-10 10 M -1 -5 L -4 -4 L -6 -1 L -7 2 L -7 4 L -6 7 L -5 8 L -2 9 L 1 9 L 4 8 L 6 5 L 7 2 L 7 0 L 6 -3 L 5 -4 L 2 -5 L -1 -5 M -4 -3 L -5 -1 L -6 2 L -6 5 L -5 7 M 4 7 L 5 5 L 6 2 L 6 -1 L 5 -3 M -1 -5 L -3 -3 L -4 -1 L -5 2 L -5 5 L -4 8 L -2 9 M 1 9 L 3 7 L 4 5 L 5 2 L 5 -1 L 4 -4 L 2 -5","-11 11 M -10 -1 L -9 -3 L -7 -5 L -5 -5 L -4 -4 L -3 -2 L -3 1 L -4 5 L -7 16 M -4 -4 L -4 1 L -5 5 L -8 16 M -4 -2 L -5 2 L -9 16 M -3 2 L -2 -1 L -1 -3 L 0 -4 L 2 -5 L 4 -5 L 6 -4 L 7 -3 L 8 0 L 8 2 L 7 5 L 5 8 L 2 9 L 0 9 L -2 8 L -3 5 L -3 2 M 6 -3 L 7 -1 L 7 2 L 6 5 L 5 7 M 4 -5 L 5 -4 L 6 -1 L 6 2 L 5 5 L 4 7 L 2 9 M -12 16 L -4 16 M -8 15 L -11 16 M -8 14 L -10 16 M -7 14 L -6 16 M -8 15 L -5 16","-11 10 M 5 -5 L -1 16 M 6 -5 L 0 16 M 5 -5 L 7 -5 L 1 16 M 3 2 L 3 -1 L 2 -4 L 0 -5 L -2 -5 L -5 -4 L -7 -1 L -8 2 L -8 4 L -7 7 L -6 8 L -4 9 L -2 9 L 0 8 L 1 7 L 2 5 L 3 2 M -5 -3 L -6 -1 L -7 2 L -7 5 L -6 7 M -2 -5 L -4 -3 L -5 -1 L -6 2 L -6 5 L -5 8 L -4 9 M -4 16 L 4 16 M 0 15 L -3 16 M 0 14 L -2 16 M 1 14 L 2 16 M 0 15 L 3 16","-9 9 M -8 -1 L -7 -3 L -5 -5 L -3 -5 L -2 -4 L -1 -2 L -1 2 L -3 9 M -2 -4 L -2 2 L -4 9 M -2 -2 L -3 2 L -5 9 L -3 9 M 7 -3 L 7 -4 L 6 -4 L 6 -2 L 8 -2 L 8 -4 L 7 -5 L 5 -5 L 3 -4 L 1 -2 L -1 2","-8 9 M 6 -2 L 6 -3 L 5 -3 L 5 -1 L 7 -1 L 7 -3 L 6 -4 L 3 -5 L 0 -5 L -3 -4 L -4 -3 L -4 -1 L -3 1 L -1 2 L 2 3 L 4 4 L 5 6 M -3 -4 L -4 -1 M -3 0 L -1 1 L 2 2 L 4 3 M 5 4 L 4 8 M -4 -3 L -3 -1 L -1 0 L 2 1 L 4 2 L 5 4 L 5 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -6 5 L -4 5 L -4 7 L -5 7 L -5 6","-7 7 M 2 -12 L -1 -1 L -2 3 L -2 6 L -1 8 L 0 9 L 2 9 L 4 7 L 5 5 M 3 -12 L 0 -1 L -1 3 L -1 8 M 2 -12 L 4 -12 L 0 2 L -1 6 M -4 -5 L 6 -5","-12 12 M -11 -1 L -10 -3 L -8 -5 L -6 -5 L -5 -4 L -4 -2 L -4 1 L -6 6 M -5 -4 L -5 0 L -6 4 L -6 8 M -5 -2 L -7 3 L -7 6 L -6 8 L -4 9 L -2 9 L 0 8 L 2 6 L 4 3 M 6 -5 L 4 3 L 4 6 L 5 8 L 6 9 L 8 9 L 10 7 L 11 5 M 7 -5 L 5 3 L 5 8 M 6 -5 L 8 -5 L 6 2 L 5 6","-10 10 M -9 -1 L -8 -3 L -6 -5 L -4 -5 L -3 -4 L -2 -2 L -2 1 L -4 6 M -3 -4 L -3 0 L -4 4 L -4 8 M -3 -2 L -5 3 L -5 6 L -4 8 L -2 9 L 0 9 L 2 8 L 4 6 L 6 3 L 7 -1 L 7 -5 L 6 -5 L 6 -4 L 7 -2","-15 15 M -14 -1 L -13 -3 L -11 -5 L -9 -5 L -8 -4 L -7 -2 L -7 1 L -9 6 M -8 -4 L -8 0 L -9 4 L -9 8 M -8 -2 L -10 3 L -10 6 L -9 8 L -7 9 L -5 9 L -3 8 L -1 6 L 0 3 M 2 -5 L 0 3 L 0 6 L 1 8 L 3 9 L 5 9 L 7 8 L 9 6 L 11 3 L 12 -1 L 12 -5 L 11 -5 L 11 -4 L 12 -2 M 3 -5 L 1 3 L 1 8 M 2 -5 L 4 -5 L 2 2 L 1 6","-11 11 M -8 -1 L -6 -4 L -4 -5 L -2 -5 L 0 -4 L 1 -2 L 1 0 M -2 -5 L -1 -4 L -1 0 L -2 4 L -3 6 L -5 8 L -7 9 L -9 9 L -10 8 L -10 6 L -8 6 L -8 8 L -9 8 L -9 7 M 0 -3 L 0 0 L -1 4 L -1 7 M 8 -3 L 8 -4 L 7 -4 L 7 -2 L 9 -2 L 9 -4 L 8 -5 L 6 -5 L 4 -4 L 2 -2 L 1 0 L 0 4 L 0 8 L 1 9 M -2 4 L -2 6 L -1 8 L 1 9 L 3 9 L 5 8 L 7 5","-11 11 M -10 -1 L -9 -3 L -7 -5 L -5 -5 L -4 -4 L -3 -2 L -3 1 L -5 6 M -4 -4 L -4 0 L -5 4 L -5 8 M -4 -2 L -6 3 L -6 6 L -5 8 L -3 9 L -1 9 L 1 8 L 3 6 L 5 2 M 7 -5 L 3 9 L 2 12 L 0 15 L -2 16 M 8 -5 L 4 9 L 2 13 M 7 -5 L 9 -5 L 5 9 L 3 13 L 1 15 L -2 16 L -5 16 L -7 15 L -8 14 L -8 12 L -6 12 L -6 14 L -7 14 L -7 13","-10 10 M 7 -5 L 6 -3 L 4 -1 L -4 5 L -6 7 L -7 9 M 6 -3 L -3 -3 L -5 -2 L -6 0 M 4 -3 L 0 -4 L -3 -4 L -4 -3 M 4 -3 L 0 -5 L -3 -5 L -5 -3 L -6 0 M -6 7 L 3 7 L 5 6 L 6 4 M -4 7 L 0 8 L 3 8 L 4 7 M -4 7 L 0 9 L 3 9 L 5 7 L 6 4","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
timesr = ["-8 8","-5 5 M 0 -12 L -1 -10 L 0 2 L 1 -10 L 0 -12 M 0 -10 L 0 -4 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 6 -9 L 5 -8 L 6 -7 L 7 -8 L 7 -9 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 7 2 M -7 -7 L -5 -5 L -3 -4 L 3 -2 L 5 -1 L 6 0 L 7 2 L 7 6 L 5 8 L 2 9 L -2 9 L -5 8 L -7 6 L -7 5 L -6 4 L -5 5 L -6 6","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-12 13 M 9 -4 L 8 -3 L 9 -2 L 10 -3 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -5 9 L -8 8 L -9 6 L -9 3 L -8 1 L -2 -3 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -7 L -4 -4 L -2 -1 L 3 6 L 5 8 L 8 9 L 9 9 L 10 8 L 10 7 M -5 9 L -7 8 L -8 6 L -8 3 L -7 1 L -5 -1 M -5 -7 L -4 -5 L 4 6 L 6 8 L 8 9","-4 4 M 0 -12 L -1 -5 M 1 -12 L -1 -5","-7 7 M 4 -16 L 2 -14 L 0 -11 L -2 -7 L -3 -2 L -3 2 L -2 7 L 0 11 L 2 14 L 4 16 M 2 -14 L 0 -10 L -1 -7 L -2 -2 L -2 2 L -1 7 L 0 10 L 2 14","-7 7 M -4 -16 L -2 -14 L 0 -11 L 2 -7 L 3 -2 L 3 2 L 2 7 L 0 11 L -2 14 L -4 16 M -2 -14 L 0 -10 L 1 -7 L 2 -2 L 2 2 L 1 7 L 0 10 L -2 14","-8 8 M 0 -6 L 0 6 M -5 -3 L 5 3 M 5 -3 L -5 3","-13 13 M 0 -9 L 0 9 M -9 0 L 9 0","-4 4 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-13 13 M -9 0 L 9 0","-4 4 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-11 11 M 9 -16 L -9 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -4 -10 L -5 -8 L -6 -3 L -6 0 L -5 5 L -4 7 L -3 8 L -1 9 M 1 9 L 3 8 L 4 7 L 5 5 L 6 0 L 6 -3 L 5 -8 L 4 -10 L 3 -11 L 1 -12","-10 10 M -4 -8 L -2 -9 L 1 -12 L 1 9 M 0 -11 L 0 9 M -4 9 L 5 9","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 3 -2 L -2 0 L -4 1 L -6 3 L -7 6 L -7 9 M 2 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 2 -2 L -2 0 M -7 7 L -6 6 L -4 6 L 1 8 L 4 8 L 6 7 L 7 6 M -4 6 L 1 9 L 5 9 L 6 8 L 7 6 L 7 4","-10 10 M -6 -8 L -5 -7 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -9 L 6 -6 L 5 -4 L 2 -3 L -1 -3 M 2 -12 L 4 -11 L 5 -9 L 5 -6 L 4 -4 L 2 -3 M 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 5 -1 L 6 2 L 6 5 L 5 7 L 4 8 L 2 9","-10 10 M 2 -10 L 2 9 M 3 -12 L 3 9 M 3 -12 L -8 3 L 8 3 M -1 9 L 6 9","-10 10 M -5 -12 L -7 -2 M -7 -2 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 4 L -6 5 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -5 -12 L 5 -12 M -5 -11 L 0 -11 L 5 -12","-10 10 M 5 -9 L 4 -8 L 5 -7 L 6 -8 L 6 -9 L 5 -11 L 3 -12 L 0 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L 0 -4 L -3 -3 L -5 -1 L -6 2 M 0 -12 L -2 -11 L -4 -9 L -5 -7 L -6 -3 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 2 L 5 -1 L 3 -3 L 1 -4","-10 10 M -7 -12 L -7 -6 M -7 -8 L -6 -10 L -4 -12 L -2 -12 L 3 -9 L 5 -9 L 6 -10 L 7 -12 M -6 -10 L -4 -11 L -2 -11 L 3 -9 M 7 -12 L 7 -9 L 6 -6 L 2 -1 L 1 1 L 0 4 L 0 9 M 6 -6 L 1 -1 L 0 1 L -1 4 L -1 9","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -6 L -5 -4 L -2 -3 L 2 -3 L 5 -4 L 6 -6 L 6 -9 L 5 -11 L 2 -12 L -2 -12 M -2 -12 L -4 -11 L -5 -9 L -5 -6 L -4 -4 L -2 -3 M 2 -3 L 4 -4 L 5 -6 L 5 -9 L 4 -11 L 2 -12 M -2 -3 L -5 -2 L -6 -1 L -7 1 L -7 5 L -6 7 L -5 8 L -2 9 L 2 9 L 5 8 L 6 7 L 7 5 L 7 1 L 6 -1 L 5 -2 L 2 -3 M -2 -3 L -4 -2 L -5 -1 L -6 1 L -6 5 L -5 7 L -4 8 L -2 9 M 2 9 L 4 8 L 5 7 L 6 5 L 6 1 L 5 -1 L 4 -2 L 2 -3","-10 10 M 6 -5 L 5 -2 L 3 0 L 0 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -6 L 7 0 L 6 4 L 5 6 L 3 8 L 0 9 L -3 9 L -5 8 L -6 6 L -6 5 L -5 4 L -4 5 L -5 6 M -1 1 L -3 0 L -5 -2 L -6 -5 L -6 -6 L -5 -9 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 5 -9 L 6 -6 L 6 0 L 5 4 L 4 6 L 2 8 L 0 9","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 0 4 L -1 5 L 0 6 L 1 5 L 0 4","-4 4 M 0 -3 L -1 -2 L 0 -1 L 1 -2 L 0 -3 M 1 5 L 0 6 L -1 5 L 0 4 L 1 5 L 1 7 L -1 9","-12 12 M 8 -9 L -8 0 L 8 9","-13 13 M -9 -3 L 9 -3 M -9 3 L 9 3","-12 12 M -8 -9 L 8 0 L -8 9","-9 9 M -5 -8 L -4 -7 L -5 -6 L -6 -7 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 1 -12 L 4 -11 L 5 -10 L 6 -8 L 6 -6 L 5 -4 L 4 -3 L 0 -1 L 0 2 M 1 -12 L 3 -11 L 4 -10 L 5 -8 L 5 -6 L 4 -4 L 2 -2 M 0 7 L -1 8 L 0 9 L 1 8 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 0 -12 L -7 9 M 0 -12 L 7 9 M 0 -9 L 6 9 M -5 3 L 4 3 M -9 9 L -3 9 M 3 9 L 9 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 3 -2 M -5 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -9 9 M 3 -2 L 5 -1 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 3 9","-11 10 M 6 -9 L 7 -6 L 7 -12 L 6 -9 L 4 -11 L 1 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8 L 1 9 L -9 9 M 1 -12 L 3 -11 L 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 L 3 8 L 1 9","-11 10 M -6 -12 L -6 9 M -5 -12 L -5 9 M 1 -6 L 1 2 M -9 -12 L 7 -12 L 7 -6 L 6 -12 M -5 -2 L 1 -2 M -9 9 L 7 9 L 7 3 L 6 9","-11 9 M -6 -12 L -6 9 M -5 -12 L -5 9 M 1 -6 L 1 2 M -9 -12 L 7 -12 L 7 -6 L 6 -12 M -5 -2 L 1 -2 M -9 9 L -2 9","-11 12 M 6 -9 L 7 -6 L 7 -12 L 6 -9 L 4 -11 L 1 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 L -3 8 L -1 9 M 6 1 L 6 9 M 7 1 L 7 9 M 3 1 L 10 1","-12 12 M -7 -12 L -7 9 M -6 -12 L -6 9 M 6 -12 L 6 9 M 7 -12 L 7 9 M -10 -12 L -3 -12 M 3 -12 L 10 -12 M -6 -2 L 6 -2 M -10 9 L -3 9 M 3 9 L 10 9","-5 6 M 0 -12 L 0 9 M 1 -12 L 1 9 M -3 -12 L 4 -12 M -3 9 L 4 9","-7 8 M 3 -12 L 3 5 L 2 8 L 0 9 L -2 9 L -4 8 L -5 6 L -5 4 L -4 3 L -3 4 L -4 5 M 2 -12 L 2 5 L 1 8 L 0 9 M -1 -12 L 6 -12","-12 10 M -7 -12 L -7 9 M -6 -12 L -6 9 M 7 -12 L -6 1 M -1 -3 L 7 9 M -2 -3 L 6 9 M -10 -12 L -3 -12 M 3 -12 L 9 -12 M -10 9 L -3 9 M 3 9 L 9 9","-9 9 M -4 -12 L -4 9 M -3 -12 L -3 9 M -7 -12 L 0 -12 M -7 9 L 8 9 L 8 3 L 7 9","-12 13 M -7 -12 L -7 9 M -6 -12 L 0 6 M -7 -12 L 0 9 M 7 -12 L 0 9 M 7 -12 L 7 9 M 8 -12 L 8 9 M -10 -12 L -6 -12 M 7 -12 L 11 -12 M -10 9 L -4 9 M 4 9 L 11 9","-11 12 M -6 -12 L -6 9 M -5 -12 L 7 7 M -5 -10 L 7 9 M 7 -12 L 7 9 M -9 -12 L -5 -12 M 4 -12 L 10 -12 M -9 9 L -3 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 0 L -6 4 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 4 L 7 0 L 7 -3 L 6 -7 L 5 -9 L 3 -11 L 1 -12","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 3 -1 L -5 -1 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -5 L 6 -3 L 5 -2 L 3 -1 M -9 9 L -2 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -1 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 0 L -6 4 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 4 L 7 0 L 7 -3 L 6 -7 L 5 -9 L 3 -11 L 1 -12 M -4 7 L -4 6 L -3 4 L -1 3 L 0 3 L 2 4 L 3 6 L 4 13 L 5 14 L 7 14 L 8 12 L 8 11 M 3 6 L 4 10 L 5 12 L 6 13 L 7 13 L 8 12","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 L -5 -2 M 3 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 3 -2 M -9 9 L -2 9 M 0 -2 L 2 -1 L 3 0 L 6 7 L 7 8 L 8 8 L 9 7 M 2 -1 L 3 1 L 5 8 L 6 9 L 8 9 L 9 7 L 9 6","-10 10 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 1 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -7 L -6 -5 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 7 2 M -7 -7 L -5 -5 L -3 -4 L 3 -2 L 5 -1 L 6 0 L 7 2 L 7 6 L 5 8 L 2 9 L -1 9 L -4 8 L -6 6 L -7 3 L -7 9 L -6 6","-9 10 M 0 -12 L 0 9 M 1 -12 L 1 9 M -6 -12 L -7 -6 L -7 -12 L 8 -12 L 8 -6 L 7 -12 M -3 9 L 4 9","-12 12 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -12 M -6 -12 L -6 3 L -5 6 L -3 8 L -1 9 M -10 -12 L -3 -12 M 4 -12 L 10 -12","-10 10 M -7 -12 L 0 9 M -6 -12 L 0 6 M 7 -12 L 0 9 M -9 -12 L -3 -12 M 3 -12 L 9 -12","-12 12 M -8 -12 L -4 9 M -7 -12 L -4 4 M 0 -12 L -4 9 M 0 -12 L 4 9 M 1 -12 L 4 4 M 8 -12 L 4 9 M -11 -12 L -4 -12 M 5 -12 L 11 -12","-10 10 M -7 -12 L 6 9 M -6 -12 L 7 9 M 7 -12 L -7 9 M -9 -12 L -3 -12 M 3 -12 L 9 -12 M -9 9 L -3 9 M 3 9 L 9 9","-10 11 M -7 -12 L 0 -1 L 0 9 M -6 -12 L 1 -1 L 1 9 M 8 -12 L 1 -1 M -9 -12 L -3 -12 M 4 -12 L 10 -12 M -3 9 L 4 9","-10 10 M 6 -12 L -7 9 M 7 -12 L -6 9 M -6 -12 L -7 -6 L -7 -12 L 7 -12 M -7 9 L 7 9 L 7 3 L 6 9","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-10 10 M -10 16 L 10 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-9 11 M -4 -3 L -4 -2 L -5 -2 L -5 -3 L -4 -4 L -2 -5 L 2 -5 L 4 -4 L 5 -3 L 6 -1 L 6 6 L 7 8 L 8 9 M 5 -3 L 5 6 L 6 8 L 8 9 L 9 9 M 5 -1 L 4 0 L -2 1 L -5 2 L -6 4 L -6 6 L -5 8 L -2 9 L 1 9 L 3 8 L 5 6 M -2 1 L -4 2 L -5 4 L -5 6 L -4 8 L -2 9","-11 10 M -6 -12 L -6 9 M -5 -12 L -5 9 M -5 -2 L -3 -4 L -1 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -1 9 L -3 8 L -5 6 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -9 -12 L -5 -12","-10 9 M 5 -2 L 4 -1 L 5 0 L 6 -1 L 6 -2 L 4 -4 L 2 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9","-10 11 M 5 -12 L 5 9 M 6 -12 L 6 9 M 5 -2 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 3 8 L 5 6 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 M 2 -12 L 6 -12 M 5 9 L 9 9","-10 9 M -6 1 L 6 1 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M 5 1 L 5 -2 L 4 -4 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9","-7 6 M 3 -11 L 2 -10 L 3 -9 L 4 -10 L 4 -11 L 3 -12 L 1 -12 L -1 -11 L -2 -9 L -2 9 M 1 -12 L 0 -11 L -1 -9 L -1 9 M -5 -5 L 3 -5 M -5 9 L 2 9","-9 10 M -1 -5 L -3 -4 L -4 -3 L -5 -1 L -5 1 L -4 3 L -3 4 L -1 5 L 1 5 L 3 4 L 4 3 L 5 1 L 5 -1 L 4 -3 L 3 -4 L 1 -5 L -1 -5 M -3 -4 L -4 -2 L -4 2 L -3 4 M 3 4 L 4 2 L 4 -2 L 3 -4 M 4 -3 L 5 -4 L 7 -5 L 7 -4 L 5 -4 M -4 3 L -5 4 L -6 6 L -6 7 L -5 9 L -2 10 L 3 10 L 6 11 L 7 12 M -6 7 L -5 8 L -2 9 L 3 9 L 6 10 L 7 12 L 7 13 L 6 15 L 3 16 L -3 16 L -6 15 L -7 13 L -7 12 L -6 10 L -3 9","-11 11 M -6 -12 L -6 9 M -5 -12 L -5 9 M -5 -2 L -3 -4 L 0 -5 L 2 -5 L 5 -4 L 6 -2 L 6 9 M 2 -5 L 4 -4 L 5 -2 L 5 9 M -9 -12 L -5 -12 M -9 9 L -2 9 M 2 9 L 9 9","-5 6 M 0 -12 L -1 -11 L 0 -10 L 1 -11 L 0 -12 M 0 -5 L 0 9 M 1 -5 L 1 9 M -3 -5 L 1 -5 M -3 9 L 4 9","-5 6 M 1 -12 L 0 -11 L 1 -10 L 2 -11 L 1 -12 M 2 -5 L 2 13 L 1 15 L -1 16 L -3 16 L -4 15 L -4 14 L -3 13 L -2 14 L -3 15 M 1 -5 L 1 13 L 0 15 L -1 16 M -2 -5 L 2 -5","-11 10 M -6 -12 L -6 9 M -5 -12 L -5 9 M 5 -5 L -5 5 M 0 1 L 6 9 M -1 1 L 5 9 M -9 -12 L -5 -12 M 2 -5 L 8 -5 M -9 9 L -2 9 M 2 9 L 8 9","-5 6 M 0 -12 L 0 9 M 1 -12 L 1 9 M -3 -12 L 1 -12 M -3 9 L 4 9","-16 17 M -11 -5 L -11 9 M -10 -5 L -10 9 M -10 -2 L -8 -4 L -5 -5 L -3 -5 L 0 -4 L 1 -2 L 1 9 M -3 -5 L -1 -4 L 0 -2 L 0 9 M 1 -2 L 3 -4 L 6 -5 L 8 -5 L 11 -4 L 12 -2 L 12 9 M 8 -5 L 10 -4 L 11 -2 L 11 9 M -14 -5 L -10 -5 M -14 9 L -7 9 M -3 9 L 4 9 M 8 9 L 15 9","-11 11 M -6 -5 L -6 9 M -5 -5 L -5 9 M -5 -2 L -3 -4 L 0 -5 L 2 -5 L 5 -4 L 6 -2 L 6 9 M 2 -5 L 4 -4 L 5 -2 L 5 9 M -9 -5 L -5 -5 M -9 9 L -2 9 M 2 9 L 9 9","-10 10 M -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 1 -5 L -1 -5 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 M 1 9 L 3 8 L 5 6 L 6 3 L 6 1 L 5 -2 L 3 -4 L 1 -5","-11 10 M -6 -5 L -6 16 M -5 -5 L -5 16 M -5 -2 L -3 -4 L -1 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -1 9 L -3 8 L -5 6 M 1 -5 L 3 -4 L 5 -2 L 6 1 L 6 3 L 5 6 L 3 8 L 1 9 M -9 -5 L -5 -5 M -9 16 L -2 16","-10 10 M 5 -5 L 5 16 M 6 -5 L 6 16 M 5 -2 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 3 8 L 5 6 M -1 -5 L -3 -4 L -5 -2 L -6 1 L -6 3 L -5 6 L -3 8 L -1 9 M 2 16 L 9 16","-9 8 M -4 -5 L -4 9 M -3 -5 L -3 9 M -3 1 L -2 -2 L 0 -4 L 2 -5 L 5 -5 L 6 -4 L 6 -3 L 5 -2 L 4 -3 L 5 -4 M -7 -5 L -3 -5 M -7 9 L 0 9","-8 9 M 5 -3 L 6 -5 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -2 -5 L -4 -4 L -5 -3 L -5 -1 L -4 0 L -2 1 L 3 3 L 5 4 L 6 5 M -5 -2 L -4 -1 L -2 0 L 3 2 L 5 3 L 6 4 L 6 7 L 5 8 L 3 9 L -1 9 L -3 8 L -4 7 L -5 5 L -5 9 L -4 7","-7 8 M -2 -12 L -2 5 L -1 8 L 1 9 L 3 9 L 5 8 L 6 6 M -1 -12 L -1 5 L 0 8 L 1 9 M -5 -5 L 3 -5","-11 11 M -6 -5 L -6 6 L -5 8 L -2 9 L 0 9 L 3 8 L 5 6 M -5 -5 L -5 6 L -4 8 L -2 9 M 5 -5 L 5 9 M 6 -5 L 6 9 M -9 -5 L -5 -5 M 2 -5 L 6 -5 M 5 9 L 9 9","-9 9 M -6 -5 L 0 9 M -5 -5 L 0 7 M 6 -5 L 0 9 M -8 -5 L -2 -5 M 2 -5 L 8 -5","-12 12 M -8 -5 L -4 9 M -7 -5 L -4 6 M 0 -5 L -4 9 M 0 -5 L 4 9 M 1 -5 L 4 6 M 8 -5 L 4 9 M -11 -5 L -4 -5 M 5 -5 L 11 -5","-10 10 M -6 -5 L 5 9 M -5 -5 L 6 9 M 6 -5 L -6 9 M -8 -5 L -2 -5 M 2 -5 L 8 -5 M -8 9 L -2 9 M 2 9 L 8 9","-10 9 M -6 -5 L 0 9 M -5 -5 L 0 7 M 6 -5 L 0 9 L -2 13 L -4 15 L -6 16 L -7 16 L -8 15 L -7 14 L -6 15 M -8 -5 L -2 -5 M 2 -5 L 8 -5","-9 9 M 5 -5 L -6 9 M 6 -5 L -5 9 M -5 -5 L -6 -1 L -6 -5 L 6 -5 M -6 9 L 6 9 L 6 5 L 5 9","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]
timesrb = ["-8 8","-5 6 M 0 -12 L -1 -11 L -1 -9 L 0 -1 M 0 -12 L 0 2 L 1 2 M 0 -12 L 1 -12 L 1 2 M 1 -12 L 2 -11 L 2 -9 L 1 -1 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-9 9 M -4 -12 L -5 -11 L -5 -5 M -4 -11 L -5 -5 M -4 -12 L -3 -11 L -5 -5 M 5 -12 L 4 -11 L 4 -5 M 5 -11 L 4 -5 M 5 -12 L 6 -11 L 4 -5","-10 11 M 1 -16 L -6 16 M 7 -16 L 0 16 M -6 -3 L 8 -3 M -7 3 L 7 3","-10 10 M -2 -16 L -2 13 M 2 -16 L 2 13 M 6 -7 L 6 -8 L 5 -8 L 5 -6 L 7 -6 L 7 -8 L 6 -10 L 5 -11 L 2 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -6 L -6 -4 L -3 -2 L 3 0 L 5 1 L 6 3 L 6 6 L 5 8 M -6 -6 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 2 M -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 3 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 3 L -5 3 L -5 5 L -6 5 L -6 4","-12 12 M 9 -12 L -9 9 M -4 -12 L -2 -10 L -2 -8 L -3 -6 L -5 -5 L -7 -5 L -9 -7 L -9 -9 L -8 -11 L -6 -12 L -4 -12 L -2 -11 L 1 -10 L 4 -10 L 7 -11 L 9 -12 M 5 2 L 3 3 L 2 5 L 2 7 L 4 9 L 6 9 L 8 8 L 9 6 L 9 4 L 7 2 L 5 2","-13 13 M 9 -3 L 9 -4 L 8 -4 L 8 -2 L 10 -2 L 10 -4 L 9 -5 L 8 -5 L 7 -4 L 6 -2 L 4 3 L 2 6 L 0 8 L -2 9 L -6 9 L -8 8 L -9 6 L -9 3 L -8 1 L -2 -3 L 0 -5 L 1 -7 L 1 -9 L 0 -11 L -2 -12 L -4 -11 L -5 -9 L -5 -6 L -4 -3 L -2 0 L 2 5 L 5 8 L 7 9 L 9 9 L 10 7 L 10 6 M -7 8 L -8 6 L -8 3 L -7 1 L -6 0 M 0 -5 L 1 -9 M 1 -7 L 0 -11 M -4 -11 L -5 -7 M -4 -4 L -2 -1 L 2 4 L 5 7 L 7 8 M -4 9 L -6 8 L -7 6 L -7 3 L -6 1 L -2 -3 M -5 -9 L -4 -5 L -1 -1 L 3 4 L 6 7 L 8 8 L 9 8 L 10 7","-4 5 M 1 -12 L 0 -11 L 0 -5 M 1 -11 L 0 -5 M 1 -12 L 2 -11 L 0 -5","-7 7 M 3 -16 L 1 -14 L -1 -11 L -3 -7 L -4 -2 L -4 2 L -3 7 L -1 11 L 1 14 L 3 16 M -1 -10 L -2 -7 L -3 -3 L -3 3 L -2 7 L -1 10 M 1 -14 L 0 -12 L -1 -9 L -2 -3 L -2 3 L -1 9 L 0 12 L 1 14","-7 7 M -3 -16 L -1 -14 L 1 -11 L 3 -7 L 4 -2 L 4 2 L 3 7 L 1 11 L -1 14 L -3 16 M 1 -10 L 2 -7 L 3 -3 L 3 3 L 2 7 L 1 10 M -1 -14 L 0 -12 L 1 -9 L 2 -3 L 2 3 L 1 9 L 0 12 L -1 14","-8 8 M 0 -12 L -1 -11 L 1 -1 L 0 0 M 0 -12 L 0 0 M 0 -12 L 1 -11 L -1 -1 L 0 0 M -5 -9 L -4 -9 L 4 -3 L 5 -3 M -5 -9 L 5 -3 M -5 -9 L -5 -8 L 5 -4 L 5 -3 M 5 -9 L 4 -9 L -4 -3 L -5 -3 M 5 -9 L -5 -3 M 5 -9 L 5 -8 L -5 -4 L -5 -3","-12 13 M 0 -9 L 0 8 L 1 8 M 0 -9 L 1 -9 L 1 8 M -8 -1 L 9 -1 L 9 0 M -8 -1 L -8 0 L 9 0","-5 6 M 2 8 L 1 9 L 0 9 L -1 8 L -1 7 L 0 6 L 1 6 L 2 7 L 2 10 L 1 12 L -1 13 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7 M 1 9 L 2 10 M 2 8 L 1 12","-13 13 M -9 0 L 9 0","-5 6 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-11 12 M 9 -16 L -9 16 L -8 16 M 9 -16 L 10 -16 L -8 16","-10 10 M -1 -12 L -4 -11 L -6 -8 L -7 -3 L -7 0 L -6 5 L -4 8 L -1 9 L 1 9 L 4 8 L 6 5 L 7 0 L 7 -3 L 6 -8 L 4 -11 L 1 -12 L -1 -12 M -4 -10 L -5 -8 L -6 -4 L -6 1 L -5 5 L -4 7 M 4 7 L 5 5 L 6 1 L 6 -4 L 5 -8 L 4 -10 M -1 -12 L -3 -11 L -4 -9 L -5 -4 L -5 1 L -4 6 L -3 8 L -1 9 M 1 9 L 3 8 L 4 6 L 5 1 L 5 -4 L 4 -9 L 3 -11 L 1 -12","-10 10 M -1 -10 L -1 9 M 0 -10 L 0 8 M 1 -12 L 1 9 M 1 -12 L -2 -9 L -4 -8 M -5 9 L 5 9 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-10 10 M -6 -8 L -6 -7 L -5 -7 L -5 -8 L -6 -8 M -6 -9 L -5 -9 L -4 -8 L -4 -7 L -5 -6 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 3 -2 L -2 0 L -4 1 L -6 3 L -7 6 L -7 9 M 5 -10 L 6 -8 L 6 -6 L 5 -4 M 2 -12 L 4 -11 L 5 -8 L 5 -6 L 4 -4 L 2 -2 L -2 0 M -7 7 L -6 6 L -4 6 L 1 7 L 5 7 L 7 6 M -4 6 L 1 8 L 5 8 L 6 7 M -4 6 L 1 9 L 5 9 L 6 8 L 7 6 L 7 4","-10 10 M -6 -8 L -6 -7 L -5 -7 L -5 -8 L -6 -8 M -6 -9 L -5 -9 L -4 -8 L -4 -7 L -5 -6 L -6 -6 L -7 -7 L -7 -8 L -6 -10 L -5 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -9 L 6 -6 L 5 -4 L 2 -3 M 4 -11 L 5 -9 L 5 -6 L 4 -4 M 1 -12 L 3 -11 L 4 -9 L 4 -6 L 3 -4 L 1 -3 M -1 -3 L 2 -3 L 4 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 3 L -4 4 L -4 5 L -5 6 L -6 6 M 5 0 L 6 2 L 6 5 L 5 7 M 1 -3 L 3 -2 L 4 -1 L 5 2 L 5 5 L 4 8 L 2 9 M -6 4 L -6 5 L -5 5 L -5 4 L -6 4","-10 10 M 1 -9 L 1 9 M 2 -10 L 2 8 M 3 -12 L 3 9 M 3 -12 L -8 3 L 8 3 M -2 9 L 6 9 M 1 8 L -1 9 M 1 7 L 0 9 M 3 7 L 4 9 M 3 8 L 5 9","-10 10 M -5 -12 L -7 -2 L -5 -4 L -2 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -2 9 L -5 8 L -6 7 L -7 5 L -7 4 L -6 3 L -5 3 L -4 4 L -4 5 L -5 6 L -6 6 M 5 -2 L 6 0 L 6 4 L 5 6 M 1 -5 L 3 -4 L 4 -3 L 5 0 L 5 4 L 4 7 L 3 8 L 1 9 M -6 4 L -6 5 L -5 5 L -5 4 L -6 4 M -5 -12 L 5 -12 M -5 -11 L 3 -11 M -5 -10 L -1 -10 L 3 -11 L 5 -12","-10 10 M 4 -9 L 4 -8 L 5 -8 L 5 -9 L 4 -9 M 5 -10 L 4 -10 L 3 -9 L 3 -8 L 4 -7 L 5 -7 L 6 -8 L 6 -9 L 5 -11 L 3 -12 L 0 -12 L -3 -11 L -5 -9 L -6 -7 L -7 -3 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 2 L 6 -1 L 4 -3 L 1 -4 L -1 -4 L -3 -3 L -4 -2 L -5 0 M -4 -9 L -5 -7 L -6 -3 L -6 3 L -5 6 L -4 7 M 5 6 L 6 4 L 6 1 L 5 -1 M 0 -12 L -2 -11 L -3 -10 L -4 -8 L -5 -4 L -5 3 L -4 6 L -3 8 L -1 9 M 1 9 L 3 8 L 4 7 L 5 4 L 5 1 L 4 -2 L 3 -3 L 1 -4","-10 10 M -7 -12 L -7 -6 M 7 -12 L 7 -9 L 6 -6 L 2 -1 L 1 1 L 0 5 L 0 9 M 1 0 L 0 2 L -1 5 L -1 9 M 6 -6 L 1 -1 L -1 2 L -2 5 L -2 9 L 0 9 M -7 -8 L -6 -10 L -4 -12 L -2 -12 L 3 -9 L 5 -9 L 6 -10 L 7 -12 M -5 -10 L -4 -11 L -2 -11 L 0 -10 M -7 -8 L -6 -9 L -4 -10 L -2 -10 L 3 -9","-10 10 M -2 -12 L -5 -11 L -6 -9 L -6 -6 L -5 -4 L -2 -3 L 2 -3 L 5 -4 L 6 -6 L 6 -9 L 5 -11 L 2 -12 L -2 -12 M -4 -11 L -5 -9 L -5 -6 L -4 -4 M 4 -4 L 5 -6 L 5 -9 L 4 -11 M -2 -12 L -3 -11 L -4 -9 L -4 -6 L -3 -4 L -2 -3 M 2 -3 L 3 -4 L 4 -6 L 4 -9 L 3 -11 L 2 -12 M -2 -3 L -5 -2 L -6 -1 L -7 1 L -7 5 L -6 7 L -5 8 L -2 9 L 2 9 L 5 8 L 6 7 L 7 5 L 7 1 L 6 -1 L 5 -2 L 2 -3 M -5 -1 L -6 1 L -6 5 L -5 7 M 5 7 L 6 5 L 6 1 L 5 -1 M -2 -3 L -4 -2 L -5 1 L -5 5 L -4 8 L -2 9 M 2 9 L 4 8 L 5 5 L 5 1 L 4 -2 L 2 -3","-10 10 M -5 5 L -5 6 L -4 6 L -4 5 L -5 5 M 5 -3 L 4 -1 L 3 0 L 1 1 L -1 1 L -4 0 L -6 -2 L -7 -5 L -7 -6 L -6 -9 L -4 -11 L -1 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -6 L 7 0 L 6 4 L 5 6 L 3 8 L 0 9 L -3 9 L -5 8 L -6 6 L -6 5 L -5 4 L -4 4 L -3 5 L -3 6 L -4 7 L -5 7 M -5 -2 L -6 -4 L -6 -7 L -5 -9 M 4 -10 L 5 -9 L 6 -6 L 6 0 L 5 4 L 4 6 M -1 1 L -3 0 L -4 -1 L -5 -4 L -5 -7 L -4 -10 L -3 -11 L -1 -12 M 1 -12 L 3 -11 L 4 -9 L 5 -6 L 5 1 L 4 5 L 3 7 L 2 8 L 0 9","-5 6 M 0 -5 L -1 -4 L -1 -3 L 0 -2 L 1 -2 L 2 -3 L 2 -4 L 1 -5 L 0 -5 M 0 -4 L 0 -3 L 1 -3 L 1 -4 L 0 -4 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-5 6 M 0 -5 L -1 -4 L -1 -3 L 0 -2 L 1 -2 L 2 -3 L 2 -4 L 1 -5 L 0 -5 M 0 -4 L 0 -3 L 1 -3 L 1 -4 L 0 -4 M 2 8 L 1 9 L 0 9 L -1 8 L -1 7 L 0 6 L 1 6 L 2 7 L 2 10 L 1 12 L -1 13 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7 M 1 9 L 2 10 M 2 8 L 1 12","-12 12 M 8 -9 L -8 0 L 8 9","-12 13 M -8 -5 L 9 -5 L 9 -4 M -8 -5 L -8 -4 L 9 -4 M -8 3 L 9 3 L 9 4 M -8 3 L -8 4 L 9 4","-12 12 M -8 -9 L 8 0 L -8 9","-9 10 M -5 -7 L -5 -8 L -4 -8 L -4 -6 L -6 -6 L -6 -8 L -5 -10 L -4 -11 L -2 -12 L 2 -12 L 5 -11 L 6 -10 L 7 -8 L 7 -6 L 6 -4 L 5 -3 L 1 -1 M 5 -10 L 6 -9 L 6 -5 L 5 -4 M 2 -12 L 4 -11 L 5 -9 L 5 -5 L 4 -3 L 3 -2 M 0 -1 L 0 2 L 1 2 L 1 -1 L 0 -1 M 0 6 L -1 7 L -1 8 L 0 9 L 1 9 L 2 8 L 2 7 L 1 6 L 0 6 M 0 7 L 0 8 L 1 8 L 1 7 L 0 7","-13 14 M 5 -4 L 4 -6 L 2 -7 L -1 -7 L -3 -6 L -4 -5 L -5 -2 L -5 1 L -4 3 L -2 4 L 1 4 L 3 3 L 4 1 M -1 -7 L -3 -5 L -4 -2 L -4 1 L -3 3 L -2 4 M 5 -7 L 4 1 L 4 3 L 6 4 L 8 4 L 10 2 L 11 -1 L 11 -3 L 10 -6 L 9 -8 L 7 -10 L 5 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -10 L -8 -8 L -9 -6 L -10 -3 L -10 0 L -9 3 L -8 5 L -6 7 L -4 8 L -1 9 L 2 9 L 5 8 L 7 7 L 8 6 M 6 -7 L 5 1 L 5 3 L 6 4","-10 10 M 0 -12 L -7 8 M -1 -9 L 5 9 M 0 -9 L 6 9 M 0 -12 L 7 9 M -5 3 L 4 3 M -9 9 L -3 9 M 2 9 L 9 9 M -7 8 L -8 9 M -7 8 L -5 9 M 5 8 L 3 9 M 5 7 L 4 9 M 6 7 L 8 9","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 M 6 -10 L 7 -8 L 7 -6 L 6 -4 M 3 -12 L 5 -11 L 6 -9 L 6 -5 L 5 -3 L 3 -2 M -4 -2 L 3 -2 L 6 -1 L 7 0 L 8 2 L 8 5 L 7 7 L 6 8 L 3 9 L -9 9 M 6 0 L 7 2 L 7 5 L 6 7 M 3 -2 L 5 -1 L 6 1 L 6 6 L 5 8 L 3 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 10 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 2 9 L 4 8 L 6 6 L 7 4 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 1 -12 L 4 -11 L 6 -9 L 7 -7 L 8 -4 L 8 1 L 7 4 L 6 6 L 4 8 L 1 9 L -9 9 M 5 -9 L 6 -7 L 7 -4 L 7 1 L 6 4 L 5 6 M 1 -12 L 3 -11 L 5 -8 L 6 -4 L 6 1 L 5 5 L 3 8 L 1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 10 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 7 -12 L 7 -6 M -4 -2 L 2 -2 M 2 -6 L 2 2 M -9 9 L 7 9 L 7 3 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M 2 -12 L 7 -11 M 4 -12 L 7 -10 M 5 -12 L 7 -9 M 6 -12 L 7 -6 M 2 -6 L 1 -2 L 2 2 M 2 -4 L 0 -2 L 2 0 M 2 -3 L -2 -2 L 2 -1 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9 M 2 9 L 7 8 M 4 9 L 7 7 M 5 9 L 7 6 M 6 9 L 7 3","-11 9 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 7 -12 L 7 -6 M -4 -2 L 2 -2 M 2 -6 L 2 2 M -9 9 L -1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M 2 -12 L 7 -11 M 4 -12 L 7 -10 M 5 -12 L 7 -9 M 6 -12 L 7 -6 M 2 -6 L 1 -2 L 2 2 M 2 -4 L 0 -2 L 2 0 M 2 -3 L -2 -2 L 2 -1 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 12 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 2 -12 L -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -4 L -8 1 L -7 4 L -6 6 L -4 8 L -1 9 L 2 9 L 4 8 L 6 8 L 7 9 L 7 1 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9 M 6 2 L 6 7 M 5 1 L 5 7 L 4 8 M 2 1 L 10 1 M 3 1 L 5 2 M 4 1 L 5 3 M 8 1 L 7 3 M 9 1 L 7 2","-12 12 M -7 -12 L -7 9 M -6 -11 L -6 8 M -5 -12 L -5 9 M 5 -12 L 5 9 M 6 -11 L 6 8 M 7 -12 L 7 9 M -10 -12 L -2 -12 M 2 -12 L 10 -12 M -5 -2 L 5 -2 M -10 9 L -2 9 M 2 9 L 10 9 M -9 -12 L -7 -11 M -8 -12 L -7 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 3 -12 L 5 -11 M 4 -12 L 5 -10 M 8 -12 L 7 -10 M 9 -12 L 7 -11 M -7 8 L -9 9 M -7 7 L -8 9 M -5 7 L -4 9 M -5 8 L -3 9 M 5 8 L 3 9 M 5 7 L 4 9 M 7 7 L 8 9 M 7 8 L 9 9","-6 6 M -1 -12 L -1 9 M 0 -11 L 0 8 M 1 -12 L 1 9 M -4 -12 L 4 -12 M -4 9 L 4 9 M -3 -12 L -1 -11 M -2 -12 L -1 -10 M 2 -12 L 1 -10 M 3 -12 L 1 -11 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-8 8 M 1 -12 L 1 5 L 0 8 L -1 9 M 2 -11 L 2 5 L 1 8 M 3 -12 L 3 5 L 2 8 L -1 9 L -3 9 L -5 8 L -6 6 L -6 4 L -5 3 L -4 3 L -3 4 L -3 5 L -4 6 L -5 6 M -5 4 L -5 5 L -4 5 L -4 4 L -5 4 M -2 -12 L 6 -12 M -1 -12 L 1 -11 M 0 -12 L 1 -10 M 4 -12 L 3 -10 M 5 -12 L 3 -11","-12 10 M -7 -12 L -7 9 M -6 -11 L -6 8 M -5 -12 L -5 9 M 6 -11 L -5 0 M -2 -2 L 5 9 M -1 -2 L 6 9 M -1 -4 L 7 9 M -10 -12 L -2 -12 M 3 -12 L 9 -12 M -10 9 L -2 9 M 2 9 L 9 9 M -9 -12 L -7 -11 M -8 -12 L -7 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 5 -12 L 6 -11 M 8 -12 L 6 -11 M -7 8 L -9 9 M -7 7 L -8 9 M -5 7 L -4 9 M -5 8 L -3 9 M 5 7 L 3 9 M 5 7 L 8 9","-9 9 M -4 -12 L -4 9 M -3 -11 L -3 8 M -2 -12 L -2 9 M -7 -12 L 1 -12 M -7 9 L 8 9 L 8 3 M -6 -12 L -4 -11 M -5 -12 L -4 -10 M -1 -12 L -2 -10 M 0 -12 L -2 -11 M -4 8 L -6 9 M -4 7 L -5 9 M -2 7 L -1 9 M -2 8 L 0 9 M 3 9 L 8 8 M 5 9 L 8 7 M 6 9 L 8 6 M 7 9 L 8 3","-13 13 M -8 -12 L -8 8 M -8 -12 L -1 9 M -7 -12 L -1 6 M -6 -12 L 0 6 M 6 -12 L -1 9 M 6 -12 L 6 9 M 7 -11 L 7 8 M 8 -12 L 8 9 M -11 -12 L -6 -12 M 6 -12 L 11 -12 M -11 9 L -5 9 M 3 9 L 11 9 M -10 -12 L -8 -11 M 9 -12 L 8 -10 M 10 -12 L 8 -11 M -8 8 L -10 9 M -8 8 L -6 9 M 6 8 L 4 9 M 6 7 L 5 9 M 8 7 L 9 9 M 8 8 L 10 9","-12 12 M -7 -12 L -7 8 M -7 -12 L 7 9 M -6 -12 L 6 6 M -5 -12 L 7 6 M 7 -11 L 7 9 M -10 -12 L -5 -12 M 4 -12 L 10 -12 M -10 9 L -4 9 M -9 -12 L -7 -11 M 5 -12 L 7 -11 M 9 -12 L 7 -11 M -7 8 L -9 9 M -7 8 L -5 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M 5 6 L 6 4 L 7 1 L 7 -4 L 6 -7 L 5 -9 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9 M 1 9 L 3 8 L 5 5 L 6 1 L 6 -4 L 5 -8 L 3 -11 L 1 -12","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -5 L 7 -3 L 6 -2 L 3 -1 L -4 -1 M 6 -10 L 7 -8 L 7 -5 L 6 -3 M 3 -12 L 5 -11 L 6 -9 L 6 -4 L 5 -2 L 3 -1 M -9 9 L -1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-11 11 M -1 -12 L -4 -11 L -6 -9 L -7 -7 L -8 -3 L -8 0 L -7 4 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 4 L 8 0 L 8 -3 L 7 -7 L 6 -9 L 4 -11 L 1 -12 L -1 -12 M -5 -9 L -6 -7 L -7 -4 L -7 1 L -6 4 L -5 6 M 5 6 L 6 4 L 7 1 L 7 -4 L 6 -7 L 5 -9 M -1 -12 L -3 -11 L -5 -8 L -6 -4 L -6 1 L -5 5 L -3 8 L -1 9 M 1 9 L 3 8 L 5 5 L 6 1 L 6 -4 L 5 -8 L 3 -11 L 1 -12 M -4 6 L -3 4 L -1 3 L 0 3 L 2 4 L 3 6 L 4 12 L 5 14 L 7 14 L 8 12 L 8 10 M 4 10 L 5 12 L 6 13 L 7 13 M 3 6 L 5 11 L 6 12 L 7 12 L 8 11","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -4 -12 L -4 9 M -9 -12 L 3 -12 L 6 -11 L 7 -10 L 8 -8 L 8 -6 L 7 -4 L 6 -3 L 3 -2 L -4 -2 M 6 -10 L 7 -8 L 7 -6 L 6 -4 M 3 -12 L 5 -11 L 6 -9 L 6 -5 L 5 -3 L 3 -2 M 0 -2 L 2 -1 L 3 1 L 5 7 L 6 9 L 8 9 L 9 7 L 9 5 M 5 5 L 6 7 L 7 8 L 8 8 M 2 -1 L 3 0 L 6 6 L 7 7 L 8 7 L 9 6 M -9 9 L -1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -3 -12 L -4 -10 M -2 -12 L -4 -11 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9","-10 10 M 6 -9 L 7 -12 L 7 -6 L 6 -9 L 4 -11 L 1 -12 L -2 -12 L -5 -11 L -7 -9 L -7 -6 L -6 -4 L -3 -2 L 3 0 L 5 1 L 6 3 L 6 6 L 5 8 M -6 -6 L -5 -4 L -3 -3 L 3 -1 L 5 0 L 6 2 M -5 -11 L -6 -9 L -6 -7 L -5 -5 L -3 -4 L 3 -2 L 6 0 L 7 2 L 7 5 L 6 7 L 5 8 L 2 9 L -1 9 L -4 8 L -6 6 L -7 3 L -7 9 L -6 6","-10 10 M -8 -12 L -8 -6 M -1 -12 L -1 9 M 0 -11 L 0 8 M 1 -12 L 1 9 M 8 -12 L 8 -6 M -8 -12 L 8 -12 M -4 9 L 4 9 M -7 -12 L -8 -6 M -6 -12 L -8 -9 M -5 -12 L -8 -10 M -3 -12 L -8 -11 M 3 -12 L 8 -11 M 5 -12 L 8 -10 M 6 -12 L 8 -9 M 7 -12 L 8 -6 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-12 12 M -7 -12 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 -11 M -6 -11 L -6 4 L -5 6 M -5 -12 L -5 4 L -4 7 L -3 8 L -1 9 M -10 -12 L -2 -12 M 4 -12 L 10 -12 M -9 -12 L -7 -11 M -8 -12 L -7 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 5 -12 L 7 -11 M 9 -12 L 7 -11","-10 10 M -7 -12 L 0 9 M -6 -12 L 0 6 L 0 9 M -5 -12 L 1 6 M 7 -11 L 0 9 M -9 -12 L -2 -12 M 3 -12 L 9 -12 M -8 -12 L -6 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 5 -12 L 7 -11 M 8 -12 L 7 -11","-12 12 M -8 -12 L -4 9 M -7 -12 L -4 4 L -4 9 M -6 -12 L -3 4 M 0 -12 L -3 4 L -4 9 M 0 -12 L 4 9 M 1 -12 L 4 4 L 4 9 M 2 -12 L 5 4 M 8 -11 L 5 4 L 4 9 M -11 -12 L -3 -12 M 0 -12 L 2 -12 M 5 -12 L 11 -12 M -10 -12 L -7 -11 M -9 -12 L -7 -10 M -5 -12 L -6 -10 M -4 -12 L -6 -11 M 6 -12 L 8 -11 M 10 -12 L 8 -11","-10 10 M -7 -12 L 5 9 M -6 -12 L 6 9 M -5 -12 L 7 9 M 6 -11 L -6 8 M -9 -12 L -2 -12 M 3 -12 L 9 -12 M -9 9 L -3 9 M 2 9 L 9 9 M -8 -12 L -5 -10 M -4 -12 L -5 -10 M -3 -12 L -5 -11 M 4 -12 L 6 -11 M 8 -12 L 6 -11 M -6 8 L -8 9 M -6 8 L -4 9 M 5 8 L 3 9 M 5 7 L 4 9 M 5 7 L 8 9","-11 11 M -8 -12 L -1 -1 L -1 9 M -7 -12 L 0 -1 L 0 8 M -6 -12 L 1 -1 L 1 9 M 7 -11 L 1 -1 M -10 -12 L -3 -12 M 4 -12 L 10 -12 M -4 9 L 4 9 M -9 -12 L -7 -11 M -4 -12 L -6 -11 M 5 -12 L 7 -11 M 9 -12 L 7 -11 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-10 10 M 7 -12 L -7 -12 L -7 -6 M 5 -12 L -7 9 M 6 -12 L -6 9 M 7 -12 L -5 9 M -7 9 L 7 9 L 7 3 M -6 -12 L -7 -6 M -5 -12 L -7 -9 M -4 -12 L -7 -10 M -2 -12 L -7 -11 M 2 9 L 7 8 M 4 9 L 7 7 M 5 9 L 7 6 M 6 9 L 7 3","-7 7 M -3 -16 L -3 16 M -2 -16 L -2 16 M -3 -16 L 4 -16 M -3 16 L 4 16","-7 7 M -7 -12 L 7 12","-7 7 M 2 -16 L 2 16 M 3 -16 L 3 16 M -4 -16 L 3 -16 M -4 16 L 3 16","-11 11 M -8 2 L 0 -3 L 8 2 M -8 2 L 0 -2 L 8 2","-10 10 M -10 16 L 10 16","-6 6 M -2 -12 L 3 -6 M -2 -12 L -3 -11 L 3 -6","-9 11 M -4 -2 L -4 -3 L -3 -3 L -3 -1 L -5 -1 L -5 -3 L -4 -4 L -2 -5 L 2 -5 L 4 -4 L 5 -3 L 6 -1 L 6 6 L 7 8 L 8 9 M 4 -3 L 5 -1 L 5 6 L 6 8 M 2 -5 L 3 -4 L 4 -2 L 4 6 L 5 8 L 8 9 L 9 9 M 4 0 L 3 1 L -2 2 L -5 3 L -6 5 L -6 6 L -5 8 L -2 9 L 1 9 L 3 8 L 4 6 M -4 3 L -5 5 L -5 6 L -4 8 M 3 1 L -1 2 L -3 3 L -4 5 L -4 6 L -3 8 L -2 9","-11 10 M -6 -12 L -6 9 L -5 8 L -3 8 M -5 -11 L -5 7 M -9 -12 L -4 -12 L -4 8 M -4 -2 L -3 -4 L -1 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -1 9 L -3 8 L -4 6 M 5 -2 L 6 0 L 6 4 L 5 6 M 1 -5 L 3 -4 L 4 -3 L 5 0 L 5 4 L 4 7 L 3 8 L 1 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10","-10 9 M 5 -1 L 5 -2 L 4 -2 L 4 0 L 6 0 L 6 -2 L 4 -4 L 2 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M -5 -2 L -6 0 L -6 4 L -5 6 M -1 -5 L -3 -4 L -4 -3 L -5 0 L -5 4 L -4 7 L -3 8 L -1 9","-10 11 M 4 -12 L 4 9 L 9 9 M 5 -11 L 5 8 M 1 -12 L 6 -12 L 6 9 M 4 -2 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 3 8 L 4 6 M -5 -2 L -6 0 L -6 4 L -5 6 M -1 -5 L -3 -4 L -4 -3 L -5 0 L -5 4 L -4 7 L -3 8 L -1 9 M 2 -12 L 4 -11 M 3 -12 L 4 -10 M 6 7 L 7 9 M 6 8 L 8 9","-10 9 M -5 1 L 6 1 L 6 -1 L 5 -3 L 4 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 M 5 0 L 5 -1 L 4 -3 M -5 -2 L -6 0 L -6 4 L -5 6 M 4 1 L 4 -2 L 3 -4 L 1 -5 M -1 -5 L -3 -4 L -4 -3 L -5 0 L -5 4 L -4 7 L -3 8 L -1 9","-7 7 M 5 -10 L 5 -11 L 4 -11 L 4 -9 L 6 -9 L 6 -11 L 5 -12 L 2 -12 L 0 -11 L -1 -10 L -2 -7 L -2 9 M 0 -10 L -1 -7 L -1 8 M 2 -12 L 1 -11 L 0 -9 L 0 9 M -5 -5 L 4 -5 M -5 9 L 3 9 M -2 8 L -4 9 M -2 7 L -3 9 M 0 7 L 1 9 M 0 8 L 2 9","-9 10 M 6 -4 L 7 -3 L 8 -4 L 7 -5 L 6 -5 L 4 -4 L 3 -3 M -1 -5 L -3 -4 L -4 -3 L -5 -1 L -5 1 L -4 3 L -3 4 L -1 5 L 1 5 L 3 4 L 4 3 L 5 1 L 5 -1 L 4 -3 L 3 -4 L 1 -5 L -1 -5 M -3 -3 L -4 -1 L -4 1 L -3 3 M 3 3 L 4 1 L 4 -1 L 3 -3 M -1 -5 L -2 -4 L -3 -2 L -3 2 L -2 4 L -1 5 M 1 5 L 2 4 L 3 2 L 3 -2 L 2 -4 L 1 -5 M -4 3 L -5 4 L -6 6 L -6 7 L -5 9 L -4 10 L -1 11 L 3 11 L 6 12 L 7 13 M -4 9 L -1 10 L 3 10 L 6 11 M -6 7 L -5 8 L -2 9 L 3 9 L 6 10 L 7 12 L 7 13 L 6 15 L 3 16 L -3 16 L -6 15 L -7 13 L -7 12 L -6 10 L -3 9 M -3 16 L -5 15 L -6 13 L -6 12 L -5 10 L -3 9","-11 12 M -6 -12 L -6 9 M -5 -11 L -5 8 M -9 -12 L -4 -12 L -4 9 M -4 -1 L -3 -3 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -3 L 7 0 L 7 9 M 5 -3 L 6 0 L 6 8 M 3 -5 L 4 -4 L 5 -1 L 5 9 M -9 9 L -1 9 M 2 9 L 10 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9 M 5 8 L 3 9 M 5 7 L 4 9 M 7 7 L 8 9 M 7 8 L 9 9","-6 6 M -1 -12 L -1 -10 L 1 -10 L 1 -12 L -1 -12 M 0 -12 L 0 -10 M -1 -11 L 1 -11 M -1 -5 L -1 9 M 0 -4 L 0 8 M -4 -5 L 1 -5 L 1 9 M -4 9 L 4 9 M -3 -5 L -1 -4 M -2 -5 L -1 -3 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-7 6 M 0 -12 L 0 -10 L 2 -10 L 2 -12 L 0 -12 M 1 -12 L 1 -10 M 0 -11 L 2 -11 M 0 -5 L 0 12 L -1 15 L -2 16 M 1 -4 L 1 11 L 0 14 M -3 -5 L 2 -5 L 2 11 L 1 14 L 0 15 L -2 16 L -5 16 L -6 15 L -6 13 L -4 13 L -4 15 L -5 15 L -5 14 M -2 -5 L 0 -4 M -1 -5 L 0 -3","-11 11 M -6 -12 L -6 9 M -5 -11 L -5 8 M -9 -12 L -4 -12 L -4 9 M 5 -4 L -4 5 M 0 1 L 7 9 M 0 2 L 6 9 M -1 2 L 5 9 M 2 -5 L 9 -5 M -9 9 L -1 9 M 2 9 L 9 9 M -8 -12 L -6 -11 M -7 -12 L -6 -10 M 3 -5 L 5 -4 M 8 -5 L 5 -4 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9 M 5 7 L 3 9 M 4 7 L 8 9","-6 6 M -1 -12 L -1 9 M 0 -11 L 0 8 M -4 -12 L 1 -12 L 1 9 M -4 9 L 4 9 M -3 -12 L -1 -11 M -2 -12 L -1 -10 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9","-17 17 M -12 -5 L -12 9 M -11 -4 L -11 8 M -15 -5 L -10 -5 L -10 9 M -10 -1 L -9 -3 L -8 -4 L -6 -5 L -3 -5 L -1 -4 L 0 -3 L 1 0 L 1 9 M -1 -3 L 0 0 L 0 8 M -3 -5 L -2 -4 L -1 -1 L -1 9 M 1 -1 L 2 -3 L 3 -4 L 5 -5 L 8 -5 L 10 -4 L 11 -3 L 12 0 L 12 9 M 10 -3 L 11 0 L 11 8 M 8 -5 L 9 -4 L 10 -1 L 10 9 M -15 9 L -7 9 M -4 9 L 4 9 M 7 9 L 15 9 M -14 -5 L -12 -4 M -13 -5 L -12 -3 M -12 8 L -14 9 M -12 7 L -13 9 M -10 7 L -9 9 M -10 8 L -8 9 M -1 8 L -3 9 M -1 7 L -2 9 M 1 7 L 2 9 M 1 8 L 3 9 M 10 8 L 8 9 M 10 7 L 9 9 M 12 7 L 13 9 M 12 8 L 14 9","-11 12 M -6 -5 L -6 9 M -5 -4 L -5 8 M -9 -5 L -4 -5 L -4 9 M -4 -1 L -3 -3 L -2 -4 L 0 -5 L 3 -5 L 5 -4 L 6 -3 L 7 0 L 7 9 M 5 -3 L 6 0 L 6 8 M 3 -5 L 4 -4 L 5 -1 L 5 9 M -9 9 L -1 9 M 2 9 L 10 9 M -8 -5 L -6 -4 M -7 -5 L -6 -3 M -6 8 L -8 9 M -6 7 L -7 9 M -4 7 L -3 9 M -4 8 L -2 9 M 5 8 L 3 9 M 5 7 L 4 9 M 7 7 L 8 9 M 7 8 L 9 9","-10 10 M -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 4 8 L 6 6 L 7 3 L 7 1 L 6 -2 L 4 -4 L 1 -5 L -1 -5 M -5 -2 L -6 0 L -6 4 L -5 6 M 5 6 L 6 4 L 6 0 L 5 -2 M -1 -5 L -3 -4 L -4 -3 L -5 0 L -5 4 L -4 7 L -3 8 L -1 9 M 1 9 L 3 8 L 4 7 L 5 4 L 5 0 L 4 -3 L 3 -4 L 1 -5","-11 10 M -6 -5 L -6 16 M -5 -4 L -5 15 M -9 -5 L -4 -5 L -4 16 M -4 -2 L -3 -4 L -1 -5 L 1 -5 L 4 -4 L 6 -2 L 7 1 L 7 3 L 6 6 L 4 8 L 1 9 L -1 9 L -3 8 L -4 6 M 5 -2 L 6 0 L 6 4 L 5 6 M 1 -5 L 3 -4 L 4 -3 L 5 0 L 5 4 L 4 7 L 3 8 L 1 9 M -9 16 L -1 16 M -8 -5 L -6 -4 M -7 -5 L -6 -3 M -6 15 L -8 16 M -6 14 L -7 16 M -4 14 L -3 16 M -4 15 L -2 16","-10 10 M 4 -4 L 4 16 M 5 -3 L 5 15 M 3 -4 L 5 -4 L 6 -5 L 6 16 M 4 -2 L 3 -4 L 1 -5 L -1 -5 L -4 -4 L -6 -2 L -7 1 L -7 3 L -6 6 L -4 8 L -1 9 L 1 9 L 3 8 L 4 6 M -5 -2 L -6 0 L -6 4 L -5 6 M -1 -5 L -3 -4 L -4 -3 L -5 0 L -5 4 L -4 7 L -3 8 L -1 9 M 1 16 L 9 16 M 4 15 L 2 16 M 4 14 L 3 16 M 6 14 L 7 16 M 6 15 L 8 16","-9 8 M -4 -5 L -4 9 M -3 -4 L -3 8 M -7 -5 L -2 -5 L -2 9 M 5 -3 L 5 -4 L 4 -4 L 4 -2 L 6 -2 L 6 -4 L 5 -5 L 3 -5 L 1 -4 L -1 -2 L -2 1 M -7 9 L 1 9 M -6 -5 L -4 -4 M -5 -5 L -4 -3 M -4 8 L -6 9 M -4 7 L -5 9 M -2 7 L -1 9 M -2 8 L 0 9","-8 9 M 5 -3 L 6 -5 L 6 -1 L 5 -3 L 4 -4 L 2 -5 L -2 -5 L -4 -4 L -5 -3 L -5 -1 L -4 1 L -2 2 L 3 3 L 5 4 L 6 7 M -4 -4 L -5 -1 M -4 0 L -2 1 L 3 2 L 5 3 M 6 4 L 5 8 M -5 -3 L -4 -1 L -2 0 L 3 1 L 5 2 L 6 4 L 6 7 L 5 8 L 3 9 L -1 9 L -3 8 L -4 7 L -5 5 L -5 9 L -4 7","-7 8 M -2 -10 L -2 4 L -1 7 L 0 8 L 2 9 L 4 9 L 6 8 L 7 6 M -1 -10 L -1 5 L 0 7 M -2 -10 L 0 -12 L 0 5 L 1 8 L 2 9 M -5 -5 L 4 -5","-11 12 M -6 -5 L -6 4 L -5 7 L -4 8 L -2 9 L 1 9 L 3 8 L 4 7 L 5 5 M -5 -4 L -5 5 L -4 7 M -9 -5 L -4 -5 L -4 5 L -3 8 L -2 9 M 5 -5 L 5 9 L 10 9 M 6 -4 L 6 8 M 2 -5 L 7 -5 L 7 9 M -8 -5 L -6 -4 M -7 -5 L -6 -3 M 7 7 L 8 9 M 7 8 L 9 9","-9 9 M -6 -5 L 0 9 M -5 -5 L 0 7 M -4 -5 L 1 7 M 6 -4 L 1 7 L 0 9 M -8 -5 L -1 -5 M 2 -5 L 8 -5 M -7 -5 L -4 -3 M -2 -5 L -4 -4 M 4 -5 L 6 -4 M 7 -5 L 6 -4","-12 12 M -8 -5 L -4 9 M -7 -5 L -4 6 M -6 -5 L -3 6 M 0 -5 L -3 6 L -4 9 M 0 -5 L 4 9 M 1 -5 L 4 6 M 0 -5 L 2 -5 L 5 6 M 8 -4 L 5 6 L 4 9 M -11 -5 L -3 -5 M 5 -5 L 11 -5 M -10 -5 L -7 -4 M -4 -5 L -6 -4 M 6 -5 L 8 -4 M 10 -5 L 8 -4","-10 10 M -6 -5 L 4 9 M -5 -5 L 5 9 M -4 -5 L 6 9 M 5 -4 L -5 8 M -8 -5 L -1 -5 M 2 -5 L 8 -5 M -8 9 L -2 9 M 1 9 L 8 9 M -7 -5 L -5 -4 M -2 -5 L -4 -4 M 3 -5 L 5 -4 M 7 -5 L 5 -4 M -5 8 L -7 9 M -5 8 L -3 9 M 4 8 L 2 9 M 5 8 L 7 9","-10 9 M -6 -5 L 0 9 M -5 -5 L 0 7 M -4 -5 L 1 7 M 6 -4 L 1 7 L -2 13 L -4 15 L -6 16 L -8 16 L -9 15 L -9 13 L -7 13 L -7 15 L -8 15 L -8 14 M -8 -5 L -1 -5 M 2 -5 L 8 -5 M -7 -5 L -4 -3 M -2 -5 L -4 -4 M 4 -5 L 6 -4 M 7 -5 L 6 -4","-9 9 M 4 -5 L -6 9 M 5 -5 L -5 9 M 6 -5 L -4 9 M 6 -5 L -6 -5 L -6 -1 M -6 9 L 6 9 L 6 5 M -5 -5 L -6 -1 M -4 -5 L -6 -2 M -3 -5 L -6 -3 M -1 -5 L -6 -4 M 1 9 L 6 8 M 3 9 L 6 7 M 4 9 L 6 6 M 5 9 L 6 5","-7 7 M 2 -16 L 0 -15 L -1 -14 L -2 -12 L -2 -10 L -1 -8 L 0 -7 L 1 -5 L 1 -3 L -1 -1 M 0 -15 L -1 -13 L -1 -11 L 0 -9 L 1 -8 L 2 -6 L 2 -4 L 1 -2 L -3 0 L 1 2 L 2 4 L 2 6 L 1 8 L 0 9 L -1 11 L -1 13 L 0 15 M -1 1 L 1 3 L 1 5 L 0 7 L -1 8 L -2 10 L -2 12 L -1 14 L 0 15 L 2 16","-4 4 M 0 -16 L 0 16","-7 7 M -2 -16 L 0 -15 L 1 -14 L 2 -12 L 2 -10 L 1 -8 L 0 -7 L -1 -5 L -1 -3 L 1 -1 M 0 -15 L 1 -13 L 1 -11 L 0 -9 L -1 -8 L -2 -6 L -2 -4 L -1 -2 L 3 0 L -1 2 L -2 4 L -2 6 L -1 8 L 0 9 L 1 11 L 1 13 L 0 15 M 1 1 L -1 3 L -1 5 L 0 7 L 1 8 L 2 10 L 2 12 L 1 14 L 0 15 L -2 16","-12 12 M -9 3 L -9 1 L -8 -2 L -6 -3 L -4 -3 L -2 -2 L 2 1 L 4 2 L 6 2 L 8 1 L 9 -1 M -9 1 L -8 -1 L -6 -2 L -4 -2 L -2 -1 L 2 2 L 4 3 L 6 3 L 8 2 L 9 -1 L 9 -3","-8 8 M -8 -12 L -8 9 L -7 9 L -7 -12 L -6 -12 L -6 9 L -5 9 L -5 -12 L -4 -12 L -4 9 L -3 9 L -3 -12 L -2 -12 L -2 9 L -1 9 L -1 -12 L 0 -12 L 0 9 L 1 9 L 1 -12 L 2 -12 L 2 9 L 3 9 L 3 -12 L 4 -12 L 4 9 L 5 9 L 5 -12 L 6 -12 L 6 9 L 7 9 L 7 -12 L 8 -12 L 8 9"]